<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="formfactory" uri="http://www.jahia.org/formfactory/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>

<toaster-container
        toaster-options="{'time-out': 6000, 'close-button':true, 'animation-class': 'toast-top-right', 'prevent-duplicates': true}"></toaster-container>
<div class="bg-info">
    <div class="builder-page-header">
        <h2>
            <span message-key="fcnt_builder"></span>
        </h2>
    </div>
</div>

<div class="row">
    <div class="col-sm-4">
        <ff-error-display ng-if="(fbc.containsInvalidStep||fbc.stepContainsUnassignedElements) && !fbc.workerRunning"></ff-error-display>
    </div>
    <div class="col-sm-4">
        <%--<ff-spinner id="previewSpinner" size="fa-3x"></ff-spinner>--%>
        <p class="text-center lead ng-binding">
            <strong uib-tooltip="{{ fbc.form.formDescription }}">{{
                fbc.form.displayableName }}</strong>
            <small>
                <a class="btn"
                   uib-tooltip="{{ fbc.i18nMessageGetter('fcnt_library.button.editMetaData') }}"
                   ng-click="fbc.openMetaDataPanel()">
                    <i class="fa fa-cog"></i>
                </a>
            </small>
            <small ng-switch="fbc.displayMode">
                <a ng-switch-when="editing"
                   class="btn"
                   uib-tooltip="{{ fbc.i18nMessageGetter('fcnt_library.button.layoutView') }}"
                   ng-disabled="fbc.inTranslateMode"
                   ng-click="fbc.setDisplayMode('layout');">
                    <i class="fa fa-columns"></i>
                </a>
                <a ng-switch-when="layout"
                   class="btn"
                   uib-tooltip="{{ fbc.i18nMessageGetter('fcnt_library.button.editView') }}"
                   ng-click="fbc.setDisplayMode('editing')">
                    <i class="fa fa-pencil"></i>
                </a>
            </small>
        </p>
    </div>
    <div class="col-sm-4">
        <ff-spinner id="buttonsSpinner" size="fa-1x" backsplash="true" orientation="rightup"></ff-spinner>
        <div class="btn-group pull-right">
            <button type="button"
                    class="btn btn-primary"
                    uib-tooltip="{{ fbc.i18nMessageGetter('fcnt_builder.tooltip.reloadForm') }}"
                    ng-click="fbc.reloadForm()"
                    ng-disabled="fbc.form.jcrId === null">
                <i class="fa fa-refresh"></i>
            </button>

            <button type="button"
                    class="btn btn-primary"
                    uib-tooltip="{{ fbc.i18nMessageGetter('fcnt_builder.tooltip.previewForm') }}"
                    ng-click="fbc.previewForm()"
                    ng-disabled="!fbc.isPreviewAvailable">
                <i class="fa fa-eye"></i>
            </button>

            <button type="button"
                    class="btn btn-primary"
                    uib-tooltip="{{ fbc.i18nMessageGetter('fcnt_builder.tooltip.saveForm') }}"
                    ng-click="fbc.saveForm()"
                    ng-if="fbc.form.jcrId !== null"
                    ng-disabled="fbc.containsInvalidStep||fbc.stepContainsUnassignedElements">
                <i class="fa fa-floppy-o"></i>
            </button>

            <button type="button"
                    class="btn btn-primary"
                    uib-tooltip="{{ fbc.i18nMessageGetter('fcnt_builder.tooltip.createForm') }}"
                    ng-click="fbc.createForm()"
                    ng-if="fbc.form.jcrId === null"
                    ng-disabled="fbc.containsInvalidStep||fbc.stepContainsUnassignedElements">
                <i class="fa fa-floppy-o"></i>
            </button>
            <button class="btn btn-primary"
                    type="button" ng-click="fbc.backToLibrary()"
                    uib-tooltip="{{fbc.i18nMessageGetter('fcnt_createEntry.button.backToLibrary')}}">
                <i class="fa fa-home"></i>
            </button>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-sm-12">
        <div class="row">
            <div ng-switch="fbc.displayMode" class="col-sm-12">
                <ul ng-switch-when="editing" class="nav nav-tabs">
                    <li ng-repeat="step in fbc.form.steps"
                        ng-click="fbc.updateCurrentStep($index)"
                        ng-class="::{'active': fbc.currentStep !== null && fbc.currentStep === $index}">
                        <a href="#step-{{ $index }}" data-toggle="tab">
                            <span uib-tooltip="{{step.label}}">{{step.label | s: 'truncate':[12]}}</span>
                            <span class="cursorPointer"
                                  uib-tooltip="{{ fbc.i18nMessageGetter('fcnt_builder.button.editCurrentStep') }}"
                                  uib-popover-template="fbc.editStepNameTemplate"
                                  data-popover-title="{{ fbc.i18nMessageGetter('angular.ffFormBuilderDirective.title.changeStepName') }}"
                                  data-popover-placement="right"
                                  data-popover-trigger="outsideClick">
                                <i class="fa fa-pencil"></i>
                            </span>
                            <span class="cursorPointer"
                                  uib-tooltip="{{ fbc.i18nMessageGetter('fcnt_builder.button.deleteCurrentStep') }}"
                                  ng-if="!fbc.inTranslateMode"
                                  ng-click="fbc.removeStep($index)">
                                <i class="fa fa-trash text-danger"></i>
                            </span>
                        </a>
                    </li>
                    <li ng-if="fbc.form.steps.length > 1 && !fbc.inTranslateMode">
                        <a href="" ng-click="$event.preventDefault();" style="cursor:default">
                            <i uib-tooltip="{{ fbc.i18nMessageGetter('fcnt_builder.button.moveCurrentStepBefore') }}"
                               style="cursor:pointer"
                               ng-click="fbc.moveStep(fbc.currentStep - 1); $event.preventDefault();"
                               ng-if="fbc.currentStep != null && fbc.form.steps.length > 1 && fbc.currentStep != 0"
                               class="fa fa-lg fa-chevron-left"></i>
                            <i ng-click="$event.preventDefault();"
                               ng-if="!(fbc.currentStep != null && fbc.form.steps.length > 1 && fbc.currentStep != 0)"
                               class="fa fa-lg fa-chevron-left text-muted"></i>
                            &nbsp;
                            <i ng-click="$event.preventDefault();"
                               ng-if="!(fbc.currentStep != null && fbc.form.steps.length > 1 && fbc.currentStep != (fbc.form.steps.length - 1))"
                               class="fa fa-lg fa-chevron-right text-muted"></i>
                            <i uib-tooltip="{{ fbc.i18nMessageGetter('fcnt_builder.button.moveCurrentStepAfter') }}"
                               style="cursor:pointer"
                               ng-click="fbc.moveStep(fbc.currentStep + 1); $event.preventDefault();"
                               ng-if="fbc.currentStep != null && fbc.form.steps.length > 1 && fbc.currentStep != (fbc.form.steps.length - 1)"
                               class="fa fa-lg fa-chevron-right"></i>
                        </a>
                    </li>
                    <li>
                        <a href="#addStep" uib-tooltip="{{ fbc.i18nMessageGetter('fcnt_builder.button.addStep') }}"
                           ng-if="!fbc.inTranslateMode"
                           ng-click="fbc.addStep(); $event.preventDefault();">
                            <i class="fa fa-lg fa-plus"></i>
                        </a>
                    </li>
                    <li ng-class="::{'active':fbc.currentStep === null}">
                        <a href="#stepActionContent"
                           data-toggle="tab"
                           ng-click="fbc.updateCurrentStep(null)"
                           uib-tooltip="{{ fbc.i18nMessageGetter('fcnt_createEntry.label.step.actionsStep') }}">
                            <i class="fa fa-lg fa-cogs"></i>
                        </a>
                    </li>
                </ul>
                <ul ng-switch-when="layout" class="nav nav-tabs">
                    <li ng-repeat="step in fbc.form.steps"
                        ng-click="fbc.updateCurrentStep($index)"
                        ng-class="::{'active': fbc.currentStep !== null && fbc.currentStep === $index}">
                        <a href="#step-{{ $index }}" data-toggle="tab">
                            <span uib-tooltip="{{step.label}}">{{step.label | s: 'truncate':[12]}}</span>
                        </a>
                    </li>
                    <li class="pull-right">
                        <switch ng-model="fbc.getLayout().active" ng-change="fbc.manageLayout()"></switch>
                    </li>
                </ul>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <ff-form-rendering></ff-form-rendering>
            </div>
        </div>
    </div>
</div>

<ff-side-panel></ff-side-panel>

<hr/>
