<%@ page contentType="text/javascript" %>
/**
 * Validates that the email value is a valid email
 * Receives the rule definition and its scope.
 * scope.$parent will contain the form to enable watch and access to other fields in the same step
 * ctrls will be an array of controllers, first the ffFormController and then the ngModel of the associated input
 *
 * @param {object} rule current rule definition
 * @param {object} scope current input scope
 * @param {object} el current html element
 * @param {array} attr attributes of the html element
 * @param {array} ctrls ctrls[0] = FFFormController ctrls[1]=ngModel
 */

ff.validationRules.email = function(rule, scope, el, attr, ctrls) {
    'use strict';
    var model = ctrls[1];
    //Regexp taken from http://www.regular-expressions.info/email.html
    var regexp = /^[A-Z0-9._%+-]{1,64}@(?:[A-Z0-9-]{1,63}\.){1,125}[A-Z]{2,63}$/i;

    return function(modelValue, viewValue) {
        return model.$isEmpty(viewValue) || regexp.test(viewValue);
    };
};