<%@ page contentType="text/javascript" %>
<%@ taglib prefix="formfactory" uri="http://www.jahia.org/formfactory/functions" %>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>

(function(){
    var dateBeforeLogic = function($log, ffTemplateResolver) {
        var directive = {
            restrict   : 'E',
            controller: dateBeforeController,
            controllerAs: 'dbc',
            bindToController: true,
            templateUrl: function(el, attrs) {
                return ffTemplateResolver.resolveTemplatePath('${formfactory:addFormFactoryModulePath('/form-factory-logics/if-date-is-before', renderContext)}', attrs.viewType);
            },
            link       : linkFunc
        };
        return directive;

        function linkFunc(scope, el, attr, ctrl) {}
    };
    var dateBeforeController = function($scope, ffCommonUseFactory) {
        //Update the error control when the validator has run
        $scope.$on('requiredValueChanged', function(event, data) {
            dbc.errorControl.max.hasError = !data.isValid;
        });

        var dbc = this;

        //Make sure that the formController is defined, otherwise wait for it to be defined and then initialize
        //the error control object.
        if (_.isUndefined($scope.logicRules)) {
            var deregisterLogicRulesWatch = $scope.$watch(function() {
                return !_.isUndefined($scope.logicRules);
            }, function(logicRulesAvailable) {
                if (logicRulesAvailable) {
                    deregisterLogicRulesWatch();
                    initErrorControl();
                }
            });
        } else {
            initErrorControl();
        }

        /**
         * Responsible for initializing the error control object used by the date picker directive
         * @function
         */
        function initErrorControl() {
            dbc.errorControl = {
                max: {
                    hasError: $scope.logicRules.requiredValue.$invalid,
                    errorMessage: $scope.ddc.i18nMessageGetter('ff.label.validDateRequired')
                }
            };
        }
        //Create a valid moment object from default value
        $scope.ddc.input.logics[$scope.ddc.logicIndex].requiredValue = ffCommonUseFactory.createMoment($scope.ddc.input.logics[$scope.ddc.logicIndex].requiredValue);
    };

    dateBeforeController.$inject = ['$scope', 'ffCommonUseFactory'];
    angular
            .module('formFactory')
            .directive('ffDateBeforeLogicWizard', ['$log', 'ffTemplateResolver', dateBeforeLogic]);
})();