<%@ page contentType="text/javascript" %>
/**
 * This visibility rule will ensure that the date provided is between the specified range
 * Each rule will received, the rule definition, its scope.
 * scope.form will contain the form to enable watch and access to other fields in the same step
 * ctrls will be an array of controllers, first the ffFormController and then the ngModel of the associated input.
 *
 * @param {object} rule current rule definition
 * @param {object} scope current input scope
 * @param {object} el current html element
 * @param {array} attr attributes of the html element
 * @param {array} ctrls ctrls[0] = FFFormController ctrls[1]=ngModel
 */
ff.logicRules.ifDateIsBetween = function(rule, scope, el, attr, ctrls) {
    'use strict';
    var dateMin = moment(rule.dateMin);
    var dateMax = moment(rule.dateMax);
    var formController = ctrls[0].getFormController();
    var fieldName = rule.fieldName;
    return function (scope, fieldValue) {
        if (!_.isUndefined(formController[fieldName]) && formController[fieldName].$error['invalidDate_' +  fieldName]) {
            return false;
        }
        var date = (moment.isMoment(fieldValue)?fieldValue:moment(fieldValue));
        return (!_.isUndefined(fieldValue) && date.isBetween(dateMin,dateMax, 'day'));
    };
};