<%@ page contentType="text/javascript" %>
<%@ taglib prefix="formfactory" uri="http://www.jahia.org/formfactory/functions" %>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>

angular
    .module('formFactory')
    .directive('ffRadiosMatrix', ['$log', 'ffTemplateResolver', function ($log, ffTemplateResolver) {
        var directive = {
            restrict: 'E',
            templateUrl: function(el, attrs) {
                return ffTemplateResolver.resolveTemplatePath('${formfactory:addFormFactoryModulePath('/form-factory-definitions/radios-matrix', renderContext)}', attrs.viewType);
            },
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ctrl) {
            scope.input.rows = angular.fromJson(scope.input.rows);
            scope.input.columns = angular.fromJson(scope.input.columns);
            if (scope.input.value === null) {
                scope.input.value = {rendererName:'matrixRadios'};
            } else if(angular.isString(scope.input.value)){
                scope.input.value = angular.merge(angular.fromJson(scope.input.value),{rendererName:'matrixRadios'});
            }
            scope.getColumnWidth = function(prefix,max) {
                return prefix + Math.floor(max/(Object.keys(scope.input.columns).length))
            };
            scope.columnWidth = scope.getColumnWidth('col-sm-',10);
            scope.$watchCollection('input.columns',function(oldValue, newValue){
                if (!_.isUndefined(oldValue) && !_.isUndefined(newValue) && Object.keys(oldValue).length != Object.keys(newValue).length){
                    scope.columnWidth = scope.getColumnWidth('col-sm-',10);
                }
            });
            scope.reset = function () {
                scope.input.value = {};
            }
        }
    }]);
