<%@ page contentType="text/javascript" %>
<%@ taglib prefix="formfactory" uri="http://www.jahia.org/formfactory/functions" %>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>

angular
    .module('formFactory')
    .directive('ffRating', ['$log', 'ffTemplateResolver', 'i18nService', function ($log, ffTemplateResolver, i18n) {
        var directive = {
            restrict: 'E',
            require: ['^ffController'],
            templateUrl: function(el, attrs) {
                return ffTemplateResolver.resolveTemplatePath('${formfactory:addFormFactoryModulePath('/form-factory-definitions/rating-input', renderContext)}', attrs.viewType);
            },
            link: linkFunction
        };

        return directive;

        function linkFunction(scope, el, attr, ctrl) {
            //Set field to dirty once it changes its value
            var unregisterDirtySetter = scope.$watch(function() {
                return scope.input.value;
            }, function(n, o) {
                if (n !== undefined) {
                    if ((n !== null && n.value !== undefined)) {
                        if (scope.input.name !== undefined && scope.form[scope.input.name] !== undefined) {
                            scope.form[scope.input.name].$setDirty();
                        }
                        unregisterDirtySetter();
                    }
                }
            }, true);

            scope.value = 0;
            scope.modelValue = 0;
            scope.star = i18n.message("fcnt_ratingDefinition.label.star");
            scope.heart = i18n.message("fcnt_ratingDefinition.label.heart");
            scope.thumbs = i18n.message("fcnt_ratingDefinition.label.thumbs");
            scope.$watch(function() { return scope.input.max}, function() {setRange()});
            scope.$watch(function() { return scope.input.inputsize}, function() {setRange()});
            scope.$watch(function() { return scope.input.stateOnOff }, function() {setRange()});

            function setRange() {
                if (scope.input.stateOnOff !== undefined) {
                    var max = parseInt(scope.input.max);
                    var states = scope.input.stateOnOff.split(',');
                    if (!isNaN(max)) {
                        var values = [];
                        for (var i = 0; i < max; i++) {
                            values.push({
                                index: i,
                                stateOn: states[0],
                                stateOff: states[1],
                                iconSize: scope.input.inputsize === 'default'? '':scope.input.inputsize
                            });
                        }
                        scope.range = values;
                    }
                }
            }

            scope.rate = function(value) {
                if (!scope.readOnly) {
                    scope.input.value = {rendererName:'rating', css:scope.input.stateOnOff.split(',')[0], value:value };
                            scope.modelValue = scope.value = value;
                }
            };

            scope.reset = function() {
                if (!scope.readOnly) {
                    scope.value = scope.modelValue;
                }
            };

            scope.enter = function(value) {
                if (!scope.readOnly) {
                    scope.value = value;
                }
            };

            //Update numeric value according to value on the input
            if (scope.input.value !== undefined && scope.input.value !== null && scope.value !== scope.input.value.value) {
                scope.rate(scope.input.value.value);
            }

            //Initialize
            setRange();
        }
    }]);