<%@ page contentType="text/javascript" %>
<%@ taglib prefix="formfactory" uri="http://www.jahia.org/formfactory/functions" %>

(function () {
    'use strict';

    var redirectToAPage = function($log, $compile, contextualData, ffDataFactory, ffTemplateResolver) {
        var directive = {
            restrict: 'E',
            controller: RedirectToPageController,
            controllerAs: 'rtp',
            bindToController: true,
            templateUrl: function(el, attrs) {
                return ffTemplateResolver.resolveTemplatePath('${formfactory:addFormFactoryModulePath('/form-factory-actions/redirect-to-a-page', renderContext)}', attrs.viewType);
            },
            link: linkFunc
        };
        return directive;

        function linkFunc(scope, el, attr) {
        }
    };

    var RedirectToPageController = function ($scope, contextualData, ffDataFactory) {
        var rtp = this;
        rtp.getPage = getPage;
        rtp.handleSelection = handleSelection;

        function handleSelection(selection, b, c) {
            $scope.action.redirectto = selection.path;
            $scope.action.pagename = selection.name;
        }

        function getPage(value) {
            return ffDataFactory.customRequest({
                url: contextualData.pageQuery,
                method: 'post',
                contentType: 'application/json',
                dataType: 'json',
                data: {
                    limit: 10,
                    queryName: 'formFactoryPageSearch',
                    parameters: [contextualData.sitePath, '%' + value.toLowerCase() + '%']
                }
            }).then(function (response) {
                return response;
            });
        }
    };

    RedirectToPageController.$inject = ['$scope', 'contextualData', 'ffDataFactory'];

    angular
            .module('formFactory')
            .directive('ffRedirectToAPage', ['$log', '$compile', 'contextualData', 'ffDataFactory', 'ffTemplateResolver', redirectToAPage]);
})();