<%@ page contentType="text/javascript" %>
<%@ taglib prefix="formfactory" uri="http://www.jahia.org/formfactory/functions" %>

(function () {
    'use strict';

    var sendEmail = function($log, $compile, contextualData, ffDataFactory, ffTemplateResolver) {
        var directive = {
            controller: SendEmailController,
            controllerAs: 'se',
            bindToController: true,
            templateUrl: function(el, attrs) {
                return ffTemplateResolver.resolveTemplatePath('${formfactory:addFormFactoryModulePath('/form-factory-actions/send-email/', renderContext)}', attrs.viewType);
            },
            link: linkFunc
        };
        return directive;

        function linkFunc(scope, el, attr) {}
    };

    var SendEmailController = function ($scope, contextualData, ffDataFactory) {
        var se = this;
        se.getModule = getModule;
        se.handleSelection = handleSelection;
        if($scope.action.moduleName !== "") {
            getEmailTemplate($scope.action.moduleName);
        }

        function resetTemplatesDropdown() {
            $scope.action.template = "";
            se.templates           = [];
        }

        $scope.$watch(function (scope) {
            return $scope.action.moduleName;
        }, function (newValue, oldValue) {
            if(newValue=="" || newValue === undefined) {
                resetTemplatesDropdown();
            }
        });

        function handleSelection(selection, b, c) {
            $scope.action.module = selection.path;
            $scope.action.moduleName = selection.name;
            getEmailTemplate(selection.name);
        }

        function getModule(value) {
            return ffDataFactory.customRequest({
                url: contextualData.pageQuery,
                method: 'post',
                contentType: 'application/json',
                dataType: 'json',
                data: {
                    limit: 10,
                    queryName: 'formFactoryModuleSearch',
                    parameters: ['%' + value.toLowerCase() + '%', '%' + value.toLowerCase() + '%']
                }
            }).then(function (response) {
                if(response.length==0) {
                    resetTemplatesDropdown();
                }
                return response;
            });
        }

        function getEmailTemplate(moduleName) {
            if(undefined === moduleName || "" == moduleName) {
                resetTemplatesDropdown();
            }
            ffDataFactory.getData(contextualData.context + '/modules/formfactory/builder/email/' + moduleName ).then(function(data) {
                se.templates = [];
                angular.forEach(data, function(template){
                    se.templates.push({id:template,name:template})
                });
                if(se.templates.length==0){
                    resetTemplatesDropdown();
                }
            });
        }
    };

    SendEmailController.$inject = ['$scope', 'contextualData', 'ffDataFactory'];

    angular
            .module('formFactory')
            .directive('ffSendEmail', ['$log', '$compile', 'contextualData', 'ffDataFactory', 'ffTemplateResolver', sendEmail]);
})();