<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>

<template:addResources type="css" resources="lib/packages/bootstrap-datepicker/dist/css/bootstrap-datepicker3.css"/>
<template:addResources type="css" resources="results.css"/>

<template:addResources type="javascript"
                       resources="lib/packages/bootstrap-datepicker/dist/js/bootstrap-datepicker.min.js"/>
<template:addResources type="javascript"
                       resources="lib/packages/bootstrap-datepicker/dist/locales/bootstrap-datepicker.${renderContext.UILocale}.min.js"/>
<template:addResources type="javascript" resources="fcResultsUtils.js"/>
<template:addResources type="javascript" resources="models/graphResult.js"/>
<template:addResources type="javascript" resources="lib/backbone.paginator.min.js"/>
<template:addResources type="javascript" resources="lib/packages/Chart.js/Chart.min.js"/>
<template:addResources type="javascript" resources="main-results.js"/>
<fmt:message key="fcnt_result.username" var="usernameHeader"/>
<fmt:message key="fcnt_result.submissionDate" var="subDateHeader"/>
<fmt:message key="fcnt_result.origin" var="originHeader"/>
<fmt:message key="fcnt_result.submissions.total" var="submissionsTotal"/>
<fmt:message key="fcnt_result.submissions.average" var="submissionsAverage"/>
<fmt:message key="fcnt_result.submissions.last" var="submissionsLast"/>
<fmt:message key="fcnt_result.formField" var="fieldHeader"/>
<fmt:message key="fcnt_result.dashboard.empty.percent" var="percentageHeader"/>
<template:addResources type="inlinejavascript">
    <script>
        var graphResultsView;
        var jsVarMap;
        $(document).ready(function () {
            var option = {
                format       : "dd/mm/yyyy",
                todayBtn     : true,
                language     : '${renderContext.UILocale}',
                calendarWeeks: true,
                autoclose    : true,
                orientation  : "bottom auto"
            };
            $("#dateRange .input-daterange").datepicker(option);

            var totalView        = new TotalAverageView();
            graphData            = new Dashboard();
            graphData.formId     = selectedResult;
            graphData.site       = "${renderContext.site.name}";
            graphData.steps      = 5;
            graphData.patternMap = [
                {serverPattern: "YYYY", displayPattern: "YYYY"},
                {serverPattern: "YYYYMM", displayPattern: "MM/YYYY"},
                {serverPattern: "YYYYww", displayPattern: "YYYY : Wo"},
                {serverPattern: "YYYYMMdd", displayPattern: "DD/MM/YYYY"}
            ];

            //Render reports calling backbone views
            timeSubmissionView  = new TimeSubmissionView({
                model      : graphData,
                lineGraphEl: $("#lineChart"),
                parameters : [{name: "group_by", values: ["month"]}, {name: "fromDate", values: []}, {
                    name  : "toDate",
                    values: []
                }],
                legends    : [{name: "day", value: "<fmt:message key='fcnt_result.daily'/>"}, {
                    name : "week",
                    value: "<fmt:message key='fcnt_result.weekly'/>"
                }, {name: "month", value: "<fmt:message key='fcnt_result.monthly'/>"}, {
                    name : "year",
                    value: "<fmt:message key='fcnt_result.annual'/>"
                }]
            });
            pageSubmissionView  = new PageSubmissionView({
                model     : graphData,
                barGraphEl: $("#barChart"),
                parameters: [{name: "group_by", values: ["origin", "month"]}, {
                    name  : "fromDate",
                    values: []
                }, {name: "toDate", values: []}]
            });
            emptySubmissionView = new EmptySubmissionView({
                model          : graphData,
                tableEl        : $("#emptyFields"),
                parameters     : [{name: "group_by", values: ["origin", "month"]}, {
                    name  : "fromDate",
                    values: []
                }, {name: "toDate", values: []}],
                datatableTitles: ["${functions:escapeJavaScript(fieldHeader)}", "${functions:escapeJavaScript(percentageHeader)}"],
                noResultLabel  : "<fmt:message key="fcnt.dataTableNoResult"/>"
            });
            choiceFieldView     = new ChoiceFieldView({
                model      : graphData,
                pieGraphEl : $("#pieChart"),
                matrixDivEl: $("#matrixField"),
                parameters : [{name: "group_by", values: ["origin", "month"]}, {
                    name  : "fromDate",
                    values: []
                }, {name: "toDate", values: []}]
            });
            setTimeParameter(timeSubmissionView, 'month');
            setTimeParameter(pageSubmissionView, 'month');
            function extracted() {
                timeSubmissionView.renderData();
                pageSubmissionView.renderData();
                choiceFieldView.renderData();
            }
            var canvasTimeout;
            $( window ).resize(function() {
                clearTimeout(canvasTimeout);
                canvasTimeout = setTimeout(function() {
                    extracted();
                }, 250);
            });
        });
    </script>
</template:addResources>

<div class="row">
    <%@include file="totalaverage.jspf" %>
    <div class="col-sm-6">
        <form id="dateRange" class="form-inline">
            <fieldset>
                <legend>
                    <fmt:message key="fcnt_result.datePicker.legend"/>
                    <a class="btn btn-primary pull-right" href="${url.context}${fn:replace(url.baseEdit, '/edit/', '/editframe/')}${renderContext.site.path}.results.html"><i class="fa fa-home"></i></a>
                </legend>
                <div class="form-group">
                    <div class="input-daterange input-group">
                        <input type="text" class="form-control" name="from"/>
                        <span class="input-group-addon">to</span>
                        <input type="text" class="form-control" name="to"/>
                    </div>
                </div>
                <button type="button" class="btn btn-primary" onclick="filterGraphResults(graphData)">
                    <fmt:message key="fcnt_result.filter"/>
                </button>
            </fieldset>
        </form>
    </div>
</div>


<h2><fmt:message key="fcnt_result.dashboard.reports.global"/></h2>
<hr/>
<div class="row">
    <div id="lineChart" class="col-sm-6">
        <div class="row">
            <div class="col-sm-6">
                <h5><fmt:message key="fcnt_result.dashboard.reports.submitsOverTime"/></h5>
            </div>
            <div class="col-sm-6">
                <h5>
                    <select name="timeFilter" class="timeFilter"
                            onchange="setTimeParameter(timeSubmissionView,$(this).val())">
                        <option value="day"><fmt:message key="fcnt_result.dashboard.selector.days"/></option>
                        <option value="week"><fmt:message key="fcnt_result.dashboard.selector.weeks"/></option>
                        <option value="month" selected="selected"><fmt:message
                                key="fcnt_result.dashboard.selector.months"/></option>
                        <option value="year"><fmt:message key="fcnt_result.dashboard.selector.years"/></option>
                    </select>
                </h5>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <div class="message box-1">
                    <fmt:message key="fcnt_result.dashboard.reports.notEnoughData"/>
                </div>
                <canvas id="countChart" width="500" height="200"></canvas>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <div id="countChart_legend" class="chart_legend"></div>
            </div>
        </div>
    </div>

    <div id="barChart" class="col-sm-6">
        <div class="row">
            <div class="col-sm-6">
                <h5><fmt:message key="fcnt_result.dashboard.reports.perPage"/></h5>
            </div>
            <div class="col-sm-6">
                <h5>
                    <select name="timeFilter" class="timeFilter"
                            onchange="setTimeParameter(pageSubmissionView,$(this).val())">
                        <option value="day"><fmt:message key="fcnt_result.dashboard.selector.days"/></option>
                        <option value="week"><fmt:message key="fcnt_result.dashboard.selector.weeks"/></option>
                        <option value="month" selected="selected"><fmt:message
                                key="fcnt_result.dashboard.selector.months"/></option>
                        <option value="year"><fmt:message key="fcnt_result.dashboard.selector.years"/></option>
                    </select>
                </h5>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <div class="message box-1">
                    <fmt:message key="fcnt_result.dashboard.reports.notEnoughData"/>
                </div>
                <canvas width="500" height="200"></canvas>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <div class="chart_legend" style="overflow-y: auto;max-height: 200px"></div>
            </div>
        </div>
    </div>
</div>
<hr/>
<div class="row">
    <div id="dataTable" class="col-sm-6">
        <h5><fmt:message key="fcnt_result.dashboard.reports.empty"/></h5>
        <table class="table table-striped table-bordered" id="emptyFields"></table>
    </div>

    <div id="pieChart" class="col-sm-6">
        <div class="row">
            <div class="col-sm-6">
                <h5><fmt:message key="fcnt_result.dashboard.reports.choice"/></h5>
            </div>
            <div class="col-sm-6">
                <h5>
                    <select name="choiceField"></select>
                </h5>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <div class="message box-1">
                    <fmt:message key="fcnt_result.dashboard.reports.notEnoughData"/>
                </div>
                <table class="table table-striped table-bordered nopadding" id="matrixField"></table>
                <canvas id="choiceChart" width="500" height="200"></canvas>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <div id="choiceChart_legend" class="chart_legend"></div>
            </div>
        </div>
    </div>
</div>
