var SimpleSlider = {
	ffSliderDirective : function($log) {
		var directive = {
			restrict: 'E',
			templateUrl: '/modules/form-factory-core/javascript/angular/templates/sliderDefinition.html',
			controller: SimpleSlider.ffSliderController,
			controllerAs: 'sc',
			bindToController: true
		};
		return directive;
	},
	ffSliderController : function ($scope, $log) {
		var sc = this;

		sc.range = $scope.input.range;
		sc.step = $scope.input.step;
		sc.handleMove = handleMove;

		function handleMove($event) {
			$scope.hc.handleMove($event);
		}
	},
	ffSliderRangeBase : function($log) {
		var directive = {
			restrict: 'A',
			link : {
				pre: linkFunction
			},
			controller : SimpleSlider.RangeController,
			controllerAs : 'rc'
		};
		return directive;

		function linkFunction(scope, el, attr) {
			$log.info(el.width());
			scope.rc.ffSliderEl = el;
		}
	},
	RangeController : function($scope, $log) {
		var rc = this;

		rc.handleClick = handleClick;

		function handleClick(e) {
			e.stopPropagation();
			$scope.hc.moveTo(e);
		}
	},
	ffSliderHandle : function($log) {
		var directive = {
			restrict: 'A',
			link: {
				pre: preLinkFunction
			},
			controller: SimpleSlider.HandleController,
			controllerAs: 'hc',
			bindToController: true
		};

		return directive;

		function preLinkFunction(scope, el, attr) {
			scope.hc.handleEl = el;
			scope.hc.setHandlerOffset(el);
		}
	},
	HandleController : function($scope, $log) {
		var hc = this;

		//Todo get rid of unnecessary function calls
		hc.totalDivisions = ($scope.sc.range[1] - $scope.sc.range[0]) / $scope.sc.step;
		hc.handlerOffset = 0; //Percentage
		hc.sliderLength = sliderLength;
		hc.divisionPercentage = divisionPercentage;
		hc.stepPercentages = []; //Arrays that holds percentages relative to slider length
		hc.setpValues = []; //Array that holds values corresponding to the percentages in stepPercentages.
		hc.stepCounter = 0;
		hc.dx = undefined;
		hc.lastX = 0;
		hc.pageX = 0;
		hc.populateStepPercentagesAndValues = populateStepPercentagesAndValues;
		hc.registerHandle = registerHandle;
		hc.unRegisterHandle = unRegisterHandle;
		hc.handleMove = handleMove;
		hc.setHandlerOffset = setHandlerOffset;
		hc.determineHandlePosition = determineHandlePosition;
		hc.moveTo = moveTo;
		hc.registered = false;
		hc.cPpadding = 0.15; //Make sure that the minimum percentage can be <= 0

		//Populates arrays with proper values for percentages and data
		hc.populateStepPercentagesAndValues();

		function registerHandle(e) {
			$log.info("Registered handle" + $scope.handleId);
			e.stopPropagation();
			hc.registered = true;
		}

		function unRegisterHandle() {
			hc.registered = false;
		}

		function handleMove(e) {
			if (hc.registered) {
				var p = hc.determineHandlePosition(e);
				if (p !== undefined) {
					hc.handleEl.css("left", (p[0] - hc.handlerOffset) + '%');
					$scope.input.value = hc.stepValues[p[1]];
				}
			}
		}

		function moveTo(e) {
			var p = hc.determineHandlePosition(e);
			if (p !== undefined) {
				hc.handleEl.animate({left: p[0] - hc.handlerOffset + '%'}, 'slow');
				$scope.input.value = hc.stepValues[p[1]];
			}

		}

		function setHandlerOffset(el) {
			hc.handlerOffset = (el.width() / (hc.sliderLength() / 100)) / 2;
			el.css('left', -hc.handlerOffset + '%');
		}

		function determineHandlePosition(e) {
			var ofX = e.pageX - $scope.rc.ffSliderEl.offset().left;
			var cP = ((ofX / hc.sliderLength()) * 100) - hc.cPpadding;
			for (var i = 0; i < hc.stepPercentages.length; i++) {
				if (cP <= hc.stepPercentages[i]) {
					return [hc.stepPercentages[i], i];
				}
			}
		}

		function sliderLength() {
			return $scope.rc.ffSliderEl.width();
		}

		function divisionPercentage() {
			var len = hc.sliderLength();
			return (len / hc.totalDivisions) / (len / 100);
		}

		function populateStepPercentagesAndValues() {
			$scope.input.value = $scope.sc.range[0];
			var divisionPercentage = hc.divisionPercentage();
			var percent = 0;
			var step = $scope.sc.range[0];
			var p = [];
			var v = [];
			while (Math.round(percent) <= 100) {
				p.push(percent);
				v.push(step);
				percent += divisionPercentage;
				step += $scope.sc.step;
			}
			hc.stepPercentages = p;
			hc.stepValues = v;
		}
	}
};

SimpleSlider.ffSliderController.$inject = ['$scope', '$log'];
SimpleSlider.RangeController.$inject = ['$scope', '$log'];
SimpleSlider.HandleController.$inject = ['$scope', '$log'];


angular.module('formFactory')
	.directive('ffSlider', ['$log', SimpleSlider.ffSliderDirective])
	.directive('ffSliderRangeBase', ['$log', SimpleSlider.ffSliderRangeBase])
	.directive('ffSliderHandle', ['$log', SimpleSlider.ffSliderHandle]);


//$(window).on('resize', function(e) {
//	clearTimeout(self.resizeTimer);
//	self.resizeTimer = setTimeout(function() {
//		self.rebuildOnWindowResize();
//	}, 250);
//
//});