angular
    .module('formFactory')
    .factory('ffTypeaheadFactory', ffTypeaheadFactory);

ffTypeaheadFactory.$inject = ['$http', '$log'];

function ffTypeaheadFactory($http, $log) {
    return {
        getTHData: getTHData
    };

    function getTHData(url) {
        return $http.get(url)
            .then(getFormDataComplete)
            .catch(getFormDataFailed);

        function getFormDataComplete(response) {
            $log.debug('ffTypeaheadFactory completed data transfer!');
            $log.debug(response);
            return response.data;
        }

        function getFormDataFailed(error) {
            $log.debug('XHR Failed for getTHData.' + error.data);
        }
    }
}
