package org.jahia.modules.formfactory.dsl

/**
 * Created by rincevent on 15-08-21.
 */
class FormFactoryWizardParser extends GroovyObjectSupport {
    Map<String, Object> contentMap = new LinkedHashMap<String, Object>();

    public Object invokeMethod(String name, Object args) {
        if (args != null && Object[].class.isAssignableFrom(args.getClass())) {
            Object[] arr = (Object[]) args;
            if (arr.length == 1) {
                if (arr[0] instanceof Closure) {
                    def inputType = new FormFactoryWizardParser()
                    def cl = (Closure) arr[0]
                    def code = cl.rehydrate(inputType, this, this)
                    code.resolveStrategy = Closure.DELEGATE_FIRST
                    code()
                    return setAndGetContent(name, inputType.contentMap);
                } else if (arr[0] instanceof Map) {
                    return setAndGetContent(name, arr[0]);
                } else if (arr[0] instanceof String) {
                    return setAndGetContent(name, arr[0]);
                } else if (arr[0] instanceof Collection) {
                    return setAndGetContent(name, arr[0]);
                }
            } else {
                return setAndGetContent(name, arr.collect({ it ->
                    if (it instanceof Closure) {
                        def inputType = new FormFactoryWizardParser()
                        def code = it.rehydrate(inputType, this, this)
                        code.resolveStrategy = Closure.DELEGATE_FIRST
                        code()
                        return inputType.contentMap;
                    } else {
                        it
                    }
                }))
            }
        } else {
            return setAndGetContent(name, new HashMap<String, Object>());
        }
    }

    private Object setAndGetContent(String name, Object value) {
        contentMap.put(name, value);

        return contentMap;
    }

    public String toString() {
        return contentMap.toMapString();
    }
}
