(function () {
    'use strict';
    angular.module('formFactory', ['ui.router', 'formFactory.dataFactory', 'datatables', 'datatables.bootstrap', 'i18n',
        'ui.bootstrap', 'ui.bootstrap.tooltip', 'formFactory.commonUseFactory', 'ngResource', 'formFactory.downloadZipFactory',
        'formFactory.updaterFactory', 'checklist-model', 'uiSwitch', 'formFactory.templateResolver',
        'toaster', 'ngAnimate', 'ngSanitize', 'dndLists'], function ($uibTooltipProvider) {
        $uibTooltipProvider.options({
            placement: 'bottom',
            popupDelay: 200,
            popupCloseDelay: 0,
            appendToBody: true
        });
    });
})();
(function () {
    'use strict';
    var ffControllerInput = function ($log, contextualData) {
        var directive = {
            restrict: 'E',
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/addelement/addElementButton.html',
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ffController) {
            scope.elementType = attr.elementType;
        }
    };

    angular
        .module('formFactory')
        .directive('ffAddElementButton', ['$log', 'contextualData', ffControllerInput]);
})();
(function () {
	'use strict';

	var stringToNumberDirective = function ($log, contextualData, ffValidationService) {

		var directive = {
			restrict: 'E',
			templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/errorDisplay.html',
			link: linkFunction
		};

		return directive;

		function linkFunction(scope, el, attr, ctrls) {
			scope.showToasts = function () {
				ffValidationService.showToasts();
			}
		}
	};

	angular
		.module('formFactory')
		.directive('ffErrorDisplay', ['$log', 'contextualData', 'ffValidationWorker', stringToNumberDirective]);
})();(function () {
    var FormBuilderController = function ($scope, $log, $state, ffDataFactory, ffCommonUseFactory, ffUpdaterFactory,
                                          contextualData, i18n, $timeout, $uibModal, toaster, ffValidationService,
                                          $filter, ffLayoutService, spinner, $window, _) {
        var fbc = this;

        //async validations
        fbc.processWorkerResponse = processWorkerResponse;
        fbc.stepValidityCheck     = stepValidityCheck;
        function stepValidityCheck() {
            var data = {
                flag       : 'containsInvalidStep', //Flag in fbc which we want to set
                flagValue  : true,             //Flag value
                form       : fbc.form,
                initialCall: true           //Must be present on initial call so we don't call callbacks
            };
            ffValidationService.runValidationWorker(contextualData.context, 'stepValidationWorker.js')(data);
        }

        fbc.unassignedElementsCheck = unassignedElementsCheck;
        function unassignedElementsCheck() {
            var data = {
                flag       : 'stepContainsUnassignedElements', //Flag in fbc which we want to set
                flagValue  : true,             //Flag value
                layout     : ffLayoutService.getLayout(),
                currentStep: fbc.currentStep,
                steps      : fbc.form.steps,
                initialCall: true           //Must be present on initial call so we don't call callbacks
            };
            ffValidationService.runValidationWorker(contextualData.context, 'layoutValidationWorker.js')(data);
        }

        fbc.saveForm                     = saveForm;
        fbc.moveInputTemplate            = contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/moveInput.html';
        fbc.editStepNameTemplate         = contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/editStepName.html';
        fbc.i18nMessageGetter            = i18nMessageGetter;
        fbc.showSidePanel                = showSidePanel;
        fbc.hideSidePanel                = hideSidePanel;
        fbc.isSidePanelDisplayed         = false;
        fbc.resolveLogic                 = resolveLogic;
        fbc.getFormController            = getFormController;
        fbc.removeInput                  = removeInput;
        fbc.createForm                   = createForm;
        fbc.prepareFormForBuilder        = prepareFormForBuilder;
        fbc.prepareFormForJCR            = prepareFormForJCR;
        fbc.getInputsAndMakeBuilderReady = getInputsAndMakeBuilderReady;
        fbc.moveInput                    = moveInput;
        fbc.test                         = test;
        fbc.availableTabs                = ['Design', 'Validations', 'Logics']; //Internationalize
        fbc.availableInputTabs = ['Input', 'Checkboxes and Radio', 'Selects', 'Additional']; //Internationalize
        fbc.previewForm               = previewForm;
        fbc.closePreviewModal         = closePreviewModal;
        fbc.getData                   = getData;
        fbc.reloadForm                = reloadForm;
        fbc.getTabHeading             = getTabHeading;
        fbc.containsInvalidValidation = false;
        fbc.containsInvalidKeyValue   = false;
        //Step management
        fbc.currentStep                    = 0;
        fbc.removeStep                     = removeStep;
        fbc.addStep                        = addStep;
        fbc.moveStep                       = moveStep;
        fbc.updateCurrentStep              = updateCurrentStep;
        fbc.containsInvalidStep            = false;
        fbc.containsDuplicateInput         = false;
        fbc.stepContainsUnassignedElements = false;
        fbc.workerRunning                  = false;
        //Needed for input move management
        fbc.moveInput      = moveInput;
        fbc.moveInputIndex = null;
        fbc.moveUpOrDown   = moveUpOrDown;
        //Needed for input editing
        fbc.editInput          = false;
        fbc.showEditInput      = showEditInput;
        fbc.selectedInputIndex = 0;
        //Needed for input addition
        fbc.addInput                 = false;
        fbc.showInputs               = showInputs;
        fbc.inputsCache              = null;
        fbc.transformToElement       = transformToElement;
        fbc.previewElement           = previewElement;
        fbc.cancelPreview            = cancelPreview;
        fbc.keepPreviewed            = keepPreviewed;
        fbc.inPreviewIndex           = -1;
        fbc.displayableInputs        = {};
        fbc.prepareDisplayableInputs = prepareDisplayableInputs;
        //Display mode management
        fbc.displayMode    = 'editing';
        fbc.setDisplayMode = setDisplayMode;
        fbc.manageLayout   = manageLayout;
        fbc.getLayout      = getLayout;
        //Set if duplicate key to disable close button
        fbc.duplicateKeyDetected = false;
        //Metadata side panel management
        fbc.editMetaData      = false;
        fbc.openMetaDataPanel = openMetaDataPanel;
        fbc.invalidFormName   = false;
        //Translation mode
        fbc.inTranslateMode = false;
        //Actions
        fbc.addAction             = false;
        fbc.editAction            = false;
        fbc.actionsCache          = null;
        fbc.prepareActions        = prepareActions;
        fbc.getAvailableActions   = getAvailableActions;
        fbc.removeAction          = removeAction;
        fbc.showEditAction        = showEditAction;
        fbc.showActions           = showActions;
        fbc.getActionKeyName      = getActionKeyName;
        fbc.selectedActionIndex   = 0;
        fbc.isPreviewAvailable    = false;
        fbc.isTranslatable        = isTranslatable;
        fbc.isLiveMode            = isLiveMode;
        fbc.containsInvalidAction = false;
        //Logics
        fbc.logicsCache           = null;
        fbc.containsInvalidLogics = false;
        //Input related info
        fbc.inputHasSupportedLogics      = inputHasSupportedLogics;
        fbc.inputHasSupportedValidations = inputHasSupportedValidations;
        fbc.nbColumnsInSidePanel         = 3;
        //Exit notification
        fbc.unsavedWarning            = null;
        fbc.warnIfUnsaved             = warnIfUnsaved;
        fbc.backToLibrary             = backToLibrary;
        fbc.handleBackToLibraryAction = handleBackToLibraryAction;
        fbc.getFormName               = getFormName;
        activate();

        $scope.$on('validateLayout', function() {
            fbc.unassignedElementsCheck();
        });
        /**
         * Activates directive by either initializing a form passed in parameters or loading form data from server
         *
         * @returns {*}
         */
        function activate() {
            ffValidationService.setController(fbc);
            if ($state.params.formIdentifier == null) {
                //Load base form if user pressed forward button
                if ($state.params.form === null) {
                    loadBasicForm();
                    return;
                }
                ffLayoutService.setBaseLayout();
                fbc.isPreviewAvailable = false;
                fbc.form               = angular.copy($state.params.form);
                if (angular.isUndefined($state.params.options) || !('doNotAddStep' in $state.params.options)) {
                    addStep();
                }
                fbc.getInputsAndMakeBuilderReady();
                fbc.getAvailableActions();
                //add default input to the layout.
                if (ffLayoutService.isActive()) {
                    ffLayoutService.handleInputAdd(fbc.currentStep, fbc.form.steps[fbc.currentStep].inputs[0].layoutUUID);
                }
            } else {
                return getData().then(function () {
                    fbc.activated = true;
                });
            }
        }

        /**
         * Loads form starter template with a generic name. Used to allow user to use forward button
         */
        function loadBasicForm() {
            ffDataFactory.getData(contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/library/formcreation/formModel.json')
                .then(function (response) {
                    response.buildingLang    = contextualData.locale;
                    response.formName     = "Change me";
                    response.displayableName = "Change me";
                    ffLayoutService.setBaseLayout();
                    fbc.isPreviewAvailable = false;
                    fbc.form               = response;
                    fbc.getInputsAndMakeBuilderReady();
                    fbc.getAvailableActions();
                    //add default input to the layout.
                    if (ffLayoutService.isActive()) {
                        ffLayoutService.handleInputAdd(fbc.currentStep, fbc.form.steps[fbc.currentStep].inputs[0].layoutUUID);
                    }
                });
        }

        /**
         * Load form data from server
         *
         * @param reloadForm
         * @returns {*}
         */
        function getData(reloadForm) {
            //Save current step before reloading
            var currentStepBeforeSave = fbc.currentStep;
            return ffDataFactory.getData(contextualData.context + '/modules/formfactory/builder/form/' + $state.params.formIdentifier + '/' + contextualData.language)
                .then(function (response) {
                        fbc.form               = response;
                        fbc.saveForm = saveForm;
                        fbc.isPreviewAvailable = true;
                        fbc.currentStep        = currentStepBeforeSave === null ? null : 0;
                        //Get available inputs and prepare form for work in builder mode.
                        fbc.getInputsAndMakeBuilderReady();
                        fbc.getAvailableActions();
                        fbc.stepValidityCheck();
                        fbc.unassignedElementsCheck();
                        if (reloadForm) {
                            spinner.hide('buttonsSpinner');
                            toaster.pop({
                                type   : 'success',
                                title: i18n.message('angular.ffFormBuilderDirective.message.formReload'),
                                toastId: 4,
                                timeout: 3000
                            });
                            fbc.stepValidityCheck();
                            $timeout(function () {
                                if (currentStepBeforeSave === null) {
                                    fbc.currentStep = null;
                                    // anything you want can go here and will safely be run on the next digest.
                                    angular.element('a[href$="stepActionContent"]').click();
                                } else if (fbc.form.steps.length >= currentStepBeforeSave) {
                                    // anything you want can go here and will safely be run on the next digest.
                                    angular.element('a[href$="step-' + currentStepBeforeSave + '"]').click();
                                } else {
                                    // anything you want can go here and will safely be run on the next digest.
                                    angular.element('a[href$="step-0"]').click();
                                }
                            });
                        }
                    }
                );
        }

        /**
         * Gets the available actions
         */
        function getAvailableActions() {
            if (fbc.actionsCache === null) {
                ffDataFactory.customRequest({
                    url   : contextualData.context + '/modules/formfactory/builder/definitionslist/actions/' + contextualData.siteIdentifier + '/en',
                    method: 'GET'
                }).then(function (response) {
                    fbc.actionsCache = response;
                    fbc.prepareActions();
                });
            } else {
                fbc.prepareActions();
            }
        }

        /**
         * Loads inputs data if not yet loaded and prepares form for builder mode.
         */
        function getInputsAndMakeBuilderReady() {
            if (fbc.inputsCache === null) {
                ffDataFactory.customRequest({
                    url   : contextualData.context + '/modules/formfactory/builder/definitionslist/inputs/' + contextualData.siteIdentifier + '/en',
                    method: 'GET'
                }).then(function (response) {
                    fbc.inputsCache = response;
                    fbc.prepareFormForBuilder();
                });
            } else {
                fbc.prepareFormForBuilder();
            }
        }

        function resolveLogic(input, form) {
            return ffCommonUseFactory.logicResolver(input, form);
        }

        /**
         * Saves the form and returns promise
         *
         * @returns {*}
         */
        function performSaving() {
            fbc.prepareFormForJCR();
            return ffDataFactory.customRequest({
                url   : contextualData.context + '/modules/formfactory/builder/form/' + fbc.form.jcrId + '/' + contextualData.language,
                method: 'PUT',
                data  : fbc.form
            });
        }

        /**
         * Saves form and sets response as the new builder form
         */
        function saveForm() {
            spinner.show('buttonsSpinner');
            var currentStepBeforeSave = fbc.currentStep;
            performSaving().then(function (response) {
                fbc.form = response;
                if (creationFormName !== undefined) {
                    creationFormName = undefined;
                }
                fbc.currentStep = currentStepBeforeSave === null ? null : 0;
                //Get available inputs and prepare form for work in builder mode.
                fbc.getInputsAndMakeBuilderReady();
                fbc.getAvailableActions();
                fbc.isPreviewAvailable = true;
                spinner.hide('buttonsSpinner');
                toaster.pop({
                    type   : 'info',
                    title  : i18n.message('angular.ffFormBuilderDirective.message.previewForm'),
                    toastId: 2,
                    timeout: 3000
                });
                toaster.pop({
                    type   : 'success',
                    title  : i18n.message('angular.ffFormBuilderDirective.message.formSaved'),
                    toastId: 3,
                    timeout: 3000
                });
                $timeout(function () {
                    if (currentStepBeforeSave === null) {
                        fbc.currentStep = null;
                        // anything you want can go here and will safely be run on the next digest.
                        angular.element('a[href$="stepActionContent"]').click();
                    } else {
                        // anything you want can go here and will safely be run on the next digest.
                        angular.element('a[href$="step-' + currentStepBeforeSave + '"]').click();
                    }
                });
            });
        }

        function performFormCreation() {
            fbc.prepareFormForJCR();
            return ffDataFactory.customRequest({
                url   : contextualData.context + '/modules/formfactory/builder/form/' + contextualData.language + '/targetsite/' + contextualData.siteIdentifier,
                method: 'POST',
                data  : fbc.form
            });
        }

        /**
         * Saves form in JCR and sets response to fbc.form
         */
        function createForm() {
            spinner.show('buttonsSpinner');
            var currentStepBeforeSave = fbc.currentStep;
            performFormCreation().then(function (response) {
                fbc.form                     = response;
                $state.params.formIdentifier = response.jcrId;
                fbc.currentStep              = currentStepBeforeSave === null ? null : 0;
                fbc.getInputsAndMakeBuilderReady();
                fbc.getAvailableActions();
                fbc.isPreviewAvailable = true;
                spinner.hide('buttonsSpinner');
                toaster.pop({
                    type   : 'info',
                    title  : i18n.message('angular.ffFormBuilderDirective.message.previewForm'),
                    toastId: 2,
                    timeout: 3000
                });
                toaster.pop({
                    type   : 'success',
                    title  : i18n.message('angular.ffFormBuilderDirective.message.formSaved'),
                    toastId: 3,
                    timeout: 3000
                });
                $timeout(function () {
                    if (currentStepBeforeSave === null) {
                        fbc.currentStep = null;
                        // anything you want can go here and will safely be run on the next digest.
                        angular.element('a[href$="stepActionContent"]').click();
                    } else if (fbc.form.steps.length >= currentStepBeforeSave) {
                        // anything you want can go here and will safely be run on the next digest.
                        angular.element('a[href$="step-' + currentStepBeforeSave + '"]').click();
                    } else {
                        // anything you want can go here and will safely be run on the next digest.
                        angular.element('a[href$="step-0"]').click();
                    }
                });
            });
        }

        function test() {
            ffDataFactory.customRequest({
                url   : contextualData.context + '/modules/formfactory/builder/definitionslist/validations/' + contextualData.siteIdentifier + '/en',
                method: 'GET'
                //data: fbc.form
            }).then(function (response) {
                //fbc.form = response;
                //fbc.saveForm = saveForm;
            });
        }

        /**
         * Shows edit input panel
         *
         * @param index
         */
        function showEditInput(index) {
            fbc.headerMessage      = i18n.message('angular.ffFormBuilderDirective.title.editInput');
            fbc.selectedInputIndex = index;
            fbc.editInput          = true;
            fbc.inPreviewIndex     = index;
            showSidePanel();
            ffValidationService.runValidationWorker(contextualData.context, 'stepValidationWorker.js');
        }

        /**
         * Shows available inputs.
         *
         * @function
         */
        function showInputs() {
            if (fbc.inputsCache === null) {
                ffDataFactory.customRequest({
                    url   : contextualData.context + '/modules/formfactory/builder/definitionslist/inputs/' + contextualData.siteIdentifier + '/en',
                    method: 'GET'
                }).then(function (response) {
                    fbc.inputsCache   = response;
                    fbc.headerMessage = i18n.message('angular.ffFormBuilderDirective.title.addInput');
                    prepareDisplayableInputs();
                });
            } else {
                fbc.headerMessage = i18n.message('angular.ffFormBuilderDirective.title.addInput');
                prepareDisplayableInputs();
            }
        }

        /**
         * Transform input/action data into an input/action object to be placed inside a step/action list
         *
         * @param name
         * @returns {*}
         */
        function transformToElement(name, elementType) {
            if (elementType === 'input') {
                var data  = null;
                var input = {};
                var ins   = fbc.inputsCache;
                for (var i in ins) {
                    if (ins[i].name === name) {
                        data = angular.copy(ins[i]);
                    }
                }
                if (data !== null) {
                    data.layoutUUID = generateUUID();
                    input           = data;
                }
                return input;
            }
            if (elementType === 'action') {
                var data   = null;
                var action = {};
                var ins    = fbc.actionsCache;
                for (var i in ins) {
                    if (ins[i].actionname === name) {
                        data = angular.copy(ins[i]);
                    }
                }
                if (data !== null) {
                    action = data;
                }
                return action;
            }
        }

        /**
         * Populates current inputs or actions array and sets inPreviewIndex to index of the added input/action.
         *
         * @param name
         * @param elementType String 'input' or 'action'
         */
        function previewElement(name, elementType) {
            function generateName(inputName, number) {
                return inputName + '_' + fbc.currentStep + '_' + (fbc.form.steps[fbc.currentStep].inputs.length + number);
            }

            switch (elementType) {
                case 'input' :
                    var input  = fbc.transformToElement(name, elementType);
                    var number = 1;
                    var inputName = input.name;
                    input.name = generateName(inputName, number);
                    while(_.findIndex(fbc.form.steps[fbc.currentStep].inputs,{name:input.name}) > -1) {
                        input.name = generateName(inputName, number++);
                    }
                    fbc.inPreviewIndex = fbc.form.steps[fbc.currentStep].inputs.length;
                    fbc.form.steps[fbc.currentStep].inputs.push(input);
                    break;
                case 'action' :
                    var action         = fbc.transformToElement(name, elementType);
                    fbc.inPreviewIndex = fbc.form.actions.length;
                    fbc.form.actions.push(action);
            }
        }

        /**
         * Cancels preview for inputs or actions by reseting inPreviewIndex back to -1 which implies that no
         * element is in preview and rolling back changes to the form.
         *
         * @param elementType
         */
        function cancelPreview(elementType) {
            if (elementType === 'input') {
                if (fbc.inPreviewIndex !== -1) {
                    var inputs = [];
                    var ins    = fbc.form.steps[fbc.currentStep].inputs;
                    for (var i in ins) {
                        if (i != fbc.inPreviewIndex) {
                            inputs.push(ins[i]);
                        }
                    }
                    fbc.form.steps[fbc.currentStep].inputs = inputs;
                }
                fbc.inPreviewIndex = -1;
                return;
            }
            if (elementType === 'action') {
                if (fbc.inPreviewIndex !== -1) {
                    var actions = [];
                    var ins     = fbc.form.actions;
                    for (var i in ins) {
                        if (i != fbc.inPreviewIndex) {
                            actions.push(ins[i]);
                        }
                    }
                    fbc.form.actions = actions;
                }
                fbc.inPreviewIndex = -1;
                return;
            }
        }

        /**
         * Resets inPreviewIndex to -1 and keeps changes to the form object
         */
        function keepPreviewed(input, type) {
            if (fbc.currentStep !== null) {
                if (ffLayoutService.isActive()) {
                    ffLayoutService.handleInputAdd(fbc.currentStep, fbc.form.steps[fbc.currentStep].inputs[fbc.inPreviewIndex].layoutUUID);
                    fbc.unassignedElementsCheck();
                }
            }
            fbc.inPreviewIndex = -1;
            fbc.stepValidityCheck();
            $window.scrollTo(0, document.body.scrollHeight);
            fbc.previewElement(input, type);
            toaster.pop({
                type   : 'success',
                title  : i18n.message('angular.ffFormBuilderDirective.message.elementAdded'),
                timeout: 2000,
                toastId: Math.random()
            });
        }

        function showSidePanel() {
            fbc.isSidePanelDisplayed = true;
            var element              = angular.element('body');
            element.addClass('modal-open');
            jQuery(document.createElement('div'))
                .addClass('modal-backdrop in')
                .appendTo(element);
        }

        function hideSidePanel() {
            var element = angular.element('body');
            element.removeClass('modal-open');
            angular.element('.modal-backdrop').remove();
            fbc.isSidePanelDisplayed = false;
            fbc.editInput            = false;
            fbc.addInput             = false;
            fbc.addAction            = false;
            fbc.editAction           = false;
            fbc.editMetaData         = false;
            fbc.inPreviewIndex       = -1;

        }

        function getFormController() {
            //remove dashes and spaces
            var formName = $filter('sanitizeFormName')(fbc.getFormName());
            return $scope[formName];
        }

        function prepareDisplayableInputs() {
            var columnCounter = {};
            _.each(fbc.inputsCache, function (input, index) {
                if (input.tab === 'hiddenbutton') {
                    return;
                }
                if (!(input.tab in columnCounter)) {
                    columnCounter[input.tab]         = 0;
                    fbc.displayableInputs[input.tab] = [];
                    fbc.displayableInputs[input.tab].push([]);
                }
                fbc.displayableInputs[input.tab][fbc.displayableInputs[input.tab].length - 1].push(input);
                columnCounter[input.tab]++;

                if (columnCounter[input.tab] % fbc.nbColumnsInSidePanel === 0) {
                    fbc.displayableInputs[input.tab].push([]);
                }
            });
        }

        /**
         * This function will open the meta data panel
         * @function
         */
        function openMetaDataPanel() {
            fbc.headerMessage = i18n.message('fcnt_metaData');
            fbc.editMetaData  = true;
            showSidePanel();
        }

        /**
         * @function reload the existing form.
         */
        function reloadForm() {
            spinner.show('buttonsSpinner');
            if ($state.params.formIdentifier == null) {
                var currentStepBeforeSave = fbc.currentStep;
                fbc.form                  = angular.copy($state.params.form);
                if (angular.isUndefined($state.params.options) || !('doNotAddStep' in $state.params.options)) {
                    addStep();
                }
                fbc.getInputsAndMakeBuilderReady();
                fbc.getAvailableActions();
                spinner.hide('buttonsSpinner');
                toaster.pop({
                    type   : 'success',
                    title  : i18n.message('angular.ffFormBuilderDirective.message.formReload'),
                    toastId: 4,
                    timeout: 3000
                });
                fbc.stepValidityCheck();
                fbc.unassignedElementsCheck();
                $timeout(function () {
                    if (currentStepBeforeSave === null) {
                        fbc.currentStep = null;
                        // anything you want can go here and will safely be run on the next digest.
                        angular.element('a[href$="stepActionContent"]').click();
                    } else {
                        // anything you want can go here and will safely be run on the next digest.
                        angular.element('a[href$="step-0"]').click();
                    }
                });
            } else {
                fbc.getData(true);
            }
        }

        /**
         * This function places the builder into preview mode
         * @function
         */
        function previewForm() {
            fbc.previewModal = $uibModal.open({
                templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/previewFormModal.html',
                size       : 'lg',
                windowClass: 'preview-modal',
                animation  : true,
                scope      : $scope
            });
            fbc.previewModal.rendered.then(function() {
                spinner.show("previewSpinner");
            });
        }

        /**
         * Closes preview modal
         * @function
         */
        function closePreviewModal() {
            spinner.hide("previewSpinner");
            fbc.previewModal.close();
        }

        /**
         * Sets the current view mode of the form
         * @function
         */
        function setDisplayMode(mode) {
            //Do nothing if we are in translate mode
            if (fbc.inTranslateMode) {
                return;
            }
            if (mode === 'layout') {
                //run worker to check for unassigned inputs on current step if layout is enabled
                if (ffLayoutService.isActive()) {
                    fbc.unassignedElementsCheck();
                    $timeout(function () {
                        $scope.$broadcast('gainColumnFocus', null);
                    });
                }
            }
            fbc.displayMode = mode;
        }

        /**
         * Responsible for activating/deactivating layout
         * @function
         */
        function manageLayout() {
            if (getLayout().active) {
                ffLayoutService.activate();
                ffLayoutService.prepareSteps(fbc.form.steps.length);
                fbc.unassignedElementsCheck();
            } else {
                ffLayoutService.deactivate();
                fbc.unassignedElementsCheck();
                $scope.$broadcast('resetAvailableInputs', null);
                //ffLayoutService.setBaseLayout();
                ffLayoutService.setBaseForSteps(fbc.form.steps.length);
            }
        }

        function getLayout() {
            return ffLayoutService.getLayout();
        }

        /**************************************************************************************************************/
        /***********************************************Actions management*********************************************/
        /**************************************************************************************************************/

        /**
         * This function is responsible for merging available actions with existing actions
         * @function
         */
        function prepareActions() {
            //If there were no previously added actions create the array that contains them.
            if (typeof fbc.form.actions === 'undefined') {
                fbc.form.actions = [];
            }
            //store cache keys under the action name to easily access cache when traversing the form actions
            var actionCacheNames = {};
            _.each(fbc.actionsCache, function (action, actionKey) {
                actionCacheNames[action.actionname] = actionKey;
            });
            for (var i in fbc.form.actions) {
                //if action does not exist in available actions remove it.
                if (!(fbc.form.actions[i].actionname in actionCacheNames)) {
                    delete fbc.form.actions[i];
                    continue;
                }
                //merge fields
                delete fbc.form.actions[i].definitionOptionsTranslatable;
                delete fbc.form.actions[i].definitionOptions;
                fbc.form.actions[i] = angular.merge({}, fbc.actionsCache[actionCacheNames[fbc.form.actions[i].actionname]], fbc.form.actions[i]);
                _.each(fbc.form.actions[i], function (field, fieldName) {
                    if (!(fieldName in fbc.actionsCache[actionCacheNames[fbc.form.actions[i].actionname]])) {
                        delete fbc.form.actions[i][fieldName];
                    }
                });
            }
        }

        function removeAction(index) {
            var actions = [];
            for (var i in fbc.form.actions) {
                if (i != index) {
                    actions.push(fbc.form.actions[i]);
                }
            }
            fbc.form.actions = actions;
            fbc.stepValidityCheck();
        }

        /**
         * Opens the side panel and to allow editing of the currently selected action
         * @param index - index of the action
         */
        function showEditAction(index) {
            fbc.editAction          = true;
            fbc.headerMessage       = i18n.message('angular.ffElementManagementBox.title.editAction');
            fbc.selectedActionIndex = index;
            fbc.inPreviewIndex      = index;
            showSidePanel();
        }

        /**
         * Opens side panel to show available actions that can be added to the form.
         * @function
         */
        function showActions() {
            fbc.addAction     = true;
            fbc.headerMessage = i18n.message('angular.ffFormBuilderDirective.title.addFormAction');
            getAvailableActions();
            showSidePanel();
        }

        /**
         * Retrieves and returns the key of the currently selected action.
         * @returns {string} - key of the currently selected action
         */
        function getActionKeyName() {
            var actionKeyName = '';
            _.each(fbc.actionsCache, function (action, actionKey) {
                if (action.actionname === fbc.form.actions[fbc.selectedActionIndex].actionname) {
                    actionKeyName = actionKey;
                }
            });
            return actionKeyName;
        }

        /**************************************************************************************************************/
        /***********************************************Steps management***********************************************/
        /**************************************************************************************************************/

        /**
         * Removes step specified by the index.
         *
         * @param index
         */
        function removeStep(index) {
            if (fbc.currentStep === index) {
                fbc.form.steps.splice(index, 1);
                ffLayoutService.removeStep(index);
                fbc.currentStep = fbc.currentStep > 0 ? --fbc.currentStep : 0;
                $timeout(function () {
                    if (fbc.form.steps.length > 0) {
                        // anything you want can go here and will safely be run on the next digest.
                        angular.element('a[href$="step-' + fbc.currentStep + '"]').click();
                    }
                });

            }
            fbc.stepValidityCheck();
            fbc.unassignedElementsCheck();
        }

        /**
         * Adds a step to form.
         */
        function addStep() {
            var newStepNumber = fbc.form.steps.length + 1;
            var newStep       = {
                'jcrId' : null,
                'label' : 'Step' + ' ' + newStepNumber,
                'inputs': []
            };
            fbc.form.steps.push(newStep);
            ffLayoutService.addStep();
            fbc.stepValidityCheck();
        }

        function moveStep(newIndex) {
            var stepToMove                  = fbc.form.steps[fbc.currentStep];
            fbc.form.steps[fbc.currentStep] = fbc.form.steps[newIndex];
            fbc.form.steps[newIndex]        = stepToMove;
            ffLayoutService.moveStep(newIndex, fbc.currentStep);
            updateCurrentStep(newIndex);
            fbc.stepValidityCheck();
        }

        /**
         * Updates current step of the form.
         *
         * @param index
         */
        function updateCurrentStep(index) {
            fbc.currentStep = index;
            //run worker to check for unassigned inputs on current step if layout is enabled
            if (fbc.displayMode === 'layout' && ffLayoutService.isActive()) {
                fbc.unassignedElementsCheck();
                $timeout(function () {
                    $scope.$broadcast('gainColumnFocus', null);
                });
            }
        }

        /**************************************************************************************************************/
        /***********************************Input/Action position management related***********************************/
        /**************************************************************************************************************/

        /**
         * Moves input within the form.
         *
         * @param targetStepIndex
         * @param targetIndex
         */
        function moveInput(targetStepIndex, targetIndex) {
            var input = angular.copy(fbc.form.steps[fbc.currentStep].inputs[fbc.moveInputIndex]);
            if (ffLayoutService.isActive()) {
                ffLayoutService.handleInputMove(fbc.currentStep, targetStepIndex, input.layoutUUID);
            }
            if (fbc.currentStep !== targetStepIndex) {
                input.jcrId = null;
                nullifyJCRIdsForValidationsAndLogics(input);
            }
            //Place input on top or at the bottom depending on targetIndex value
            if (targetIndex < 1000) {
                if (fbc.moveInputIndex < targetIndex) { //Need to remove input after move in this case
                    putInputInPosition(input, targetStepIndex, targetIndex);
                    removeInputFromPosition(fbc.currentStep, fbc.moveInputIndex);
                } else {
                    removeInputFromPosition(fbc.currentStep, fbc.moveInputIndex);
                    putInputInPosition(input, targetStepIndex, targetIndex);
                }
            }//Move input at the end of inputs array
            else {
                removeInputFromPosition(fbc.currentStep, fbc.moveInputIndex);
                putInputInPosition(input, targetStepIndex, fbc.form.steps[targetStepIndex].inputs.length);
            }
            fbc.stepValidityCheck();
            fbc.unassignedElementsCheck();
        }

        /**
         * Nullifies jcrIds in logics and validations (this is needed when we move input from step to step)
         *
         * @param input
         */
        function nullifyJCRIdsForValidationsAndLogics(input) {
            for (var i in input.validations) {
                input.validations[i].jcrId = null;
            }
            for (var j in input.logics) {
                input.logics[j].jcrId = null;
            }
        }

        /**
         * Insert object into a given step in a given position.
         *
         * @param obj
         * @param stepIndex
         * @param positionIndex
         */
        function putInputInPosition(obj, stepIndex, positionIndex) {
            fbc.form.steps[stepIndex].inputs.splice(positionIndex, 0, obj);
        }

        /**
         * Removes object from a given step and given position.
         *
         * @param stepIndex
         * @param positionIndex
         */
        function removeInputFromPosition(stepIndex, positionIndex) {
            fbc.form.steps[stepIndex].inputs.splice(positionIndex, 1);
        }

        /**
         * Removes input (identified by index) from current step.
         *
         * @function
         * @memberOf ffController
         * @param index
         */
        function removeInput(index) {
            var newInputs = [];
            var inputs    = fbc.form.steps[fbc.currentStep].inputs;
            ffLayoutService.handleInputRemoval(fbc.currentStep, inputs[index].layoutUUID);
            for (var i in inputs) {
                if (i != index) {
                    newInputs.push(inputs[i]);
                }
            }
            fbc.form.steps[fbc.currentStep].inputs = newInputs;
            fbc.stepValidityCheck();
            fbc.unassignedElementsCheck();
        }

        /**
         * Moves input or action up or down.
         *
         * @param index
         * @param direction
         * @param target
         */
        function moveUpOrDown(index, direction, target) {
            switch (direction) {
                case 'up' :
                    if (target === 'input') {
                        if (fbc.form.steps[fbc.currentStep].inputs[index - 1] !== undefined) {
                            var inputAbove                                    = fbc.form.steps[fbc.currentStep].inputs[index - 1];
                            var currentInput                                  = fbc.form.steps[fbc.currentStep].inputs[index];
                            fbc.form.steps[fbc.currentStep].inputs[index - 1] = currentInput;
                            fbc.form.steps[fbc.currentStep].inputs[index]     = inputAbove;
                        }
                        return;
                    }
                    if (fbc.form.actions[index - 1] !== undefined) {
                        var actionAbove             = fbc.form.actions[index - 1];
                        var currentAction           = fbc.form.actions[index];
                        fbc.form.actions[index - 1] = currentAction;
                        fbc.form.actions[index]     = actionAbove;
                    }
                    break;
                case 'down' :
                    if (target === 'input') {
                        if (fbc.form.steps[fbc.currentStep].inputs[index + 1] !== undefined) {
                            var inputBelow                                    = fbc.form.steps[fbc.currentStep].inputs[index + 1];
                            var currentInput                                  = fbc.form.steps[fbc.currentStep].inputs[index];
                            fbc.form.steps[fbc.currentStep].inputs[index + 1] = currentInput;
                            fbc.form.steps[fbc.currentStep].inputs[index]     = inputBelow;
                        }
                        return;
                    }
                    if (fbc.form.actions[index + 1] !== undefined) {
                        var actionBelow             = fbc.form.actions[index + 1];
                        var currentAction           = fbc.form.actions[index];
                        fbc.form.actions[index + 1] = currentAction;
                        fbc.form.actions[index]     = actionBelow;
                    }
                    break;
            }
        }

        /**************************************************************************************************************/
        /***********************Below are methods necessary for manipulation of fbc.form object************************/
        /**************************************************************************************************************/

        /**
         * This method makes sure that all inputs have all the needed information like supported validation types etc.
         * which is necessary for form to correctly function when we create input from scratch and when we load it
         * from JCR.
         */
        function prepareFormForBuilder() {
            for (var i in fbc.form.steps) {
                for (var j in fbc.form.steps[i].inputs) {
                    makeConsistentWithDefaultInput(i, j);
                }
            }
            //Create json object from layout string if it exists
            if (!_.isUndefined(fbc.form.layoutJson) && !_.isEmpty(fbc.form.layoutJson)) {
                ffLayoutService.setExistingLayout(JSON.parse(fbc.form.layoutJson));
            }
            ffLayoutService.prepareSteps(fbc.form.steps.length);
            delete fbc.form.layoutJson;
            processRouteOptions();
        }

        /**
         * Handles all necessary operations associated with parameters passed to the builder route.
         */
        function processRouteOptions() {
            //Manage metadata panel
            if ('openEditMetaDataPanel' in $state.params.options) {
                //unset the option so that if we render the form again it doesn't keep open the meta data panel again
                delete $state.params.options.openEditMetaDataPanel;
                openMetaDataPanel();
            }
            //Manage translation state
            fbc.inTranslateMode = !!('translate' in $state.params.options);
        }

        /**
         * Verifies that attributes on the existing input model are the same as the ones on the default model.
         * That means that adding/removing attributes from wizard (input model) will ultimately transform the input.
         *
         * @param i
         * @param j
         */
        function makeConsistentWithDefaultInput(i, j) {
            var mandatoryFields = ['jcrId', 'choiceField', 'validations', 'logics', '$$hashKey', 'value', 'layoutUUID'];

            for (var k in fbc.inputsCache) {
                if (fbc.inputsCache[k].nodeType === fbc.form.steps[i].inputs[j].nodeType) {
                    //Add missing fields
                    for (var key in fbc.inputsCache[k]) {
                        if (!(key in fbc.form.steps[i].inputs[j]) && key !== '$$hashKey') {
                            fbc.form.steps[i].inputs[j][key] = angular.copy(fbc.inputsCache[k][key]);
                        }
                    }
                    //Add unique identifier that will be used to keep track of input in the layout.
                    if (!('layoutUUID' in fbc.form.steps[i].inputs[j])) {
                        fbc.form.steps[i].inputs[j].layoutUUID = generateUUID();
                    }
                    //Remove fields that no longer exist
                    for (var key in fbc.form.steps[i].inputs[j]) {
                        if (!isMandatory(key) && !(key in fbc.inputsCache[k])) {
                            delete fbc.form.steps[i].inputs[j][key];
                        }
                    }
                    fbc.form.steps[i].inputs[j]['definitionOptionsTranslatable'] = angular.copy(fbc.inputsCache[k]['definitionOptionsTranslatable']);
                    fbc.form.steps[i].inputs[j]['definitionOptions']             = angular.copy(fbc.inputsCache[k]['definitionOptions']);
                }
            }

            function isMandatory(key) {
                for (var i in mandatoryFields) {
                    if (key === mandatoryFields[i]) {
                        return true;
                    }
                }
                return false;
            }
        }

        /**
         * Removes unnecessary information on the form.
         */
        function prepareFormForJCR() {
            for (var i in fbc.form.steps) {
                for (var j in fbc.form.steps[i].inputs) {
                    //Remove unneeded fields
                    deleteFields(i, j);
                    //Create null fields in they don't exist
                    createNullFields(i, j);
                    for (var k in fbc.form.steps[i].inputs[j].validations) {
                        if (fbc.form.steps[i].inputs[j].validations[k].active === false) {
                            delete fbc.form.steps[i].inputs[j].validations[k];
                        } else {
                            delete fbc.form.steps[i].inputs[j].validations[k].types;
                            delete fbc.form.steps[i].inputs[j].validations[k].active;
                            if (fbc.form.steps[i].inputs[j].validations[k].jcrId === undefined) {
                                fbc.form.steps[i].inputs[j].validations[k].jcrId = null;
                            }
                        }
                    }
                }
            }
            //Remove progress bar
            if (fbc.form.progressBar !== null && fbc.form.progressBar.show === false) {
                delete fbc.form.progressBar;
            }
            if (fbc.form.expectedFormName !== undefined) {
                delete fbc.form.expectedFormName;
            }
            //Add Layout to the form.
            fbc.form.layoutJson = JSON.stringify(ffLayoutService.getLayout());
        }

        function deleteFields(currentStep, inputNumber) {
            var fields = ['supportedLogicTypes', 'supportedValidationTypes'];
            for (var i in fields) {
                delete fbc.form.steps[currentStep].inputs[inputNumber][fields[i]];
            }
        }

        function createNullFields(currentStep, inputNumber) {
            var fields = ['jcrId', 'choiceField'];
            for (var i in fields) {
                if (fbc.form.steps[currentStep].inputs[inputNumber][fields[i]] === undefined) {
                    fbc.form.steps[currentStep].inputs[inputNumber][fields[i]] = null;
                }
            }
        }

        /**************************************************************************************************************/
        /*******************************************i18n related functions*********************************************/
        /**************************************************************************************************************/
        function i18nMessageGetter(key) {
            return i18n.message(key);
        }

        /**************************************************************************************************************/
        /*******************************************Validation related*************************************************/
        /**************************************************************************************************************/

        /**
         * This function handles validation responses
         *
         * @param data
         */
        function processWorkerResponse(data) {
            $timeout(function () {
                $scope.$apply(function () {
                    if (fbc[data.flag] !== undefined) {
                        fbc.workerRunning = true;
                        fbc[data.flag] = data.flagValue;
                    }
                    if (data.initialCall === undefined || data.initialCall === false) {
                        ffValidationService.handleCallbacks(data);
                        fbc.workerRunning = false;
                    }
                });
            });
        }

        fbc.test = function () {
            console.log('Testing!!!');
        };

        /**
         * Determine is input has supported logics.
         *
         * @returns {boolean}
         */
        function inputHasSupportedLogics() {
            return !_.isUndefined(fbc.form.steps[fbc.currentStep].inputs[fbc.selectedInputIndex].supportedLogicTypes);
        }

        /**
         * Determines if input has supported validations
         * @returns {boolean}
         */
        function inputHasSupportedValidations() {
            return !_.isUndefined(fbc.form.steps[fbc.currentStep].inputs[fbc.selectedInputIndex].supportedValidationTypes);
        }

        function isTranslatable() {
            return !fbc.inTranslateMode && (angular.isObject(fbc.form.missingLanguages) || (Object.keys(fbc.form.existingLanguages).length > 1));
        }

        function isLiveMode() {
            return false;
        }

        function getTabHeading(tab) {
            return fbc.i18nMessageGetter('angular.ffEditInputTabsDirective.tab.heading.' + $filter('lowercase')(tab));
        }

        //Retrieved from http://stackoverflow.com/questions/105034/create-guid-uuid-in-javascript
        function generateUUID() {
            var d = Date.now();
            if ($window.performance && typeof $window.performance.now === "function") {
                d += performance.now(); //use high-precision timer if available
            }
            var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                var r = (d + Math.random() * 16) % 16 | 0;
                d     = Math.floor(d / 16);
                return (c == 'x' ? r : (r & 0x3 | 0x8)).toString(16);
            });
            return uuid;
        }

        /**
         * Hide preview spinner once iframe is loaded
         */
        $window.hidePreviewSpinner = function () {
            $timeout(function () {
                $scope.$apply(function () {
                    spinner.hide('previewSpinner');
                });
            }, 2500);
        };

        /**
         * Sets the src for the iframe in the preview modal if it hasn't yet been set.
         */
        $window.setupPreviewModalIFrameSrc = function () {
            var previewFormPath = contextualData.urlBase + contextualData.sitePath + '/formFactory/forms/' + fbc.form.formName + '.preview.html?isPreviewMode=true';
            if (angular.element('.previewModalIFrame').attr('src') != previewFormPath) {
                angular.element('.previewModalIFrame').attr('src', previewFormPath);
            }
        };

        /**************************************************************************************************************/
        /*******************************************Save changes warning***********************************************/
        /**************************************************************************************************************/

        function warnIfUnsaved() {
            fbc.unsavedWarning = $uibModal.open({
                templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/saveChangesWarning.html',
                size       : 'md',
                windowClass: 'save-warning',
                animation  : true,
                scope      : $scope
            });
        }

        function backToLibrary() {
            fbc.warnIfUnsaved();
        }

        function handleBackToLibraryAction(typeOfTransition) {
            switch (typeOfTransition) {
                case 'save' :
                    if (fbc.form.jcrId === null) {
                        performFormCreation().then(function () {
                            fbc.unsavedWarning.dismiss('cancel');
                            $state.go('library');
                        });
                    }
                    else {
                        performSaving().then(function () {
                            fbc.unsavedWarning.dismiss('cancel');
                            $state.go('library');
                        });
                    }
                    break;
                case 'exit' :
                    fbc.unsavedWarning.dismiss('cancel');
                    $state.go('library');
                    break;
                case 'stay' :
                    fbc.unsavedWarning.dismiss('cancel');
                    break;
            }
        }

        var creationFormName;

        function getFormName() {
            if (creationFormName !== undefined) {
                return creationFormName;
            }
            if (fbc.form === undefined) {
                return undefined;
            }
            if (fbc.form.expectedFormName != undefined) {
                creationFormName = fbc.form.expectedFormName;
                return fbc.form.expectedFormName;
            } else {
                return fbc.form.formName;
            }
        }
    };

    FormBuilderController.$inject = ['$scope', '$log', '$state', 'ffDataFactory', 'ffCommonUseFactory',
        'ffUpdaterFactory', 'contextualData', 'i18nService', '$timeout', '$uibModal',
        'toaster', 'ffValidationWorker', '$filter', 'ffLayoutService', 'ffSpinnerService', '$window', '_'];

    var formBuilderDirective = function ($log, contextualData) {
        var directive = {
            restrict        : 'E',
            templateUrl     : contextualData.urlBaseSiteSettingsTemplates + 'builder.html.ajax',
            controller      : FormBuilderController,
            controllerAs    : 'fbc',
            bindToController: true,
            link            : linkFunction
        };

        return directive;

        function linkFunction(scope, el, attr) {
            //
        }
    };

    angular.module('formFactory')
        .directive('ffController', ['$log', 'contextualData', formBuilderDirective]);
})();
(function () {
	'use strict';

	var inputTypeDirective = function($log, toaster) {
		var directive = {
			restrict: 'A',
			require: ['^ngModel'],
			link: linkFunction
		};

		return directive;

		function linkFunction(scope, el, attr, ctrl) {
			var type = attr['ffInputType'];
			var ngModelCtrl = ctrl[0];

			/**
			 * This function is responsible for parsing the entered text into a valid number
			 * @function
			 * @param text - view value text being parsed
             * @returns {*} - parsed value, undefined if no value
             */
			function number(text) {
				if (text) {
					var transformedInput = text.replace(/[^0-9]/g, '');
					if (transformedInput !== text) {
						ngModelCtrl.$setViewValue(transformedInput);
						ngModelCtrl.$render();
					}
					return transformedInput;
				}
				return undefined;
			}

			/**
			 * This function is responsible for parsing the entered text into a valid float
			 * @function
			 * @param text - view value text being parsed
			 * @returns {*} - parsed value, undefined if no value
			 */
			function float(text) {
				if (text) {
					var transformedInput = text.replace(/[^0-9\.]/g, '');
					if (transformedInput !== text) {
						ngModelCtrl.$setViewValue(transformedInput);
						ngModelCtrl.$render();
					}
					return transformedInput;
				}
				return undefined;
			}

			if (type === 'number') {
				ngModelCtrl.$parsers.push(number);
			}
			else if (type === 'float') {
				ngModelCtrl.$parsers.push(float);
			}
			else if (type === 'string') {
				//Do nothing
			}

		}
	};
	angular
		.module('formFactory')
		.directive('ffInputType', ['$log', inputTypeDirective]);
})();(function() {
    'use strict';

    var stringToNumberDirective = function($log) {

        var directive = {
            restrict: 'A',
            require: ['^ngModel'],
            link: linkFunction
        };

        return directive;

        function linkFunction(scope, el, attr, ctrls) {
            var model = ctrls[0];
            model.$parsers.push(function(value) {
                return '' + parseInt(value);
            });
            model.$formatters.push(function(value) {
                return parseInt(value);
            });
        }
    };

    angular
        .module('formFactory')
        .directive('stringToNumber',  ['$log', stringToNumberDirective]);
})();(function () {
	'use strict';

	var validationWorker = function ($log, i18n, toaster) {
		this.ctrl = null;
		this.additionalCtrls = {};
		this.toastTracker = {};
		this.toastTracker.CIS = {}; //Object for containsInvalidStep validation
		this.toastTracker.SCUE = {}; //Object for stepContainsUnassignedElements
		this.setController = function (ctrl) {
			this.ctrl = ctrl;
		};

		this.setAdditionalController = function (ctrl, name) {
			this.additionalCtrls[name] = ctrl;
		};

		/**
		 * This function spawns a web worker and returns a function that accepts a callback for setting of a flag,
		 * initial value for the flag (must be one that disables flag dependencies), and data passed to the web worker.
		 *
		 * The web worker should return boolean for setting of the flag once its work is complete.
		 *
		 * @param context
		 * @param workerName
		 * @returns {Function}
		 */
		this.runValidationWorker = function (context, workerName) {
			var ctrl = this.ctrl;
			if (window.Worker) {
				var callback;
				var validationWorker = new Worker(context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/' + workerName);

				validationWorker.onmessage = function (e) {
					//Set the flag to the value returned by the worker
					callback.call(ctrl, e.data);
				};

				return function (data) {
					callback = ctrl['processWorkerResponse'];
					//Set initial value for the flag being set by the callback
					callback.call(ctrl, data);
					validationWorker.postMessage(data);
				}
			}
			//Make sure we disable validation if web workers are not supported
			return function (data) {
				ctrl['processWorkerResponse'].call(ctrl, data);
				$log.error("Your browser does not support web workers, migrate to something a bit less archaic!!!")
			};
		};

		/**
		 * Handles validation callbacks. It calls the callback in the scope of this class and/or ctrl depending on
		 * where it is defined
		 *
		 * @param obj
		 */
		this.handleCallbacks = function (obj) {
			for (var i in obj.callbacks) {
				//Handle callback on current object
				if (typeof this[obj.callbacks[i].callback] === 'function') {
					this[obj.callbacks[i].callback].apply(this, [obj.callbacks[i].args, obj.flagValue]);
				} //Handle callback on the main controller
				else if (typeof this.ctrl[obj.callbacks[i].callback] === 'function') {
					this.ctrl[obj.callbacks[i].callback].call(this.ctrl, obj.callbacks[i].args);
				}
				else { //Handle callback on additional controller
					for (var j in this.additionalCtrls) {
						if (typeof this.additionalCtrls[j][obj.callbacks[i].callback] === 'function') {
							this.additionalCtrls[j][obj.callbacks[i].callback].call(this.additionalCtrls[j], obj.callbacks[i].args);
							return;
						}
					}
				}
			}
		};

		/**************************************************************************************************************/
		/**************************************************Callbacks***************************************************/
		/**************************************************************************************************************/

		/**
		 * Notifies user of an invalid step in the form
		 *
		 * @param args
		 * @param flagValue
		 */
		this.notifyUserOfInvalidStep = function (args, flagValue) {
			if (this.ctrl.containsInvalidStep) {
				for (var i in args) {
					var arg = args[i];
					if (this.toastTracker.CIS[i] === undefined || this.needToShowWhenCaseDefined(i)) {
						toaster.pop({
							type: 'error',
							title: i18n.message('angular.ffFormBuilderDirective.title.invalidStep'),
							body: i18n.format(arg.validationMessage, arg.errorInfo),
							toastId: arg.toastId,
							onHideCallback: function () {
								console.log("Step validation callback!!!");
							}
						});
						this.toastTracker.CIS[i] = {};
						this.toastTracker.CIS[i].validationMessage = arg.validationMessage;
						this.toastTracker.CIS[i].showingToast = true;
						this.toastTracker.CIS[i].toastId = arg.toastId;
						this.toastTracker.CIS[i].errorInfo = arg.errorInfo;
						this.toastTracker.CIS[i].stepIndex = arg.stepIndex;
						this.toastTracker.CIS[i].actionIndex = arg.actionIndex;
					}
				}
			}
			//Update validationMessage status
			var toRemove = [];
			for (var i in this.toastTracker.CIS) {
				if (!(i in args) && this.toastTracker.CIS[i].showingToast) {
					toRemove.push(i);
					toaster.pop({
						type: 'success',
						title: i18n.message('angular.ffFormBuilderDirective.title.validSteps'),
						body: this.makeBody(i),
						toastId: this.toastTracker.CIS[i].toastId
					});
					this.toastTracker.CIS[i].showingToast = false;
				}
			}

			//Remove resolved errors
			for (var i in toRemove) {
				delete this.toastTracker.CIS[toRemove[i]];
			}
		};

		/**
		 * Determines if the toast is shown when a given case (i.e. emptyStep) has been registered in CIS object
		 *
		 * @param currentCase
		 * @returns {boolean}
		 */
		this.needToShowWhenCaseDefined = function(currentCase) {
			return this.toastTracker.CIS[currentCase] !== undefined
					&& (!this.toastTracker.CIS[currentCase].showingToast
					|| currentCase === 'emptyStep' || currentCase === 'invalidActionFields');
		};

		/**
		 * Generates body for success message based on particular case
		 *
		 * @returns {string}
		 */
		this.makeBody = function(switchCase) {
			switch(switchCase) {
				case 'emptyStep' :
					var step = this.ctrl.form.steps[this.toastTracker.CIS[switchCase].stepIndex];
					var stepName;
					if (step !== undefined) {
						stepName = this.ctrl.form.steps[this.toastTracker.CIS[switchCase].stepIndex].label;
					}
					else {
						stepName = this.toastTracker.CIS[switchCase].errorInfo;
					}
					return i18n.format(this.validMessage(switchCase), stepName);
					break;
				case 'invalidActionFields' :
					var action = this.ctrl.form.actions[this.toastTracker.CIS[switchCase].actionIndex];
					var actionName;
					if (action !== undefined) {
						actionName = this.ctrl.form.actions[this.toastTracker.CIS[switchCase].actionIndex].label;
					}
					else {
						actionName = this.toastTracker.CIS[switchCase].errorInfo;
					}
					return i18n.format(this.validMessage(switchCase), actionName);
					break;
				case 'layoutStepInvalid' :
					var step = this.ctrl.form.steps[this.toastTracker.SCUE[switchCase].stepIndex];
					var stepName;
					if (step !== undefined) {
						stepName = this.ctrl.form.steps[this.toastTracker.SCUE[switchCase].stepIndex].label;
					}
					else {
						stepName = this.toastTracker.SCUE[switchCase].errorInfo;
					}
					return i18n.format(this.validMessage(switchCase), stepName);
					break;
				default : return i18n.format(this.validMessage(switchCase), this.toastTracker.CIS[switchCase].errorInfo);
			}
		};

		/**
		 * Resolves message id for notifying that previously incorrect state has been corrected
		 *
		 * @param validationType
		 * @returns {*}
		 */
		this.validMessage = function (validationType) {
			var messages = {
				//Step validation messages
				emptyStep: 'angular.ffFormBuilderDirective.message.noEmptyStep',
				emptyStepName: 'angular.ffFormBuilderDirective.message.noInvalidStepName',
				noAction: 'angular.ffFormBuilderDirective.message.noMissingAction',
				invalidActionFields: 'angular.ffFormBuilderDirective.message.validActionFields',
				noStep: 'angular.ffFormBuilderDirective.message.StepExists',
				layoutStepInvalid: 'angular.ffFormBuilderDirective.message.noLayoutStepInvalid',
				//Logics validation message
				logicsSourceMissing: 'angular.ffFormBuilderDirective.message.logicsCorrect',
				logicsFirstStepError: 'angular.ffFormBuilderDirective.message.noFirstStepLogicsError',
				logicsUnreachableSource: 'angular.ffFormBuilderDirective.message.logicSourceReachable',
				logicsCycleDetected: 'angular.ffFormBuilderDirective.message.noCycleDetected',
				emptyLogics: 'angular.ffFormBuilderDirective.message.noEmptyLogics'
			};
			return messages[validationType];
		};

		/**
		 * Displays existing toasts
		 */
		this.showToasts = function () {
			for (var i in this.toastTracker) {
				for (var j in this.toastTracker[i]) {
					var arg = this.toastTracker[i][j];
					toaster.pop({
						type: 'error',
						title: i18n.message('angular.ffFormBuilderDirective.title.invalidStep'),
						body: i18n.format(arg.validationMessage, arg.errorInfo),
						toastId: arg.toastId,
						onHideCallback: function () {
							console.log("Step validation callback!!!");
						}
					});
				}
			}
		};

		/**
		 * Displays notifications to the user
		 * @function
		 * @param args message(s) to be notified to user
		 */
		this.unassignedElementsNotification = function(args) {
			for (var i in args) {
				if (i === 'layoutStepInvalid') {
					if (this.ctrl.stepContainsUnassignedElements) {
						var arg = args[i];
						if (this.toastTracker.SCUE[i] === undefined || this.toastTracker.SCUE[i].errorInfo !== arg.errorInfo) {
							toaster.pop({
								type: 'error',
								title: i18n.message('angular.ffFormBuilderDirective.title.layoutStepInvalid'),
								body: i18n.format(arg.validationMessage, arg.errorInfo),
								toastId: arg.toastId,
								onHideCallback: function () {
									console.log("Step validation callback!!!");
								}
							});
							this.toastTracker.SCUE[i] = {};
							this.toastTracker.SCUE[i].validationMessage = arg.validationMessage;
							this.toastTracker.SCUE[i].showingToast = true;
							this.toastTracker.SCUE[i].toastId = arg.toastId;
							this.toastTracker.SCUE[i].errorInfo = arg.errorInfo;
							this.toastTracker.SCUE[i].stepIndex = arg.stepIndex;
						}
					}
				} else {
					toaster.pop({
						type: args[i].class,
						title: i18n.message('angular.ffFormBuilderDirective.title.unassignedElement'),
						body: i18n.format(args[i].validationMessage, args[i].errorInfo),
						toastId: args[i].toastId
					});
				}
			}
			//Update validationMessage status
			var toRemove = [];
			for (var i in this.toastTracker.SCUE) {
				if (!(i in args) && this.toastTracker.SCUE[i].showingToast) {
					toRemove.push(i);
					toaster.pop({
						type: 'success',
						title: i18n.message('angular.ffFormBuilderDirective.title.validSteps'),
						body: this.makeBody(i),
						toastId: this.toastTracker.SCUE[i].toastId
					});
					this.toastTracker.SCUE[i].showingToast = false;
				}
			}

			//Remove resolved errors
			for (var i in toRemove) {
				delete this.toastTracker.SCUE[toRemove[i]];
			}
		}
	};

	angular
		.module('formFactory')
		.service('ffValidationWorker', ['$log', 'i18nService', 'toaster', validationWorker]);
})();(function () {
    'use strict';
    var ffElementManagementBox = function ($log, contextualData) {
        var directive = {
            restrict: 'E',
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/elementbox/elementManagementBox.html',
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ffController) {
            scope.elementType = attr.elementType;
        }
    };

    angular
        .module('formFactory')
        .directive('ffElementManagementBox', ['$log', 'contextualData', ffElementManagementBox]);
})();
(function() {
    'use strict';
    var actionDisplay = function($log, contextualData) {

        var directive = {
            restrict: 'E',
            scope: {
                action: '='
            },
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/actionDisplayDirective.html',
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ctrls) {}

    };

    angular
        .module('formFactory')
        .directive('ffActionDisplay', ['$log', 'contextualData', actionDisplay]);
})();(function () {
	'use strict';
	var input = function ($compile, $log, $timeout) {
		var directive = {
			restrict: 'E',
			require: ['^ffController'],
			scope   : {
				input: '=',
				resolveLogic: '&'
			},
			link    : postLinkFunc
		};

		return directive;

		function postLinkFunc(scope, el, attr, ctrls) {
			scope.form = ctrls[0].getFormController();
			scope.readOnly = !ctrls[0].isLiveMode();
			if (scope.input && scope.input.template) {
				el.append($compile(scope.input.template)(scope));
			}

			//Recompile template if in layout mode to make sure that inputs change as layout changes
			if (attr.layout) {
				scope.$watch(function() {
					return scope.input;
				}, function(input) {

					$timeout(function() {
						scope.$apply(function() {
							if (input !== null) {
								el.html($compile(input.template)(scope));
							} else {
								el.html('');
							}
						});
					});

				});
			}
		}
	};

	angular
		.module('formFactory')
		.directive('ffBuilderInput', ['$compile', '$log', '$timeout', input]);
})();
(function() {
    var formRenderingDirective = function($log, contextualData) {
        var directive = {
            restrict: 'E',
            require: ['^ffController'],
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/formRendering.html',
            link: linkFunction
        };

        return directive;

        function linkFunction(scope, el, attr) {}
    };

    angular.module('formFactory')
        .directive('ffFormRendering', ['$log', 'contextualData', formRenderingDirective]);
})();(function () {
    'use strict';

    var layoutManagement = function ($log, contextualData) {

        var directive = {
            restrict        : 'E',
            scope           : {
                step       : '=',
                form       : '=',
                currentStep: '='
            },
            controller      : LayoutManagementController,
            controllerAs    : 'lmc',
            bindToController: true,
            templateUrl     : contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/layout/layoutManagement.html',
            link            : linkFunc
        };
        return directive;

        function linkFunc(scope, el, attr, ctrls) {
        }
    };

    angular
        .module('formFactory')
        .directive('ffLayoutManagement', ['$log', 'contextualData', 'ffLayoutService', layoutManagement]);

    var LayoutManagementController = function ($scope, ffLayoutService, contextualData, toaster, i18n, $log,
                                               $document, $timeout, $sce, $window, spinner) {
        $scope.$on('layoutInputChanged', function (event, data) {
            ffLayoutService.addInput(lmc.currentStep, lmc.currentRowIndex, lmc.currentColumnIndex, data.fieldName);
            //Regain focus of div.
            focusActiveColumn();
            lmc.notifyBuilder();
        });
        //Broadcasted when form mode is switched to layout and the layout is active.
        $scope.$on('gainColumnFocus', function() {
            //Focus the last known active row/column or the first row/column if one exists.
            lmc.ensureActiveInput();
        });
        $scope.$on('resetAvailableInputs', function () {
            for (var i in lmc.availableInputs) {
                delete lmc.availableInputs[i].inUse;
            }
        });
        $scope.$on('$destroy', function() {
            //Remove the window keydown event listener when destroying the scope.
            $window.document.body.removeEventListener('keydown', globalKeydownEventListener);
        });
        var lmc                 = this;
        lmc.currentRowIndex     = null;
        lmc.currentColumnIndex  = null;
        lmc.availableInputs     = [];
        lmc.addInputTemplateUrl = contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/layout/addInputTemplate.html';
        lmc.shortcutsInfoTemplateUrl = contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/layout/shortcutsInfoTemplateUrl.html';
        lmc.addRow              = addRow;
        lmc.removeRow           = removeRow;
        lmc.removeInput         = removeInput;
        lmc.moveRow             = moveRow;
        lmc.cleanAndResizeRow   = cleanAndResizeRow;
        lmc.addCol              = addCol;
        lmc.shrinkCol           = shrinkCol;
        lmc.expandCol           = expandCol;
        lmc.removeColumn        = removeColumn;
        lmc.addColOffset        = addColOffset;
        lmc.removeColOffset     = removeColOffset;
        lmc.moveInput           = moveInput;
        lmc.displayToast         = displayToast;
        lmc.manageActiveInputPosition       = manageActiveInputPosition;
        lmc.isInputManagementPositionActive = isInputManagementPositionActive;
        lmc.captureOutsideKeyPress             = captureOutsideKeyPress;
        lmc.activeInputSelectionPromise = null;
        lmc.deletionInProgress = false;
        lmc.dispatchInputsPromise = null;
        lmc.ensureActiveInput               = ensureActiveInput;
        lmc.autoFitTooltip                  = $sce.trustAsHtml(i18n.message('angular.ffLayoutManagementDirective.label.autoFitCells') + '<br/>' + i18n.message('angular.ffLayoutManagementDirective.tooltip.autoFitCells'));
        lmc.activeKeyEventPromise           = null;
        lmc.globalKeydownEventListener      = globalKeydownEventListener;
        //Button management
        lmc.currentRow       = null;
        lmc.currentIndex     = null;
        lmc.setCurrentColumn = setCurrentColumn;
        lmc.isCurrentColumn  = isCurrentColumn;
        lmc.columnHasInput   = columnHasInput;
        lmc.dispatchInputs   = dispatchInputs;
        //Helpers
        lmc.inputsInUse       = inputsInUse;
        lmc.rememberIndices   = rememberIndices;
        lmc.selectLastInput   = selectLastInput;
        lmc.getLayout         = getLayout;
        lmc.getInputObject    = getInputObject;
        lmc.resolveLogic      = resolveLogic;
        lmc.i18nMessageGetter = i18nMessageGetter;
        lmc.hover             = [];
        lmc.popoverActivated  = false;
        lmc.inRow             = inRow;
        lmc.outRow            = outRow;
        lmc.notifyBuilder     = notifyBuilder;
        activate();

        function activate() {
            ffLayoutService.displayToast = lmc.displayToast;
            ffLayoutService.controllerContext = lmc;
            $window.document.body.addEventListener('keydown', globalKeydownEventListener);
            var hiddenInputs = [];
            var inputsInUse = lmc.inputsInUse();
            for (var i in lmc.step.inputs) {
                if (lmc.step.inputs[i].nodeType === 'fcnt:hiddenDefinition') {
                    hiddenInputs.push(angular.copy(lmc.step.inputs[i]))
                } else {
                    prepareAvailableInput(angular.copy(lmc.step.inputs[i]), inputsInUse.indexOf(lmc.step.inputs[i].layoutUUID) !== -1);
                }
            }
            for (var i in hiddenInputs) {
                prepareAvailableInput(hiddenInputs[i], inputsInUse.indexOf(hiddenInputs[i].layoutUUID) !== -1);
            }
        }

        function prepareAvailableInput(input, inUse) {
            lmc.availableInputs.push(input);
            var index = lmc.availableInputs.length-1;
            lmc.availableInputs[index].index = index;
            if(_.isEmpty(lmc.availableInputs[index].label)) {
                //if input label is empty, replace it with the name for rendering purposes
                lmc.availableInputs[index].label = lmc.availableInputs[index].name;
            }
            //rename for readability
            lmc.availableInputs[index].fieldName = lmc.availableInputs[index].layoutUUID;
            if (inUse) {
                lmc.availableInputs[index].inUse = index;
            }
        }

        function globalKeydownEventListener(event) {
            event.preventDefault();
            $timeout(function (event) {
                if (event.keyCode === 9) {
                    captureOutsideKeyPress(event);
                } else {
                    moveInput(event);
                }
            }, 0, true, event);
        }

        function getLayout() {
            return ffLayoutService.getLayout();
        }

        function dispatchInputs(size) {
            spinner.show('layoutDispatchSpinner');
            if (lmc.dispatchInputsPromise !== null) {
                $timeout.cancel(lmc.dispatchInputsPromise);
            }
            lmc.dispatchInputsPromise = $timeout(function () {
                ffLayoutService.createLayout(lmc.currentStep, size, lmc.availableInputs);
                for (var i in lmc.availableInputs) {
                    lmc.availableInputs[i].inUse = i;
                }
                lmc.ensureActiveInput();
                spinner.hide('layoutDispatchSpinner');
                lmc.notifyBuilder();
            });
        }

        /**
         * Adds a new row and sets it's column as the active column
         * @function
         */
        function addRow() {
            ffLayoutService.addRow(lmc.currentStep);
            //Manage selected column
            manageActiveInputPosition(getLayout().steps[lmc.currentStep].rows.length - 1, 0);
        }

        /**
         * Removes a row and passes the focus to the next available column.
         * @param rowIndex index of row to be removed
         */
        function removeRow(rowIndex) {
            var row = ffLayoutService.removeRow(lmc.currentStep, rowIndex);
            updateAvailableInputs(row[0]);
            lmc.notifyBuilder();
        }

        /**
         * Removes the input belonging to the selected row
         * @function
         * @param rowIndex index of the row input belongs to
         * @param colIndex index of the column input belongs to
         */
        function removeInput(rowIndex, colIndex) {
            var col = ffLayoutService.removeInput(lmc.currentStep, rowIndex, colIndex);
            focusActiveColumn();
            updateAvailableInputs(col);
            lmc.notifyBuilder();
        }

        /**
         * Moves a row and reestablishes the focus on the moved row.
         * @function
         * @param rowIndex index of the selected row
         * @param direction direction in which the row should be moved - 'up' 'down'
         */
        function moveRow(rowIndex, direction) {
            switch (direction) {
                case 'up' :
                    ffLayoutService.moveRowUp(lmc.currentStep, rowIndex);
                    break;
                case 'down' :
                    ffLayoutService.moveRowDown(lmc.currentStep, rowIndex);
                    break;
            }
            focusActiveColumn();
        }

        function cleanAndResizeRow(rowIndex) {
            ffLayoutService.cleanAndResizeRow(lmc.currentStep, rowIndex);
            focusActiveColumn();
        }

        function addCol(rowIndex) {
            var result = ffLayoutService.addCol(lmc.currentStep, rowIndex);
            if (!result) {
                toaster.pop({
                    type : "info",
                    title: i18n.message("angular.ffLayoutManagementDirective.label.fullRow"),
                    body : i18n.message("angular.ffLayoutManagementDirective.message.fullRow")
                });
            }
        }

        function shrinkCol(rowIndex, colIndex) {
            ffLayoutService.shrinkCol(lmc.currentStep, rowIndex, colIndex);
        }

        function expandCol(rowIndex, colIndex) {
            ffLayoutService.expandCol(lmc.currentStep, rowIndex, colIndex);
        }

        /**
         * Removes the selected column and activates the next available column
         * @param rowIndex
         * @param colIndex
         */
        function removeColumn(rowIndex, colIndex) {
            var currentlyActiveColumn = ffLayoutService.getActiveInputPosition(lmc.currentStep).rowIndex === rowIndex && ffLayoutService.getActiveInputPosition(lmc.currentStep).colIndex === colIndex;
            var col = ffLayoutService.removeCol(lmc.currentStep, rowIndex, colIndex);
            if (currentlyActiveColumn) {
                ffLayoutService.selectNextAvailableColumn(lmc.currentStep);
            }
            //Flag that we are deleting a column, so that we can ignore the click event that is generated on the current column
            lmc.deletionInProgress = true;
            $timeout(function() {
                ffLayoutService.selectNextAvailableColumn(lmc.currentStep);
                focusActiveColumn();
            }).then(function(success) {
                //reset flag
                lmc.deletionInProgress = false;
            }, function(error) {
                //reset flag
                lmc.deletionInProgress = false;
            });
            updateAvailableInputs(col[0]);
            lmc.notifyBuilder();
        }

        function addColOffset(rowIndex, colIndex) {
            ffLayoutService.addColOffset(lmc.currentStep, rowIndex, colIndex);
        }

        function removeColOffset(rowIndex, colIndex) {
            ffLayoutService.removeColOffset(lmc.currentStep, rowIndex, colIndex);
        }

        /**
         * This function will captures keydown events on the columns
         * and delegates the task that is bound to valid keystroke
         * @function
         * @param $event keydown event object
         */
        function moveInput($event) {
            var activePosition = ffLayoutService.getActiveInputPosition(lmc.currentStep);
            if (($event.keyCode === 37 || $event.keyCode === 38 || $event.keyCode === 39 || $event.keyCode === 40)
                && lmc.isInputManagementPositionActive(activePosition.rowIndex, activePosition.colIndex)) {
                $event.preventDefault();
                if (lmc.activeKeyEventPromise !== null) {
                    $timeout.cancel(lmc.activeKeyEventPromise);
                }
                lmc.activeKeyEventPromise = $timeout(function() {
                    switch ($event.keyCode) {
                        case 37:
                            if ($event.shiftKey) {
                                ffLayoutService.moveInputX(lmc.currentStep, 'left', 'shift');
                            } else if ($event.altKey) {
                                ffLayoutService.moveInputY(lmc.currentStep, 'left', 'alt');
                            } else {
                                ffLayoutService.navigate(lmc.currentStep, 'left');
                            }
                            break;
                        case 39:
                            if ($event.shiftKey) {
                                ffLayoutService.moveInputX(lmc.currentStep, 'right', 'shift');
                            } else if ($event.altKey) {
                                ffLayoutService.moveInputY(lmc.currentStep, 'right', 'alt');
                            } else {
                                ffLayoutService.navigate(lmc.currentStep, 'right');
                            }
                            break;
                        case 38:
                            if ($event.shiftKey) {
                                ffLayoutService.moveInputY(lmc.currentStep, 'up', 'shift');
                                updateScrollPosition('up');
                            } else if ($event.altKey) {
                                ffLayoutService.moveInputY(lmc.currentStep, 'up', 'alt');
                            } else {
                                ffLayoutService.navigate(lmc.currentStep, 'up');
                                updateScrollPosition('up');
                            }
                            break;
                        case 40:
                            if ($event.shiftKey) {
                                ffLayoutService.moveInputY(lmc.currentStep, 'down', 'shift');
                                updateScrollPosition('down');
                            } else if ($event.altKey) {
                                ffLayoutService.moveInputY(lmc.currentStep, 'down', 'alt');
                            } else {
                                ffLayoutService.navigate(lmc.currentStep, 'down');
                                updateScrollPosition('down');
                            }
                            break;
                    }
                    //Activate column after move is done.
                    //In the case the move was no successful we will just be reactivating the input again
                    ffLayoutService.manageActiveInputPosition(lmc.currentStep, ffLayoutService.getActiveInputPosition(lmc.currentStep).rowIndex, ffLayoutService.getActiveInputPosition(lmc.currentStep).colIndex, true);
                }, 100);
            }
        }

        /**
         * Updates body scroll to make sure that activeColumn class is always visible
         */
        function updateScrollPosition(direction) {
            var activePosition = $window.document.getElementsByClassName("activeColumn")[0].getBoundingClientRect().top;
            activePosition = !_.isUndefined($window.scrollY) ? $window.scrollY + activePosition : $window.pageYOffset + activePosition;
            if (direction === 'up') {
                activePosition -= $window.innerHeight / 1.5;
            }
            else if (direction === 'down'){
                activePosition -= $window.innerHeight / 3;
            }
            $window.scrollTo(0, activePosition);
        }

        /**
         * This function will attempt to make active the provided row/column
         * @function
         * @param rowIndex index of the selected row
         * @param colIndex index of the selected column
         */
        function manageActiveInputPosition(rowIndex, colIndex) {
            //Deletion is occurring, do not try and update active column.
            if (lmc.deletionInProgress) {
                return;
            }
            if (lmc.activeInputSelectionPromise !== null) {
                $timeout.cancel(lmc.activeInputSelectionPromise);
            }
            lmc.activeInputSelectionPromise = $timeout(function () {
                //activate current input
                ffLayoutService.manageActiveInputPosition(lmc.currentStep, rowIndex, colIndex);
                angular.element(".row_" + ffLayoutService.getActiveInputPosition(lmc.currentStep).rowIndex + '_col_' + ffLayoutService.getActiveInputPosition(lmc.currentStep).colIndex).focus();
            });
        }

        /**
         * Get current active status of column
         * @param rowIndex index of the selected row
         * @param colIndex index of the selected column
         * @returns {boolean} Whether the selected row/column is active
         */
        function isInputManagementPositionActive(rowIndex, colIndex) {
            if(rowIndex === null || colIndex === null) {
                return false;
            }
            return ffLayoutService.getLayout().steps[lmc.currentStep].rows[rowIndex].row[colIndex].moveActive;
        }

        /**
         * This function is used to select an available column if an active one does not exist
         * and focus it if successful.
         * @function
         */
        function ensureActiveInput() {
            ffLayoutService.verifyActiveInputExists(lmc.currentStep);
            $timeout(function() {
                focusActiveColumn();
            });
        }

        /**
         * This function catches keydown events on the layoutHolder div
         * and handles any tab presses.
         * When a tab key is identified the next available column will become active.
         * @function
         * @param $event keydown event
         */
        function captureOutsideKeyPress($event) {
            if ($event.keyCode === 9) {
                $event.preventDefault();
                if (lmc.activeInputSelectionPromise !== null) {
                    $timeout.cancel(lmc.activeInputSelectionPromise);
                }
                lmc.activeInputSelectionPromise = $timeout(function() {
                    var captureNextElement = false;
                    var nextElementSet = false;
                    for (var i in ffLayoutService.getLayout().steps[lmc.currentStep].rows) {
                        for (var j in ffLayoutService.getLayout().steps[lmc.currentStep].rows[i].row) {
                            if (captureNextElement) {
                                lmc.manageActiveInputPosition(i, j);
                                nextElementSet = true;
                                break;
                            }
                            if (ffLayoutService.getLayout().steps[lmc.currentStep].rows[i].row[j].moveActive) {
                                captureNextElement = true;
                            }
                        }
                        if (nextElementSet) {
                            break;
                        }
                    }
                    if (!nextElementSet) {
                        //set first element
                        if (ffLayoutService.getLayout().steps[lmc.currentStep].rows.length > 0 && ffLayoutService.getLayout().steps[lmc.currentStep].rows[0].row.length > 0) {
                            lmc.manageActiveInputPosition(0,0);
                        }
                    }
                });
            }
        }

        /**
         * This function creates a toast using the received data object
         * @param data object containing: type, toastId, title, body
         */
        function displayToast(data) {
            toaster.pop({
                type    : data.type,
                toastId : data.toastId,
                title   : !_.isUndefined(data.title) && data.title !== null ? i18n.message(data.title) : '',
                body    : !_.isUndefined(data.message) && data.message !== null ? i18n.message(data.message) : ''
            });
        }
        /**************************************************************************************************************/
        /******************************************Column controls management******************************************/
        /**************************************************************************************************************/

        function setCurrentColumn(rowIndex, colIndex) {
            lmc.currentRow    = rowIndex;
            lmc.currentColumn = colIndex;
        }

        function isCurrentColumn(rowIndex, colIndex) {
            return lmc.currentRow === rowIndex && lmc.currentColumn === colIndex;
        }

        function columnHasInput(rowIndex, colIndex) {
            return ffLayoutService.getLayout().steps[lmc.currentStep].rows[rowIndex].row[colIndex].layoutUUID !== null;
        }

        /**************************************************************************************************************/
        /*********************************************Various helper methods*******************************************/
        /**************************************************************************************************************/

        function inputsInUse() {
            var inputsInUse = [];
            var layout      = ffLayoutService.getLayout();
            for (var row in layout.steps[lmc.currentStep].rows) {
                for (var col in layout.steps[lmc.currentStep].rows[row].row) {
                    if (layout.steps[lmc.currentStep].rows[row].row[col].layoutUUID !== null) {
                        inputsInUse.push(layout.steps[lmc.currentStep].rows[row].row[col].layoutUUID);
                    }
                }
            }
            return inputsInUse;
        }

        function rememberIndices(rowIndex, colIndex) {
            lmc.currentRowIndex    = rowIndex;
            lmc.currentColumnIndex = colIndex;
            lmc.popoverActivated   = true;
        }

        function selectLastInput(rowIndex, colIndex) {
            var layoutUUID = null;
            var index = 0;
            for (var i in lmc.availableInputs) {
                if ('dummy' in lmc.availableInputs[i]) {
                    continue;
                }
                if (!('inUse' in lmc.availableInputs[i]) && layoutUUID !== null) {
                    return;
                } else if (!('inUse' in lmc.availableInputs[i])) {
                    layoutUUID = lmc.availableInputs[i].fieldName;
                    index = i;
                }

            }
            //Mark the selected input as in use, just like the input bucket directive would upon selection.
            lmc.availableInputs[index].inUse = index;
            ffLayoutService.addInput(lmc.currentStep, rowIndex, colIndex, layoutUUID);
            lmc.notifyBuilder();
        }

        /**
         * Returns input object from available inputs.
         *
         * @param inputName
         * @returns {*}
         */
        function getInputObject(layoutUUID) {
            for (var i in lmc.availableInputs) {
                if (layoutUUID === lmc.availableInputs[i].fieldName) {
                    return lmc.availableInputs[i];
                }
            }
            return null;
        }

        /**
         * Removes inUse parameter from input if it is no longer used.
         *
         * @param obj
         */
        function updateAvailableInputs(obj) {
            //Remove whole row
            if (obj.row !== undefined) {
                for (var col in obj.row) {
                    for (var input in lmc.availableInputs) {
                        if (obj.row[col].layoutUUID === lmc.availableInputs[input].fieldName) {
                            delete lmc.availableInputs[input].inUse;
                        }
                    }
                }
            }
            //Remove individual column
            else {
                for (var input in lmc.availableInputs) {
                    if (obj.layoutUUID === lmc.availableInputs[input].fieldName) {
                        delete lmc.availableInputs[input].inUse;
                    }
                }
            }
        }

        function resolveLogic() {
            return true;
        }

        function i18nMessageGetter(key) {
            return i18n.message(key);
        }

        function inRow(index) {
            if (lmc.popoverActivated && angular.element('.layoutInputPicker').length === 0) {
                lmc.popoverActivated = false;
                lmc.hover            = [];
            }
            if (!lmc.popoverActivated) {
                lmc.hover[index] = true;
            }
        }

        function outRow(index) {
            if (!lmc.popoverActivated) {
                lmc.hover[index] = false;
            }
        }

        function notifyBuilder() {
            $scope.$emit('validateLayout', null);
        }
        /**
         * Helper function to focus the active row;
         * @function
         */
        function focusActiveColumn() {
            if (lmc.activeInputSelectionPromise !== null) {
                $timeout.cancel(lmc.activeInputSelectionPromise);
            }
            lmc.activeInputSelectionPromise = $timeout(function () {
                angular.element(".row_" + ffLayoutService.getActiveInputPosition(lmc.currentStep).rowIndex + '_col_' + ffLayoutService.getActiveInputPosition(lmc.currentStep).colIndex).focus();
            });
        }
    };

    LayoutManagementController.$inject = ['$scope', 'ffLayoutService', 'contextualData', 'toaster',
        'i18nService', '$log', '$document', '$timeout', '$sce', '$window', 'ffSpinnerService'];
})();
(function() {
    'use strict';

    var layoutService = function($log) {
        var MAX_WIDTH = 12;
        var MIN_COL_THRESHOLD = 1;
        var colClass = 'col-sm-12';
        var offsetClass = 'col-sm-offset-0';
        var displayToast = null;
        var controllerContext = null;
        var layout = {
            active: false,
            layoutEmpty: true,
            steps: []
        };
        var baseLayout = {
            active: false,
            layoutEmpty: true,
            steps: [
				{
                    rows: [],
                    inputPositionManagement: {
                        colIndex: null,
                        rowIndex: null,
                        activeInputFieldName: null,
                        activeInputExists: false
                    },
                    inputMovementHistory: []
				}
			]
        };
        var historyMovementTemplate = {
            rowIndex: null,
            colIndex: null,
            createdColumn: false
        };
        var stepBase = {
            rows: [],
            inputPositionManagement: {
                colIndex: null,
                rowIndex: null,
                activeInputFieldName: null,
                activeInputExists: false
            },
            inputMovementHistory: []
        };
        var rowBase = {
            row: [
				{
                    'col': colClass,
                    'layoutUUID': null,
                    'offset': offsetClass,
                    'moveActive': false,
                    'activeClass': 'inActiveColumn'
				}
			]
        };
        var colBase = {
            'col': colClass,
            'layoutUUID': null,
            'offset': offsetClass,
            'moveActive': false,
            'activeClass': null
        };

        /**
         * Returns layout object if layout has been activated.
         *
         * @returns object or null
         */
        this.getLayout = function() {
            return layout;
        };

        this.activate = function() {
            layout.active = true;
        };

        this.deactivate = function() {
            layout.active = false;
            for(var i in layout.steps) {
                layout.steps[i].inputPositionManagement.activeInputExists = false;
            }
        };
        /**
         * This function is responsible for creating a layout with the desired amount of columns per row
         * dispatching all available inputs.
         * @function
         * @param size
         */
        this.createLayout = function(stepIndex, size, availableInputs) {
            size = parseInt(size);
            layout.steps[stepIndex] = angular.copy(stepBase);
            for (var i in availableInputs) {
                if ('dummy' in availableInputs[i]) {
                    //ignore the dummy input
                    continue;
                }
                if (availableInputs[i].nodeType === 'fcnt:hiddenDefinition') {
                    //ignore column structure for hidden inputs and place them 1 per row
                    layout.steps[stepIndex].rows.push(angular.copy(rowBase));
                    layout.steps[stepIndex].rows[layout.steps[stepIndex].rows.length - 1].row[0].layoutUUID = availableInputs[i].fieldName;
                    continue;
                }
                if (i % size === 0) {
                    //Add row when we are equally divisible
                    layout.steps[stepIndex].rows.push(angular.copy(rowBase));
                    var rowIndex = layout.steps[stepIndex].rows.length - 1;
                    var colIndex = layout.steps[stepIndex].rows[rowIndex].row.length - 1;
                    //Modify the default column;
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = availableInputs[i].fieldName;
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex].col = updateClass(colClass, MAX_WIDTH/size);
                } else {
                    //Add column and place available input inside.
                    var rowIndex = layout.steps[stepIndex].rows.length - 1;
                    layout.steps[stepIndex].rows[rowIndex].row.push(angular.copy(colBase));
                    var colIndex = layout.steps[stepIndex].rows[rowIndex].row.length - 1;
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = availableInputs[i].fieldName;
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex].col = updateClass(colClass, MAX_WIDTH/size);
                }
            }
        };

        this.setExistingLayout = function(existingLayout) {
            layout = existingLayout;
        };

        this.setBaseLayout = function() {
            layout = angular.copy(baseLayout);
        };

        this.setBaseForSteps = function(stepNumber) {
            layout.steps = [];
            for (var i = 0; i < stepNumber; i++) {
                layout.steps.push(angular.copy(stepBase));
            }
        };

        this.isActive = function() {
            return layout.active;
        };
        /**************************************************************************************************************/
        /***********************************************Step management************************************************/
        /**************************************************************************************************************/
        this.addStep = function() {
            layout.steps.push(angular.copy(stepBase));
        };

        this.removeStep = function(index) {
            return layout.steps.splice(index, 1);
        };

        this.moveStep = function(newIndex, currentIndex) {
            var stepToMove = layout.steps[currentIndex];
            layout.steps[currentIndex] = layout.steps[newIndex];
            layout.steps[newIndex] = stepToMove;
        };

        this.prepareSteps = function(steps) {
            if (layout.steps.length !== steps) {
                while (steps - layout.steps.length > 0) {
                    layout.steps.push(angular.copy(stepBase));
                }
            }
        };
        /**************************************************************************************************************/
        /************************************************Row management************************************************/
        /**************************************************************************************************************/

        this.addRow = function(stepIndex) {
            layout.layoutEmpty = false;
            layout.steps[stepIndex].rows.push(angular.copy(rowBase));
        };

        /**
         * Removes the specified row
         * @function
         * @param stepIndex current active step
         * @param rowIndex index of row to be removed
         * @returns {*} Removed row
         */
        this.removeRow = function(stepIndex, rowIndex) {
            var removedRow = layout.steps[stepIndex].rows.splice(rowIndex, 1);
            if(this.getActiveInputPosition(stepIndex).rowIndex === rowIndex && layout.steps[stepIndex].rows.length > 0) {
                var targetRowIndex = rowIndex === layout.steps[stepIndex].rows.length ? rowIndex - 1 : rowIndex;
                if ( layout.steps[stepIndex].rows[targetRowIndex].row.length > 0 ) {
                    this.manageActiveInputPosition(stepIndex, targetRowIndex, 0);
                }
            }
            this.updateActiveInputPosition(stepIndex);
            return removedRow;
        };

        /**
         * Moves selected row 1 position higher
         * @function
         * @param stepIndex current active step
         * @param rowIndex index of the row to be moved
         */
        this.moveRowUp = function(stepIndex, rowIndex) {
            if (layout.steps[stepIndex].rows[rowIndex - 1] !== undefined) {
                var rowAbove = layout.steps[stepIndex].rows[rowIndex - 1];
                var currentRow = layout.steps[stepIndex].rows[rowIndex];
                layout.steps[stepIndex].rows[rowIndex - 1] = currentRow;
                layout.steps[stepIndex].rows[rowIndex] = rowAbove;
                //Update active row
                this.manageActiveInputPosition(stepIndex, rowIndex - 1, 0);
            }
        };

        /**
         * Moves selected row 1 position lower
         * @function
         * @param stepIndex current active step
         * @param rowIndex index of the row to be moved
         */
        this.moveRowDown = function(stepIndex, rowIndex) {
            if (layout.steps[stepIndex].rows[rowIndex + 1] !== undefined) {
                var rowBelow = layout.steps[stepIndex].rows[rowIndex + 1];
                var currentRow = layout.steps[stepIndex].rows[rowIndex];
                layout.steps[stepIndex].rows[rowIndex + 1] = currentRow;
                layout.steps[stepIndex].rows[rowIndex] = rowBelow;
                //Update active row
                this.manageActiveInputPosition(stepIndex, rowIndex + 1, 0);
            }
        };

        /**
         * This function will remove any empty columns within the specified row
         * and resize all remaining columns.
         * @function
         * @param stepIndex - the current step we are working on
         * @param rowIndex - row that will be cleaned and resized
         */
        this.cleanAndResizeRow = function(stepIndex, rowIndex) {
            //remove any empty columns
            var row = [];
            for (var i in layout.steps[stepIndex].rows[rowIndex].row) {
                if (layout.steps[stepIndex].rows[rowIndex].row[i].layoutUUID !== null) {
                    //save any columns that are not empty
                    row.push(angular.copy(layout.steps[stepIndex].rows[rowIndex].row[i]));
                }
            }
            layout.steps[stepIndex].rows[rowIndex].row = row;
            //resize all columns to be equal size
            if (layout.steps[stepIndex].rows[rowIndex].row.length === 0) {
                this.removeRow(stepIndex, rowIndex);
            } else {
                resizeColumns(stepIndex, rowIndex, layout.steps[stepIndex].rows[rowIndex].row.length, true);
            }
        };
        /**************************************************************************************************************/
        /************************************************Col management************************************************/
        /**************************************************************************************************************/

        this.shrinkCol = function(currentStep, rowIndex, colIndex) {
            this.reduceColValue(currentStep, rowIndex, colIndex, 'col');
        };

        this.expandCol = function(currentStep, rowIndex, colIndex) {
            this.addColValue(currentStep, rowIndex, colIndex, 'col');
        };

        this.addCol = function(currentStep, rowIndex) {
            var totalWidth = this.getTotalWidth(currentStep, rowIndex);
            if (totalWidth === MAX_WIDTH) {
                return false;
            }
            var newWidth = MAX_WIDTH - totalWidth;
            var cl = updateClass(colClass, newWidth);
            layout.steps[currentStep].rows[rowIndex].row.push({
                col: cl,
                layoutUUID: null,
                offset: offsetClass,
                moveActive: false,
                activeClass: 'inActiveColumn'
            });
            return true;
        };

        this.removeCol = function(stepIndex, rowIndex, colIndex) {
            return layout.steps[stepIndex].rows[rowIndex].row.splice(colIndex, 1);
        };

        this.addColOffset = function(stepIndex, rowIndex, colIndex) {
            this.addColValue(stepIndex, rowIndex, colIndex, 'offset');
        };

        this.removeColOffset = function(stepIndex, rowIndex, colIndex) {
            this.reduceColValue(stepIndex, rowIndex, colIndex, 'offset');
        };

        this.getTotalWidth = function(currentStep, rowIndex) {
            var totalWidth = 0;
            for (var colIndex in layout.steps[currentStep].rows[rowIndex].row) {
                totalWidth += getColWidth(layout.steps[currentStep].rows[rowIndex].row[colIndex].col);
                totalWidth += getColWidth(layout.steps[currentStep].rows[rowIndex].row[colIndex].offset);
            }
            return totalWidth;
        };

        this.reduceColValue = function(stepIndex, rowIndex, colIndex, target) {
            var rowClass = layout.steps[stepIndex].rows[rowIndex].row[colIndex][target];
            var colWidth = getColWidth(rowClass);

            if (target === 'offset') {
                if (colWidth > 0) {
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex][target] = updateClass(rowClass, --colWidth);
                }
            } else {
                if (colWidth > 1) {
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex][target] = updateClass(rowClass, --colWidth);
                }
            }
        };

        this.addColValue = function(stepIndex, rowIndex, colIndex, target) {
            var rowClass = layout.steps[stepIndex].rows[rowIndex].row[colIndex][target];
            var colWidth = getColWidth(rowClass);
            var totalWidth = this.getTotalWidth(stepIndex, rowIndex);
            if (totalWidth + 1 <= MAX_WIDTH) {
                layout.steps[stepIndex].rows[rowIndex].row[colIndex][target] = updateClass(rowClass, ++colWidth);
            }
        };

        function getColWidth(item) {
            if (item === null) {
                return 0;
            }
            var parts = item.split('-');
            if (parts.length === 4) {
                return parseInt(parts[3]);
            } else if (parts.length === 3) {
                return parseInt(parts[2]);
            }
        }

        function updateClass(oldClass, size) {
            var parts = oldClass.split('-');
            if (parts.length === 4) {
                parts.splice(3, 1);
            } else if (parts.length === 3) {
                parts.splice(2, 1);
            }
            parts.push(size);
            return parts.join('-');
        }

        /**
         * This function will attempt to resize all columns into equal sized rows.
         *
         * @param stepIndex - the current step we are working on
         * @param rowIndex - row that will be resized
         * @param numOfCols - Number of columns in the given row
         * @param useAllColSpaces - Option to distribute left over column size
         */
        function resizeColumns(stepIndex, rowIndex, numOfCols, useAllColSpaces) {
            var requiredSpace = Math.floor(MAX_WIDTH / numOfCols);
            requiredSpace = requiredSpace == 0 ? MIN_COL_THRESHOLD : requiredSpace;
            for (var i in layout.steps[stepIndex].rows[rowIndex].row) {
                var offsetAvailable = getColWidth(layout.steps[stepIndex].rows[rowIndex].row[i].offset);
                var colWidth = getColWidth(layout.steps[stepIndex].rows[rowIndex].row[i].col);
                //If specified apply leftover column spaces as long there are any left over
                //Distribute them equally till none are left.
                if (useAllColSpaces && numOfCols < MAX_WIDTH && numOfCols * MIN_COL_THRESHOLD < 12 && MAX_WIDTH % numOfCols != 0) {
                    //distribute extra spaces as we increase each column's size
                    requiredSpace = parseInt(i) + 1 <= Math.ceil(MAX_WIDTH % numOfCols) ? Math.ceil(MAX_WIDTH / numOfCols) : Math.floor(MAX_WIDTH / numOfCols);

                }
                //attempt to shrink offset first
                if (colWidth > requiredSpace) {
                    if (offsetAvailable > 0) {
                        //set offset to zero
                        layout.steps[stepIndex].rows[rowIndex].row[i].offset = updateClass(layout.steps[stepIndex].rows[rowIndex].row[i].offset, 0);
                    }
                    layout.steps[stepIndex].rows[rowIndex].row[i].col = updateClass(layout.steps[stepIndex].rows[rowIndex].row[i].col, requiredSpace);
                } else if (colWidth + offsetAvailable > requiredSpace) {
                    layout.steps[stepIndex].rows[rowIndex].row[i].offset = updateClass(layout.steps[stepIndex].rows[rowIndex].row[i].offset, colWidth - requiredSpace);
                } else {
                    layout.steps[stepIndex].rows[rowIndex].row[i].col = updateClass(layout.steps[stepIndex].rows[rowIndex].row[i].col, requiredSpace - offsetAvailable);
                }
            }
        }
        /**************************************************************************************************************/
        /************************************************Input management**********************************************/
        /**************************************************************************************************************/

        this.addInput = function(stepIndex, rowIndex, colIndex, fieldName) {
            layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = fieldName;
        };

        this.removeInput = function(stepIndex, rowIndex, colIndex) {
            //Copy to keep input name intact
            var col = angular.copy(layout.steps[stepIndex].rows[rowIndex].row[colIndex]);
            layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = null;
            return col;
        };

        /**
         * This function will move an input and its associated column in the specified direction.
         *
         * @param stepIndex - the current step we are working on
         * @param rowIndex  - row that column belongs to
         * @param colIndex  - column that we are moving
         * @param direction - direction in which to move input and associated column : 'left' or 'right'
         * @param movement  - the type of movement that should be down based on the keyed action - 'shift' or 'alt'
         */
        this.moveInputX = function(stepIndex, direction, movement) {
            var rowIndex = layout.steps[stepIndex].inputPositionManagement.rowIndex;
            var colIndex = layout.steps[stepIndex].inputPositionManagement.colIndex;
            var canMove = false;
            var newIndex;
            //verify if input can move
            switch(movement) {
                case 'shift':
                    switch (direction) {
                        case 'left' :
                            if (layout.steps[stepIndex].rows[rowIndex].row.length > 1 && colIndex - 1 >= 0) {
                                canMove = true;
                                newIndex = colIndex - 1;
                            }
                            break;
                        case 'right' :
                            if (layout.steps[stepIndex].rows[rowIndex].row.length > 1 && colIndex + 1 < layout.steps[stepIndex].rows[rowIndex].row.length) {
                                canMove = true;
                                newIndex = colIndex + 1;
                            }
                            break;
                    }
                    if (canMove) {
                        var target = angular.copy(layout.steps[stepIndex].rows[rowIndex].row[newIndex].layoutUUID);
                        layout.steps[stepIndex].rows[rowIndex].row[newIndex].layoutUUID = angular.copy(layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID);
                        layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = target;
                        layout.steps[stepIndex].inputPositionManagement.colIndex = newIndex;
                        this.manageInputMovementHistory(stepIndex, layout.steps[stepIndex].inputPositionManagement.rowIndex, layout.steps[stepIndex].inputPositionManagement.colIndex, false, false);
                    }
                    break;
                case 'alt':
                    break;
            }
        };

        /**
         * This function will move an input from its corresponding row and column into the
         * specified row, based on the chosen direction.
         * If no row is found above/below, one will be created with a default column and the input will be placed within it.
         * If there is a row, the first empty column will be used.
         * If there is no available column, one will be created and the remaining columns will be resized to allow the fitment of the input.
         * Overflow will occur when too many inputs are added.
         *
         * @param stepIndex - the current step we are working on
         * @param rowIndex  - row that column belongs to
         * @param colIndex  - column that we are moving
         * @param direction - direction in which to move input and associated column : 'up' or 'down'
         * @param movement  - the type of movement that should be down based on the keyed action - 'shift' or 'alt'
         */
        this.moveInputY = function(stepIndex, direction, movement) {
            var rowIndex = layout.steps[stepIndex].inputPositionManagement.rowIndex;
            var colIndex = layout.steps[stepIndex].inputPositionManagement.colIndex;
            if (layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID === null) {
                return false;
            }
            var targetRowIndex = direction == 'up' ? rowIndex - 1 : rowIndex + 1;
            var targetColIndex;
            var topOrBottomRow = !!((rowIndex === 0 && direction == 'up') || (rowIndex === layout.steps[stepIndex].rows.length - 1 && direction == 'down'));
            switch(movement) {
                case 'shift':
                        //top or bottom row with respective movement out of bounds.
                        if (topOrBottomRow) {
                            return false;
                        } else if (layout.steps[stepIndex].rows[targetRowIndex].row.length === 0) {
                            if (_.isFunction(displayToast) && controllerContext !== null) {
                                var data = {
                                    toastId : 'noAvailableColumn',
                                    type    : 'warning',
                                    title   : 'angular.ffLayoutService.toast.unAbleToMoveInput',
                                    message : 'angular.ffLayoutService.toast.noAvailableColumn'
                                };
                                displayToast.call(controllerContext, data);
                            }
                            return false;
                        }
                        var layoutUUID = angular.copy(layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID);
                        //remove input from column
                        layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = null;
                        if (layout.steps[stepIndex].rows[rowIndex].row.length === layout.steps[stepIndex].rows[targetRowIndex].row.length) {
                            //Rows containing equal amount of columns just switch exact index as expected
                            targetColIndex = colIndex;
                        } else if (colIndex === 0) {
                            //Switch first index with first index in target row
                            targetColIndex = 0;
                        } else if(layout.steps[stepIndex].rows[targetRowIndex].row.length > 0 && layout.steps[stepIndex].rows[targetRowIndex].row.length < 3) {
                            //If target row size is greater than either 1 or 2,
                            //than if we are moving up we want to choose the right most column otherwise
                            //the first column when moving down.
                            targetColIndex = direction === 'up' || layout.steps[stepIndex].rows[rowIndex].row.length - 1 === colIndex ? layout.steps[stepIndex].rows[targetRowIndex].row.length - 1 : 0;
                        } else if(colIndex === layout.steps[stepIndex].rows[rowIndex].row.length - 1) {
                            //Switch last index with last index in target row
                            targetColIndex = layout.steps[stepIndex].rows[targetRowIndex].row.length - 1;
                        } else {
                            //Calculate the appropriate index in the target row, selecting the ceiling index when moving column up
                            //and flooring when moving down
                            var ratio = (colIndex + 1) / layout.steps[stepIndex].rows[rowIndex].row.length;
                            targetColIndex = Math.round(ratio * (layout.steps[stepIndex].rows[targetRowIndex].row.length - 2));
                            if (targetColIndex === 0 && layout.steps[stepIndex].rows[targetRowIndex].row.length > 2) {
                                targetColIndex++;
                            } else if(targetColIndex === layout.steps[stepIndex].rows[targetRowIndex].row.length - 1 && layout.steps[stepIndex].rows[targetRowIndex].row.length > 2) {
                                targetColIndex--;
                            }
                        }
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = angular.copy(layout.steps[stepIndex].rows[targetRowIndex].row[targetColIndex].layoutUUID);
                    layout.steps[stepIndex].rows[targetRowIndex].row[targetColIndex].layoutUUID = layoutUUID;
                    this.manageActiveInputPosition(stepIndex, targetRowIndex, targetColIndex);
                    this.manageInputMovementHistory(stepIndex, layout.steps[stepIndex].inputPositionManagement.rowIndex, layout.steps[stepIndex].inputPositionManagement.colIndex, false, false);
                    break;
                case 'alt':
                    /*if (topOrBottomRow) {
                        //Don't do anything if it's the only input in the row.
                        if(layout.steps[stepIndex].rows[rowIndex].row.length === 1) {
                            return;
                        }
                        this.addRow(stepIndex);
                        this.addCol(stepIndex, rowIndex);
                        //copy the input we want to move
                        var layoutUUID = angular.copy(layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID);
                        //remove input from column
                        layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = null;
                        //replace empty input with input we copied.
                        layout.steps[stepIndex].rows[layout.steps[stepIndex].rows.length - 1].row[0].layoutUUID = layoutUUID;
                        if (direction === 'up') {
                            //place the row we that was created at first position.
                            layout.steps[stepIndex].rows.unshift(layout.steps[stepIndex].rows.pop());
                        }
                        this.manageActiveInputPosition(stepIndex, direction === 'up' ? 0 : layout.steps[stepIndex].rows.length - 1, 0);
                        this.manageInputMovementHistory(stepIndex, direction === 'up' ? 1 : layout.steps[stepIndex].rows.length - 2, layout.steps[stepIndex].inputPositionManagement.colIndex, false, true);
                        this.manageInputMovementHistory(stepIndex, layout.steps[stepIndex].inputPositionManagement.rowIndex, layout.steps[stepIndex].inputPositionManagement.colIndex, true, false);
                    } else {
                        if (this.getTotalWidth(stepIndex, targetRowIndex) < MAX_WIDTH) {
                            //we can create a column in the above/below row and insert the input in there.
                            this.addCol(stepIndex, targetRowIndex);
                            var layoutUUID = angular.copy(layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID);
                            //remove input from column
                            layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = null;
                            //replace empty input with input we copied.
                            layout.steps[stepIndex].rows[targetRowIndex].row[layout.steps[stepIndex].rows[targetRowIndex].row.length - 1].layoutUUID = layoutUUID;
                            this.manageActiveInputPosition(stepIndex, targetRowIndex, layout.steps[stepIndex].rows[targetRowIndex].row.length - 1);
                            this.manageInputMovementHistory(stepIndex, layout.steps[stepIndex].inputPositionManagement.rowIndex, layout.steps[stepIndex].inputPositionManagement.colIndex, true, false);
                        } else {
                            resizeColumns(stepIndex, targetRowIndex, layout.steps[stepIndex].rows[targetRowIndex].row.length + 1, false);
                            var layoutUUID = angular.copy(layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID);
                            //remove input from column
                            layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = null;
                            //replace empty input with input we copied.
                            var newColWidth =  MAX_WIDTH - (Math.floor(MAX_WIDTH / (layout.steps[stepIndex].rows[targetRowIndex].row.length + 1)) * layout.steps[stepIndex].rows[targetRowIndex].row.length);
                            newColWidth = layout.steps[stepIndex].rows[targetRowIndex].row.length + 1 <= 12 ? newColWidth : MIN_COL_THRESHOLD;
                            layout.steps[stepIndex].rows[targetRowIndex].row.push({
                                col: updateClass(colClass, newColWidth),
                                layoutUUID: layoutUUID,
                                offset: offsetClass,
                                moveActive: false,
                                activeClass: 'inActiveColumn'
                            });
                            this.manageActiveInputPosition(stepIndex, targetRowIndex, layout.steps[stepIndex].rows[targetRowIndex].row.length - 1, layout.steps[stepIndex].rows[targetRowIndex].row.length - 1);
                            this.manageInputMovementHistory(stepIndex, layout.steps[stepIndex].inputPositionManagement.rowIndex, layout.steps[stepIndex].inputPositionManagement.colIndex, true, false);
                        }
                    }*/
                    break;
            }
        };

        /**
         * Moves to the focus in the direction specified
         * @function
         * @param stepIndex current active step
         * @param direction The direction in which to move the focus - 'left' 'right' 'up' 'down'
         */
        this.navigate = function(stepIndex, direction) {
            switch (direction) {
                case 'left':
                case 'right':
                    var targetColIndex = direction == 'left' ? layout.steps[stepIndex].inputPositionManagement.colIndex - 1 : layout.steps[stepIndex].inputPositionManagement.colIndex + 1;
                    if (targetColIndex >= 0 && targetColIndex < layout.steps[stepIndex].rows[layout.steps[stepIndex].inputPositionManagement.rowIndex].row.length) {
                        this.manageActiveInputPosition(stepIndex, layout.steps[stepIndex].inputPositionManagement.rowIndex, targetColIndex);
                    }
                    break;
                case 'up':
                case 'down':
                    var targetRowIndex = direction == 'up' ? layout.steps[stepIndex].inputPositionManagement.rowIndex - 1 : layout.steps[stepIndex].inputPositionManagement.rowIndex + 1;
                    if (targetRowIndex >= 0 && targetRowIndex < layout.steps[stepIndex].rows.length && layout.steps[stepIndex].rows[targetRowIndex].row.length > 0) {
                        var rowIndex = layout.steps[stepIndex].inputPositionManagement.rowIndex;
                        var colIndex = layout.steps[stepIndex].inputPositionManagement.colIndex;
                        var targetColIndex;
                        if (layout.steps[stepIndex].rows[rowIndex].row.length === layout.steps[stepIndex].rows[targetRowIndex].row.length) {
                            //Rows containing equal amount of columns just switch exact index as expected
                            targetColIndex = colIndex;
                        } else if (colIndex === 0) {
                            //Switch first index with first index in target row
                            targetColIndex = 0;
                        } else if(layout.steps[stepIndex].rows[targetRowIndex].row.length > 0 && layout.steps[stepIndex].rows[targetRowIndex].row.length < 3) {
                            //If target row size is greater than either 1 or 2,
                            //than if we are moving up we want to choose the right most column otherwise
                            //the first column when moving down.
                            targetColIndex = direction === 'up' || layout.steps[stepIndex].rows[rowIndex].row.length - 1 === colIndex ? layout.steps[stepIndex].rows[targetRowIndex].row.length - 1 : 0;
                        } else if(colIndex === layout.steps[stepIndex].rows[rowIndex].row.length - 1) {
                            //Switch last index with last index in target row
                            targetColIndex = layout.steps[stepIndex].rows[targetRowIndex].row.length - 1;
                        } else {
                            //Calculate the appropriate index in the target row, selecting the ceiling index when moving column up
                            //and flooring when moving down
                            var ratio = (colIndex + 1) / layout.steps[stepIndex].rows[rowIndex].row.length;
                            targetColIndex = Math.round(ratio * (layout.steps[stepIndex].rows[targetRowIndex].row.length - 2));
                            if (targetColIndex === 0 && layout.steps[stepIndex].rows[targetRowIndex].row.length > 2) {
                                targetColIndex++;
                            } else if(targetColIndex === layout.steps[stepIndex].rows[targetRowIndex].row.length - 1 && layout.steps[stepIndex].rows[targetRowIndex].row.length > 2) {
                                targetColIndex--;
                            }
                        }
                        this.manageActiveInputPosition(stepIndex, targetRowIndex, targetColIndex);
                    }
                    break;
            }
        };

        /**
         * Function to mark currently selected input as active
         * @function
         * @param stepIndex the current active step
         * @param rowIndex row containing selected input
         * @param colIndex column containing selected input
         */
        this.manageActiveInputPosition = function(stepIndex, rowIndex, colIndex) {
            for (var i in layout.steps[stepIndex].rows) {
                for (var j in layout.steps[stepIndex].rows[i].row) {
                    layout.steps[stepIndex].rows[i].row[j].moveActive = false;
                    layout.steps[stepIndex].rows[i].row[j].activeClass = 'inActiveColumn';
                }
            }
            rowIndex = parseInt(rowIndex);
            colIndex = parseInt(colIndex);
            layout.steps[stepIndex].inputPositionManagement.rowIndex = rowIndex;
            layout.steps[stepIndex].inputPositionManagement.colIndex = colIndex;
            layout.steps[stepIndex].rows[rowIndex].row[colIndex].moveActive = true;
            layout.steps[stepIndex].rows[rowIndex].row[colIndex].activeClass = 'activeColumn';
            layout.steps[stepIndex].inputPositionManagement.activeInputExists = false;
            layout.steps[stepIndex].inputPositionManagement.activeInputExists = true;
            //Reset history if the input has changed.
            if (layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID !== layout.steps[stepIndex].inputPositionManagement.activeInputFieldName) {
                layout.steps[stepIndex].inputPositionManagement.activeInputFieldName  = layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID;
                layout.steps[stepIndex].inputMovementHistory = [];
                this.manageInputMovementHistory(stepIndex, layout.steps[stepIndex].inputPositionManagement.rowIndex, layout.steps[stepIndex].inputPositionManagement.colIndex, false, false);
            }
        };

        /**
         * Returns currently active input's position
         * @function
         * @param stepIndex the current active step
         * @returns {inputPositionManagement|{colIndex, rowIndex, activeInputExists}|stepBase.inputPositionManagement|*}
         */
        this.getActiveInputPosition = function(stepIndex) {
            return layout.steps[stepIndex].inputPositionManagement;
        };

        /**
         * This function verifies if there is an existing active input selected.
         * If no active input is found, the input in the first column and row will be selected
         * @param stepIndex the current active step
         * @returns {boolean} whether an active input exists
         */
        this.verifyActiveInputExists = function(stepIndex) {
            if (!layout.steps[stepIndex].inputPositionManagement.activeInputExists) {
                if (layout.steps[stepIndex].rows.length > 0) {
                    //Make the first available row/column active if it exists
                    this.manageActiveInputPosition(stepIndex, 0, 0);
                    return true;
                }
                return false;
            }
            return true;
        };

        /**
         * Function to check if an active column exists
         * @function
         * @param stepIndex current active step
         * @returns {boolean} If there is an active column
         */
        this.isActiveColumn = function (stepIndex) {
            return layout.steps[stepIndex].inputPositionManagement.activeInputExists;
        };

        /**
         * Function to select the next available column.
         * If position of previous column is still valid, it will be marked as the active column
         * In the case previous column is not valid, the next previous column will become active
         * If no columns remain on the previous row, the next available row's first column will be selected.
         * @function
         * @param stepIndex current active step
         */
        this.selectNextAvailableColumn = function(stepIndex) {
            //Attempt to update active column
            var rowIndex = layout.steps[stepIndex].inputPositionManagement.rowIndex;
            var colIndex = layout.steps[stepIndex].inputPositionManagement.colIndex;
            if (rowIndex < layout.steps[stepIndex].rows.length) {
                //start row from selected row if it still exists otherwise the next available row
                for (var i = rowIndex < layout.steps[stepIndex].rows.length ? rowIndex : rowIndex - 1; i >= 0; i--) {
                    for (var j = layout.steps[stepIndex].rows[i].row.length-1; j >= 0; j--) {
                        if (rowIndex === i && colIndex === j) {
                            //keep the same column active (would have been the column after the column we removed)
                            this.manageActiveInputPosition(stepIndex, i, j, true);
                            return;
                        } else if (rowIndex === i && colIndex > j) {
                            //make active the previous column to the column that was removed
                            this.manageActiveInputPosition(stepIndex, i, j, true);
                            return;
                        } else if (i < rowIndex) {
                            //if we werent able to select a column in the same row, then select next available rows first column
                            this.manageActiveInputPosition(stepIndex, i, 0, true);
                            return;
                        }
                    }
                }
            } else {
                layout.steps[stepIndex].inputPositionManagement.activeInputExists = false;
            }
        };

        /**
         * This function is responsible for removing any empty columns created during the movement of an input.
         * It will only delete the intermediate movement if it was created programmatically when moving an input.
         * @function
         * @param stepIndex step that we are working on
         * @param rowIndex the current row position of the moved element
         * @param colIndex the current col position of the moved element
         * @param createdColumn Whether the column was created during the movement of the input
         * @param updatePreviousMovement Whether this call is to update the previous movement.
         */
        this.manageInputMovementHistory = function(stepIndex, rowIndex, colIndex, createdColumn, updatePreviousMovement) {
            if (updatePreviousMovement) {
                layout.steps[stepIndex].inputMovementHistory[0].rowIndex = rowIndex;
                layout.steps[stepIndex].inputMovementHistory[0].colIndex = colIndex;
                layout.steps[stepIndex].inputMovementHistory[0].createdColumn = createdColumn;
                return;
            }
            var historyItem = angular.copy(historyMovementTemplate);
            historyItem.rowIndex = rowIndex;
            historyItem.colIndex = colIndex;
            historyItem.createdColumn = createdColumn;

            layout.steps[stepIndex].inputMovementHistory.push(historyItem);
            //Check if we should remove the intermediate history item, if there is one.
            if (layout.steps[stepIndex].inputMovementHistory.length === 2) {
                if (layout.steps[stepIndex].inputMovementHistory[0].createdColumn && layout.steps[stepIndex].rows[layout.steps[stepIndex].inputMovementHistory[0].rowIndex].row[layout.steps[stepIndex].inputMovementHistory[0].colIndex].layoutUUID === null) {
                    var columnToRemove = layout.steps[stepIndex].inputMovementHistory.splice(0, 1)[0];
                    this.removeCol(stepIndex, columnToRemove.rowIndex, columnToRemove.colIndex);
                } else {
                    //shift elements to the left, removing the first element.
                    layout.steps[stepIndex].inputMovementHistory.shift();
                }
            }
        };

        this.updateActiveInputPosition = function(stepIndex) {
            for (var i in layout.steps[stepIndex].rows) {
                for (var j in layout.steps[stepIndex].rows[i].row) {
                    if (layout.steps[stepIndex].rows[i].row[j].moveActive) {
                        //Update position of active column
                        layout.steps[stepIndex].inputPositionManagement.rowIndex = parseInt(i);
                        layout.steps[stepIndex].inputPositionManagement.colIndex = parseInt(j);
                        //Update history of the position.
                        this.manageInputMovementHistory(stepIndex, i, j, layout.steps[stepIndex].inputMovementHistory[0].createdColumn, true);
                        return;
                    }
                }
            }
            //If no active column reset position to null
            layout.steps[stepIndex].inputPositionManagement.rowIndex = null;
            layout.steps[stepIndex].inputPositionManagement.colIndex = null;
        };
        /**************************************************************************************************************/
        /***********************************Handle add/remove/move of input from fbc***********************************/
        /**************************************************************************************************************/

        this.handleInputMove = function(currentStep, targetStep, layoutUUID) {
            this.handleInputRemoval(currentStep, layoutUUID);
            this.addRow(targetStep);
            this.addInput(targetStep, layout.steps[targetStep].rows.length - 1, 0, layoutUUID);
        };

        this.handleInputRemoval = function(currentStep, layoutUUID) {
            for (var rowIndex in layout.steps[currentStep].rows) {
                for (var colIndex in layout.steps[currentStep].rows[rowIndex].row) {
                    if (layout.steps[currentStep].rows[rowIndex].row[colIndex].layoutUUID === layoutUUID) {
                        //Remove input
                        if (layout.steps[currentStep].rows[rowIndex].row.length > 1) {
                            layout.steps[currentStep].rows[rowIndex].row[colIndex].layoutUUID = null;
                        }//Remove row
                        else {
                            this.removeRow(currentStep, rowIndex);
                        }
                    }
                }
            }
        };

        this.handleInputAdd = function(currentStep, layoutUUID) {
            this.addRow(currentStep);
            layout.steps[currentStep].rows[layout.steps[currentStep].rows.length - 1].row[0].layoutUUID = layoutUUID;
        };
    };

    angular
    .module('formFactory')
    .service('ffLayoutService', ['$log', layoutService]);
})();
(function () {
	'use strict';

	var inputValidationDirective = function ($log, contextualData, ffValidationService, $timeout) {

		var directive = {
			restrict: 'A',
			require: ['ngModel'],
			link: linkFunction
		};

		return directive;

		function linkFunction(scope, el, attr, ctrls) {
			var fbc = scope.$parent.$parent.$parent.fbc;
			var model = ctrls[0];
			var nameExists = false;
			var inputDiv = $(el).parent();

			model.$viewChangeListeners.push(function() {
				nameExists = false;
				var s = fbc.form.steps[fbc.currentStep].inputs;
				for (var input1 in s) {
					for (var input2 in s) {
						if (input1 !== input2 && s[input1].name === s[input2].name) {
							nameExists = true;
							fbc.containsDuplicateInput = true;
						}
					}
				}

				if (!nameExists) {
					fbc.containsDuplicateInput = false;
					inputDiv.removeClass('has-error');
					inputDiv.find('.help-block').addClass('hide');
				}
				else {
					inputDiv.addClass('has-error');
					inputDiv.find('.help-block').removeClass('hide');
				}

			});
		}
	};

	angular
		.module('formFactory')
		.directive('ffNameUniquenessCheck', ['$log', 'contextualData', 'ffValidationWorker', '$timeout', inputValidationDirective]);
})();
onmessage = function(e) {
    'use strict';

    var layoutInvalid = false;
    var messages = [];
    if (e.data.layout !== null && e.data.layout.active && e.data.layout.steps.length > 0) {
        var runningInputCount = 0;
        for (var i in e.data.layout.steps[e.data.currentStep].rows) {
            for (var j in e.data.layout.steps[e.data.currentStep].rows[i].row) {
                //check each column if there is an input assigned.)
                if (e.data.layout.steps[e.data.currentStep].rows[i].row[j].layoutUUID !== undefined &&
                    e.data.layout.steps[e.data.currentStep].rows[i].row[j].layoutUUID !== null &&
                    e.data.layout.steps[e.data.currentStep].rows[i].row[j].layoutUUID.trim() !== '') {
                    runningInputCount++;
                }
            }
        }

        //If not all inputs have been added to the current step's layout, then notify user
        //with a warning.
        if (runningInputCount !== e.data.steps[e.data.currentStep].inputs.length) {
            messages.unassignedElement = {};
            messages.unassignedElement.validationMessage = 'angular.ffFormBuilderDirective.message.unassignedElement';
            messages.unassignedElement.errorInfo = '';
            messages.unassignedElement.toastId = 'ue';
            messages.unassignedElement.class = 'warning';
        }
        for (var i = e.data.layout.steps.length-1; i >= 0; i--) {
            var containsAnInput = false;
            for (var j in e.data.layout.steps[i].rows) {
                for (var k in e.data.layout.steps[i].rows[j].row) {
                    if (e.data.layout.steps[i].rows[j].row[k].layoutUUID !== undefined &&
                        e.data.layout.steps[i].rows[j].row[k].layoutUUID !== null &&
                        e.data.layout.steps[i].rows[j].row[k].layoutUUID.trim() !== '') {
                        containsAnInput = true;
                        break;
                    }
                }
                if (containsAnInput) {
                    break;
                }
            }
            if (containsAnInput) {
                containsAnInput = false;
            } else {
                //If step contains no input, flag layoutInvalid error
                messages.layoutStepInvalid = {};
                messages.layoutStepInvalid.validationMessage = 'angular.ffFormBuilderDirective.message.layoutStepInvalid';
                messages.layoutStepInvalid.errorInfo = e.data.steps[i].label !== "" ? "'" + e.data.steps[i].label + "'" : "'name is empty'";
                messages.layoutStepInvalid.stepIndex = i;
                messages.layoutStepInvalid.toastId = 'lsi';
                messages.layoutStepInvalid.class = 'error';
                layoutInvalid = true;
                break;
            }
        }
    }
    postMessage({
        flag: 'stepContainsUnassignedElements',
        flagValue: layoutInvalid,
        callbacks: [
            {
                callback: 'unassignedElementsNotification',
                args: messages
            }
        ]
    });
    //Remove thread!!!
    close();
};onmessage = function (e) {
	var hasInvalidLogics = false;

	if (e.data.input.logics !== undefined) {
		//Check that all values are set
		for (var i in e.data.input.logics) {
			switch (e.data.type) {
				case 'any' :
					if (e.data.input.logics[i].requiredValue === undefined
						|| e.data.input.logics[i].requiredValue === ""
						|| e.data.input.logics[i].requiredValue === null) {
						hasInvalidLogics = true;
					}
					break;
				case 'number' :
					if (e.data.input.logics[i].requiredValue === undefined
						|| e.data.input.logics[i].requiredValue === ""
						|| e.data.input.logics[i].requiredValue === null
						|| isNaN(e.data.input.logics[i].requiredValue)) {
						hasInvalidLogics = true;
					}
					break;
			}
		}
	}

	//Pass flag value to disable/enable UI elements and callback(s) with messages
	postMessage({
		flag: "containsInvalidLogics",
		flagValue: hasInvalidLogics,
		callbacks: []
	});
	//Remove thread!!!
	close();
};
(function () {
	'use strict';

	var logicsSyncronizerDirective = function ($log) {

		var directive = {
			restrict: 'A',
			require: ['ngModel'],
			link: linkFunction
		};

		return directive;

		function linkFunction(scope, el, attr, ctrls) {
			var fbc = scope.$parent.$parent.$parent.fbc;
			var model = ctrls[0];
			var s = fbc.form.steps[fbc.currentStep].inputs;

			//Do not debounce since in this case we cannot guarantee that old will be the same as last stored fieldName
			scope.$watch(function() {
				return model.$modelValue;
			}, _.debounce(function(newValue, oldValue) {
				for (var i in s) {
					for (var logic in s[i].logics) {
						if (s[i].logics[logic].fieldName === oldValue) {
							s[i].logics[logic].fieldName = newValue;
						}
					}
				}
			}, 0));
		}
	};

	angular
		.module('formFactory')
		.directive('ffLogicsSyncronizer', ['$log', logicsSyncronizerDirective]);
})();
(function() {
    'use strict';

    var editActionDisplay = function($log, $compile, $timeout) {
        var directive = {
            restrict: 'E',
            require: ['^ffController'],
            scope: {
                form: '=',
                action: '=',
                inTranslateMode: '=',
                containsInvalidAction: '='
            },
            link: linkFunc
        };
        return directive;

        function linkFunc(scope, el, attr, ctrls) {
            scope.formController = ctrls[0].getFormController();
            if (scope.action.wizard) {
                el.append($compile(scope.action.wizard)(scope));
            }

            scope.fields = {};

            //Validate fields when a field's value has changed.
            scope.$on('validateFields', function() {
                validateFields();
                //Emit event after fields have been validated.
                $timeout(function() {
                    scope.$emit('validateActions', null);
                });
            });

            /**
             * Checks the validity of all fields and sets the side panel's
             * close status accordingly.
             * @function
             */
            function validateFields() {
                var isValid = true;
                for (var i in scope.fields) {
                    if (!scope.fields[i]) {
                        isValid = false;
                        break;
                    }
                }
                scope.containsInvalidAction = !isValid;
            }

            scope.isFieldValid = function(fieldName) {
                return scope.fields[fieldName];
            };
        }
    };

    angular
        .module('formFactory')
        .directive('ffEditActionDisplay', ['$log', '$compile', '$timeout', editActionDisplay]);

    var actionValidator = function($log) {
        var directive = {
            restrict: 'A',
            require: ['^ngModel'],
            link: linkFunc
        };
        return directive;

        function linkFunc(scope, el, attr, ctrls) {
            var model = ctrls[0];
            var fieldName = attr.fieldName;
            var validationType = attr.validationType;
            //Email regexp
            var emailRegexp = /^[A-Z0-9._%+-]{1,64}@(?:[A-Z0-9-]{1,63}\.){1,125}[A-Z]{2,63}$/i;
            //set options for model if options has not been defined.
            if (!('ngModelOptions' in attr)) {
                model.$options = {
                    updateOn: 'blur',
                    updateOnDefault: true,
                    debounce: {
                        blur: 0,
                        default: 500
                    }
                };
            }

            model.$validators[fieldName] = function(newValue) {

                var isValid = true;
                //Validate value based on the supplied validation type.
                switch (validationType) {
                    case 'number' :
                        if (newValue === undefined || newValue === '' || newValue === null || isNaN(newValue)) {
                            isValid = false;
                        }
                        break;
                    case 'positiveNumber' :
                        if (newValue === undefined || newValue === '' || newValue === null || isNaN(newValue) || newValue < 0) {
                            isValid = false;
                        }
                        break;
                    case 'email' :
                        if (!emailRegexp.test(newValue)) {
                            isValid = false;
                        }
                        break;
                    case 'any' :
                    default :
                        if (newValue === undefined || newValue === "" || newValue === null) {
                            isValid = false;
                        }
                        break;
                }
                scope.fields[fieldName] = isValid;
                //Emit an event to the editActionTab directive to update
                //the status of the action's validity
                scope.$emit('validateFields', null);
                return isValid;
            };
        }
    };

    angular
        .module('formFactory')
        .directive('ffActionValidator', ['$log', '$compile', actionValidator]);
})();(function() {

    'use strict';

    var editActionTab = function($log, contextualData) {
        var directive = {
            restrict: 'E',
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editaction/editActionTab.html',
            link: linkFunc
        };
        return directive;

        function linkFunc(scope, el, attr, ctrl) {
            scope.$on('validateActions', function() {
                //Run validation worker to check actions
                scope.fbc.stepValidityCheck();
            });
        }
    };

    angular
        .module('formFactory')
        .directive('ffEditActionTab', ['$log', 'contextualData', editActionTab]);
})();(function () {
	'use strict';

	var nodePicker = function (contextualData) {
		var directive = {
			restrict: "E",
			scope: {
				//selectedPath: '=ngModel',
				selectedPath: '=',
				selectedId: '=',
				selectedName: '=',
				nodeTypes: '@',
				selectableNodeTypes: '@',
				rootPath: '@',
				label: '@'
			},
			controller: NodePickerController,
			controllerAs: 'npc',
			bindToController: true,
			link: function (scope, element, attrs) {
				if (!attrs.selectedId) {
					scope.selectedIdSpecified = false;
				} else {
					scope.selectedIdSpecified = true;
				}
			},
			templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editaction/pickerPopup.html'
		};

		return directive;
	};

	var NodePickerController = function ($scope, $modal, contextualData) {
		var npc = this;
		npc.openPicker = openPicker;
		npc.selectedPath = npc.selectedPath === '' ? contextualData.sitePath : npc.selectedPath;
		npc.selectedName = npc.selectedName === '' ? '' : npc.selectedName;

		function openPicker() {
			var modalInstance = $modal.open({
				backdrop: false,
				templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editaction/nodePicker.html',
				controller: function ($scope, $uibModalInstance, ds) {
					$scope.root = {};

					function selectInTree() {
						if (npc.selectedPath) {
							$scope.root.children.forEach(function (child) {
								if (npc.selectedPath != child.path && npc.selectedPath.indexOf(child.path) == 0) {
									$scope.toggle(child, selectItemInTree)
								}
							});
						}
					}

					function selectItemInTree(item) {
						if (npc.selectedPath && item && item.hasChildren && item.children.length > 0) {
							item.displayed = true;
							item.children.forEach(function (child) {
								if (npc.selectedPath != child.path && npc.selectedPath.indexOf(child.path) == 0) {
									$scope.toggle(child, selectItemInTree)
								}
							});
						}
					}

					// init get root node
					$.ajax({
						type: "GET",
						dataType: "json",
						url: (npc.rootPath ? contextualData.urlBase + npc.rootPath : contextualData.urlSiteBase) + ".treeRootItem.json?nodeTypes=" + npc.nodeTypes + (ds.selectableNodeTypes ? "&selectableNodeTypes=" + ds.selectableNodeTypes : "")
					}).done(function (data) {
						$scope.$apply(function () {
							if (data && data.length > 0) {
								$scope.root = data[0];
								$scope.root.displayed = true;
								$scope.$watch(function () {
									return npc.selectedPath;
								}, selectInTree);
							}
						});
					});

					$scope.getIcon = function (isRoot, item) {
						if (isRoot) {
							return "fa fa-globe";
						}

						if (item) {
							if ($scope.isSelectable(item)) {
								return "fa fa-file";
							} else {
								return "fa fa-folder"
							}
						}

						return "fa fa-file";
					};

					$scope.getArrow = function (item) {
						if (item.hasChildren) {
							if (item.displayed) {
								return "fa fa-chevron-down";
							} else {
								return "fa fa-chevron-right";
							}
						}
						return "";
					};

					$scope.getItemClass = function (item) {
						if ($scope.isSelected(item)) {
							return "selected cursorPointer";
						}

						if ($scope.isSelectable(item)) {
							return "selectable cursorPointer";
						}
					};

					$scope.isSelectable = function (item) {
						return "selectable" == item.classes;
					};

					$scope.isSelected = function (item) {
						return item.path == npc.selectedPath;
					};

					$scope.select = function (item) {
						//console.log(item);
						if ("selectable" == item.classes) {
							npc.selectedName = item.text;
							npc.selectedPath = item.path;
							$uibModalInstance.close(item)
						}
					};

					$scope.closeModal = function () {
						$uibModalInstance.dismiss('cancel');
					};

					$scope.toggle = function (item, cb) {
						if (item.hasChildren) {
							if (item.children && item.children.length > 0) {
								item.displayed = !item.displayed;
								if (cb) {
									cb(item)
								}
							} else {
								$.ajax({
									type: "GET",
									dataType: "json",
									url: contextualData.urlBase + item.path + ".treeRootItem.json?nodeTypes=" + npc.nodeTypes + (ds.selectableNodeTypes ? "&selectableNodeTypes=" + ds.selectableNodeTypes : "")
								}).done(function (data) {
									var children = data && data.length > 0 ? data[0].children : [];
									$scope.$apply(function () {
										item.children = children;
										item.displayed = true;
										if (cb) {
											cb(item)
										}
									});
								});
							}
						}
					};
				},
				size: 'sm',
				resolve: {
					ds: function () {
						return $scope;
					}
				}
			});

			modalInstance.result.then(function (item) {
				$scope.selectedPath = item.path;
				if ($scope.selectedIdSpecified) {
					$scope.selectedId = item.id;
				}
			});

		}
	};

	NodePickerController.$inject = ['$scope', '$uibModal', 'contextualData'];

	angular
		.module('formFactory')
		.directive('ffNodePicker', ['contextualData', nodePicker]);
})();(function() {
	'use strict';
	var callbackEditor = function($log, contextualData) {

		var directive = {
			restrict: 'E',
			scope: {
				clbks: '='
			},
			templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editformmetadata/callbacktab/callback.html',
			controller: CallbackEditorController,
			controllerAs: 'cbe',
			bindToController: true,
			link: linkFunc
		};

		return directive;

		function linkFunc(scope, el, attr, ctrls) {}
	};

	angular
		.module('formFactory')
		.directive('ffCallbackEditor', ['$log', 'contextualData', callbackEditor]);

	var CallbackEditorController = function($scope, $log, ffDataFactory, contextualData, $i18n) {
		var cbe = this;
		cbe.callbacks = [];
		cbe.callbackName = null;
		cbe.data = [];
		cbe.callbackOn = false;
		cbe.message = $i18n.message;
		cbe.toggleON = toggleOn;
		cbe.addSelected = addSelected;
		cbe.removeCallback = removeCallback;

		activate();

		function activate() {
			ffDataFactory.getData(contextualData.context + '/modules/formfactory/builder/definitionslist/callbacks/' + contextualData.siteIdentifier + '/' + contextualData.language)
				.then(function(data) {
					var tmp = (cbe.clbks !== null) ? cbe.clbks.callbacks : [];
					for (var i in data) {
						if (!_.contains(tmp, i)) {
							cbe.callbacks.push(i);
						}
						cbe.data.push(i);
					}

					if (tmp.length > 0) {
						cbe.callbackOn = true;
					}

					cbe.activated = true;

					//Reset callback value in case the underlying directive no longer exists/available
					if (cbe.callbacks.length === 0 && tmp.length === 0) {
						cbe.callbackOn = false;
					}
				});
		}

		function toggleOn() {
			if (!cbe.callbackOn) {
				cbe.clbks = null;
			}
			else {
				cbe.callbacks = angular.copy(cbe.data);
				cbe.clbks = {
					"callbacks":[],
					"displayTemplates":true
				};
			}
		}

		function addSelected() {
			if (cbe.callbackName !== null) {
				cbe.clbks.callbacks.push(cbe.callbackName);
				cbe.callbacks = allExcept(cbe.callbacks, cbe.callbackName);
			}
		}

		function removeCallback(callback) {
			cbe.clbks.callbacks = allExcept(cbe.clbks.callbacks, callback);
			cbe.callbacks.push(callback);
		}

		function allExcept(array, exception) {
			var a = [];
			for (var i in array) {
				if (array[i] !== exception && array[i] !== null) {
					a.push(array[i]);
				}
			}
			return a;
		}

	};

	CallbackEditorController.$inject = ['$scope', '$log', 'ffDataFactory', 'contextualData', 'i18nService'];
})();(function() {
    'use strict';
    var metaDataEditor = function($log, contextualData, ffDataFactory) {

        var directive = {
            restrict: 'E',
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editformmetadata/metaDataEditor.html',
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ctrls) {
            scope.hasThemes = false;
            scope.activeTab = 'edit-meta-data';
            scope.updateActiveTab = updateActiveTab;
            scope.getImgSrc = getImgSrc;

            ffDataFactory.getData(contextualData.context + '/modules/formfactory/builder/themes/' + contextualData.siteIdentifier ).then(function(data) {
                if(data.length > 0) {
                    scope.hasThemes = true;
                }
            });
            //Setup the object that will contain img paths for each tab that has an associated image to it
            scope.icons = {
                'callback': {
                    active: null,
                    inactive: null
                },
                'edit-meta-data': {
                    active: null,
                    inactive: null
                },
                'progress-bar': {
                    active: null,
                    inactive: null
                },
                'theme': {
                    active: null,
                    inactive: null
                }
            };
            //Setup the paths for both active and inactive icons for each tab
            for (var i in scope.icons) {
                scope.icons[i].active = contextualData.context + '/modules/form-factory-core/img/metaDataIcons/' + i + '_active.png';
                scope.icons[i].inactive = contextualData.context + '/modules/form-factory-core/img/metaDataIcons/' + i + '_inactive.png';
            }

            /**
             * Sets the currently active tab
             * @function
             * @param tab - currently active tab
             */
            function updateActiveTab(tab) {
                scope.activeTab = tab;
            }

            /**
             * Retrieves the appropriate path for the tab (active/inactive based on it's state)
             * @function
             * @param tab - the to retrieve the path for
             * @returns string - the active/inactive path of the tab
             */
            function getImgSrc(tab) {
                return tab === scope.activeTab ? scope.icons[tab].active : scope.icons[tab].inactive;
            }
        }
    };

    angular
        .module('formFactory')
        .directive('ffMetaDataEditor', ['$log', 'contextualData', 'ffDataFactory', metaDataEditor]);
})();(function() {
    'use strict';

    var editLanguages = function($log, contextualData) {

        var directive = {
            restrict: 'E',
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editformmetadata/languagestab/editLanguages.html',
            controller: EditLanguagesController,
            controllerAs: 'elc',
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ctrls) {}

    };

    angular
        .module('formFactory')
        .directive('ffEditLanguages', ['$log', 'contextualData', editLanguages]);

    var EditLanguagesController = function($scope, $log) {
        var elc = this;
        elc.selectedLanguagesToAdd = null;
        elc.existingLanguages = $scope.fbc.form.existingLanguages;
        elc.missingLanguages = $scope.fbc.form.missingLanguages;
        elc.addLanguages = addLanguages;
        elc.isLanguageSelected = false;
        elc.updateAddButton = updateAddButton;
        elc.removeLanguage = removeLanguage;
        elc.isMissingLanguages = false;
        elc.newlyAddedLanguages = {};

        init();

        /**
         * Initialization of any required variables
         * @function
         */
        function init() {
            elc.isMissingLanguages = !_.isEmpty(elc.missingLanguages);
            //track all the missing languages that are existing at this point so that we can
            //revert any added languages if the user requires this before closing the language tab
            _.each(elc.missingLanguages, function(language, code) {
                elc.newlyAddedLanguages[code] = false;
            });
        }

        /**
         * This function will add the selected missing languages to existing languages
         * @function
         */
        function addLanguages() {
            _.each(elc.selectedLanguagesToAdd, function(code) {
                elc.existingLanguages[code] = elc.missingLanguages[code];
                elc.newlyAddedLanguages[code] = true;
                delete elc.missingLanguages[code];
            });
            elc.selectedLanguagesToAdd = [];
            elc.isMissingLanguages = !_.isEmpty(elc.missingLanguages);
            //Update the add button after each addition of language(s)
            updateAddButton();
        }

        /**
         * Updates the flag that is used to disable and enable
         * the add button for the addition of languages
         * @function
         */
        function updateAddButton() {
           elc.isLanguageSelected = !_.isEmpty(elc.selectedLanguagesToAdd);
        }

        /**
         * This function will remove the language from existingLanguages
         * back to missingLanguages
         * @function
         * @param code the language code for the language that will be removed
         */
        function removeLanguage(code) {
            elc.missingLanguages[code] = elc.existingLanguages[code];
            elc.newlyAddedLanguages[code] = false;
            delete elc.existingLanguages[code];
            //update flag to ensure that we now have missing languages to display
            elc.isMissingLanguages = true;
        }
    };
    EditLanguagesController.$inject = ['$scope', '$log'];
})();(function() {
    'use strict';
    var metaDataEditor = function($log, contextualData) {

        var directive = {
            restrict: 'E',
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editformmetadata/metadatatab/metaDataTab.html',
            controller: MetaDataEditorController,
            controllerAs: 'mdec',
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ctrls) {}
    };

    angular
        .module('formFactory')
        .directive('ffMetaDataTab', ['$log', 'contextualData', metaDataEditor]);

    var MetaDataEditorController = function($scope, $log, contextualData, $sce, i18n) {
        var mdec = this;
        mdec.formInvalidMessage = '';
        mdec.hasCaptcha = contextualData.hasCaptcha;
        mdec.formRenameWarning = $sce.trustAsHtml(i18n.message('fcnt_metaData.formRenamingWarningMessage'));
    };

    MetaDataEditorController.$inject = ['$scope', '$log', 'contextualData', '$sce', 'i18nService'];
})();(function () {
	'use strict';
	var progressBarEditor = function ($log, $compile, contextualData) {

		var directive = {
			restrict: 'E',
			controller: ProgressBarEditorController,
			controllerAs: 'pbec',
			bindToController: true,
			templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editformmetadata/progressbartab/progressBarEditor.html',
			link: linkFunc
		};

		return directive;

		function linkFunc(scope, el, attr, ctrls) {}
	};

	var ProgressBarEditorController = function ($scope, $log, $compile, ffDataFactory, contextualData) {
		var pbec = this;
		pbec.toggle = false;
		pbec.progressBarsCache = null;
		pbec.retrieveProgressBars = retrieveProgressBars;
		pbec.syncData = syncData;

		activate();

		function activate() {
			retrieveProgressBars();
			if ($scope.fbc.form.progressBar !== null) {
				pbec.toggle = true;
			}
		}

		/**
		 * Retrieves available progress bars.
		 *
		 * @function
		 */
		function retrieveProgressBars() {
			if (pbec.progressBarsCache === null) {
				ffDataFactory.customRequest({
					url: contextualData.context + '/modules/formfactory/builder/definitionslist/progressBars/' + contextualData.siteIdentifier + '/' + 'en',
					method: 'GET'
				}).then(function (response) {
					pbec.progressBarsCache = response;
				});
			}
		}

		function syncData() {
			if (pbec.toggle) {
                $scope.fbc.form.progressBar = pbec.progressBarsCache[Object.keys(pbec.progressBarsCache)[0]];
			} else {
                $scope.fbc.form.progressBar = null;
			}
		}
 	};

	ProgressBarEditorController.$inject = ['$scope', '$log', '$compile', 'ffDataFactory', 'contextualData'];

	angular
		.module('formFactory')
		.directive('ffProgressBarEditor', ['$log', '$compile', 'contextualData', progressBarEditor]);
})();angular.module('formFactory')
	.directive('ffProgressBarViewChooser', ['$log', '$compile', function ($log, $compile) {
		var directive = {
			restrict: 'E',
			replace: true,
			scope: {
				form: '=',
				currentStep: '='
			},
			link: linkFunc
		};

		return directive;

		function linkFunc(scope, el, attr) {
			if (scope.form.progressBar != null)
				el.append($compile(scope.form.progressBar.template)(scope));
			//Replace directive when viewType changes
			scope.$watch(function () {
					if (scope.form.progressBar != null)
						return scope.form.progressBar.nodeType;
					return null;
				}, function () {
					if (scope.form.progressBar != null)
						el.html($compile(scope.form.progressBar.template)(scope));
				}
			);
		}
	}]);
(function() {
    'use strict';
    var themeDirective = function($log, contextualData, ffDataFactory) {

        var directive = {
            restrict: 'E',
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editformmetadata/themetab/themeTab.html',
            controller: themeController,
            controllerAs: 'tc',
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ctrls) {
        }
    };

    angular
        .module('formFactory')
        .directive('ffTheme', ['$log', 'contextualData', themeDirective]);

    var themeController = function($scope, $log, ffDataFactory, contextualData, i18nService) {
        var tc = this;
        tc.themeStatusChange = themeStatusChange;
        init();

        function init() {
            ffDataFactory.getData(contextualData.context + '/modules/formfactory/builder/themes/' + contextualData.siteIdentifier ).then(function(data) {
                tc.themeEnabled = !!(!_.isUndefined($scope.fbc.form.theme) && $scope.fbc.form.theme !== null);
                tc.themes = [];
                angular.forEach(data, function(theme){
                    tc.themes.push({id:theme,name:i18nService.message('label.themes.'+theme.toLowerCase()+'.display.name')})
                })
            });
        }

        function themeStatusChange() {
            if (!tc.themeEnabled) {
                delete $scope.fbc.form.theme;
            }
        }
    };

    themeController.$inject = ['$scope', '$log', 'ffDataFactory', 'contextualData', 'i18nService'];
})();
(function() {
    'use strict';
    var topSelectionsSelection = function(contextualData) {
        var directive = {
            restrict        : 'E',
            scope           : {
                topSelections: '=',
                countries    : '='
            },
            controller      : CountrySelectionController,
            controllerAs    : 'csc',
            bindToController: true,
            templateUrl     : contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/countrytop/countryTopSelection.html',

            link            : linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr) {
		}
    };

    var CountrySelectionController = function($scope) {
        var csc = this;
        csc.addToTop = addToTop;
        csc.removeFromTop = removeFromTop;
        csc.swapCountry = swapCountry;
        csc.currentSelection = null;
        csc.selectedObjects = [];

        activate();

        function activate() {
            //Prepopulate selectedObjects
            for (var i in csc.topSelections) {
                csc.selectedObjects.push(angular.copy(csc.countries[i]));
            }
        }

        /**
         * Update topSelections array to propagate changes throughout the model.
         */
        function addToTop() {
            if (notInTop(csc.currentSelection.country.key)) {
                csc.topSelections.push(csc.currentSelection.country.key);
                csc.selectedObjects.push(angular.copy(csc.currentSelection));
            }
            csc.currentSelection = null;
        }

        function removeFromTop(index) {
            var newSelectedObjects = [];
            var newTopSelections = [];
            for (var i in csc.selectedObjects) {
                if (i != index) {
                    newSelectedObjects.push(csc.selectedObjects[i]);
                    newTopSelections.push(csc.selectedObjects[i].country.key);
                }
            }
            csc.topSelections = newTopSelections;
            csc.selectedObjects = newSelectedObjects;
        }

        function notInTop(key) {
            for (var i in csc.topSelections) {
                if (key === csc.topSelections[i]) {
                    return false;
                }
            }
            return true;
        }

        function swapCountry($index) {
            csc.selectedObjects.splice($index, 1);
            csc.topSelections = [];
            for (var i in csc.selectedObjects) {
                csc.topSelections.push(csc.selectedObjects[i].country.key);
            }
        }
    };

    CountrySelectionController.$inject = ['$scope'];

    angular
    .module('formFactory')
    .directive('ffCountryTopSelection', ['contextualData', topSelectionsSelection]);
})();
(function () {
	'use strict';
	var designInput = function ($compile, ffDataFactory, $log, contextualData, $timeout) {
		var directive = {
			restrict: 'E',
			require: ['^ffController'],
			scope: {
				input: '=',
				duplicateKeyDetected: '=',
				inTranslateMode: '=',
				containsInvalidInput: '=',
				containsInvalidKeyValue: '='
			},
			link    : linkFunc
		};

		return directive;

		function linkFunc(scope, el, attr, ctrls) {
			scope.readOnly = !ctrls[0].isLiveMode();
			//Listen to keyvalue directive
			scope.$on('containsInvalidKeyValue', function(event, result) {
				scope.containsInvalidKeyValue = result;
			});

			if (scope.input.wizard !== undefined) {
				var compiled = $compile(scope.input.wizard)(scope);
				el.append(compiled);
			}

			scope.fieldsStatus = {};
			for (var i in scope.input.definitionOptions) {
				scope.fieldsStatus[scope.input.definitionOptions[i]] = true;
			}
			scope.$on('requiredValueChanged', function (event, data) {
				scope.fieldsStatus[data.fieldId] = data.isValid;
				scope.containsInvalidInput = areFieldsInvalid();
			});
			function areFieldsInvalid() {
				for (var i in scope.fieldsStatus){
					if (!scope.fieldsStatus[i]) {
						return true;
					}
				}
				return false;
			}
			scope.isFieldValid = function(fieldId) {
				return scope.fieldsStatus[fieldId];
			};

			//Listen for duplicate key check
			scope.$on('duplicateKeyCheck', function(event, isInvalid){
				scope.duplicateKeyDetected = isInvalid;
			});
		}
	};

	angular
		.module('formFactory')
		.directive('ffDesignInput', ['$compile', 'ffDataFactory', '$log', 'contextualData', '$timeout', designInput]);
})();
(function () {
	'use strict';
	var editInputTabs = function ($log, contextualData) {
		var directive = {
			restrict: 'E',
			templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/editInputTabs.html',
			link    : linkFunc
		};

		return directive;

		function linkFunc(scope, el, attr, ctrl) {}
	};

	angular
		.module('formFactory')
		.directive('ffEditInputTabs', ['$log', 'contextualData', editInputTabs]);
})();(function() {
    'use strict';

    var inputBucket = function($log, contextualData) {

        var directive = {
            restrict: 'E',
            scope: {
                fieldName: '=',
                setDefault: '=',
                displayTitle: '=',
                availableInputs: '=',
                bucketMode: '=',
                multiStepMode: '=',
                emitOnChange: '@?',
                broadcast: '&?'
            },
            controller: InputBucketController,
            controllerAs: 'ibc',
            bindToController: true,

            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/inputBucket.html',
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ctrls) {}
    };

    angular
        .module('formFactory')
        .directive('ffInputBucket', ['$log', 'contextualData', inputBucket]);

    var InputBucketController = function($scope, $log, i18n) {
        var ibc = this;
        ibc.updateSelectedChoice = updateSelectedChoice;
        ibc.sortOptions = sortOptions;
        ibc.filterInputs = filterInputs;
        init();

        /**
         * initializes the bucket with the available inputs
         * @function
         */
        function init() {
            var dummyOption = {
                exists: false,
                index: 0
            };
            ibc.fieldNameNotSet = true;
            for (var i in ibc.availableInputs) {
                if ('dummy' in ibc.availableInputs[i]) {
                    dummyOption.exists = true;
                    dummyOption.index = i;
                    continue;
                }
                //If no field has been previously set, set first unused input as selected input.
                if ((_.isUndefined(ibc.fieldName) || ibc.fieldName === null) && ibc.setDefault && !('inUse' in ibc.availableInputs[i])) {
                    ibc.selectedInput = ibc.availableInputs[i];
                    ibc.fieldNameNotSet = false;
                    break;
                } else {
                    if (ibc.fieldName === ibc.availableInputs[i].fieldName) {
                        ibc.selectedInput = ibc.availableInputs[i];
                        ibc.fieldNameNotSet = false;
                    }
                }
            }
            //Create a dummy select option when no other option has been preselected
            if (ibc.fieldNameNotSet && !dummyOption.exists) {
                ibc.availableInputs.push({
                    label: i18n.message('angular.ffInputBucketDirective.selectOption'),
                    index: ibc.availableInputs.length,
                    dummy:  true
                });
                ibc.selectedInput = ibc.availableInputs[ibc.availableInputs.length - 1];
                ibc.fieldNameNotSet = false;
            } else if (ibc.fieldNameNotSet) {
                ibc.selectedInput = ibc.availableInputs[dummyOption.index];
                ibc.fieldNameNotSet = false;
            }
            if (!_.isUndefined(ibc.selectedInput)) {
                ibc.updateSelectedChoice();
            }
        }

        /**
         * Handles updating of required values for selected input.
         * @function
         */
        function updateSelectedChoice(previousValue) {
            //If this is dummy option being programmatically selected, set it in use and ignore the rest.
            if (ibc.selectedInput !== null && !_.isUndefined(ibc.selectedInput)) {
                if ('dummy' in ibc.selectedInput) {
                    ibc.availableInputs[ibc.selectedInput.index].inUse = ibc.selectedInput.index;
                    return;
                }
                if (!_.isUndefined(previousValue) && previousValue.index === ibc.selectedInput.index) {
                    //ignore false triggers
                    return;
                }
                $scope.$parent.selectedInput = ibc.selectedInput;
                if (!_.isUndefined(ibc.broadcast) && _.isFunction(ibc.broadcast)) {
                    ibc.broadcast();
                }

                if (ibc.bucketMode) {
                    //when a value is selected leave dummy as "in use"
                    if (_.isObject(previousValue) && !('dummy' in previousValue)) {
                        delete ibc.availableInputs[previousValue.index].inUse;
                    }
                    ibc.availableInputs[ibc.selectedInput.index].inUse = ibc.selectedInput.index;
                }
                if (!_.isUndefined(ibc.emitOnChange)) {
                    $scope.$emit(ibc.emitOnChange, ibc.selectedInput);
                }
            }
        }

        /**
         * Filter that makes sure to only display available options including currently selected option (if one exists)
         * @param input 
         * @returns {boolean}
         */
        function filterInputs(input) {
            return !!(!('inUse' in input) || (ibc.selectedInput !== null && !_.isUndefined(ibc.selectedInput) && (input.inUse === ibc.selectedInput.index)));
        }

        function sortOptions() {
            //Sort all options while keeping select input option at top.
            return function(option) {
                //If input bucket is in multi step mode, then we
                //want to add the step number to the prefixe to maintain ascending order.
                var prefix = ibc.multiStepMode ? 'b' + option.stepIndex : 'b';
                return 'dummy' in option ? 'a' : prefix + option.label;
            };

        }
    };
    InputBucketController.$inject = ['$scope', '$log', 'i18nService'];
})();(function() {
    'use strict';

    var KeyValueController = function($scope, $log, $parse, $timeout, i18n, _) {
        var kvc = this;

        /**
         * Initializes the controller once the inputType has been set.
         */
        function init() {
            kvc.kv = kvc.input[kvc.property];
            if (kvc.multipleDefaultValueSelection === undefined) {
                kvc.useMultipleSelect = false;
            } else {
                kvc.useMultipleSelect = $parse(kvc.multipleDefaultValueSelection)($scope);
            }
            if (kvc.displayName === undefined) {
                kvc.displayName = 'ff.label.keyValue';
            }
            if (kvc.displayDefaultValueSelection === undefined) {
                kvc.showSelectors = true;
            } else {
                kvc.showSelectors = $parse(kvc.displayDefaultValueSelection)($scope);
            }
            kvc.remove = remove;
            kvc.addKeyValue = addKeyValue;
            kvc.isDuplicateKey = isDuplicateKey;
            kvc.checkForDuplicateKeys = checkForDuplicateKeys;
            kvc.duplicateKeyDetected = false;
            kvc.resetDefault = resetDefault;
            kvc.markPairIfInvalid = markPairIfInvalid;
            kvc.areFieldsValid = areFieldsValid;
            kvc.clearValues = clearValues;
            kvc.i18nMessageGetter = i18nMessageGetter;
            kvc.moveUp = moveUp;
            kvc.moveDown = moveDown;
            checkForDuplicateKeys();
        }

        function remove(key) {
            removeByKey(key);
            $scope.$emit('containsInvalidKeyValue', !kvc.areFieldsValid());
        }

        function resetDefault() {
            kvc.input.value = null;
        }

        /**
         * This function will remove the specified checkbox/radio
         * @function
         * @param key the key for the specified checkbox/radio
         */
        function removeByKey(key) {
            var arr = [];
            var selectedValues = [];
            for (var i in kvc.kv) {
                if (kvc.kv[i].key !== key) {
                    arr.push(kvc.kv[i]);
                }
            }
            //Do this to reset the selected checkbox/option that is being deleted
            //and maintain all other selected checkboxes (or option in the case of a radio button)
            var value = kvc.input.value;
            if (kvc.useMultipleSelect) {
                selectedValues = _.filter(value, function(value) {
                    return value !== key;
                });
            } else if (key !== value) {
                selectedValues.push(value);
            }

            kvc.input.value = selectedValues;
            kvc.kv = arr;
            kvc.input[kvc.property] = kvc.kv;
            checkForDuplicateKeys();
        }

        /**
         * Will add new checkbox that contains a unique key
         * @function
         */
        function addKeyValue() {
            var length = 0;
            var keys = [];
            _.each(kvc.kv, function(item, key) {
                keys.push(item.key);
            });
            //iterate over the collection of options until we find an unused default key
            while (true) {
                var keyTaken = _.find(keys, function(key) {
                    return 'option' + length == key;
                });
                if (keyTaken === undefined) {
                    var obj = {'key': 'option' + length, 'value': 'Option ' + length, 'selected': false};
                    kvc.kv.push(obj);
                    break;
                }
                length++;
            }
            kvc.input[kvc.property] = kvc.kv;
            $scope.$emit('containsInvalidKeyValue', !kvc.areFieldsValid());
        }

        /**
         * Checks to see if there are any duplicate keys.
         * @function
         */
        function checkForDuplicateKeys() {
            var keys = [];
            _.each(kvc.kv, function(item, index) {
                keys.push(item.key);
            });
            $scope.$parent.duplicateKeyDetected = kvc.duplicateKeyDetected = keys.length !== _.uniq(keys).length;
            //Update duplicate key flag for side panel
            $scope.$emit('duplicateKeyCheck', kvc.duplicateKeyDetected);
        }

        function clearValues() {
            if (_.isArray(kvc.input.value)) {
                kvc.input.value = [];
            } else {
                kvc.input.value = null;
            }
        }
        /**
         * This function will determine whether or not the current checkbox key is a duplicate
         * @function
         * @param checkbox key
         * @returns {boolean} whether the key is a duplicate or not
         */
        function isDuplicateKey(key) {
            var keys = [];
            _.each(kvc.kv, function(item, index) {
                if (item.key === key) {
                    keys.push(item.key);
                }
            });
            return keys.length > 1;
        }

        function markPairIfInvalid(index) {
            var i = kvc.kv[index];
            if (i.key === '' || i.key === null) {
                i['invalidKey'] = true;
            }
            else {
                delete i.invalidKey;
            }

            if (i.value === '' || i.value === null) {
                i['invalidValue'] = true;
            }
            else {
                delete i.invalidValue;
            }
            $scope.$emit('containsInvalidKeyValue', !kvc.areFieldsValid());
        }

        function areFieldsValid() {
            if (kvc.kv.length < 1) {
                return false;
            }

            for (var i in kvc.kv) {
                if (kvc.kv[i].invalidKey || kvc.kv[i].invalidValue) {
                    return false;
                }
            }
            return true;
        }
        init();

        function i18nMessageGetter(key) {
            return i18n.message(key);
        }

        /**
         * Moves the selected key one position up
         * @param key - key to be moved
         */
        function moveUp(key) {
            var originalIndex = _.findIndex(kvc.kv,{key:key});
            var previousObject = kvc.kv[originalIndex-1];
            kvc.kv[originalIndex-1] = kvc.kv[originalIndex];
            kvc.kv[originalIndex] = previousObject;
        }

        /**
         * Moves the selected key one position down
         * @param key - key to be moved
         */
        function moveDown(key) {
            var originalIndex = _.findIndex(kvc.kv,{key:key});
            var previousObject = kvc.kv[originalIndex+1];
            kvc.kv[originalIndex+1] = kvc.kv[originalIndex];
            kvc.kv[originalIndex] = previousObject;
        }
    };

    KeyValueController.$inject = ['$scope', '$log', '$parse', '$timeout', 'i18nService','_'];

    var keyValueMaker = function($log, contextualData, i18n) {
        var directive = {
            restrict: 'E',
            controller: KeyValueController,
            scope: {
                input: '=',
                readOnly: '=',
                property: '@',
                displayName: '@',
                multipleDefaultValueSelection: '@',
                displayDefaultValueSelection: '@',
                inTranslateMode: '='
            },
            controllerAs: 'kvc',
            bindToController: true,
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/keyvalue/keyValue.html',
        };

        return directive;
    };

    angular
    .module('formFactory')
    .directive('ffKeyValueMaker', ['$log', 'contextualData', 'i18nService', keyValueMaker]);
})();
(function() {
    'use strict';
    var editLogics = function($log, contextualData) {
        var directive = {
            restrict: 'E',
            scope: {
                input: '=',
                form: '=',
                currentStep: '=',
                validateAllSteps: '&'
            },
            controller: DesignLogicsController,
            controllerAs: 'dlc',
            bindToController: true,
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/logics/logics.html',
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr) {
		}
    };

    var DesignLogicsController = function($scope, contextualData, ffDataFactory, i18n, $timeout, _) {
        var dlc = this;
        dlc.validationStatuses = {};
        dlc.enableLogics = false;
        dlc.addRemoveLogicsArray = addRemoveLogicsArray;
        dlc.logicsCache = null;
        dlc.addLogicRule = addLogicRule;
        dlc.i18nMessageGetter = i18n.message;
        dlc.prepareLogicsForBuilder = prepareLogicsForBuilder;
        dlc.prepareAvailableInputs = prepareAvailableInputs;
        dlc.checkAvailableLogics = checkAvailableLogics;
        dlc.resetAvailableInputs = resetAvailableInputs;
        dlc.availableLogics = false;
        dlc.validateSteps = validateSteps;
        dlc.displayFieldName = displayFieldName;
        activate();

        $scope.$on('updateAvailableLogics', function() {
            dlc.checkAvailableLogics();
        });

        function activate() {
            if ($scope.$parent.fbc.logicsCache === null) {
                ffDataFactory.customRequest({
                    url: contextualData.context + '/modules/formfactory/builder/definitionslist/logics/' + contextualData.siteIdentifier + '/' + contextualData.locale,
                    method: 'GET'
                }).then(function(data) {
                    dlc.logicsCache = $scope.$parent.fbc.logicsCache = data;
                    dlc.prepareLogicsForBuilder();
                    $scope.$broadcast('logicsCacheAvailable', null);
                });
            } else {
                dlc.logicsCache = $scope.$parent.fbc.logicsCache;
            }
            if (dlc.input.logics !== undefined) {
                dlc.enableLogics = true;
            }
            dlc.prepareAvailableInputs();
            //Code to remove logics when the source is no longer valid (input has been deleted)
            //Commented out for now but can be re-added if we decide to take this route in handling a logic that is invalid
            /*if (dlc.input.logics !== undefined) {
                dlc.enableLogics = true;
                var logics = [];
                var fieldNames = [];
                for (var i in dlc.availableInputs) {
                    fieldNames.push(dlc.availableInputs[i].fieldName);
                }
                //check that logics are still bound to valid inputs
                for (var i in dlc.input.logics) {
                    var fieldNameIsValid = false;
                    if (_.find(
                            fieldNames,
                            function(fieldName) {
                                return fieldName === dlc.input.logics[i].fieldName;
                            })) {
                        fieldNameIsValid = true;
                    }
                    if (fieldNameIsValid) {
                        logics.push(dlc.input.logics[i]);
                    }
                }
                dlc.input.logics = logics;
            }*/
        }

        function validateSteps() {
            $timeout(function() {
                dlc.validateAllSteps();
            }, 550);
        }

        /**
         * Populates an array of available inputs to be used as logic sources for current input.
         * Adds additional information to help locate the inputs in the form.
         */
        function prepareAvailableInputs() {
            dlc.availableInputs = [];
            _.each(dlc.form.steps, function(step, sIndex) {
                if (sIndex <= dlc.currentStep) {
                    _.each(step.inputs, function(input, iIndex) {
                        if (input.name === dlc.input.name || _.isUndefined(input.supportedLogicTypes)) {
                            return;
                        }
                        dlc.availableInputs.push({
                            fieldName: input.name,
                            label: input.label,
                            supportedLogicTypes: input.supportedLogicTypes,
                            stepName: step.label,
                            stepIndex: sIndex,
                            inputIndex: iIndex
                        });
                        dlc.availableInputs[dlc.availableInputs.length - 1].index = dlc.availableInputs.length - 1;
                    });
                }
            });
            dlc.checkAvailableLogics();
        }

        /**
         * Responsible for adding/removing of the logics object on the form
         */
        function addRemoveLogicsArray() {
            dlc.checkAvailableLogics();
            if (!dlc.enableLogics) {
                if (dlc.input.logics !== undefined) {
                    dlc.resetAvailableInputs();
                    delete dlc.input.logics;
                    $scope.$broadcast('requiredValueChanged', {isValid: true, case: 'any'});
                }
            } else {
                dlc.input.logics = [];
                addLogicRule();
            }
            dlc.validateSteps();
        }

        function addLogicRule() {
            if (dlc.availableLogics) {
                var dummy = {};
                dummy.name = 'dummyLogic';
                dummy.fieldName = null;
                dummy.requiredValue = null;
                dlc.input.logics.push(dummy);
            }
        }

        /**
         * Merges existing logics with logics cache
         */
        function prepareLogicsForBuilder() {
            for (var cacheLogic in dlc.logicsCache) {
                dlc.logicsCache[cacheLogic].name = cacheLogic;
                dlc.logicsCache[cacheLogic].label = i18n.message('ff.label.logic.' + cacheLogic, dlc.logicsCache[cacheLogic].label);
            }
            for (var inputLogic in dlc.input.logics) {
                delete dlc.input.logics[inputLogic].definitionOptionsTranslatable;
                delete dlc.input.logics[inputLogic].definitionOptions;
                for (var cacheLogic in dlc.logicsCache) {
                    if (dlc.input.logics[inputLogic].nodeType === dlc.logicsCache[cacheLogic].nodeType) {
                        dlc.input.logics[inputLogic] = angular.merge({}, dlc.logicsCache[cacheLogic], dlc.input.logics[inputLogic]);
                    }
                }
            }
        }

        /**
         * Sets the flag responsible for enabling/disabling the "add logic rule" button
         */
        function checkAvailableLogics() {
            var usedInputs = 0;
            for (var i in dlc.availableInputs) {
                if ('inUse' in dlc.availableInputs[i]) {
                    usedInputs++;
                }
            }
            var availableInputs = dlc.availableInputs.length - usedInputs;
            dlc.availableLogics = !_.isUndefined(dlc.availableInputs) && availableInputs > 0;
        }

        /**
         * Makes all available inputs not in use.
         */
        function resetAvailableInputs() {
            for (var i in dlc.availableInputs) {
                delete dlc.availableInputs[i].inUse;
            }
        }

        /**
         * Responsible for the display of easy to understand message regarding selected rule's function.
         *
         * @param logic
         * @returns {string}
         */
        function displayFieldName(logic) {
            if (dlc.logicsCache !== null) {
                var s = i18n.message('ff.label.logic.nlg.display') + ' <strong><em>' + dlc.input.label +'</em></strong>';
                if (logic.name.split('_')[1] > 0) {
                    s = i18n.message('ff.label.logic.nlg.and');
                }
                var logic2 = dlc.input.logics[logic.name.split('_')[1]];

                if (!_.isUndefined(logic2)) {
                    //use the resource bundle to get the value property names.
                    var feedBack = i18n.message('ff.label.logic.displayFeedback.' + logic.name.split('_')[0]);
                    var properties = feedBack.match(/\{(.*?)\}/g);
                    for (var i in properties) {
                        var property = properties[i].replace(/\{|\}/g, '');

                        var value = (logic2[property] === null || _.isUndefined(logic2[property]) ? '' : (logic2[property] instanceof Date ? moment(logic2[property]).format('YYYY-MM-DD') : (moment(logic2[property], moment.ISO_8601, true).isValid() ? moment(logic2[property], moment.ISO_8601, true).format('YYYY-MM-DD') : logic2[property])));
                        feedBack = feedBack.replace(properties[i], '<mark>'+value+'</mark>');
                    }
                    var input = _.where(dlc.availableInputs,{'fieldName': logic.fieldName});
                    feedBack = feedBack.replace(i18n.message('ff.label.logic.nlg.field.placeholder'), '<strong><em>'+input[0].label+'</em></strong>');
                    return input.length > 0 ? s + ' ' + feedBack : i18n.message('angular.ffEditLogicsDirective.message.invalidLogicRule');
                }
            }
        }
    };

    DesignLogicsController.$inject = ['$scope', 'contextualData', 'ffDataFactory', 'i18nService', '$timeout', '_', '$sanitize'];

    angular
    .module('formFactory')
    .directive('ffDesignLogics', ['$log', 'contextualData', '_', '$sanitize', editLogics]);
})();
(function () {
	'use strict';
	var valueSelector = function ($log, contextualData) {
		var directive = {
			restrict: 'E',
			controller: ValueSelectorController,
			controllerAs: 'vsc',
			bindToController: true,
			templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/logics/logicsCountrySelector.html',
			link: linkFunc
		};

		return directive;

		function linkFunc(scope, el, attr) {
			//console.log(scope);
			scope.vsc.countryObjects = angular.fromJson(attr.countryObjects.replace(/'/g, "\""));
			scope.vsc.activate();
		}
	};

	var ValueSelectorController = function ($scope, ffLogicsService, i18n) {
		var vsc = this;
		vsc.selectedValues = [];
		vsc.selectedValue = null;
		vsc.availableValues = [];
		vsc.updateSelected = updateSelected;
		vsc.removeValue = removeValue;
		vsc.activate = activate;
		vsc.getLabel = i18n.message;

		function activate() {
			var step = $scope.$parent.selectedInput.stepIndex;
			//Gather available values

			if (!_.isUndefined(step)) {
				vsc.availableValues = vsc.countryObjects;
				//Preload required/selected values to reflect existing selection
				var rv = ffLogicsService.getProperty($scope.ddc.input.logics, $scope.ddc.logicIndex, 'requiredValue');
				var req;
				if (rv.replace) {
					req = angular.fromJson(rv.replace(/'/g, "\""));
				}
				else {
					req = rv;
				}

				for (var j in req) {
					for (var k in vsc.availableValues) {
						if (req[j] === vsc.availableValues[k].name) {
							vsc.selectedValues.push(vsc.availableValues[k]);
						}
					}
				}
			}

			if (vsc.selectedValues.length > 0) {
				vsc.selectedValue = vsc.selectedValues[0];
			}
			else {
				vsc.selectedValue = vsc.availableValues[0];
			}
			vsc.activated = true;
			vsc.updateSelected();
		}

		function updateSelected() {
			if (vsc.activated) {
				if (!_.contains(vsc.selectedValues, vsc.selectedValue)) {
					vsc.selectedValues.push(vsc.selectedValue);
				}
				updateRequiredValues();
				$scope.$emit('requiredValueChanged', {isValid: vsc.selectedValues.length > 0, case: 'multiple'});
			}
		}

		function removeValue(index) {
			//Check if selected value is the one being removed
			if (vsc.selectedValues[index] === vsc.selectedValue) {
				if(vsc.selectedValues.length - 1 > 0) {
					//Change selected value to last one in list
					//if last value is the removed value then choose one previous to it
					vsc.selectedValue =
						vsc.selectedValues.length - 1 !== index
							? vsc.selectedValue = vsc.selectedValues[vsc.selectedValues.length - 1]
							: vsc.selectedValue = vsc.selectedValues[vsc.selectedValues.length - 2];
				} else {
					vsc.selectedValue = '';
				}
			}

			vsc.selectedValues.splice(index, 1);
			updateRequiredValues();
			$scope.$emit('requiredValueChanged', {isValid: vsc.selectedValues.length > 0, case: 'multiple'});
			if (vsc.selectedValues.length < 1) {
				vsc.selectedValue = null;
			}
		}

		function updateRequiredValues() {
			var requiredValues = [];
			for (var i in vsc.selectedValues) {
				requiredValues.push(vsc.selectedValues[i].name);
			}
			ffLogicsService.setProperty($scope.ddc.input.logics, $scope.ddc.logicIndex, 'requiredValue', requiredValues);
		}
	};

	ValueSelectorController.$inject = ['$scope', 'ffLogicsService', 'i18nService'];

	angular
		.module('formFactory')
		.directive('ffLogicsCountrySelector', ['$log', 'contextualData', valueSelector]);
})();(function () {
	'use strict';
	var logicsDropDown = function ($log, contextualData, ffLogicsService) {
		var directive = {
			restrict: 'E',
			scope: {
				input: '=',
				form: '=',
				logicIndex: '@',
				selectedLogicType: '@',
				logicModule: '@',
				logicWizard: '=?'
			},
			controller: DropDownController,
			controllerAs: 'ddc',
			bindToController: true,
			templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/logics/logicsDropDown.html',
			link: linkFunc
		};

		return directive;

		function linkFunc(scope, el, attr) {}
	};

	var DropDownController = function ($scope, contextualData, ffLogicsService, i18n) {
		$scope.$on('targetChanged', function () {
			ddc.availableLogics = [];
			ffLogicsService.setProperty(ddc.input.logics, ddc.logicIndex, 'fieldName', $scope.$parent.selectedInput.fieldName);
			ddc.getAvailableLogics();
			//Validate steps when input changes
			ddc.selectedLogicType = ddc.availableLogics[0].logicId;
			ddc.logicModule = ddc.availableLogics[0].logicModule;
			ddc.logicWizard = ddc.availableLogics[0].logicWizard;
			updateAvailableLogics(undefined);
			$scope.$parent.dlc.validateSteps();
		});
		$scope.$on('logicsCacheAvailable', function() {
			ddc.getAvailableLogics();
		});
		var ddc = this;

		//Keep track of previously selected value when dropdown is updated on ddc.availableLogics change
		$scope.$watch(function () {
			return ddc.selectedLogicType;
		}, function (newValue, oldValue) {
			ddc.oldSelectedLogicType = ffLogicsService.normalizeSelectedLogicsType(oldValue);
			ddc.selectedLogicType = ffLogicsService.normalizeSelectedLogicsType(ddc.selectedLogicType);
			//Get logic module here
		});

		ddc.availableLogics = [];
		ddc.getAvailableLogics = getAvailableLogics;
		ddc.updateAvailableLogics = updateAvailableLogics;
		ddc.showCloseButtonIfNoView = showCloseButtonIfNoView;
		ddc.i18nMessageGetter = i18n.message;

		activate();

		function activate() {
			ddc.getAvailableLogics();
			if(ddc.availableLogics.length > 0) {
				if (ddc.selectedLogicType === 'dummyLogic') {
					ddc.selectedLogicType = ddc.availableLogics[0].logicId;
					ddc.logicModule = ddc.availableLogics[0].logicModule;
					ddc.logicWizard = ddc.availableLogics[0].logicWizard;
					updateAvailableLogics(undefined);
				}
			}
			if (!_.isUndefined($scope.$parent.dlc.logicsCache) && $scope.$parent.dlc.logicsCache !== null) {
				//Update module path after form save
				if (ddc.logicModule === "") {
					ddc.logicModule =
						ddc.input.logics[ddc.logicIndex].logicModule =
							$scope.$parent.dlc.logicsCache[ddc.input.logics[ddc.logicIndex].name.split('_')[0]].logicModule;
				}
			} else {
				var deregisterLogicsCacheWatch = $scope.$watch(function () {
					return !_.isUndefined($scope.$parent.dlc.logicsCache) && $scope.$parent.dlc.logicsCache !== null;
				}, function (newValue) {
					if (newValue) {
						deregisterLogicsCacheWatch();
						//Update module path after form save
						if (ddc.logicModule === "") {
							ddc.logicModule =
								ddc.input.logics[ddc.logicIndex].logicModule =
									$scope.$parent.dlc.logicsCache[ddc.input.logics[ddc.logicIndex].name.split('_')[0]].logicModule;
						}
					}
				});
			}
		}

		/**
		 * Updates selected logic type
		 */
		function updateAvailableLogics(oldValue) {
			if (ddc.input.logics[oldValue] !== undefined) {
				delete ddc.input.logics[oldValue];
			}
			ddc.selectedLogicType = ddc.selectedLogicType === null ? ddc.oldSelectedLogicType : ddc.selectedLogicType;

			ffLogicsService.addFromCache(ddc.input.logics, $scope.$parent.dlc.logicsCache, ddc.logicIndex, ddc.selectedLogicType);
			ffLogicsService.setProperty(ddc.input.logics, ddc.logicIndex, 'fieldName', $scope.$parent.selectedInput.fieldName);
			ddc.logicModule = ddc.input.logics[ddc.logicIndex].logicModule;
			ddc.logicWizard = !_.isUndefined(ddc.input.logics[ddc.logicIndex].wizard) ? ddc.input.logics[ddc.logicIndex].wizard : undefined
		}

		function showCloseButtonIfNoView() {
			if (!$scope.$parent.dlc.logicsCache[ddc.selectedLogicType].noview !== undefined) {
				$scope.$emit('requiredValueChanged', {isValid: true, case: 'any'});
			}
		}

		/**
		 * Loads logic ids (logic names), i18n key, module and nodeType of logics supported by current input.
		 */
		function getAvailableLogics() {
			if(!_.isUndefined($scope.$parent.selectedInput)) {
				for (var i in $scope.$parent.selectedInput.supportedLogicTypes) {
					for (var j in $scope.$parent.dlc.logicsCache) {
						for (var k in $scope.$parent.dlc.logicsCache[j].types) {
							if ($scope.$parent.selectedInput.supportedLogicTypes[i] === $scope.$parent.dlc.logicsCache[j].types[k]) {
								ddc.availableLogics.push({
									logicId: j,
									logicName: ddc.i18nMessageGetter('ff.label.logic.' + $scope.$parent.dlc.logicsCache[j].name),
									logicModule: $scope.$parent.dlc.logicsCache[j].logicModule,
									logicNodeType: $scope.$parent.dlc.logicsCache[j].nodeType,
									logicWizard: !_.isUndefined($scope.$parent.dlc.logicsCache[j].wizard) ? $scope.$parent.dlc.logicsCache[j].wizard : undefined
								});
							}
						}
					}
				}
			}
		}
	};

	DropDownController.$inject = ['$scope', 'contextualData', 'ffLogicsService', 'i18nService'];

	angular
		.module('formFactory')
		.directive('ffLogicsDropDown', ['$log', 'contextualData', 'ffLogicsService', logicsDropDown]);
})();
(function () {
	'use strict';

	var logicsService = function ($log) {

		/**
		 * Given logics array the field name to be checked against field value it returns property
		 *
		 * @param logics
		 * @param index
		 * @param property
		 * @returns {*}
		 */
		this.getProperty = function (logics, index, property) {
			return logics[index][property];
		};

		/**
		 * Given logics array the field name to be checked against field value it sets value to property
		 *
		 * @param logics
		 * @param index
		 * @param property
		 * @param value
		 */
		this.setProperty = function (logics, index, property, value) {
			logics[index][property] = value;
		};

		/**
		 * Removes logic at a given index
		 *
		 * @param index
		 * @param logics
		 */
		this.removeLogic = function (logics, index) {
			logics.splice(index, 1);
		};

		/**
		 * Adds logic from logics cache
		 *
		 * @param logics
		 * @param cache
		 * @param logicIndex
		 * @param logicType
		 */
		this.addFromCache = function (logics, cache, logicIndex, logicType) {
			logics[logicIndex] = angular.copy(cache[logicType]);
			logics[logicIndex].name = logicType + '_' + logicIndex;
		};

		this.normalizeSelectedLogicsType = function(type) {
			return type.split('_')[0];
		}
	};

	angular
		.module('formFactory')
		.service('ffLogicsService', ['$log', logicsService]);
})();
(function () {
	'use strict';
	var valueSelector = function ($log, contextualData) {
		var directive = {
			restrict: 'E',
			controller: ValueSelectorController,
			controllerAs: 'vsc',
			bindToController: true,
			templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/logics/logicsValueSelector.html',
			link: linkFunc
		};

		return directive;

		function linkFunc(scope, el, attr) {
			//console.log(scope);
			console.log("Linking");
		}
	};

	var ValueSelectorController = function ($scope, ffLogicsService, i18n) {
		var vsc = this;
		vsc.selectedValues = [];
		vsc.selectedValue = null;
		vsc.availableValues = [];
		vsc.recognizedFields = ['radios', 'checkboxes', 'options'];
		vsc.updateSelected = updateSelected;
		vsc.removeValue = removeValue;
		vsc.getLabel = i18n.message;

		activate();

		function activate() {
			var input = $scope.$parent.selectedInput.inputIndex;
			var step = $scope.$parent.selectedInput.stepIndex;
			//Gather available values
			if (!_.isUndefined(step)) {
				for (var i in vsc.recognizedFields) {
					if (vsc.recognizedFields[i] in $scope.ddc.form.steps[step].inputs[input]) {
						vsc.availableValues = angular.copy($scope.ddc.form.steps[step].inputs[input][vsc.recognizedFields[i]]);

						//Preload required/selected values to reflect existing selection
						var req = ffLogicsService.getProperty($scope.ddc.input.logics, $scope.ddc.logicIndex, 'requiredValue');

						for (var j in req) {
							for (var k in vsc.availableValues) {
								if (req[j] === vsc.availableValues[k].key) {
									vsc.selectedValues.push(vsc.availableValues[k]);
								}
							}
						}
						break;
					}
				}
			}

			if (vsc.selectedValues.length > 0) {
				vsc.selectedValue = vsc.selectedValues[0];
			}
			else {
				vsc.selectedValue = vsc.availableValues[0];
			}
			vsc.updateSelected();
		}

		function updateSelected() {
			if (!_.contains(vsc.selectedValues, vsc.selectedValue)) {
				vsc.selectedValues.push(vsc.selectedValue);
			}
			updateRequiredValues();
			$scope.$emit('requiredValueChanged', {isValid: vsc.selectedValues.length > 0, case: 'multiple'});
		}

		function removeValue(index) {
			//Check if selected value is the one being removed
			if (vsc.selectedValues[index] === vsc.selectedValue) {
				if(vsc.selectedValues.length - 1 > 0) {
					//Change selected value to last one in list
					//if last value is the removed value then choose one previous to it
					vsc.selectedValue =
						vsc.selectedValues.length - 1 !== index
							? vsc.selectedValue = vsc.selectedValues[vsc.selectedValues.length - 1]
							: vsc.selectedValue = vsc.selectedValues[vsc.selectedValues.length - 2];
				} else {
					vsc.selectedValue = '';
				}
			}

			vsc.selectedValues.splice(index, 1);
			updateRequiredValues();
			$scope.$emit('requiredValueChanged', {isValid: vsc.selectedValues.length > 0, case: 'multiple'});
			if (vsc.selectedValues.length < 1) {
				vsc.selectedValue = null;
			}
		}

		function updateRequiredValues() {
			var requiredValues = [];
			for (var i in vsc.selectedValues) {
				requiredValues.push(vsc.selectedValues[i].key);
			}
			ffLogicsService.setProperty($scope.ddc.input.logics, $scope.ddc.logicIndex, 'requiredValue', requiredValues);
		}
	};

	ValueSelectorController.$inject = ['$scope', 'ffLogicsService', 'i18nService'];

	angular
		.module('formFactory')
		.directive('ffLogicsValueSelector', ['$log', 'contextualData', valueSelector]);
})();(function () {
	'use strict';
	var wd = function (ffDataFactory, $compile, contextualData) {
		var directive = {
			restrict: 'E',
			link: linkFunc
		};

		return directive;

		function linkFunc(scope, el, attr) {
			//Clear any previously compiled template.
			scope.$on('targetChanged', function() {
				el.html('');
			});
			//Compile new wizard template
			scope.$watch(scope.ddc.selectedLogicType, function () {
				if (scope.ddc.selectedLogicType !== 'dummyLogic' && !_.isUndefined(scope.ddc.logicModule) && !_.isEmpty(scope.ddc.logicModule)) {
					if (_.isUndefined(scope.ddc.logicWizard) || scope.ddc.logicWizard === null) {

						ffDataFactory.customRequest({
							url: contextualData.context + '/cms/render/default/en/' + scope.ddc.logicModule + '/templates/contents/form-factory-logics/' + scope.ddc.selectedLogicType.split('_')[0] + '.designView.html.ajax',
							method: 'GET'
						}).then(function (response) {
							el.html(response);
							$compile(el.contents())(scope);
						});

					} else {
						var compiled = $compile(scope.ddc.logicWizard)(scope);
						el.html(compiled);
					}
				}
			});
		}
	};

	angular
		.module('formFactory')
		.directive('ffLogicsWizardDisplay', ['ffDataFactory', '$compile', 'contextualData', wd]);
})();(function () {
	'use strict';
	var logicsWrap = function ($log, contextualData, ffLogicsService, ffValidationService) {
		var directive = {
			restrict: 'E',
			link: linkFunc
		};

		return directive;

		function linkFunc(scope, el, attr) {
			scope.invalidRequiredValue = false;

			scope.broadcastEvent = function () {
				scope.$broadcast('targetChanged', null);
			};

			scope.removeLogic = function (logics, index) {
				for(var i in scope.dlc.availableInputs) {
					//restore input to available inputs list
					if(!_.isUndefined(scope.selectedInput) && scope.dlc.availableInputs[i].fieldName === scope.selectedInput.fieldName) {
						delete scope.dlc.availableInputs[i].inUse;
						scope.$emit('updateAvailableLogics', null);
						break;
					}
				}
				ffLogicsService.removeLogic(logics, index);
				delete scope.dlc.validationStatuses[scope.logic.fieldName];
				checkValidationStatuses();
			};

			//This event is emitted by LogicsFieldValidationDirective or LogicsValueSelectorDirective
			scope.$on('requiredValueChanged', function (event, data) {
				scope.invalidRequiredValue = !data.isValid;
				scope.dlc.validationStatuses[scope.logic.fieldName] = data.isValid;
				updateValidationSatusesFields();
				checkValidationStatuses();
			});

			function updateValidationSatusesFields() {
				for (var i in scope.dlc.validationStatuses) {
					var validField = false;
					for (var j in scope.dlc.availableInputs) {
						if (i === scope.dlc.availableInputs[j].fieldName) {
							validField = true;
						}
					}
					if (!validField || !scope.dlc.enableLogics) {
						delete scope.dlc.validationStatuses[i];
					}
				}
			}

			function checkValidationStatuses() {
				var hasInvalid = false;
				for (var i in scope.dlc.validationStatuses) {
					if (scope.dlc.validationStatuses[i] === false) {
						hasInvalid = true;
					}
				}
				scope.$parent.$parent.fbc.containsInvalidLogics = hasInvalid;
			}
		}
	};

	angular
		.module('formFactory')
		.directive('ffLogicsWrap', ['$log', 'contextualData', 'ffLogicsService', 'ffValidationWorker', logicsWrap]);
})();
(function() {
    'use strict';
    var designValidation = function($compile, ffDataFactory, $log, contextualData) {
        var directive = {
            restrict    : 'E',
            scope       : {
                input              : '=',
                validationName     : '@',
                validation         : '=',
                inTranslateMode    : '=',
                form               : '=',
                currentStep        : '=',
                broadcastedSyncFunc: '='
            },
            controller  : ValidationController,
            controllerAs: 'vc',
            link        : linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ctrls) {
            scope.element = el;
            ctrls.afterSyncInit();
        }
    };

    var ValidationController     = function($scope, $log, $compile, ffDataFactory, contextualData) {
        var vc                    = this;
        vc.areFieldsValid         = areFieldsValid;
        vc.isFieldValid           = isFieldValid;
        vc.afterSyncInit          = afterSyncInit;
        vc.validatedFields        = {};
        init();
        /**
         * Cache and merge of validations is done asynchronously so we need
         * to check if this has been done, and then call the function that
         * will initialize any newly added fields.
         */
        if ($scope.broadcastedSyncFunc) {
            afterSyncInit();
        } else {
            $scope.$on('validationsMergeCompleted', function() {
                // After broadcast we need to update the validation object with the one updated in the input list
                $scope.validation = $scope.input.validations[$scope.validationName];
                afterSyncInit();
            });
        }
        /**
         * Retrieves the current validation object that we want to bind to
         */
        function init() {
            setUpValidatedFields();
        }

        /**
         * This function is called once the validations have been successfully merged
         * Any initialization or preparation of new fields should be done here in order
         * to prevent any conflicts.
         * @function
         */
        function afterSyncInit() {
            //Validate that merge and broadcast happened as $on is always called once. and taht we called linkFunc
            if($scope.validation.validationModule !== undefined && $scope.element !== undefined) {
                if ($scope.validation.wizard === undefined) {
                    var url = contextualData.context + '/cms/render/default/en/' + $scope.validation.validationModule + '/templates/contents/form-factory-validations/' + $scope.validationName + '.designView.html.ajax';
                    ffDataFactory.getData(url)
                        .then(function success(data) {
                                var compiled = $compile(data)($scope);
                                $scope.element.html(compiled);
                            },
                            function error(data) {
                                //Complete
                            });
                } else {
                    var compiled = $compile($scope.validation.wizard)($scope);
                    $scope.element.html(compiled);
                }
            }
        }

        /**************************************************************************************************************/
        /**************************************Validations of validation fields****************************************/
        /**************************************************************************************************************/

        /**
         * Force validation check when validation becomes active
         */
        $scope.$on('validationOn', function(event, data) {
            $scope.$emit('checkValidationsValidity', {isValid: vc.areFieldsValid(), caseName: $scope.validationName});
        });

        /**
         * Set validation statuses for individual fields based on current validation
         */
        $scope.$on('requiredValueChanged', function(event, data) {
            vc.validatedFields[data.fieldId] = data.isValid;
            if ($scope.input.validations[$scope.validationName].active) {
                $scope.$emit('checkValidationsValidity', {isValid: vc.areFieldsValid(), caseName: data.caseName});
            }
        });

        /**
         * Initializes all validated fields to true status => valid
         */
        function setUpValidatedFields() {
            for (var i in $scope.input.validations[$scope.validationName].definitionOptions) {
                vc.validatedFields[$scope.input.validations[$scope.validationName].definitionOptions[i]] = true;
            }
        }

        /**
         * Check all validated fields in the view if they are valid.
         *
         * @returns {boolean}
         */
        function areFieldsValid() {
            for (var i in vc.validatedFields) {
                if (!vc.isFieldValid(i)) {
                    return false;
                }
            }
            return true;
        }

        function isFieldValid(fieldName) {
            return vc.validatedFields[fieldName];
        }

    };
    ValidationController.$inject = ['$scope', '$log', '$compile', 'ffDataFactory', 'contextualData'];
    angular
        .module('formFactory')
        .directive('ffDesignValidation', ['$compile', 'ffDataFactory', '$log', 'contextualData', designValidation]);
})();
(function() {
    'use strict';
    var designValidations = function($compile, ffDataFactory, $log, contextualData) {
        var directive = {
            restrict    : 'E',
            scope       : {
                input                    : '=',
                inTranslateMode          : '=',
                form                     : '=',
                currentStep              : '=',
                containsInvalidValidation: '='
            },
            controller  : DesignValidationsController,
            controllerAs: 'dvc',
            templateUrl : contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/validations/designValidations.html',
            link        : linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ffController) {
            //I update the state for each panel
            var accordion = el.find('#ffValidationsAccordion');
            accordion.on('show.bs.collapse', function(event) { //Start to open panel - register lock for toggle
                var validationName = event.target.id;
                updatePanelsParam(validationName, 'inProgress', true);

            }).on('shown.bs.collapse', function(event) { //Panel fully opened - remove lock from toggle
                var validationName = event.target.id;
                updatePanelsParam(validationName, 'inProgress', false);
                updatePanelsParam(validationName, 'open', true);

            }).on('hide.bs.collapse', function(event) { //Panel begins to close - register lock for toggle
                var validationName = event.target.id;
                updatePanelsParam(validationName, 'inProgress', true);

            }).on('hidden.bs.collapse', function(event) { //Panel fully closed - remove lock from toggle
                var validationName = event.target.id;
                updatePanelsParam(validationName, 'inProgress', false);
                updatePanelsParam(validationName, 'open', false);
            });

            function updatePanelsParam(validationName, param, value) {
                scope.dvc.panels[validationName][param] = value;
            }
        }
    };

    var DesignValidationsController = function($scope, $log, contextualData, ffDataFactory, i18n, $timeout) {
        var dvc = this;
        dvc.validationsCache = null;
        dvc.validationStatuses = {};
        dvc.hasInvalidValidation = hasInvalidValidation;
        dvc.setInvalidFlag = setInvalidFlag;
        dvc.retrieveValidations = retrieveValidations;
        dvc.closeOrOpenPanel = closeOrOpenPanel;
        dvc.panels = {}; //tracks panel close/open state
        dvc.i18nMessageGetter = i18n.message;
        dvc.broadcastedSyncFunc = false;

        activate();

        function activate() {
            retrieveValidations();
        }

        /**
        		 * Retrieves available validations.
        		 *
        		 * @function
        		 */
        function retrieveValidations() {
            if (dvc.validationsCache === null) {
                ffDataFactory.customRequest({
                    url   : contextualData.context + '/modules/formfactory/builder/definitionslist/validations/' + contextualData.siteIdentifier + '/en',
                    method: 'GET'
                }).then(function(response) {
                    dvc.validationsCache = response;
                    initializeValidations();
                    console.log('input validation');
                    console.log($scope.input.validations);
                    buildPanelObject();
                    $scope.$broadcast('validationsMergeCompleted', null);
                    dvc.broadcastedSyncFunc = true;
                });
            }
        }

        /**
        		 * This function will populate the current input with all available validations for that input
        		 * A merge is done on each of the active validation fields. Obsolete fields are removed.
        		 * Each validation is marked active true/false.
        		 * @function
        		 */
        function initializeValidations() {
            var validValidations = [];
            _.each($scope.input.validations, function(validation, validationName) {
                if (validation.active === undefined || validation.active === true) {
                    validValidations.push(validationName);
                    $scope.input.validations[validationName] = angular.merge({}, dvc.validationsCache[validationName], $scope.input.validations[validationName]);
                    //Remove validations that no longer exist
                    _.each($scope.input.validations[validationName], function(field, fieldKey) {
                        if (!(fieldKey in dvc.validationsCache[validationName])) {
                            delete $scope.input.validations[validationName][fieldKey];
                        }
                    });
                    $scope.input.validations[validationName].active = true;
                }
            });

            var validationNames = [];
            var hasValidation = false;

            //Match supportedValidationTypes to validation types category to get the applicable validation names
            for (var i in $scope.input.supportedValidationTypes) {
                _.each(dvc.validationsCache, function(item, validationName) {
                    hasValidation = _.find(item.types, function(value) {
                        return value === $scope.input.supportedValidationTypes[i];
                    });
                    if (hasValidation) {
                        validationNames.push(validationName);
                    }
                });
            }

            //Filter to just keep unique validation names
            validationNames = _.unique(validationNames);

            //Incase there were no validations attached to the input before
            if (!('validations' in $scope.input)) {
                $scope.input.validations = {};
            } else {
                //remove any validation that is not longer supported by the input
                validValidations = _.difference(validValidations, validationNames);
                for (var i in validValidations) {
                    delete $scope.input.validations[validValidations[i]];
                }
            }

            for (var i in validationNames) {
                if (!(validationNames[i] in $scope.input.validations)) {
                    //add the validation as inactive.
                    $scope.input.validations[validationNames[i]] = angular.copy(dvc.validationsCache[validationNames[i]]);
                    $scope.input.validations[validationNames[i]].active = false;
                }
            }

            //Set all validation statuses to false => invalid entry
            for (var i in $scope.input.validations) {
                dvc.validationStatuses[i] = false;
            }
        }

        /**************************************************************************************************************/
        /**************************************Validations of validation fields****************************************/
        /**************************************************************************************************************/

        /**
        		 * Receive and process event emitted by ffDesignValidationDirective
        		 */
        $scope.$on('checkValidationsValidity', function(event, data) {
            dvc.validationStatuses[data.caseName] = data.isValid;
            dvc.setInvalidFlag(hasInvalidValidation());
        });

        function setInvalidFlag(value) {
            $timeout(function() {
                $scope.$apply(function() {
                    $scope.containsInvalidValidation = value;
                });
            });
        }

        /**
        		 * Determines if any of validations on the input have incorrectly filled up fields
        		 *
        		 * @returns {boolean}
        		 */
        function hasInvalidValidation() {
            for (var i in dvc.validationStatuses) {
                if ($scope.input.validations[i].active && !dvc.validationStatuses[i]) {
                    return true;
                }
            }
            return false;
        }

        /**************************************************************************************************************/
        /***********************************Related to toggle-panel coordination***************************************/
        /**************************************************************************************************************/

        //Receive toggle event when switch is clicked and process it accordingly
        $scope.$on('toggleEvent', function(event, validationName) {
            if (!dvc.panels['panel_' + validationName].inProgress) {
                var newState = !$scope.input.validations[validationName].active;
                $scope.input.validations[validationName].active = newState;

                if (dvc.panels['panel_' + validationName].open && newState === false) {
                    dvc.closeOrOpenPanel(validationName);
                }

                if (!dvc.panels['panel_' + validationName].open && newState === true) {
                    dvc.closeOrOpenPanel(validationName);
                }
                //Send event to panels
                $scope.$broadcast('switchToggle', {validationName: validationName, active: newState});
            }
        });

        /**
        		 * Constructs an object of panel/panel names and associated properties for each validation
        		 * {
        		 * 		panel_required : {
        		 * 			validationName: ...,
        		 * 			inProgress : bool, 	 	//Panel is opening or closing
        		 * 			active: bool, 			//State of validation
        		 *			open: bool
        		 * 		}, ...
        		 * }
        		 */
        function buildPanelObject() {
            for (var name in $scope.input.validations) {
                var v = $scope.input.validations[name];
                var ref = 'panel_' + name;
                dvc.panels[ref] = {};
                dvc.panels[ref]['validationName'] = name;
                dvc.panels[ref]['inProgress'] = false;
                dvc.panels[ref]['active'] = v.active;
                dvc.panels[ref]['open'] = false;
            }
        }

        /**
        		 * Triggers a click event on panel's link element to open/close panel.
        		 *
        		 * @param validationName
        		 */
        function closeOrOpenPanel(validationName) {
            angular.element('#link_' + validationName).trigger('click');
        }
    };

    DesignValidationsController.$inject = ['$scope', '$log', 'contextualData', 'ffDataFactory', 'i18nService', '$timeout'];

    angular
    .module('formFactory')
    .directive('ffDesignValidations', ['$compile', 'ffDataFactory', '$log', 'contextualData', designValidations]);

    angular
    .module('formFactory')
		.directive('ffValidationSwitch', function() {
    return {
        restrict: 'E',
        replace : true,
        template: function(element, attrs) {
            var html = '';
            html += '<span';
            html += ' class="switch' + (attrs.color ? ' ' + attrs.color : '') + '"';
            html += ' ng-class="{ checked:' + attrs.initState + ', disabled:' + attrs.disabled + ' }"';
            html += '>';
            html += '<small></small>';
            return html;
        },
        link    : function(scope, el, attr, ctrls) {
            //Receive event and processes it as it applies (or not) to current panel
            scope.$on('switchToggle', function(event, data) {
                if (data.validationName === scope.validationName) {
                    data.active ? el.addClass('checked') : el.removeClass('checked');
                }
                scope.$parent.$broadcast('validationOn', {validationName : scope.validationName});
            });
            el.bind('click', function() {
                //Ask controller to process event
                scope.$emit('toggleEvent', attr.validationName);

            });
        }
    };
		});
})();
/**
 * Created by dgaillard on 2015-11-10.
 */
(function () {
    'use strict';
    var ffRenderInput = function ($log, contextualData) {
        var directive = {
            restrict: 'E',
            require : ['^ffController'],
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/sidePanel.html',
            link    : linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ffController) {

        }
    };

    angular
        .module('formFactory')
        .directive('ffSidePanel', ['$log', 'contextualData', ffRenderInput]);
})();
(function() {
    'use strict';

    var pickActionTabs = function($log, contextualData, $http, _) {

        var directive = {
            require : '^ffController',
            restrict   : 'E',
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/pickaction/pickActionTabs.html',
            link       : linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, fbc) {
            if(_.isUndefined(fbc.actionsIconsCache)){
                fbc.actionsIconsCache = {};
                _.forEach(fbc.actionsCache, function(action) {
                    var url = contextualData.context + '/modules/' + action.packageId + '/img/actionIcons/' + action.actionname + '.png';
                    fbc.actionsIconsCache[action.actionname] = '';
                    $http.get(url).then(function() {
                        fbc.actionsIconsCache[action.actionname] = url;
                    }, function() {
                        fbc.actionsIconsCache[action.actionname] = contextualData.context + '/modules/form-factory-core/img/actionIcons/default.png';
                    });
                });
            }
        }
    };

    angular
        .module('formFactory')
        .directive('ffPickActionTabs', ['$log', 'contextualData', '$http', '_', pickActionTabs]);
})();
(function() {
    'use strict';
    var showInputTabs = function($compile, $log, contextualData, $http, _) {
        var directive = {
            require    : '^ffController',
            restrict   : 'E',
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/pickinput/pickInputTabs.html',
            link       : linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, fbc) {
            if (_.isUndefined(fbc.inputsIconsCache)) {
                fbc.inputsIconsCache = {};
                _.forEach(fbc.inputsCache, function(input) {
                    var url = contextualData.context + '/modules/' + input.packageId + '/img/inputIcons/' + input.name + '.png';
                    fbc.inputsIconsCache[input.name] = '';
                    $http.get(url).then(function() {
                        fbc.inputsIconsCache[input.name] = url;
                    }, function() {
                        fbc.inputsIconsCache[input.name] = contextualData.context + '/modules/form-factory-core/img/inputIcons/default.png';
                    });
                });
            }
        }
    };

    angular
        .module('formFactory')
        .directive('ffPickInputTabs', ['$compile', '$log', 'contextualData', '$http', '_', showInputTabs]);
})();
/**
 * For each case of validation this function returns an object:
 * validationType:{
 * 		errorInfo: "" 					//Index or step name depending on validation type or a set of values separated by "|" as required by i18nService.format() from MF
 * 		validationMessage: ""
 *		toastId: ""
 * }
 *
 * The toast id will be associated with a toast and upon display will replace toasts (if any) for a given validation
 * type.
 *
 */
onmessage = function (e) {
	var hasInvalidSteps = false;
	var messages = {};

	if (e.data.form.steps.length < 1) {
		hasInvalidSteps = true;
		messages["noStep"] = {};
		messages["noStep"].errorInfo = "";
		messages["noStep"].validationMessage = "angular.ffFormBuilderDirective.message.noStep";
		messages["noStep"].toastId = "ns";
	}

	//Check for invalid steps
	for (var i in e.data.form.steps) {
		//Send empty step message and step name
		if (e.data.form.steps[i].inputs.length < 1) {
			hasInvalidSteps = true;
			messages["emptyStep"] = {};
			messages["emptyStep"].errorInfo = e.data.form.steps[i].label !== "" ? "'" + e.data.form.steps[i].label + "'" : "'name is empty'";
			messages["emptyStep"].stepIndex = i;
			messages["emptyStep"].validationMessage = "angular.ffFormBuilderDirective.message.emptyStep";
			messages["emptyStep"].toastId = "es";
		}
		//Send invalid step name message and step index
		if (e.data.form.steps[i].label === '') {
			hasInvalidSteps = true;
			messages["emptyStepName"] = {};
			messages["emptyStepName"].errorInfo = i;
			messages["emptyStepName"].validationMessage = "angular.ffFormBuilderDirective.message.invalidStepName";
			messages["emptyStepName"].toastId = "esn";
		}
	}
	//Check if actions step is invalid
	if (e.data.form.actions.length < 1) {
		hasInvalidSteps = true;
		messages["noAction"] = {};
		messages["noAction"].errorInfo = "action";
		messages["noAction"].validationMessage = "angular.ffFormBuilderDirective.message.missingAction";
		messages["noAction"].toastId = "na";
	}
	//Check if actions on form have required fields
	var invalidAction = false;
	//Email regexp
	var emailRegexp = /^[A-Z0-9._%+-]{1,64}@(?:[A-Z0-9-]{1,63}\.){1,125}[A-Z]{2,63}$/i;
	for (var i in e.data.form.actions) {
		if ('requiredFields' in e.data.form.actions[i] && e.data.form.actions[i].requiredFields.length > 0) {
			//Validate the required fields.
			for (var j in e.data.form.actions[i].requiredFields) {
				//get the current value of the required field from the action
				var value = e.data.form.actions[i][e.data.form.actions[i].requiredFields[j].key];
				var isValid = true;
				switch(e.data.form.actions[i].requiredFields[j].value) {
					case 'number' :
						if (value === undefined || value === '' || value === null || isNaN(value)) {
							isValid = false;
						}
						break;
					case 'positiveNumber' :
						if (value === undefined || value === '' || value === null || isNaN(value) || value < 0) {
							isValid = false;
						}
						break;
					case 'email' :
						if (!emailRegexp.test(value)) {
							isValid = false;
						}
						break;
					case 'any' :
					default :
						if (value === undefined || value === "" || value === null) {
							isValid = false;
						}
						break;
				}
				if (!isValid) {
					invalidAction = true;
					break;
				}
			}
			if(invalidAction) {
				hasInvalidSteps = true;
				messages['invalidActionFields'] = {};
				messages['invalidActionFields'].errorInfo = e.data.form.actions[i].label;
				messages['invalidActionFields'].validationMessage = 'angular.ffFormBuilderDirective.message.invalidActionFields';
				messages['invalidActionFields'].toastId = 'iaf';
				messages['invalidActionFields'].actionIndex = i;
				invalidAction = false;
			}
		}
	}

	hasInvalidSteps = (hasInvalidSteps) ? true : validateLogics(e.data.form, messages);

	//Pass flag value to disable/enable UI elements and callback(s) with messages
	postMessage({
		flag: "containsInvalidStep",
		flagValue: hasInvalidSteps,
		callbacks: [
			{
				callback: 'notifyUserOfInvalidStep',
				args: messages
			}
		]
	});
	//Remove thread!!!
	close();
};

var validateLogics = function (form, messages) {
	var hasInvalidSteps = false;
	//1st step contains > n-1 logics applications
	var numberOfLogicsOnFirstStep = 0;
	for (var i in form.steps[0].inputs) {
		if (form.steps[0].inputs[i].logics !== undefined) {
			numberOfLogicsOnFirstStep++;
		}
	}

	if (numberOfLogicsOnFirstStep === form.steps[0].inputs.length) {
		hasInvalidSteps = true;
		messages["logicsFirstStepError"] = {};
		messages["logicsFirstStepError"].errorInfo = form.steps[0].label;
		messages["logicsFirstStepError"].validationMessage = "angular.ffFormBuilderDirective.message.firstStepLogicsError";
		messages["logicsFirstStepError"].toastId = "logicsFirstStepError";
		return hasInvalidSteps;
	}

	//Build input map
	var inputMap = {};
	for (var i in form.steps) {
		for (var j in form.steps[i].inputs) {
			inputMap[form.steps[i].inputs[j].name] = {stepNumber: i, stepName: form.steps[i].label};
		}
	}

	//Validate logics at a given step against inputMap
	//Input number in inputMap must be <= step number of the step where that input is used as source of logics.
	for (var i in form.steps) {
		for (var j in form.steps[i].inputs) {
			if (form.steps[i].inputs[j].logics !== undefined) {
				for (var k in form.steps[i].inputs[j].logics) {
					if (!(form.steps[i].inputs[j].logics[k].fieldName in inputMap)) {
						hasInvalidSteps = true;
						messages["logicsSourceMissing"] = {};
						messages["logicsSourceMissing"].errorInfo = form.steps[i].inputs[j].name
						+ "|" + form.steps[i].label
						+ "|" + form.steps[i].inputs[j].logics[k].fieldName;
						messages["logicsSourceMissing"].validationMessage = "angular.ffFormBuilderDirective.message.logicSourceMissing";
						messages["logicsSourceMissing"].toastId = "logicsSourceMissing";
						return hasInvalidSteps;
					}
					else if (parseInt(inputMap[form.steps[i].inputs[j].logics[k].fieldName].stepNumber) > i) {
						hasInvalidSteps = true;
						messages["logicsUnreachableSource"] = {};
						messages["logicsUnreachableSource"].errorInfo = form.steps[i].inputs[j].name
						+ "|" + form.steps[i].label
						+ "|" + form.steps[i].inputs[j].logics[k].fieldName
						+ "|" + inputMap[form.steps[i].inputs[j].logics[k].fieldName].stepName;
						messages["logicsUnreachableSource"].validationMessage = "angular.ffFormBuilderDirective.message.logicSourceNotReachable";
						messages["logicsUnreachableSource"].toastId = "logicsUnreachableSource";
						return hasInvalidSteps;
					}
				}
			}
		}
	}

	//Test for cycles
	hasInvalidSteps = (hasInvalidSteps) ? true : logicsCycleTest(form, inputMap, messages);
	hasInvalidSteps = (hasInvalidSteps) ? true : emptyLogicsTest(form, messages);

	return hasInvalidSteps;
};

var logicsCycleTest = function (form, inputMap, messages) {
	var hasInvalidSteps = false;
	var sourceTargetMap = [];
	for (var i in form.steps) {
		var step = {
			targetSourcePairs: [],
			stepName: form.steps[i].label
		};
		for (var j in form.steps[i].inputs) {
			if (form.steps[i].inputs[j].logics !== undefined) {
				for (var k in form.steps[i].inputs[j].logics) {
					if (parseInt(inputMap[form.steps[i].inputs[j].logics[k].fieldName].stepNumber) == i) {
						step.targetSourcePairs.push({
							target: form.steps[i].inputs[j].name,
							source: form.steps[i].inputs[j].logics[k].fieldName
						});
					}
				}
			}
		}
		sourceTargetMap.push(step);
	}

	for (var step in sourceTargetMap) {
		for (var l1 in sourceTargetMap[step].targetSourcePairs) {
			for (var l2 in sourceTargetMap[step].targetSourcePairs) {
				if (l1 != l2) {
					if (sourceTargetMap[step].targetSourcePairs[l2].target === sourceTargetMap[step].targetSourcePairs[l1].source
						&& sourceTargetMap[step].targetSourcePairs[l2].source === sourceTargetMap[step].targetSourcePairs[l1].target) {
						hasInvalidSteps = true;
						messages["logicsCycleDetected"] = {};
						messages["logicsCycleDetected"].errorInfo = sourceTargetMap[step].stepName
						+ "|" + sourceTargetMap[step].targetSourcePairs[l1].target
						+ "|" + sourceTargetMap[step].targetSourcePairs[l1].source;
						messages["logicsCycleDetected"].validationMessage = "angular.ffFormBuilderDirective.message.cycleDetected";
						messages["logicsCycleDetected"].toastId = "logicsCycleDetected";
						return hasInvalidSteps;
					}
				}
			}
		}
	}
	return hasInvalidSteps;
};

var emptyLogicsTest = function (form, messages) {
	var hasInvalidSteps = false;

	for (var i in form.steps) {
		for (var j in form.steps[i].inputs) {
			if (form.steps[i].inputs[j].logics !== undefined && form.steps[i].inputs[j].logics.length < 1) {
				hasInvalidSteps = true;
				messages["emptyLogics"] = {};
				messages["emptyLogics"].errorInfo = form.steps[i].label
				+ "|" + form.steps[i].inputs[j].name;
				messages["emptyLogics"].validationMessage = "angular.ffFormBuilderDirective.message.logicsEmpty";
				messages["emptyLogics"].toastId = "emptyLogics";
				return hasInvalidSteps;
			}
		}
	}
	return hasInvalidSteps;
};(function() {
    'use strict';

    var formNameValidator = function($log, ffCommonUseFactory, contextualData, ffDataFactory, $q, i18n) {
        var directive = {
            restrict: 'A',
            require: ['ngModel'],
            scope: {
                invalidFlag: '=?',
                errorMessage: '=',
                formIdentifier: '='
            },
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ctrls) {
            var model = ctrls[0];
            var regexp = new RegExp(/^[\'\"~+=!*&%#@,:;_\.\^\$\?<\>\|\/\\\[\]\(\)\}\{\-0-9]|[\'\"~+=!*&%#@,:;_\.\^\$\?<\>\|\/\\\[\]\(\)\}\{\-]$|(?=[`])/);
            //asynchronous validator that checks to see if the form name is valid and if it is available
            model.$asyncValidators.formName = function(modelValue, viewValue) {
                var def = $q.defer();
                scope.invalidFlag = true;
                //determine if form name is valid before checking to see if it exists
                if (regexp.test(viewValue) || model.$isEmpty(viewValue)) {
                    scope.errorMessage = setMessage(model.$isEmpty(viewValue) ? 'empty' : 'invalid');
                    def.reject();
                } else {
                    //verify if the chosen form name is available
                    var data = {
                        formName: viewValue,
                        siteIdentifier: contextualData.siteIdentifier
                    };
                    if (!model.$isEmpty(scope.formIdentifier)) {
                        data.formIdentifier = scope.formIdentifier;
                    }
                    ffDataFactory.customRequest({
                        url: contextualData.context + '/modules/formfactory/builder/checkformnameavailability/' + contextualData.locale,
                        method: 'POST',
                        data: data
                    }).then(function(response) {
                        if (response.available) {
                            scope.invalidFlag = false;
                            if (model.$isEmpty(scope.formIdentifier)) {
                                if(scope.$parent.fbc !== undefined) {
                                    scope.$parent.fbc.form.expectedFormName = response.expectedFormName;
                                } else if (scope.$parent.fc !== undefined) {
                                    scope.$parent.fc.expectedFormName = response.expectedFormName;
                                }
                            }
                            def.resolve();
                        } else {
                            scope.errorMessage = setMessage('exists');
                            scope.invalidFlag = true;
                            def.reject();
                        }
                    }, function(response) {
                        scope.errorMessage = setMessage('invalid');
                        scope.invalidFlag = true;
                        def.reject();
                    });
                }
                return def.promise;
            };
        }

        /**
         * This function determines what error message will be displayed
         * @function
         * @param flag determines which error message key should be returned
         * @returns {*} message key
         */
        function setMessage(flag) {
            if (flag === 'empty') {
                return i18n.message('angular.ffMetaDataTabDirective.label.emptyFormName');
            } else if (flag === 'invalid') {
                return i18n.message('angular.ffMetaDataTabDirective.label.invalidCharacters');
            } else if (flag === 'exists') {
                return i18n.message('fcnt_createEntry.error.formNameAlreadyExists');
            }
        }
    };

    angular
        .module('formFactory')
        .directive('ffFormNameValidator', ['$log', 'ffCommonUseFactory', 'contextualData', 'ffDataFactory', '$q', 'i18nService', formNameValidator]);
})();(function() {

    var DownloadZipFactory = function($log, $resource, contextualData) {
        return $resource(null, null,
            {
                download: {
                    url: contextualData.context + '/modules/formfactory/builder/exportforms/' + contextualData.locale,
                    method: 'POST',
                    headers: {
                        accept: 'application/zip'
                    },
                    responseType: 'arraybuffer',
                    cache: false,
                    transformResponse: function(data, headers) {
                        var zip = null;
                        if (data) {
                            zip = new Blob([data], {
                                type: 'application/zip'
                            });
                        }
                        var fileName = getFileNameFromHeader(headers('content-disposition'));
                        var result = {
                            blob: zip,
                            fileName: fileName
                        };
                        return {
                            response: result
                        };
                    }
                }
            }
        );

        function getFileNameFromHeader(header) {
            if (!header) {
                return null;
            }
            var result = header.split(';')[1].trim().split('=')[1];
            return result.replace(/"/g, '');
        }
    }

    DownloadZipFactory.$inject = ['$log', '$resource', 'contextualData'];

    angular
        .module('formFactory.downloadZipFactory', [])
        .factory('ffDownloadZipFactory', DownloadZipFactory);

})();
angular.module('formFactory').config(function(contextualData, $stateProvider, $urlRouterProvider) {
	$urlRouterProvider.otherwise(function ($injector, $location) {
		var $state = $injector.get('$state');
		if ($location.$$state == null) {
			$state.go('library', {}, {
				location: false
			});
		}
	});

	$stateProvider
		.state('library', {
			url: '/library',
			templateUrl:contextualData.urlBaseSiteSettingsTemplates + 'library.html.ajax'
		})
		.state('builder', {
			url: '/builder',
			template: '<ff-controller>',
			params: {
				formIdentifier: null,
				form: null,
				options: {}
			}
		})
		.state('translator', {
			url: '/translator',
			template: '<ff-form-translator>',
			params: {formIdentifier: null}
		});
}, ['contextualData', '$stateProvider', '$urlRouterProvider']);/**
 * Simple wrapper around font awesome spinner.
 * To use:
 * 1 create and place a spinner directive within an html element
 * 2 inject spinner service inside directive/controller
 * 3 call show(<spinner id>) and hide(<spinner id>) to show/hide spinner
 */
(function () {
	'use strict';

	var SpinnerFactory = function ($log) {
		var spinners = {};
		return {
			register: function(data) {
				spinners[data.id] = data;
			},
			show: function(id) {
				spinners[id].show();
			},
			hide: function(id) {
				spinners[id].hide();
			}
		}
	};

	angular
		.module('formFactory')
		.factory('ffSpinnerService', ['$log', SpinnerFactory]);

	var SpinnerController = function($scope, spinnerService) {
		var sc = this;
		sc.show = false;

		sc.showSpinner = function() {
			sc.show = true;
		};
		sc.hideSpinner = function() {
			sc.show = false;
		};

		var data = {
			id : sc.id,
			show : sc.showSpinner,
			hide : sc.hideSpinner
		};

		spinnerService.register(data);
	};

	SpinnerController.$inject = ['$scope', 'ffSpinnerService'];

	var spinnerDirective = function ($log, spinnerService) {

		var directive = {
			restrict: 'E',
			scope: {
				id: '@',
				size: '@?',
				backsplash: '=?',
				orientation: '@?'
			},
			controller:SpinnerController,
			controllerAs: 'sc',
			bindToController:true,
			template: '<div class="ffSpinnerBacksplash" ng-show="sc.show && sc.backsplash"></div>' +
			'<div class="ffSpinner{{sc.orientation}}" ng-show="sc.show">' +
			'<i class="fa fa-spinner fa-spin {{sc.size}}"></i>' +
			'</div>',
			link: linkFunction
		};

		return directive;

		function linkFunction(scope, el, attr, ctrls) {}
	};

	angular
		.module('formFactory')
		.directive('ffSpinner', ['$log', 'ffSpinnerService', spinnerDirective]);
})();(function() {

    /**
     * This object is used to set a flag when the contents of the formlist has changed.
     * @param $log
     * @returns {{getFormListUpdated: getFormListUpdated, setFormListUpdated: setFormListUpdated}}
     * @constructor
     */
    var UpdaterFactory = function($log) {

        return {
            getFormListUpdated: getFormListUpdated,
            setFormListUpdated: setFormListUpdated
        }

        var isFormListedUpdated = false;

        function getFormListUpdated() {
            return isFormListedUpdated;
        }

        function setFormListUpdated(value) {
            isFormListedUpdated = value;
        }
    }

    UpdaterFactory.$inject = ['$log'];

    angular
        .module('formFactory.updaterFactory', [])
        .factory('ffUpdaterFactory', UpdaterFactory);
})();(function() {
    var DuplicateFormController = function($scope, $log, $http, $state, contextualData, ffCommonUseFactory) {
        var df = this;
        df.isFormNameAvailable = false;
        df.formName = '';
        df.duplicateForm = duplicateForm;
        df.checkFormAvailability = checkFormAvailability;
        df.formIdentifier = $scope.formIdentifier;

        function duplicateForm() {
            if (df.formName != '' && df.isFormNameAvailable) {
                $http.post(
                    contextualData.context + '/modules/formfactory/builder/duplicateform/' + df.formIdentifier + '/' + contextualData.locale,
                    {
                        formName: df.formName,
                        siteIdentifier: contextualData.siteIdentifier
                    }
                ).then(function(response) {
                        if ('success' in response.data) {
                            df.formName = '';
                            df.isFormNameAvailable = false;
                        }
                    }
                );
            }
        }

        function checkFormAvailability() {
            ffCommonUseFactory.checkIfNameExists.call(df, df.formName, 'isFormNameAvailable', df.formIdentifier);
        }

    };

    DuplicateFormController.$inject = ['$scope','$log', '$http', '$state', 'contextualData', 'ffCommonUseFactory'];

    var duplicateFormDirective = function($log, contextualData) {

        var directive = {
            restrict: 'E',
            scope: {
                formIdentifier: '='
            },
            controller: DuplicateFormController,
            controllerAs: 'df',
            link: postLinkFunc,
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/library/duplicate/duplicateForm.html'
        };

        return directive;

        function postLinkFunc(scope, el, attr, ffLibraryCtrl) {
        }
    };
    angular
        .module('formFactory')
        .directive('ffDuplicateForm', ['$log', 'contextualData', duplicateFormDirective]);
})();


(function() {
    var ffExportDirective = function($log) {
        var directive = {
            restrict: 'A',
            controller: ExportController,
            controllerAs: 'ec',
            link: linkFunc
        };
        return directive;

        function linkFunc(scope, el, attr, ctrls) {
        }

    };

    angular
        .module('formFactory')
        .directive('ffExport', ['$log',  ffExportDirective]);

    var ExportController = function($scope, $log, ffDownloadZipFactory) {
        var ec = this;
        ec.exportForms = exportForms;
        ec.exportListChanged = exportListChanged;
        ec.exportAvailable = false;

        ec._isSafari = function ()
        {
            return navigator.userAgent.indexOf('Safari') !== -1 &&
                navigator.userAgent.indexOf('Chrome') === -1 &&
                navigator.userAgent.indexOf('Opera') === -1;
        };

        function exportListChanged() {
            ec.exportAvailable = !_.isEmpty($scope.flc.exportChoices);
        }

        /**
         * This function starts the process of downloading the selected form(s)
         * @function
         * @returns {*}
         */
        function exportForms() {
            if (!_.isEmpty($scope.flc.exportChoices)) {
                var data = {
                    formIdentifiers: $scope.flc.exportChoices
                };
                return ffDownloadZipFactory.download(data).$promise.then(function (data) {
                    saveAs(data.response.blob, data.response.fileName);
                    //clear selection
                    $scope.flc.exportChoices = [];
                });
            }
        }
    };

    ExportController.$inject = ['$scope', '$log', 'ffDownloadZipFactory'];
})();(function() {
    var formCreation = function($log, contextualData) {
        var directive = {
            restrict: 'E',
            controller: formCreationController,
            controllerAs: 'fc',
            link: linkFunc,
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/library/formcreation/formCreation.html'
        };

        return directive;

        function linkFunc(scope, el, attr, ffLibraryCtrl) {

        }
    };

    var formCreationController = function($scope, $log, $state, ffDataFactory, contextualData, i18n) {

        var fc = this;
        fc.createForm = getFormModel;
        fc.invalidFlag = false;
        fc.formInvalidMessage = '';
        fc.i18nMessageGetter = i18n.message;

        /**
         * Retrieves the default form model and routes to the form builder
         * @function
         */
        function getFormModel() {
            ffDataFactory.getData(contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/library/formcreation/formModel.json')
            .then(function(response) {
                response.buildingLang = contextualData.locale;
                response.formName = fc.formName;
                response.displayableName = fc.formName;
                response.expectedFormName = fc.expectedFormName;
                    $state.go('builder', {
                        form: response,
                        options: {
                            doNotAddStep: true
                        }
                    });
            });
        }
    };

    formCreationController.$inject = ['$scope','$log', '$state', 'ffDataFactory', 'contextualData', 'i18nService'];

    angular
        .module('formFactory')
        .directive('ffFormCreation', ['$log', 'contextualData', formCreation]);
})();
(function() {
	var MenuController = function($scope, contextualData, $log) {
		var mc = this;
		mc.switchValue = switchValue;
		mc.switchValueDropDown = switchValueDropDown;
		mc.switchIfMarkedForRemoval = switchIfMarkedForRemoval;


		function switchValue(item) {
			if (item.markedForRemoval) {
				return "markedForRemoval";
			}
			if (item.hasPublicationWorkflow) {
				return "hasWorkflow";
			}
			if (item.buildLanguage === contextualData.language) {
				return "modify";
			}
			return "translate";
		}

		function switchIfMarkedForRemoval(item) {
			if (!item.published) {
				return "notpublished";
			}
			return "workflow";
		}

		function switchValueDropDown(item) {
			if (item.markedForRemoval) {
				return "markedForRemoval";
			}
			if (item.hasAllDefaultPermission) {
				return "hasAllDefault";
			}
		}
	};

	MenuController.$inject = ['$scope', 'contextualData', '$log'];

	var actionMenu = function($log, contextualData) {
		var directive = {
			restrict: 'E',
			templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/library/formlist/actionMenu.html',
			link: linkFunction,
			controller: MenuController,
			controllerAs: 'mc',
			bindToController: true
		};

		return directive;

		function linkFunction(scope, el, attr) {}
	};

	angular.module('formFactory')
		.directive('ffActionMenu', ['$log', 'contextualData', actionMenu]);
})();(function () {
    var FormListController     = function ($scope, ffDataFactory, contextualData, $log, $state, $uibModal,
                                           i18nService, ffUpdaterFactory, DTOptionsBuilder, DTColumnDefBuilder, spinner, $window) {
        var flc           = this;
        flc.getImageType  = getImageType;
        flc.imageType     = '';
        flc.formToCopyId  = null;
        flc.rbPublish     = '';
        flc.exportChoices = [];
        flc.dtOptions     = DTOptionsBuilder.newOptions();
        var locale        = (contextualData.locale in contextualData.supportedLocales) ? contextualData.locale : 'en';
        flc.dtOptions.withOption('language',
            {
                url: contextualData.context + '/modules/form-factory-core/javascript/dtlanguages/datatable.language_' + locale + '.json'
            }
        );
        flc.dtOptions.withBootstrap();
        flc.dtColumnDefs      = [
            DTColumnDefBuilder.newColumnDef(0).withOption('width', '5%'),
            DTColumnDefBuilder.newColumnDef(1).withOption('width', '5%'),
            DTColumnDefBuilder.newColumnDef(2).withOption('width', '15%'),
            DTColumnDefBuilder.newColumnDef(3).withOption('width', '40%'),
            DTColumnDefBuilder.newColumnDef(4).withOption('width', '15%').renderWith(function render(data, type, row, meta) {
                if (type === 'display') {
                    return moment(flc.formlist[meta.row].modified, [moment.ISO_8601], true).calendar();
                }
                else {
                    return moment(flc.formlist[meta.row].modified, [moment.ISO_8601], true).format('x');
                }
            }),
            DTColumnDefBuilder.newColumnDef(5).withOption('width', '20%')
        ];
        flc.i18nMessageGetter = i18nService.message;
        flc.updateFormList = updateFormList;
        activate();

        //this watch is used to update the formlist whenever a form has been imported.
        $scope.$watch(
            function () {
                return ffUpdaterFactory.getFormListUpdated();
            },
            function (newValue) {
                if (newValue) {
                    updateFormList();
                    ffUpdaterFactory.setFormListUpdated(false);
                }
            }
        );

        function activate() {
            spinner.show('formListSpinner');
            return getData().then(function () {
                //$log.info('FFormlist loaded and is activated');
                flc.activated = true;
                spinner.hide('formListSpinner');
            });
        }

        function getImageType(item) {
            if (item.hasPublicationWorkflow) {
                return 'publicationwf';
            }
            if (!item.published) {
                return 'notpublished';
            }
            if (item.needPublication) {
                return 'needpublication';
            }
            return 'default';
        }

        function getData() {
            return ffDataFactory.getData(contextualData.context + '/modules/formfactory/builder/formslist/' + contextualData.siteIdentifier + '/' + contextualData.language).then(function (data) {
                flc.formlist             = data.formlist;
                flc.context              = contextualData.context;
                flc.publishForm          = publishForm;
                flc.deleteForm           = deleteForm;
                flc.undeleteForm         = undeleteForm;
                flc.modifyForm           = modifyForm;
                flc.editFormMetaData     = editFormMetaData;
                flc.translateForm        = translateForm;
                flc.startWorkflow        = startWorkflow;
                flc.useAsTemplate        = useAsTemplate;
                flc.setRbPublish         = setRbPublish;
                flc.createCustomLabelOne = createCustomLabelOne;
                flc.createCustomLabelTwo = createCustomLabelTwo;
                flc.getTitleFromRB       = getTitleFromRB;
            });
        }

        /**
         * This function is used to refresh the formlist when needed.
         * @function
         */
        function updateFormList() {
            spinner.show('formListSpinner');
            ffDataFactory.getData(contextualData.context + '/modules/formfactory/builder/formslist/' + contextualData.siteIdentifier + '/' + contextualData.language).then(function (data) {
                flc.formlist = data.formlist;
                spinner.hide('formListSpinner');
            });
        }

        function createCustomLabelOne(item, abbr) {
            if (item.markedForRemoval) {
                flc.setRbPublish('ff.label.delete');
            } else {
                flc.setRbPublish('ff.label.startWorkflow');
            }
            var string = flc.rbPublish + ' - ' + item.availableWorkflows[0];
            if (abbr) {
                return abbreviate(string, 15, 40, '...');
            }
            return string;
        }

        function createCustomLabelTwo(item, abbr) {
            if (item.markedForRemoval) {
                flc.setRbPublish('ff.label.deletePermanently');
            } else {
                flc.setRbPublish('ff.label.publish');
            }

            var label = i18nService.message('ff.label.bypassWorkflow') + ' - ' + flc.rbPublish;
            if (abbr) {
                return abbreviate(label, 15, 40, '...');
            }
            return label;
        }

        function getTitleFromRB(key) {
            return i18nService.message(key);
        }

        function setRbPublish(key) {
            flc.rbPublish = i18nService.message(key);
        }

        /**
         * Initializes the publishing process for the selected form
         * @function
         * @param currentFormIdentifier - identifier of the currently selected form
         */
        function publishForm(currentFormIdentifier) {
            var data = {
                url   : contextualData.context + '/modules/formfactory/builder/publishform/' + currentFormIdentifier + '/' + contextualData.language,
                method: 'PUT'
            };
            spinner.show('formListSpinner');
            ffDataFactory.customRequest(data).then(
                function successCallback() {
                    //$log.debug('Success!!!!!');
                    spinner.hide('formListSpinner');
                    getData();
                },
                function errorCallback() {
                    spinner.hide('formListSpinner');
                    $log.debug('Could not publish form');
                }
            );
        }

        /**
         * Reverses form deletion.
         * @function
         * @param formIdentifier - identifier of the currently selected form
         */
        function undeleteForm(formIdentifier) {
            spinner.show('formListSpinner');
            ffDataFactory.customRequest({
                url   : contextualData.context + '/modules/formfactory/builder/undelete/' + formIdentifier + '/' + contextualData.language,
                method: 'PUT'
            }).then(function (result) {
                spinner.hide('formListSpinner');
                if (result.error) {
                    $log.error(result.error);
                } else {
                    getData();
                }
            });
        }

        /**
         * Marks the form for removal, or removes the form if it has not been published and is already marked
         * @function
         * @param item - the currently selected form object
         */
        function deleteForm(item) {
            var request;
            if (item.markedForRemoval) {
                request = {
                    url   : contextualData.context + '/modules/formfactory/builder/delete/' + item.jcrId + '/' + contextualData.language,
                    method: 'DELETE'
                };
            } else {
                request = {
                    url   : contextualData.context + '/modules/formfactory/builder/markfordeletion/' + item.jcrId + '/' + contextualData.language,
                    method: 'PUT'
                };
            }
            spinner.show('formListSpinner');
            ffDataFactory.customRequest(request).then(
                function (result) {
                    spinner.hide('formListSpinner');
                    if (result.error) {
                        $log.error(result.error);
                    } else {
                        getData();
                    }
                }
            );
        }

        /**
         * Routes to builder to allow modification of the currently selected form
         * @function
         * @param currentFormIdentifier - identifier of the currently selected form
         */
        function modifyForm(currentFormIdentifier) {
            $state.go('builder', {formIdentifier: currentFormIdentifier});
        }

        /**
         * Routes to builder where meta data panel will be opened for the current selected form
         * @function
         * @param currentFormIdentifier - identifier of the currently selected form
         */
        function editFormMetaData(currentFormIdentifier) {
            $state.go('builder', {
                formIdentifier: currentFormIdentifier,
                options       : {
                    openEditMetaDataPanel: true
                }
            });
        }

        function translateForm(currentFormIdentifier) {
            $state.go('builder', {
                formIdentifier: currentFormIdentifier,
                options       : {
                    translate: true
                }
            });
        }

        function startWorkflow(formId) {
            var data = {
                url   : contextualData.context + '/modules/formfactory/builder/workflowonform/' + formId + '/' + contextualData.language,
                method: 'PUT'
            };
            spinner.show('formListSpinner');
            ffDataFactory.customRequest(data).then(
                function successCallback(data) {
                    spinner.hide('formListSpinner');
                    getData();
                },
                function errorCallback(data) {
                    spinner.hide('formListSpinner');
                    $log.error(data.error);
                }
            );
        }

        /**
         * Displays a modal with a name field and then transitions to the builder passing a copy of chosen form as json.
         *
         * @function
         * @memberOf FormlistController
         * @param formId
         * @param template (template for modal display)
         */
        function useAsTemplate(formId, template) {
            flc.formToCopyId = formId;
            $uibModal.open({
                templateUrl     : contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/library/formlist/' + template,
                controller      : ModalController,
                controllerAs    : 'modalctrl',
                bindToController: true,
                scope           : $scope
            });
        }

        /**
         * Abbreviates a string (see WordUtils.java in org.apache.commons.lang for details)
         *
         * @function
         * @memberOf ffFormlistController
         * @param str
         * @param lower
         * @param upper
         * @param ending
         * @return string
         */
        function abbreviate(str, lower, upper, ending) {
            if (str.trim() === '') {
                return null;
            }

            if (lower > str.length) {
                lower = str.length;
            }

            if (upper == -1 || upper > str.length) {
                upper = str.length;
            }

            if (upper < lower) {
                upper = lower;
            }

            var result = '';
            var index  = str.indexOf(' ', lower);

            if (index === -1) {
                result += str.substring(0, upper);
                if (upper != str.length) {
                    result += ending;
                }
            } else if (index > upper) {
                result += str.substring(0, upper);
                result += ending;
            } else {
                result += str.substring(0, index);
                result += ending;
            }
            return result;
        }

        /**
         * Method for creating test forms.
         *
         * @type {createTestForm}
         */
        flc.createTestForm = createTestForm;
        function createTestForm(obj) {
            ffDataFactory.customRequest({
                url   : contextualData.context + '/modules/formfactory/builder/form/' + contextualData.language + '/targetsite/' + contextualData.siteIdentifier,
                method: 'POST',
                data  : obj
            }).then(function (response) {
                $window.location.reload();
            });
        }

    };
    FormListController.$inject = ['$scope', 'ffDataFactory', 'contextualData', '$log', '$state', '$uibModal',
        'i18nService', 'ffUpdaterFactory', 'DTOptionsBuilder', 'DTColumnDefBuilder', 'ffSpinnerService', '$window'];

    var formListDirective = function ($log, contextualData) {
        var directive = {
            restrict        : 'E',
            templateUrl     : contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/library/formlist/formList.html',
            controller      : FormListController,
            controllerAs    : 'flc',
            bindToController: true,
            link            : linkFunction

        };

        return directive;

        function linkFunction(scope, el, attr) {
            //$log.info("List directive linked!!!");
        }
    };

    var ModalController = function ($scope, $state, ffDataFactory, ffCommonUseFactory, contextualData, $uibModalInstance, $log) {
        var modalctrl                   = this;
        modalctrl.newName               = null;
        modalctrl.startTemplate         = startTemplate;
        modalctrl.duplicateAsTemplate   = duplicateAsTemplate;
        modalctrl.checkFormAvailability = checkFormAvailability;
        modalctrl.closeModal            = closeModal;
        modalctrl.formInvalidMessage    = '';

        /**
         * Uses currently selected form as a template.
         */
        function startTemplate() {
            var data = {
                url   : contextualData.context + '/modules/formfactory/builder/copyform/' + $scope.flc.formToCopyId + '/' + contextualData.language + '/' + modalctrl.newName,
                method: 'post'
            };
            ffDataFactory.customRequest(data).then(
                function successCallback(data) {
                    modalctrl.newName = null;
                    $state.go('builder', {
                        form   : data,
                        options: {
                            doNotAddStep: true
                        }
                    });
                },
                function errorCallback(data) {
                    $log.error(data.error);
                }
            );
        }

        /**
         * Duplicates (in JCR) selected form and uses it as template.
         */
        function duplicateAsTemplate() {
            var data = {
                url   : contextualData.context + '/modules/formfactory/builder/duplicateform/' + $scope.flc.formToCopyId + '/' + contextualData.language,
                method: 'post',
                data  : {
                    formName      : modalctrl.newName,
                    siteIdentifier: contextualData.siteIdentifier
                }
            };
            ffDataFactory.customRequest(data).then(
                function successCallback(data) {
                    modalctrl.newName             = null;
                    modalctrl.isFormNameAvailable = false;
                    $state.go('builder', {
                        form   : data,
                        options: {
                            doNotAddStep: true
                        }
                    });
                },
                function errorCallback(data) {
                    $log.error(data.error);
                }
            );
        }

        function closeModal() {
            $uibModalInstance.dismiss('cancel');
        }

        function checkFormAvailability() {
            ffCommonUseFactory.checkIfNameExists.call(modalctrl, modalctrl.newName, 'isFormNameAvailable');
        }
    };

    ModalController.$inject = ['$scope', '$state', 'ffDataFactory', 'ffCommonUseFactory',
        'contextualData', '$uibModalInstance', '$log'];

    angular.module('formFactory')
        .directive('ffFormList', ['$log', 'contextualData', formListDirective]);
})();
(function() {
    var importFormDisplayDirective = function($log, contextualData){
        var directive = {
            restrict: 'E',
            controller: ImportFormController,
            controllerAs: 'ifc',
            templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/formbuilder/library/import/importFormDisplay.html',
            link: linkFunc
        };
        return directive;

        function linkFunc(scope, el, attr, ctrls) {
        }
    };

    angular
        .module('formFactory')
        .directive('ffImportFormDisplay', ['$log', 'contextualData', importFormDisplayDirective]);

    var importFormDirective = function($log) {
        var directive = {
            restrict: 'A',
            controller: ImportFormController,
            controllerAs: 'ifc',
            bindToController: true,
            require: ['^ngModel'],
            link: postLinkFunction
        };

        return directive;

        function postLinkFunction(scope, el, attr, ctrls) {
            var ngModelCtrl = ctrls[0];
            scope.ifc.el = el;
            scope.ifc.model = ngModelCtrl;
            var $scope = scope;
            var onChange = function(event, data) {
                if (!_.isUndefined(data) && 'reset' in data && data['reset']) {
                    el.val(null);
                } else {
                    var isValid = event.target.files.length > 0;
                    if (isValid) {
                        var type = event.target.files[0].name.substring(event.target.files[0].name.lastIndexOf('.') + 1).toLowerCase();
                        if (type != 'zip') {
                            isValid = false;
                        }
                    }
                    if (isValid) {
                        ngModelCtrl.$setViewValue(event.target.files, 'change');
                    } else {
                        el.val(null);
                    }
                    $scope.$apply(function () {
                        $scope.ifc.fileAvailable = isValid;
                    });
                }
            };
            el.bind('change', onChange);
        }
    };

    angular
        .module('formFactory')
        .directive('ffImportForm', ['$log', importFormDirective]);

    var ImportFormController = function($scope, $log, contextualData, ffDataFactory, ffUpdaterFactory, i18n, toaster, spinner) {
        var ifc = this;
        ifc.fileUpload = fileUpload;
        ifc.files = '';
        ifc.fileAvailable = false;
        ifc.el = null;
        ifc.model = null;
        ifc.i18nMessageGetter = i18n.message;

        /**
         * Uploads the currently selected file for importation.
         * @function
         */
        function fileUpload() {
            spinner.show('importSpinner');
            if(ifc.files.length > 0){
                _.each(ifc.files, function(file){
                    var request = {
                        url: contextualData.context + '/modules/formfactory/builder/importforms/' + contextualData.siteIdentifier + '/' + contextualData.locale,
                        method: 'POST',
                        headers: {
                            'Content-Type': 'application/octet-stream'
                        },
                        data: file
                    };
                    ffDataFactory.customRequest(request).then(
                        function (success) {
                            /*
                            * sets the flag that the formlist has changed, so that the formlist directive can react to this flag
                            * and update the list
                            */
                            ffUpdaterFactory.setFormListUpdated(true);
                            $scope.ifc.files = '';
                            //reset the input element
                            ifc.model.$setViewValue(null);
                            ifc.el.val(null);
                            ifc.fileAvailable = false;
                            ifc.el.trigger('change', {reset:true});
                            spinner.hide('importSpinner');
                            toaster.pop({
                                type: 'success',
                                title: i18n.message('angular.ffImportFormDisplayDirective.label.success'),
                                toastId: 'importSuccess'
                            });
                        },
                        function (error) {
                            spinner.hide('importSpinner');
                            toaster.pop({
                                type: 'error',
                                title: i18n.message('angular.ffImportFormDisplayDirective.label.fail'),
                                body: i18n.format('angular.ffImportFormDisplayDirective.message.fail', error.statusText)
                            });
                        }
                    );
                });
            }
        }
    };

    ImportFormController.$inject = ['$scope', '$log', 'contextualData', 'ffDataFactory', 'ffUpdaterFactory', 'i18nService', 'toaster', 'ffSpinnerService'];
})();
