(function() {
    "use strict";
    angular.module("formFactory", [ "ui.router", "formFactory.dataFactory", "datatables", "datatables.bootstrap", "i18n", "ui.bootstrap", "ui.bootstrap.tooltip", "formFactory.commonUseFactory", "ngResource", "formFactory.downloadZipFactory", "formFactory.updaterFactory", "checklist-model", "uiSwitch", "formFactory.templateResolver", "toaster", "ngAnimate", "ngSanitize", "dndLists" ], function($uibTooltipProvider) {
        $uibTooltipProvider.options({
            placement: "bottom",
            popupDelay: 200,
            popupCloseDelay: 0,
            appendToBody: true
        });
    });
})();

(function() {
    "use strict";
    var ffControllerInput = function($log, contextualData) {
        var directive = {
            restrict: "E",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/addelement/addElementButton.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ffController) {
            scope.elementType = attr.elementType;
        }
    };
    angular.module("formFactory").directive("ffAddElementButton", [ "$log", "contextualData", ffControllerInput ]);
})();

(function() {
    "use strict";
    var stringToNumberDirective = function($log, contextualData, ffValidationService) {
        var directive = {
            restrict: "E",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/errorDisplay.html",
            link: linkFunction
        };
        return directive;
        function linkFunction(scope, el, attr, ctrls) {
            scope.showToasts = function() {
                ffValidationService.showToasts();
            };
        }
    };
    angular.module("formFactory").directive("ffErrorDisplay", [ "$log", "contextualData", "ffValidationWorker", stringToNumberDirective ]);
})();

(function() {
    var FormBuilderController = function($scope, $log, $state, ffDataFactory, ffCommonUseFactory, ffUpdaterFactory, contextualData, i18n, $timeout, $uibModal, toaster, ffValidationService, $filter, ffLayoutService, spinner, $window, _) {
        var fbc = this;
        fbc.processWorkerResponse = processWorkerResponse;
        fbc.stepValidityCheck = stepValidityCheck;
        function stepValidityCheck() {
            var data = {
                flag: "containsInvalidStep",
                flagValue: true,
                form: fbc.form,
                initialCall: true
            };
            ffValidationService.runValidationWorker(contextualData.context, "stepValidationWorker.js")(data);
        }
        fbc.unassignedElementsCheck = unassignedElementsCheck;
        function unassignedElementsCheck() {
            var data = {
                flag: "stepContainsUnassignedElements",
                flagValue: true,
                layout: ffLayoutService.getLayout(),
                currentStep: fbc.currentStep,
                steps: fbc.form.steps,
                initialCall: true
            };
            ffValidationService.runValidationWorker(contextualData.context, "layoutValidationWorker.js")(data);
        }
        fbc.saveForm = saveForm;
        fbc.moveInputTemplate = contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/moveInput.html";
        fbc.editStepNameTemplate = contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/editStepName.html";
        fbc.i18nMessageGetter = i18nMessageGetter;
        fbc.showSidePanel = showSidePanel;
        fbc.hideSidePanel = hideSidePanel;
        fbc.isSidePanelDisplayed = false;
        fbc.resolveLogic = resolveLogic;
        fbc.getFormController = getFormController;
        fbc.removeInput = removeInput;
        fbc.createForm = createForm;
        fbc.prepareFormForBuilder = prepareFormForBuilder;
        fbc.prepareFormForJCR = prepareFormForJCR;
        fbc.getInputsAndMakeBuilderReady = getInputsAndMakeBuilderReady;
        fbc.moveInput = moveInput;
        fbc.test = test;
        fbc.availableTabs = [ "Design", "Validations", "Logics" ];
        fbc.availableInputTabs = [ "Input", "Checkboxes and Radio", "Selects", "Additional" ];
        fbc.previewForm = previewForm;
        fbc.closePreviewModal = closePreviewModal;
        fbc.getData = getData;
        fbc.reloadForm = reloadForm;
        fbc.getTabHeading = getTabHeading;
        fbc.containsInvalidValidation = false;
        fbc.containsInvalidKeyValue = false;
        fbc.currentStep = 0;
        fbc.removeStep = removeStep;
        fbc.addStep = addStep;
        fbc.moveStep = moveStep;
        fbc.updateCurrentStep = updateCurrentStep;
        fbc.containsInvalidStep = false;
        fbc.containsDuplicateInput = false;
        fbc.stepContainsUnassignedElements = false;
        fbc.workerRunning = false;
        fbc.moveInput = moveInput;
        fbc.moveInputIndex = null;
        fbc.moveUpOrDown = moveUpOrDown;
        fbc.editInput = false;
        fbc.showEditInput = showEditInput;
        fbc.selectedInputIndex = 0;
        fbc.addInput = false;
        fbc.showInputs = showInputs;
        fbc.inputsCache = null;
        fbc.transformToElement = transformToElement;
        fbc.previewElement = previewElement;
        fbc.cancelPreview = cancelPreview;
        fbc.keepPreviewed = keepPreviewed;
        fbc.inPreviewIndex = -1;
        fbc.displayableInputs = {};
        fbc.prepareDisplayableInputs = prepareDisplayableInputs;
        fbc.displayMode = "editing";
        fbc.setDisplayMode = setDisplayMode;
        fbc.manageLayout = manageLayout;
        fbc.getLayout = getLayout;
        fbc.duplicateKeyDetected = false;
        fbc.editMetaData = false;
        fbc.openMetaDataPanel = openMetaDataPanel;
        fbc.invalidFormName = false;
        fbc.inTranslateMode = false;
        fbc.addAction = false;
        fbc.editAction = false;
        fbc.actionsCache = null;
        fbc.prepareActions = prepareActions;
        fbc.getAvailableActions = getAvailableActions;
        fbc.removeAction = removeAction;
        fbc.showEditAction = showEditAction;
        fbc.showActions = showActions;
        fbc.getActionKeyName = getActionKeyName;
        fbc.selectedActionIndex = 0;
        fbc.isPreviewAvailable = false;
        fbc.isTranslatable = isTranslatable;
        fbc.isLiveMode = isLiveMode;
        fbc.containsInvalidAction = false;
        fbc.logicsCache = null;
        fbc.containsInvalidLogics = false;
        fbc.inputHasSupportedLogics = inputHasSupportedLogics;
        fbc.inputHasSupportedValidations = inputHasSupportedValidations;
        fbc.nbColumnsInSidePanel = 3;
        fbc.unsavedWarning = null;
        fbc.warnIfUnsaved = warnIfUnsaved;
        fbc.backToLibrary = backToLibrary;
        fbc.handleBackToLibraryAction = handleBackToLibraryAction;
        fbc.getFormName = getFormName;
        activate();
        $scope.$on("validateLayout", function() {
            fbc.unassignedElementsCheck();
        });
        function activate() {
            ffValidationService.setController(fbc);
            if ($state.params.formIdentifier == null) {
                if ($state.params.form === null) {
                    loadBasicForm();
                    return;
                }
                ffLayoutService.setBaseLayout();
                fbc.isPreviewAvailable = false;
                fbc.form = angular.copy($state.params.form);
                if (angular.isUndefined($state.params.options) || !("doNotAddStep" in $state.params.options)) {
                    addStep();
                }
                fbc.getInputsAndMakeBuilderReady();
                fbc.getAvailableActions();
                if (ffLayoutService.isActive()) {
                    ffLayoutService.handleInputAdd(fbc.currentStep, fbc.form.steps[fbc.currentStep].inputs[0].layoutUUID);
                }
            } else {
                return getData().then(function() {
                    fbc.activated = true;
                });
            }
        }
        function loadBasicForm() {
            ffDataFactory.getData(contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/library/formcreation/formModel.json").then(function(response) {
                response.buildingLang = contextualData.locale;
                response.formName = "Change me";
                response.displayableName = "Change me";
                ffLayoutService.setBaseLayout();
                fbc.isPreviewAvailable = false;
                fbc.form = response;
                fbc.getInputsAndMakeBuilderReady();
                fbc.getAvailableActions();
                if (ffLayoutService.isActive()) {
                    ffLayoutService.handleInputAdd(fbc.currentStep, fbc.form.steps[fbc.currentStep].inputs[0].layoutUUID);
                }
            });
        }
        function getData(reloadForm) {
            var currentStepBeforeSave = fbc.currentStep;
            return ffDataFactory.getData(contextualData.context + "/modules/formfactory/builder/form/" + $state.params.formIdentifier + "/" + contextualData.language).then(function(response) {
                fbc.form = response;
                fbc.saveForm = saveForm;
                fbc.isPreviewAvailable = true;
                fbc.currentStep = currentStepBeforeSave === null ? null : 0;
                fbc.getInputsAndMakeBuilderReady();
                fbc.getAvailableActions();
                fbc.stepValidityCheck();
                fbc.unassignedElementsCheck();
                if (reloadForm) {
                    spinner.hide("buttonsSpinner");
                    toaster.pop({
                        type: "success",
                        title: i18n.message("angular.ffFormBuilderDirective.message.formReload"),
                        toastId: 4,
                        timeout: 3e3
                    });
                    fbc.stepValidityCheck();
                    $timeout(function() {
                        if (currentStepBeforeSave === null) {
                            fbc.currentStep = null;
                            angular.element('a[href$="stepActionContent"]').click();
                        } else if (fbc.form.steps.length >= currentStepBeforeSave) {
                            angular.element('a[href$="step-' + currentStepBeforeSave + '"]').click();
                        } else {
                            angular.element('a[href$="step-0"]').click();
                        }
                    });
                }
            });
        }
        function getAvailableActions() {
            if (fbc.actionsCache === null) {
                ffDataFactory.customRequest({
                    url: contextualData.context + "/modules/formfactory/builder/definitionslist/actions/" + contextualData.siteIdentifier + "/en",
                    method: "GET"
                }).then(function(response) {
                    fbc.actionsCache = response;
                    fbc.prepareActions();
                });
            } else {
                fbc.prepareActions();
            }
        }
        function getInputsAndMakeBuilderReady() {
            if (fbc.inputsCache === null) {
                ffDataFactory.customRequest({
                    url: contextualData.context + "/modules/formfactory/builder/definitionslist/inputs/" + contextualData.siteIdentifier + "/en",
                    method: "GET"
                }).then(function(response) {
                    fbc.inputsCache = response;
                    fbc.prepareFormForBuilder();
                });
            } else {
                fbc.prepareFormForBuilder();
            }
        }
        function resolveLogic(input, form) {
            return ffCommonUseFactory.logicResolver(input, form);
        }
        function performSaving() {
            fbc.prepareFormForJCR();
            return ffDataFactory.customRequest({
                url: contextualData.context + "/modules/formfactory/builder/form/" + fbc.form.jcrId + "/" + contextualData.language,
                method: "PUT",
                data: fbc.form
            });
        }
        function saveForm() {
            spinner.show("buttonsSpinner");
            var currentStepBeforeSave = fbc.currentStep;
            performSaving().then(function(response) {
                fbc.form = response;
                if (creationFormName !== undefined) {
                    creationFormName = undefined;
                }
                fbc.currentStep = currentStepBeforeSave === null ? null : 0;
                fbc.getInputsAndMakeBuilderReady();
                fbc.getAvailableActions();
                fbc.isPreviewAvailable = true;
                spinner.hide("buttonsSpinner");
                toaster.pop({
                    type: "info",
                    title: i18n.message("angular.ffFormBuilderDirective.message.previewForm"),
                    toastId: 2,
                    timeout: 3e3
                });
                toaster.pop({
                    type: "success",
                    title: i18n.message("angular.ffFormBuilderDirective.message.formSaved"),
                    toastId: 3,
                    timeout: 3e3
                });
                $timeout(function() {
                    if (currentStepBeforeSave === null) {
                        fbc.currentStep = null;
                        angular.element('a[href$="stepActionContent"]').click();
                    } else {
                        angular.element('a[href$="step-' + currentStepBeforeSave + '"]').click();
                    }
                });
            });
        }
        function performFormCreation() {
            fbc.prepareFormForJCR();
            return ffDataFactory.customRequest({
                url: contextualData.context + "/modules/formfactory/builder/form/" + contextualData.language + "/targetsite/" + contextualData.siteIdentifier,
                method: "POST",
                data: fbc.form
            });
        }
        function createForm() {
            spinner.show("buttonsSpinner");
            var currentStepBeforeSave = fbc.currentStep;
            performFormCreation().then(function(response) {
                fbc.form = response;
                $state.params.formIdentifier = response.jcrId;
                fbc.currentStep = currentStepBeforeSave === null ? null : 0;
                fbc.getInputsAndMakeBuilderReady();
                fbc.getAvailableActions();
                fbc.isPreviewAvailable = true;
                spinner.hide("buttonsSpinner");
                toaster.pop({
                    type: "info",
                    title: i18n.message("angular.ffFormBuilderDirective.message.previewForm"),
                    toastId: 2,
                    timeout: 3e3
                });
                toaster.pop({
                    type: "success",
                    title: i18n.message("angular.ffFormBuilderDirective.message.formSaved"),
                    toastId: 3,
                    timeout: 3e3
                });
                $timeout(function() {
                    if (currentStepBeforeSave === null) {
                        fbc.currentStep = null;
                        angular.element('a[href$="stepActionContent"]').click();
                    } else if (fbc.form.steps.length >= currentStepBeforeSave) {
                        angular.element('a[href$="step-' + currentStepBeforeSave + '"]').click();
                    } else {
                        angular.element('a[href$="step-0"]').click();
                    }
                });
            });
        }
        function test() {
            ffDataFactory.customRequest({
                url: contextualData.context + "/modules/formfactory/builder/definitionslist/validations/" + contextualData.siteIdentifier + "/en",
                method: "GET"
            }).then(function(response) {});
        }
        function showEditInput(index) {
            fbc.headerMessage = i18n.message("angular.ffFormBuilderDirective.title.editInput");
            fbc.selectedInputIndex = index;
            fbc.editInput = true;
            fbc.inPreviewIndex = index;
            showSidePanel();
            ffValidationService.runValidationWorker(contextualData.context, "stepValidationWorker.js");
        }
        function showInputs() {
            if (fbc.inputsCache === null) {
                ffDataFactory.customRequest({
                    url: contextualData.context + "/modules/formfactory/builder/definitionslist/inputs/" + contextualData.siteIdentifier + "/en",
                    method: "GET"
                }).then(function(response) {
                    fbc.inputsCache = response;
                    fbc.headerMessage = i18n.message("angular.ffFormBuilderDirective.title.addInput");
                    prepareDisplayableInputs();
                });
            } else {
                fbc.headerMessage = i18n.message("angular.ffFormBuilderDirective.title.addInput");
                prepareDisplayableInputs();
            }
        }
        function transformToElement(name, elementType) {
            if (elementType === "input") {
                var data = null;
                var input = {};
                var ins = fbc.inputsCache;
                for (var i in ins) {
                    if (ins[i].name === name) {
                        data = angular.copy(ins[i]);
                    }
                }
                if (data !== null) {
                    data.layoutUUID = generateUUID();
                    input = data;
                }
                return input;
            }
            if (elementType === "action") {
                var data = null;
                var action = {};
                var ins = fbc.actionsCache;
                for (var i in ins) {
                    if (ins[i].actionname === name) {
                        data = angular.copy(ins[i]);
                    }
                }
                if (data !== null) {
                    action = data;
                }
                return action;
            }
        }
        function previewElement(name, elementType) {
            function generateName(inputName, number) {
                return inputName + "_" + fbc.currentStep + "_" + (fbc.form.steps[fbc.currentStep].inputs.length + number);
            }
            switch (elementType) {
              case "input":
                var input = fbc.transformToElement(name, elementType);
                var number = 1;
                var inputName = input.name;
                input.name = generateName(inputName, number);
                while (_.findIndex(fbc.form.steps[fbc.currentStep].inputs, {
                    name: input.name
                }) > -1) {
                    input.name = generateName(inputName, number++);
                }
                fbc.inPreviewIndex = fbc.form.steps[fbc.currentStep].inputs.length;
                fbc.form.steps[fbc.currentStep].inputs.push(input);
                break;

              case "action":
                var action = fbc.transformToElement(name, elementType);
                fbc.inPreviewIndex = fbc.form.actions.length;
                fbc.form.actions.push(action);
            }
        }
        function cancelPreview(elementType) {
            if (elementType === "input") {
                if (fbc.inPreviewIndex !== -1) {
                    var inputs = [];
                    var ins = fbc.form.steps[fbc.currentStep].inputs;
                    for (var i in ins) {
                        if (i != fbc.inPreviewIndex) {
                            inputs.push(ins[i]);
                        }
                    }
                    fbc.form.steps[fbc.currentStep].inputs = inputs;
                }
                fbc.inPreviewIndex = -1;
                return;
            }
            if (elementType === "action") {
                if (fbc.inPreviewIndex !== -1) {
                    var actions = [];
                    var ins = fbc.form.actions;
                    for (var i in ins) {
                        if (i != fbc.inPreviewIndex) {
                            actions.push(ins[i]);
                        }
                    }
                    fbc.form.actions = actions;
                }
                fbc.inPreviewIndex = -1;
                return;
            }
        }
        function keepPreviewed(input, type) {
            if (fbc.currentStep !== null) {
                if (ffLayoutService.isActive()) {
                    ffLayoutService.handleInputAdd(fbc.currentStep, fbc.form.steps[fbc.currentStep].inputs[fbc.inPreviewIndex].layoutUUID);
                    fbc.unassignedElementsCheck();
                }
            }
            fbc.inPreviewIndex = -1;
            fbc.stepValidityCheck();
            $window.scrollTo(0, document.body.scrollHeight);
            fbc.previewElement(input, type);
            toaster.pop({
                type: "success",
                title: i18n.message("angular.ffFormBuilderDirective.message.elementAdded"),
                timeout: 2e3,
                toastId: Math.random()
            });
        }
        function showSidePanel() {
            fbc.isSidePanelDisplayed = true;
            var element = angular.element("body");
            element.addClass("modal-open");
            jQuery(document.createElement("div")).addClass("modal-backdrop in").appendTo(element);
        }
        function hideSidePanel() {
            var element = angular.element("body");
            element.removeClass("modal-open");
            angular.element(".modal-backdrop").remove();
            fbc.isSidePanelDisplayed = false;
            fbc.editInput = false;
            fbc.addInput = false;
            fbc.addAction = false;
            fbc.editAction = false;
            fbc.editMetaData = false;
            fbc.inPreviewIndex = -1;
        }
        function getFormController() {
            var formName = $filter("sanitizeFormName")(fbc.getFormName());
            return $scope[formName];
        }
        function prepareDisplayableInputs() {
            var columnCounter = {};
            _.each(fbc.inputsCache, function(input, index) {
                if (input.tab === "hiddenbutton") {
                    return;
                }
                if (!(input.tab in columnCounter)) {
                    columnCounter[input.tab] = 0;
                    fbc.displayableInputs[input.tab] = [];
                    fbc.displayableInputs[input.tab].push([]);
                }
                fbc.displayableInputs[input.tab][fbc.displayableInputs[input.tab].length - 1].push(input);
                columnCounter[input.tab]++;
                if (columnCounter[input.tab] % fbc.nbColumnsInSidePanel === 0) {
                    fbc.displayableInputs[input.tab].push([]);
                }
            });
        }
        function openMetaDataPanel() {
            fbc.headerMessage = i18n.message("fcnt_metaData");
            fbc.editMetaData = true;
            showSidePanel();
        }
        function reloadForm() {
            spinner.show("buttonsSpinner");
            if ($state.params.formIdentifier == null) {
                var currentStepBeforeSave = fbc.currentStep;
                fbc.form = angular.copy($state.params.form);
                if (angular.isUndefined($state.params.options) || !("doNotAddStep" in $state.params.options)) {
                    addStep();
                }
                fbc.getInputsAndMakeBuilderReady();
                fbc.getAvailableActions();
                spinner.hide("buttonsSpinner");
                toaster.pop({
                    type: "success",
                    title: i18n.message("angular.ffFormBuilderDirective.message.formReload"),
                    toastId: 4,
                    timeout: 3e3
                });
                fbc.stepValidityCheck();
                fbc.unassignedElementsCheck();
                $timeout(function() {
                    if (currentStepBeforeSave === null) {
                        fbc.currentStep = null;
                        angular.element('a[href$="stepActionContent"]').click();
                    } else {
                        angular.element('a[href$="step-0"]').click();
                    }
                });
            } else {
                fbc.getData(true);
            }
        }
        function previewForm() {
            fbc.previewModal = $uibModal.open({
                templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/previewFormModal.html",
                size: "lg",
                windowClass: "preview-modal",
                animation: true,
                scope: $scope
            });
            fbc.previewModal.rendered.then(function() {
                spinner.show("previewSpinner");
            });
        }
        function closePreviewModal() {
            spinner.hide("previewSpinner");
            fbc.previewModal.close();
        }
        function setDisplayMode(mode) {
            if (fbc.inTranslateMode) {
                return;
            }
            if (mode === "layout") {
                if (ffLayoutService.isActive()) {
                    fbc.unassignedElementsCheck();
                    $timeout(function() {
                        $scope.$broadcast("gainColumnFocus", null);
                    });
                }
            }
            fbc.displayMode = mode;
        }
        function manageLayout() {
            if (getLayout().active) {
                ffLayoutService.activate();
                ffLayoutService.prepareSteps(fbc.form.steps.length);
                fbc.unassignedElementsCheck();
            } else {
                ffLayoutService.deactivate();
                fbc.unassignedElementsCheck();
                $scope.$broadcast("resetAvailableInputs", null);
                ffLayoutService.setBaseForSteps(fbc.form.steps.length);
            }
        }
        function getLayout() {
            return ffLayoutService.getLayout();
        }
        function prepareActions() {
            if (typeof fbc.form.actions === "undefined") {
                fbc.form.actions = [];
            }
            var actionCacheNames = {};
            _.each(fbc.actionsCache, function(action, actionKey) {
                actionCacheNames[action.actionname] = actionKey;
            });
            for (var i in fbc.form.actions) {
                if (!(fbc.form.actions[i].actionname in actionCacheNames)) {
                    delete fbc.form.actions[i];
                    continue;
                }
                delete fbc.form.actions[i].definitionOptionsTranslatable;
                delete fbc.form.actions[i].definitionOptions;
                fbc.form.actions[i] = angular.merge({}, fbc.actionsCache[actionCacheNames[fbc.form.actions[i].actionname]], fbc.form.actions[i]);
                _.each(fbc.form.actions[i], function(field, fieldName) {
                    if (!(fieldName in fbc.actionsCache[actionCacheNames[fbc.form.actions[i].actionname]])) {
                        delete fbc.form.actions[i][fieldName];
                    }
                });
            }
        }
        function removeAction(index) {
            var actions = [];
            for (var i in fbc.form.actions) {
                if (i != index) {
                    actions.push(fbc.form.actions[i]);
                }
            }
            fbc.form.actions = actions;
            fbc.stepValidityCheck();
        }
        function showEditAction(index) {
            fbc.editAction = true;
            fbc.headerMessage = i18n.message("angular.ffElementManagementBox.title.editAction");
            fbc.selectedActionIndex = index;
            fbc.inPreviewIndex = index;
            showSidePanel();
        }
        function showActions() {
            fbc.addAction = true;
            fbc.headerMessage = i18n.message("angular.ffFormBuilderDirective.title.addFormAction");
            getAvailableActions();
            showSidePanel();
        }
        function getActionKeyName() {
            var actionKeyName = "";
            _.each(fbc.actionsCache, function(action, actionKey) {
                if (action.actionname === fbc.form.actions[fbc.selectedActionIndex].actionname) {
                    actionKeyName = actionKey;
                }
            });
            return actionKeyName;
        }
        function removeStep(index) {
            if (fbc.currentStep === index) {
                fbc.form.steps.splice(index, 1);
                ffLayoutService.removeStep(index);
                fbc.currentStep = fbc.currentStep > 0 ? --fbc.currentStep : 0;
                $timeout(function() {
                    if (fbc.form.steps.length > 0) {
                        angular.element('a[href$="step-' + fbc.currentStep + '"]').click();
                    }
                });
            }
            fbc.stepValidityCheck();
            fbc.unassignedElementsCheck();
        }
        function addStep() {
            var newStepNumber = fbc.form.steps.length + 1;
            var newStep = {
                jcrId: null,
                label: "Step" + " " + newStepNumber,
                inputs: []
            };
            fbc.form.steps.push(newStep);
            ffLayoutService.addStep();
            fbc.stepValidityCheck();
        }
        function moveStep(newIndex) {
            var stepToMove = fbc.form.steps[fbc.currentStep];
            fbc.form.steps[fbc.currentStep] = fbc.form.steps[newIndex];
            fbc.form.steps[newIndex] = stepToMove;
            ffLayoutService.moveStep(newIndex, fbc.currentStep);
            updateCurrentStep(newIndex);
            fbc.stepValidityCheck();
        }
        function updateCurrentStep(index) {
            fbc.currentStep = index;
            if (fbc.displayMode === "layout" && ffLayoutService.isActive()) {
                fbc.unassignedElementsCheck();
                $timeout(function() {
                    $scope.$broadcast("gainColumnFocus", null);
                });
            }
        }
        function moveInput(targetStepIndex, targetIndex) {
            var input = angular.copy(fbc.form.steps[fbc.currentStep].inputs[fbc.moveInputIndex]);
            if (ffLayoutService.isActive()) {
                ffLayoutService.handleInputMove(fbc.currentStep, targetStepIndex, input.layoutUUID);
            }
            if (fbc.currentStep !== targetStepIndex) {
                input.jcrId = null;
                nullifyJCRIdsForValidationsAndLogics(input);
            }
            if (targetIndex < 1e3) {
                if (fbc.moveInputIndex < targetIndex) {
                    putInputInPosition(input, targetStepIndex, targetIndex);
                    removeInputFromPosition(fbc.currentStep, fbc.moveInputIndex);
                } else {
                    removeInputFromPosition(fbc.currentStep, fbc.moveInputIndex);
                    putInputInPosition(input, targetStepIndex, targetIndex);
                }
            } else {
                removeInputFromPosition(fbc.currentStep, fbc.moveInputIndex);
                putInputInPosition(input, targetStepIndex, fbc.form.steps[targetStepIndex].inputs.length);
            }
            fbc.stepValidityCheck();
            fbc.unassignedElementsCheck();
        }
        function nullifyJCRIdsForValidationsAndLogics(input) {
            for (var i in input.validations) {
                input.validations[i].jcrId = null;
            }
            for (var j in input.logics) {
                input.logics[j].jcrId = null;
            }
        }
        function putInputInPosition(obj, stepIndex, positionIndex) {
            fbc.form.steps[stepIndex].inputs.splice(positionIndex, 0, obj);
        }
        function removeInputFromPosition(stepIndex, positionIndex) {
            fbc.form.steps[stepIndex].inputs.splice(positionIndex, 1);
        }
        function removeInput(index) {
            var newInputs = [];
            var inputs = fbc.form.steps[fbc.currentStep].inputs;
            ffLayoutService.handleInputRemoval(fbc.currentStep, inputs[index].layoutUUID);
            for (var i in inputs) {
                if (i != index) {
                    newInputs.push(inputs[i]);
                }
            }
            fbc.form.steps[fbc.currentStep].inputs = newInputs;
            fbc.stepValidityCheck();
            fbc.unassignedElementsCheck();
        }
        function moveUpOrDown(index, direction, target) {
            switch (direction) {
              case "up":
                if (target === "input") {
                    if (fbc.form.steps[fbc.currentStep].inputs[index - 1] !== undefined) {
                        var inputAbove = fbc.form.steps[fbc.currentStep].inputs[index - 1];
                        var currentInput = fbc.form.steps[fbc.currentStep].inputs[index];
                        fbc.form.steps[fbc.currentStep].inputs[index - 1] = currentInput;
                        fbc.form.steps[fbc.currentStep].inputs[index] = inputAbove;
                    }
                    return;
                }
                if (fbc.form.actions[index - 1] !== undefined) {
                    var actionAbove = fbc.form.actions[index - 1];
                    var currentAction = fbc.form.actions[index];
                    fbc.form.actions[index - 1] = currentAction;
                    fbc.form.actions[index] = actionAbove;
                }
                break;

              case "down":
                if (target === "input") {
                    if (fbc.form.steps[fbc.currentStep].inputs[index + 1] !== undefined) {
                        var inputBelow = fbc.form.steps[fbc.currentStep].inputs[index + 1];
                        var currentInput = fbc.form.steps[fbc.currentStep].inputs[index];
                        fbc.form.steps[fbc.currentStep].inputs[index + 1] = currentInput;
                        fbc.form.steps[fbc.currentStep].inputs[index] = inputBelow;
                    }
                    return;
                }
                if (fbc.form.actions[index + 1] !== undefined) {
                    var actionBelow = fbc.form.actions[index + 1];
                    var currentAction = fbc.form.actions[index];
                    fbc.form.actions[index + 1] = currentAction;
                    fbc.form.actions[index] = actionBelow;
                }
                break;
            }
        }
        function prepareFormForBuilder() {
            for (var i in fbc.form.steps) {
                for (var j in fbc.form.steps[i].inputs) {
                    makeConsistentWithDefaultInput(i, j);
                }
            }
            if (!_.isUndefined(fbc.form.layoutJson) && !_.isEmpty(fbc.form.layoutJson)) {
                ffLayoutService.setExistingLayout(JSON.parse(fbc.form.layoutJson));
            }
            ffLayoutService.prepareSteps(fbc.form.steps.length);
            delete fbc.form.layoutJson;
            processRouteOptions();
        }
        function processRouteOptions() {
            if ("openEditMetaDataPanel" in $state.params.options) {
                delete $state.params.options.openEditMetaDataPanel;
                openMetaDataPanel();
            }
            fbc.inTranslateMode = !!("translate" in $state.params.options);
        }
        function makeConsistentWithDefaultInput(i, j) {
            var mandatoryFields = [ "jcrId", "choiceField", "validations", "logics", "$$hashKey", "value", "layoutUUID" ];
            for (var k in fbc.inputsCache) {
                if (fbc.inputsCache[k].nodeType === fbc.form.steps[i].inputs[j].nodeType) {
                    for (var key in fbc.inputsCache[k]) {
                        if (!(key in fbc.form.steps[i].inputs[j]) && key !== "$$hashKey") {
                            fbc.form.steps[i].inputs[j][key] = angular.copy(fbc.inputsCache[k][key]);
                        }
                    }
                    if (!("layoutUUID" in fbc.form.steps[i].inputs[j])) {
                        fbc.form.steps[i].inputs[j].layoutUUID = generateUUID();
                    }
                    for (var key in fbc.form.steps[i].inputs[j]) {
                        if (!isMandatory(key) && !(key in fbc.inputsCache[k])) {
                            delete fbc.form.steps[i].inputs[j][key];
                        }
                    }
                    fbc.form.steps[i].inputs[j]["definitionOptionsTranslatable"] = angular.copy(fbc.inputsCache[k]["definitionOptionsTranslatable"]);
                    fbc.form.steps[i].inputs[j]["definitionOptions"] = angular.copy(fbc.inputsCache[k]["definitionOptions"]);
                }
            }
            function isMandatory(key) {
                for (var i in mandatoryFields) {
                    if (key === mandatoryFields[i]) {
                        return true;
                    }
                }
                return false;
            }
        }
        function prepareFormForJCR() {
            for (var i in fbc.form.steps) {
                for (var j in fbc.form.steps[i].inputs) {
                    deleteFields(i, j);
                    createNullFields(i, j);
                    for (var k in fbc.form.steps[i].inputs[j].validations) {
                        if (fbc.form.steps[i].inputs[j].validations[k].active === false) {
                            delete fbc.form.steps[i].inputs[j].validations[k];
                        } else {
                            delete fbc.form.steps[i].inputs[j].validations[k].types;
                            delete fbc.form.steps[i].inputs[j].validations[k].active;
                            if (fbc.form.steps[i].inputs[j].validations[k].jcrId === undefined) {
                                fbc.form.steps[i].inputs[j].validations[k].jcrId = null;
                            }
                        }
                    }
                }
            }
            if (fbc.form.progressBar !== null && fbc.form.progressBar.show === false) {
                delete fbc.form.progressBar;
            }
            if (fbc.form.expectedFormName !== undefined) {
                delete fbc.form.expectedFormName;
            }
            fbc.form.layoutJson = JSON.stringify(ffLayoutService.getLayout());
        }
        function deleteFields(currentStep, inputNumber) {
            var fields = [ "supportedLogicTypes", "supportedValidationTypes" ];
            for (var i in fields) {
                delete fbc.form.steps[currentStep].inputs[inputNumber][fields[i]];
            }
        }
        function createNullFields(currentStep, inputNumber) {
            var fields = [ "jcrId", "choiceField" ];
            for (var i in fields) {
                if (fbc.form.steps[currentStep].inputs[inputNumber][fields[i]] === undefined) {
                    fbc.form.steps[currentStep].inputs[inputNumber][fields[i]] = null;
                }
            }
        }
        function i18nMessageGetter(key) {
            return i18n.message(key);
        }
        function processWorkerResponse(data) {
            $timeout(function() {
                $scope.$apply(function() {
                    if (fbc[data.flag] !== undefined) {
                        fbc.workerRunning = true;
                        fbc[data.flag] = data.flagValue;
                    }
                    if (data.initialCall === undefined || data.initialCall === false) {
                        ffValidationService.handleCallbacks(data);
                        fbc.workerRunning = false;
                    }
                });
            });
        }
        fbc.test = function() {
            console.log("Testing!!!");
        };
        function inputHasSupportedLogics() {
            return !_.isUndefined(fbc.form.steps[fbc.currentStep].inputs[fbc.selectedInputIndex].supportedLogicTypes);
        }
        function inputHasSupportedValidations() {
            return !_.isUndefined(fbc.form.steps[fbc.currentStep].inputs[fbc.selectedInputIndex].supportedValidationTypes);
        }
        function isTranslatable() {
            return !fbc.inTranslateMode && (angular.isObject(fbc.form.missingLanguages) || Object.keys(fbc.form.existingLanguages).length > 1);
        }
        function isLiveMode() {
            return false;
        }
        function getTabHeading(tab) {
            return fbc.i18nMessageGetter("angular.ffEditInputTabsDirective.tab.heading." + $filter("lowercase")(tab));
        }
        function generateUUID() {
            var d = Date.now();
            if ($window.performance && typeof $window.performance.now === "function") {
                d += performance.now();
            }
            var uuid = "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function(c) {
                var r = (d + Math.random() * 16) % 16 | 0;
                d = Math.floor(d / 16);
                return (c == "x" ? r : r & 3 | 8).toString(16);
            });
            return uuid;
        }
        $window.hidePreviewSpinner = function() {
            $timeout(function() {
                $scope.$apply(function() {
                    spinner.hide("previewSpinner");
                });
            }, 2500);
        };
        $window.setupPreviewModalIFrameSrc = function() {
            var previewFormPath = contextualData.urlBase + contextualData.sitePath + "/formFactory/forms/" + fbc.form.formName + ".preview.html?isPreviewMode=true";
            if (angular.element(".previewModalIFrame").attr("src") != previewFormPath) {
                angular.element(".previewModalIFrame").attr("src", previewFormPath);
            }
        };
        function warnIfUnsaved() {
            fbc.unsavedWarning = $uibModal.open({
                templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/saveChangesWarning.html",
                size: "md",
                windowClass: "save-warning",
                animation: true,
                scope: $scope
            });
        }
        function backToLibrary() {
            fbc.warnIfUnsaved();
        }
        function handleBackToLibraryAction(typeOfTransition) {
            switch (typeOfTransition) {
              case "save":
                if (fbc.form.jcrId === null) {
                    performFormCreation().then(function() {
                        fbc.unsavedWarning.dismiss("cancel");
                        $state.go("library");
                    });
                } else {
                    performSaving().then(function() {
                        fbc.unsavedWarning.dismiss("cancel");
                        $state.go("library");
                    });
                }
                break;

              case "exit":
                fbc.unsavedWarning.dismiss("cancel");
                $state.go("library");
                break;

              case "stay":
                fbc.unsavedWarning.dismiss("cancel");
                break;
            }
        }
        var creationFormName;
        function getFormName() {
            if (creationFormName !== undefined) {
                return creationFormName;
            }
            if (fbc.form === undefined) {
                return undefined;
            }
            if (fbc.form.expectedFormName != undefined) {
                creationFormName = fbc.form.expectedFormName;
                return fbc.form.expectedFormName;
            } else {
                return fbc.form.formName;
            }
        }
    };
    FormBuilderController.$inject = [ "$scope", "$log", "$state", "ffDataFactory", "ffCommonUseFactory", "ffUpdaterFactory", "contextualData", "i18nService", "$timeout", "$uibModal", "toaster", "ffValidationWorker", "$filter", "ffLayoutService", "ffSpinnerService", "$window", "_" ];
    var formBuilderDirective = function($log, contextualData) {
        var directive = {
            restrict: "E",
            templateUrl: contextualData.urlBaseSiteSettingsTemplates + "builder.html.ajax",
            controller: FormBuilderController,
            controllerAs: "fbc",
            bindToController: true,
            link: linkFunction
        };
        return directive;
        function linkFunction(scope, el, attr) {}
    };
    angular.module("formFactory").directive("ffController", [ "$log", "contextualData", formBuilderDirective ]);
})();

(function() {
    "use strict";
    var inputTypeDirective = function($log, toaster) {
        var directive = {
            restrict: "A",
            require: [ "^ngModel" ],
            link: linkFunction
        };
        return directive;
        function linkFunction(scope, el, attr, ctrl) {
            var type = attr["ffInputType"];
            var ngModelCtrl = ctrl[0];
            function number(text) {
                if (text) {
                    var transformedInput = text.replace(/[^0-9]/g, "");
                    if (transformedInput !== text) {
                        ngModelCtrl.$setViewValue(transformedInput);
                        ngModelCtrl.$render();
                    }
                    return transformedInput;
                }
                return undefined;
            }
            function float(text) {
                if (text) {
                    var transformedInput = text.replace(/[^0-9\.]/g, "");
                    if (transformedInput !== text) {
                        ngModelCtrl.$setViewValue(transformedInput);
                        ngModelCtrl.$render();
                    }
                    return transformedInput;
                }
                return undefined;
            }
            if (type === "number") {
                ngModelCtrl.$parsers.push(number);
            } else if (type === "float") {
                ngModelCtrl.$parsers.push(float);
            } else if (type === "string") {}
        }
    };
    angular.module("formFactory").directive("ffInputType", [ "$log", inputTypeDirective ]);
})();

(function() {
    "use strict";
    var stringToNumberDirective = function($log) {
        var directive = {
            restrict: "A",
            require: [ "^ngModel" ],
            link: linkFunction
        };
        return directive;
        function linkFunction(scope, el, attr, ctrls) {
            var model = ctrls[0];
            model.$parsers.push(function(value) {
                return "" + parseInt(value);
            });
            model.$formatters.push(function(value) {
                return parseInt(value);
            });
        }
    };
    angular.module("formFactory").directive("stringToNumber", [ "$log", stringToNumberDirective ]);
})();

(function() {
    "use strict";
    var validationWorker = function($log, i18n, toaster) {
        this.ctrl = null;
        this.additionalCtrls = {};
        this.toastTracker = {};
        this.toastTracker.CIS = {};
        this.toastTracker.SCUE = {};
        this.setController = function(ctrl) {
            this.ctrl = ctrl;
        };
        this.setAdditionalController = function(ctrl, name) {
            this.additionalCtrls[name] = ctrl;
        };
        this.runValidationWorker = function(context, workerName) {
            var ctrl = this.ctrl;
            if (window.Worker) {
                var callback;
                var validationWorker = new Worker(context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/" + workerName);
                validationWorker.onmessage = function(e) {
                    callback.call(ctrl, e.data);
                };
                return function(data) {
                    callback = ctrl["processWorkerResponse"];
                    callback.call(ctrl, data);
                    validationWorker.postMessage(data);
                };
            }
            return function(data) {
                ctrl["processWorkerResponse"].call(ctrl, data);
                $log.error("Your browser does not support web workers, migrate to something a bit less archaic!!!");
            };
        };
        this.handleCallbacks = function(obj) {
            for (var i in obj.callbacks) {
                if (typeof this[obj.callbacks[i].callback] === "function") {
                    this[obj.callbacks[i].callback].apply(this, [ obj.callbacks[i].args, obj.flagValue ]);
                } else if (typeof this.ctrl[obj.callbacks[i].callback] === "function") {
                    this.ctrl[obj.callbacks[i].callback].call(this.ctrl, obj.callbacks[i].args);
                } else {
                    for (var j in this.additionalCtrls) {
                        if (typeof this.additionalCtrls[j][obj.callbacks[i].callback] === "function") {
                            this.additionalCtrls[j][obj.callbacks[i].callback].call(this.additionalCtrls[j], obj.callbacks[i].args);
                            return;
                        }
                    }
                }
            }
        };
        this.notifyUserOfInvalidStep = function(args, flagValue) {
            if (this.ctrl.containsInvalidStep) {
                for (var i in args) {
                    var arg = args[i];
                    if (this.toastTracker.CIS[i] === undefined || this.needToShowWhenCaseDefined(i)) {
                        toaster.pop({
                            type: "error",
                            title: i18n.message("angular.ffFormBuilderDirective.title.invalidStep"),
                            body: i18n.format(arg.validationMessage, arg.errorInfo),
                            toastId: arg.toastId,
                            onHideCallback: function() {
                                console.log("Step validation callback!!!");
                            }
                        });
                        this.toastTracker.CIS[i] = {};
                        this.toastTracker.CIS[i].validationMessage = arg.validationMessage;
                        this.toastTracker.CIS[i].showingToast = true;
                        this.toastTracker.CIS[i].toastId = arg.toastId;
                        this.toastTracker.CIS[i].errorInfo = arg.errorInfo;
                        this.toastTracker.CIS[i].stepIndex = arg.stepIndex;
                        this.toastTracker.CIS[i].actionIndex = arg.actionIndex;
                    }
                }
            }
            var toRemove = [];
            for (var i in this.toastTracker.CIS) {
                if (!(i in args) && this.toastTracker.CIS[i].showingToast) {
                    toRemove.push(i);
                    toaster.pop({
                        type: "success",
                        title: i18n.message("angular.ffFormBuilderDirective.title.validSteps"),
                        body: this.makeBody(i),
                        toastId: this.toastTracker.CIS[i].toastId
                    });
                    this.toastTracker.CIS[i].showingToast = false;
                }
            }
            for (var i in toRemove) {
                delete this.toastTracker.CIS[toRemove[i]];
            }
        };
        this.needToShowWhenCaseDefined = function(currentCase) {
            return this.toastTracker.CIS[currentCase] !== undefined && (!this.toastTracker.CIS[currentCase].showingToast || currentCase === "emptyStep" || currentCase === "invalidActionFields");
        };
        this.makeBody = function(switchCase) {
            switch (switchCase) {
              case "emptyStep":
                var step = this.ctrl.form.steps[this.toastTracker.CIS[switchCase].stepIndex];
                var stepName;
                if (step !== undefined) {
                    stepName = this.ctrl.form.steps[this.toastTracker.CIS[switchCase].stepIndex].label;
                } else {
                    stepName = this.toastTracker.CIS[switchCase].errorInfo;
                }
                return i18n.format(this.validMessage(switchCase), stepName);
                break;

              case "invalidActionFields":
                var action = this.ctrl.form.actions[this.toastTracker.CIS[switchCase].actionIndex];
                var actionName;
                if (action !== undefined) {
                    actionName = this.ctrl.form.actions[this.toastTracker.CIS[switchCase].actionIndex].label;
                } else {
                    actionName = this.toastTracker.CIS[switchCase].errorInfo;
                }
                return i18n.format(this.validMessage(switchCase), actionName);
                break;

              case "layoutStepInvalid":
                var step = this.ctrl.form.steps[this.toastTracker.SCUE[switchCase].stepIndex];
                var stepName;
                if (step !== undefined) {
                    stepName = this.ctrl.form.steps[this.toastTracker.SCUE[switchCase].stepIndex].label;
                } else {
                    stepName = this.toastTracker.SCUE[switchCase].errorInfo;
                }
                return i18n.format(this.validMessage(switchCase), stepName);
                break;

              default:
                return i18n.format(this.validMessage(switchCase), this.toastTracker.CIS[switchCase].errorInfo);
            }
        };
        this.validMessage = function(validationType) {
            var messages = {
                emptyStep: "angular.ffFormBuilderDirective.message.noEmptyStep",
                emptyStepName: "angular.ffFormBuilderDirective.message.noInvalidStepName",
                noAction: "angular.ffFormBuilderDirective.message.noMissingAction",
                invalidActionFields: "angular.ffFormBuilderDirective.message.validActionFields",
                noStep: "angular.ffFormBuilderDirective.message.StepExists",
                layoutStepInvalid: "angular.ffFormBuilderDirective.message.noLayoutStepInvalid",
                logicsSourceMissing: "angular.ffFormBuilderDirective.message.logicsCorrect",
                logicsFirstStepError: "angular.ffFormBuilderDirective.message.noFirstStepLogicsError",
                logicsUnreachableSource: "angular.ffFormBuilderDirective.message.logicSourceReachable",
                logicsCycleDetected: "angular.ffFormBuilderDirective.message.noCycleDetected",
                emptyLogics: "angular.ffFormBuilderDirective.message.noEmptyLogics"
            };
            return messages[validationType];
        };
        this.showToasts = function() {
            for (var i in this.toastTracker) {
                for (var j in this.toastTracker[i]) {
                    var arg = this.toastTracker[i][j];
                    toaster.pop({
                        type: "error",
                        title: i18n.message("angular.ffFormBuilderDirective.title.invalidStep"),
                        body: i18n.format(arg.validationMessage, arg.errorInfo),
                        toastId: arg.toastId,
                        onHideCallback: function() {
                            console.log("Step validation callback!!!");
                        }
                    });
                }
            }
        };
        this.unassignedElementsNotification = function(args) {
            for (var i in args) {
                if (i === "layoutStepInvalid") {
                    if (this.ctrl.stepContainsUnassignedElements) {
                        var arg = args[i];
                        if (this.toastTracker.SCUE[i] === undefined || this.toastTracker.SCUE[i].errorInfo !== arg.errorInfo) {
                            toaster.pop({
                                type: "error",
                                title: i18n.message("angular.ffFormBuilderDirective.title.layoutStepInvalid"),
                                body: i18n.format(arg.validationMessage, arg.errorInfo),
                                toastId: arg.toastId,
                                onHideCallback: function() {
                                    console.log("Step validation callback!!!");
                                }
                            });
                            this.toastTracker.SCUE[i] = {};
                            this.toastTracker.SCUE[i].validationMessage = arg.validationMessage;
                            this.toastTracker.SCUE[i].showingToast = true;
                            this.toastTracker.SCUE[i].toastId = arg.toastId;
                            this.toastTracker.SCUE[i].errorInfo = arg.errorInfo;
                            this.toastTracker.SCUE[i].stepIndex = arg.stepIndex;
                        }
                    }
                } else {
                    toaster.pop({
                        type: args[i].class,
                        title: i18n.message("angular.ffFormBuilderDirective.title.unassignedElement"),
                        body: i18n.format(args[i].validationMessage, args[i].errorInfo),
                        toastId: args[i].toastId
                    });
                }
            }
            var toRemove = [];
            for (var i in this.toastTracker.SCUE) {
                if (!(i in args) && this.toastTracker.SCUE[i].showingToast) {
                    toRemove.push(i);
                    toaster.pop({
                        type: "success",
                        title: i18n.message("angular.ffFormBuilderDirective.title.validSteps"),
                        body: this.makeBody(i),
                        toastId: this.toastTracker.SCUE[i].toastId
                    });
                    this.toastTracker.SCUE[i].showingToast = false;
                }
            }
            for (var i in toRemove) {
                delete this.toastTracker.SCUE[toRemove[i]];
            }
        };
    };
    angular.module("formFactory").service("ffValidationWorker", [ "$log", "i18nService", "toaster", validationWorker ]);
})();

(function() {
    "use strict";
    var ffElementManagementBox = function($log, contextualData) {
        var directive = {
            restrict: "E",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/elementbox/elementManagementBox.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ffController) {
            scope.elementType = attr.elementType;
        }
    };
    angular.module("formFactory").directive("ffElementManagementBox", [ "$log", "contextualData", ffElementManagementBox ]);
})();

(function() {
    "use strict";
    var actionDisplay = function($log, contextualData) {
        var directive = {
            restrict: "E",
            scope: {
                action: "="
            },
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/actionDisplayDirective.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {}
    };
    angular.module("formFactory").directive("ffActionDisplay", [ "$log", "contextualData", actionDisplay ]);
})();

(function() {
    "use strict";
    var input = function($compile, $log, $timeout) {
        var directive = {
            restrict: "E",
            require: [ "^ffController" ],
            scope: {
                input: "=",
                resolveLogic: "&"
            },
            link: postLinkFunc
        };
        return directive;
        function postLinkFunc(scope, el, attr, ctrls) {
            scope.form = ctrls[0].getFormController();
            scope.readOnly = !ctrls[0].isLiveMode();
            if (scope.input && scope.input.template) {
                el.append($compile(scope.input.template)(scope));
            }
            if (attr.layout) {
                scope.$watch(function() {
                    return scope.input;
                }, function(input) {
                    $timeout(function() {
                        scope.$apply(function() {
                            if (input !== null) {
                                el.html($compile(input.template)(scope));
                            } else {
                                el.html("");
                            }
                        });
                    });
                });
            }
        }
    };
    angular.module("formFactory").directive("ffBuilderInput", [ "$compile", "$log", "$timeout", input ]);
})();

(function() {
    var formRenderingDirective = function($log, contextualData) {
        var directive = {
            restrict: "E",
            require: [ "^ffController" ],
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/formRendering.html",
            link: linkFunction
        };
        return directive;
        function linkFunction(scope, el, attr) {}
    };
    angular.module("formFactory").directive("ffFormRendering", [ "$log", "contextualData", formRenderingDirective ]);
})();

(function() {
    "use strict";
    var layoutManagement = function($log, contextualData) {
        var directive = {
            restrict: "E",
            scope: {
                step: "=",
                form: "=",
                currentStep: "="
            },
            controller: LayoutManagementController,
            controllerAs: "lmc",
            bindToController: true,
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/layout/layoutManagement.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {}
    };
    angular.module("formFactory").directive("ffLayoutManagement", [ "$log", "contextualData", "ffLayoutService", layoutManagement ]);
    var LayoutManagementController = function($scope, ffLayoutService, contextualData, toaster, i18n, $log, $document, $timeout, $sce, $window, spinner) {
        $scope.$on("layoutInputChanged", function(event, data) {
            ffLayoutService.addInput(lmc.currentStep, lmc.currentRowIndex, lmc.currentColumnIndex, data.fieldName);
            focusActiveColumn();
            lmc.notifyBuilder();
        });
        $scope.$on("gainColumnFocus", function() {
            lmc.ensureActiveInput();
        });
        $scope.$on("resetAvailableInputs", function() {
            for (var i in lmc.availableInputs) {
                delete lmc.availableInputs[i].inUse;
            }
        });
        $scope.$on("$destroy", function() {
            $window.document.body.removeEventListener("keydown", globalKeydownEventListener);
        });
        var lmc = this;
        lmc.currentRowIndex = null;
        lmc.currentColumnIndex = null;
        lmc.availableInputs = [];
        lmc.addInputTemplateUrl = contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/layout/addInputTemplate.html";
        lmc.shortcutsInfoTemplateUrl = contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/formrendering/layout/shortcutsInfoTemplateUrl.html";
        lmc.addRow = addRow;
        lmc.removeRow = removeRow;
        lmc.removeInput = removeInput;
        lmc.moveRow = moveRow;
        lmc.cleanAndResizeRow = cleanAndResizeRow;
        lmc.addCol = addCol;
        lmc.shrinkCol = shrinkCol;
        lmc.expandCol = expandCol;
        lmc.removeColumn = removeColumn;
        lmc.addColOffset = addColOffset;
        lmc.removeColOffset = removeColOffset;
        lmc.moveInput = moveInput;
        lmc.displayToast = displayToast;
        lmc.manageActiveInputPosition = manageActiveInputPosition;
        lmc.isInputManagementPositionActive = isInputManagementPositionActive;
        lmc.captureOutsideKeyPress = captureOutsideKeyPress;
        lmc.activeInputSelectionPromise = null;
        lmc.deletionInProgress = false;
        lmc.dispatchInputsPromise = null;
        lmc.ensureActiveInput = ensureActiveInput;
        lmc.autoFitTooltip = $sce.trustAsHtml(i18n.message("angular.ffLayoutManagementDirective.label.autoFitCells") + "<br/>" + i18n.message("angular.ffLayoutManagementDirective.tooltip.autoFitCells"));
        lmc.activeKeyEventPromise = null;
        lmc.globalKeydownEventListener = globalKeydownEventListener;
        lmc.currentRow = null;
        lmc.currentIndex = null;
        lmc.setCurrentColumn = setCurrentColumn;
        lmc.isCurrentColumn = isCurrentColumn;
        lmc.columnHasInput = columnHasInput;
        lmc.dispatchInputs = dispatchInputs;
        lmc.inputsInUse = inputsInUse;
        lmc.rememberIndices = rememberIndices;
        lmc.selectLastInput = selectLastInput;
        lmc.getLayout = getLayout;
        lmc.getInputObject = getInputObject;
        lmc.resolveLogic = resolveLogic;
        lmc.i18nMessageGetter = i18nMessageGetter;
        lmc.hover = [];
        lmc.popoverActivated = false;
        lmc.inRow = inRow;
        lmc.outRow = outRow;
        lmc.notifyBuilder = notifyBuilder;
        activate();
        function activate() {
            ffLayoutService.displayToast = lmc.displayToast;
            ffLayoutService.controllerContext = lmc;
            $window.document.body.addEventListener("keydown", globalKeydownEventListener);
            var hiddenInputs = [];
            var inputsInUse = lmc.inputsInUse();
            for (var i in lmc.step.inputs) {
                if (lmc.step.inputs[i].nodeType === "fcnt:hiddenDefinition") {
                    hiddenInputs.push(angular.copy(lmc.step.inputs[i]));
                } else {
                    prepareAvailableInput(angular.copy(lmc.step.inputs[i]), inputsInUse.indexOf(lmc.step.inputs[i].layoutUUID) !== -1);
                }
            }
            for (var i in hiddenInputs) {
                prepareAvailableInput(hiddenInputs[i], inputsInUse.indexOf(hiddenInputs[i].layoutUUID) !== -1);
            }
        }
        function prepareAvailableInput(input, inUse) {
            lmc.availableInputs.push(input);
            var index = lmc.availableInputs.length - 1;
            lmc.availableInputs[index].index = index;
            if (_.isEmpty(lmc.availableInputs[index].label)) {
                lmc.availableInputs[index].label = lmc.availableInputs[index].name;
            }
            lmc.availableInputs[index].fieldName = lmc.availableInputs[index].layoutUUID;
            if (inUse) {
                lmc.availableInputs[index].inUse = index;
            }
        }
        function globalKeydownEventListener(event) {
            event.preventDefault();
            $timeout(function(event) {
                if (event.keyCode === 9) {
                    captureOutsideKeyPress(event);
                } else {
                    moveInput(event);
                }
            }, 0, true, event);
        }
        function getLayout() {
            return ffLayoutService.getLayout();
        }
        function dispatchInputs(size) {
            spinner.show("layoutDispatchSpinner");
            if (lmc.dispatchInputsPromise !== null) {
                $timeout.cancel(lmc.dispatchInputsPromise);
            }
            lmc.dispatchInputsPromise = $timeout(function() {
                ffLayoutService.createLayout(lmc.currentStep, size, lmc.availableInputs);
                for (var i in lmc.availableInputs) {
                    lmc.availableInputs[i].inUse = i;
                }
                lmc.ensureActiveInput();
                spinner.hide("layoutDispatchSpinner");
                lmc.notifyBuilder();
            });
        }
        function addRow() {
            ffLayoutService.addRow(lmc.currentStep);
            manageActiveInputPosition(getLayout().steps[lmc.currentStep].rows.length - 1, 0);
        }
        function removeRow(rowIndex) {
            var row = ffLayoutService.removeRow(lmc.currentStep, rowIndex);
            updateAvailableInputs(row[0]);
            lmc.notifyBuilder();
        }
        function removeInput(rowIndex, colIndex) {
            var col = ffLayoutService.removeInput(lmc.currentStep, rowIndex, colIndex);
            focusActiveColumn();
            updateAvailableInputs(col);
            lmc.notifyBuilder();
        }
        function moveRow(rowIndex, direction) {
            switch (direction) {
              case "up":
                ffLayoutService.moveRowUp(lmc.currentStep, rowIndex);
                break;

              case "down":
                ffLayoutService.moveRowDown(lmc.currentStep, rowIndex);
                break;
            }
            focusActiveColumn();
        }
        function cleanAndResizeRow(rowIndex) {
            ffLayoutService.cleanAndResizeRow(lmc.currentStep, rowIndex);
            focusActiveColumn();
        }
        function addCol(rowIndex) {
            var result = ffLayoutService.addCol(lmc.currentStep, rowIndex);
            if (!result) {
                toaster.pop({
                    type: "info",
                    title: i18n.message("angular.ffLayoutManagementDirective.label.fullRow"),
                    body: i18n.message("angular.ffLayoutManagementDirective.message.fullRow")
                });
            }
        }
        function shrinkCol(rowIndex, colIndex) {
            ffLayoutService.shrinkCol(lmc.currentStep, rowIndex, colIndex);
        }
        function expandCol(rowIndex, colIndex) {
            ffLayoutService.expandCol(lmc.currentStep, rowIndex, colIndex);
        }
        function removeColumn(rowIndex, colIndex) {
            var currentlyActiveColumn = ffLayoutService.getActiveInputPosition(lmc.currentStep).rowIndex === rowIndex && ffLayoutService.getActiveInputPosition(lmc.currentStep).colIndex === colIndex;
            var col = ffLayoutService.removeCol(lmc.currentStep, rowIndex, colIndex);
            if (currentlyActiveColumn) {
                ffLayoutService.selectNextAvailableColumn(lmc.currentStep);
            }
            lmc.deletionInProgress = true;
            $timeout(function() {
                ffLayoutService.selectNextAvailableColumn(lmc.currentStep);
                focusActiveColumn();
            }).then(function(success) {
                lmc.deletionInProgress = false;
            }, function(error) {
                lmc.deletionInProgress = false;
            });
            updateAvailableInputs(col[0]);
            lmc.notifyBuilder();
        }
        function addColOffset(rowIndex, colIndex) {
            ffLayoutService.addColOffset(lmc.currentStep, rowIndex, colIndex);
        }
        function removeColOffset(rowIndex, colIndex) {
            ffLayoutService.removeColOffset(lmc.currentStep, rowIndex, colIndex);
        }
        function moveInput($event) {
            var activePosition = ffLayoutService.getActiveInputPosition(lmc.currentStep);
            if (($event.keyCode === 37 || $event.keyCode === 38 || $event.keyCode === 39 || $event.keyCode === 40) && lmc.isInputManagementPositionActive(activePosition.rowIndex, activePosition.colIndex)) {
                $event.preventDefault();
                if (lmc.activeKeyEventPromise !== null) {
                    $timeout.cancel(lmc.activeKeyEventPromise);
                }
                lmc.activeKeyEventPromise = $timeout(function() {
                    switch ($event.keyCode) {
                      case 37:
                        if ($event.shiftKey) {
                            ffLayoutService.moveInputX(lmc.currentStep, "left", "shift");
                        } else if ($event.altKey) {
                            ffLayoutService.moveInputY(lmc.currentStep, "left", "alt");
                        } else {
                            ffLayoutService.navigate(lmc.currentStep, "left");
                        }
                        break;

                      case 39:
                        if ($event.shiftKey) {
                            ffLayoutService.moveInputX(lmc.currentStep, "right", "shift");
                        } else if ($event.altKey) {
                            ffLayoutService.moveInputY(lmc.currentStep, "right", "alt");
                        } else {
                            ffLayoutService.navigate(lmc.currentStep, "right");
                        }
                        break;

                      case 38:
                        if ($event.shiftKey) {
                            ffLayoutService.moveInputY(lmc.currentStep, "up", "shift");
                            updateScrollPosition("up");
                        } else if ($event.altKey) {
                            ffLayoutService.moveInputY(lmc.currentStep, "up", "alt");
                        } else {
                            ffLayoutService.navigate(lmc.currentStep, "up");
                            updateScrollPosition("up");
                        }
                        break;

                      case 40:
                        if ($event.shiftKey) {
                            ffLayoutService.moveInputY(lmc.currentStep, "down", "shift");
                            updateScrollPosition("down");
                        } else if ($event.altKey) {
                            ffLayoutService.moveInputY(lmc.currentStep, "down", "alt");
                        } else {
                            ffLayoutService.navigate(lmc.currentStep, "down");
                            updateScrollPosition("down");
                        }
                        break;
                    }
                    ffLayoutService.manageActiveInputPosition(lmc.currentStep, ffLayoutService.getActiveInputPosition(lmc.currentStep).rowIndex, ffLayoutService.getActiveInputPosition(lmc.currentStep).colIndex, true);
                }, 100);
            }
        }
        function updateScrollPosition(direction) {
            var activePosition = $window.document.getElementsByClassName("activeColumn")[0].getBoundingClientRect().top;
            activePosition = !_.isUndefined($window.scrollY) ? $window.scrollY + activePosition : $window.pageYOffset + activePosition;
            if (direction === "up") {
                activePosition -= $window.innerHeight / 1.5;
            } else if (direction === "down") {
                activePosition -= $window.innerHeight / 3;
            }
            $window.scrollTo(0, activePosition);
        }
        function manageActiveInputPosition(rowIndex, colIndex) {
            if (lmc.deletionInProgress) {
                return;
            }
            if (lmc.activeInputSelectionPromise !== null) {
                $timeout.cancel(lmc.activeInputSelectionPromise);
            }
            lmc.activeInputSelectionPromise = $timeout(function() {
                ffLayoutService.manageActiveInputPosition(lmc.currentStep, rowIndex, colIndex);
                angular.element(".row_" + ffLayoutService.getActiveInputPosition(lmc.currentStep).rowIndex + "_col_" + ffLayoutService.getActiveInputPosition(lmc.currentStep).colIndex).focus();
            });
        }
        function isInputManagementPositionActive(rowIndex, colIndex) {
            if (rowIndex === null || colIndex === null) {
                return false;
            }
            return ffLayoutService.getLayout().steps[lmc.currentStep].rows[rowIndex].row[colIndex].moveActive;
        }
        function ensureActiveInput() {
            ffLayoutService.verifyActiveInputExists(lmc.currentStep);
            $timeout(function() {
                focusActiveColumn();
            });
        }
        function captureOutsideKeyPress($event) {
            if ($event.keyCode === 9) {
                $event.preventDefault();
                if (lmc.activeInputSelectionPromise !== null) {
                    $timeout.cancel(lmc.activeInputSelectionPromise);
                }
                lmc.activeInputSelectionPromise = $timeout(function() {
                    var captureNextElement = false;
                    var nextElementSet = false;
                    for (var i in ffLayoutService.getLayout().steps[lmc.currentStep].rows) {
                        for (var j in ffLayoutService.getLayout().steps[lmc.currentStep].rows[i].row) {
                            if (captureNextElement) {
                                lmc.manageActiveInputPosition(i, j);
                                nextElementSet = true;
                                break;
                            }
                            if (ffLayoutService.getLayout().steps[lmc.currentStep].rows[i].row[j].moveActive) {
                                captureNextElement = true;
                            }
                        }
                        if (nextElementSet) {
                            break;
                        }
                    }
                    if (!nextElementSet) {
                        if (ffLayoutService.getLayout().steps[lmc.currentStep].rows.length > 0 && ffLayoutService.getLayout().steps[lmc.currentStep].rows[0].row.length > 0) {
                            lmc.manageActiveInputPosition(0, 0);
                        }
                    }
                });
            }
        }
        function displayToast(data) {
            toaster.pop({
                type: data.type,
                toastId: data.toastId,
                title: !_.isUndefined(data.title) && data.title !== null ? i18n.message(data.title) : "",
                body: !_.isUndefined(data.message) && data.message !== null ? i18n.message(data.message) : ""
            });
        }
        function setCurrentColumn(rowIndex, colIndex) {
            lmc.currentRow = rowIndex;
            lmc.currentColumn = colIndex;
        }
        function isCurrentColumn(rowIndex, colIndex) {
            return lmc.currentRow === rowIndex && lmc.currentColumn === colIndex;
        }
        function columnHasInput(rowIndex, colIndex) {
            return ffLayoutService.getLayout().steps[lmc.currentStep].rows[rowIndex].row[colIndex].layoutUUID !== null;
        }
        function inputsInUse() {
            var inputsInUse = [];
            var layout = ffLayoutService.getLayout();
            for (var row in layout.steps[lmc.currentStep].rows) {
                for (var col in layout.steps[lmc.currentStep].rows[row].row) {
                    if (layout.steps[lmc.currentStep].rows[row].row[col].layoutUUID !== null) {
                        inputsInUse.push(layout.steps[lmc.currentStep].rows[row].row[col].layoutUUID);
                    }
                }
            }
            return inputsInUse;
        }
        function rememberIndices(rowIndex, colIndex) {
            lmc.currentRowIndex = rowIndex;
            lmc.currentColumnIndex = colIndex;
            lmc.popoverActivated = true;
        }
        function selectLastInput(rowIndex, colIndex) {
            var layoutUUID = null;
            var index = 0;
            for (var i in lmc.availableInputs) {
                if ("dummy" in lmc.availableInputs[i]) {
                    continue;
                }
                if (!("inUse" in lmc.availableInputs[i]) && layoutUUID !== null) {
                    return;
                } else if (!("inUse" in lmc.availableInputs[i])) {
                    layoutUUID = lmc.availableInputs[i].fieldName;
                    index = i;
                }
            }
            lmc.availableInputs[index].inUse = index;
            ffLayoutService.addInput(lmc.currentStep, rowIndex, colIndex, layoutUUID);
            lmc.notifyBuilder();
        }
        function getInputObject(layoutUUID) {
            for (var i in lmc.availableInputs) {
                if (layoutUUID === lmc.availableInputs[i].fieldName) {
                    return lmc.availableInputs[i];
                }
            }
            return null;
        }
        function updateAvailableInputs(obj) {
            if (obj.row !== undefined) {
                for (var col in obj.row) {
                    for (var input in lmc.availableInputs) {
                        if (obj.row[col].layoutUUID === lmc.availableInputs[input].fieldName) {
                            delete lmc.availableInputs[input].inUse;
                        }
                    }
                }
            } else {
                for (var input in lmc.availableInputs) {
                    if (obj.layoutUUID === lmc.availableInputs[input].fieldName) {
                        delete lmc.availableInputs[input].inUse;
                    }
                }
            }
        }
        function resolveLogic() {
            return true;
        }
        function i18nMessageGetter(key) {
            return i18n.message(key);
        }
        function inRow(index) {
            if (lmc.popoverActivated && angular.element(".layoutInputPicker").length === 0) {
                lmc.popoverActivated = false;
                lmc.hover = [];
            }
            if (!lmc.popoverActivated) {
                lmc.hover[index] = true;
            }
        }
        function outRow(index) {
            if (!lmc.popoverActivated) {
                lmc.hover[index] = false;
            }
        }
        function notifyBuilder() {
            $scope.$emit("validateLayout", null);
        }
        function focusActiveColumn() {
            if (lmc.activeInputSelectionPromise !== null) {
                $timeout.cancel(lmc.activeInputSelectionPromise);
            }
            lmc.activeInputSelectionPromise = $timeout(function() {
                angular.element(".row_" + ffLayoutService.getActiveInputPosition(lmc.currentStep).rowIndex + "_col_" + ffLayoutService.getActiveInputPosition(lmc.currentStep).colIndex).focus();
            });
        }
    };
    LayoutManagementController.$inject = [ "$scope", "ffLayoutService", "contextualData", "toaster", "i18nService", "$log", "$document", "$timeout", "$sce", "$window", "ffSpinnerService" ];
})();

(function() {
    "use strict";
    var layoutService = function($log) {
        var MAX_WIDTH = 12;
        var MIN_COL_THRESHOLD = 1;
        var colClass = "col-sm-12";
        var offsetClass = "col-sm-offset-0";
        var displayToast = null;
        var controllerContext = null;
        var layout = {
            active: false,
            layoutEmpty: true,
            steps: []
        };
        var baseLayout = {
            active: false,
            layoutEmpty: true,
            steps: [ {
                rows: [],
                inputPositionManagement: {
                    colIndex: null,
                    rowIndex: null,
                    activeInputFieldName: null,
                    activeInputExists: false
                },
                inputMovementHistory: []
            } ]
        };
        var historyMovementTemplate = {
            rowIndex: null,
            colIndex: null,
            createdColumn: false
        };
        var stepBase = {
            rows: [],
            inputPositionManagement: {
                colIndex: null,
                rowIndex: null,
                activeInputFieldName: null,
                activeInputExists: false
            },
            inputMovementHistory: []
        };
        var rowBase = {
            row: [ {
                col: colClass,
                layoutUUID: null,
                offset: offsetClass,
                moveActive: false,
                activeClass: "inActiveColumn"
            } ]
        };
        var colBase = {
            col: colClass,
            layoutUUID: null,
            offset: offsetClass,
            moveActive: false,
            activeClass: null
        };
        this.getLayout = function() {
            return layout;
        };
        this.activate = function() {
            layout.active = true;
        };
        this.deactivate = function() {
            layout.active = false;
            for (var i in layout.steps) {
                layout.steps[i].inputPositionManagement.activeInputExists = false;
            }
        };
        this.createLayout = function(stepIndex, size, availableInputs) {
            size = parseInt(size);
            layout.steps[stepIndex] = angular.copy(stepBase);
            for (var i in availableInputs) {
                if ("dummy" in availableInputs[i]) {
                    continue;
                }
                if (availableInputs[i].nodeType === "fcnt:hiddenDefinition") {
                    layout.steps[stepIndex].rows.push(angular.copy(rowBase));
                    layout.steps[stepIndex].rows[layout.steps[stepIndex].rows.length - 1].row[0].layoutUUID = availableInputs[i].fieldName;
                    continue;
                }
                if (i % size === 0) {
                    layout.steps[stepIndex].rows.push(angular.copy(rowBase));
                    var rowIndex = layout.steps[stepIndex].rows.length - 1;
                    var colIndex = layout.steps[stepIndex].rows[rowIndex].row.length - 1;
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = availableInputs[i].fieldName;
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex].col = updateClass(colClass, MAX_WIDTH / size);
                } else {
                    var rowIndex = layout.steps[stepIndex].rows.length - 1;
                    layout.steps[stepIndex].rows[rowIndex].row.push(angular.copy(colBase));
                    var colIndex = layout.steps[stepIndex].rows[rowIndex].row.length - 1;
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = availableInputs[i].fieldName;
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex].col = updateClass(colClass, MAX_WIDTH / size);
                }
            }
        };
        this.setExistingLayout = function(existingLayout) {
            layout = existingLayout;
        };
        this.setBaseLayout = function() {
            layout = angular.copy(baseLayout);
        };
        this.setBaseForSteps = function(stepNumber) {
            layout.steps = [];
            for (var i = 0; i < stepNumber; i++) {
                layout.steps.push(angular.copy(stepBase));
            }
        };
        this.isActive = function() {
            return layout.active;
        };
        this.addStep = function() {
            layout.steps.push(angular.copy(stepBase));
        };
        this.removeStep = function(index) {
            return layout.steps.splice(index, 1);
        };
        this.moveStep = function(newIndex, currentIndex) {
            var stepToMove = layout.steps[currentIndex];
            layout.steps[currentIndex] = layout.steps[newIndex];
            layout.steps[newIndex] = stepToMove;
        };
        this.prepareSteps = function(steps) {
            if (layout.steps.length !== steps) {
                while (steps - layout.steps.length > 0) {
                    layout.steps.push(angular.copy(stepBase));
                }
            }
        };
        this.addRow = function(stepIndex) {
            layout.layoutEmpty = false;
            layout.steps[stepIndex].rows.push(angular.copy(rowBase));
        };
        this.removeRow = function(stepIndex, rowIndex) {
            var removedRow = layout.steps[stepIndex].rows.splice(rowIndex, 1);
            if (this.getActiveInputPosition(stepIndex).rowIndex === rowIndex && layout.steps[stepIndex].rows.length > 0) {
                var targetRowIndex = rowIndex === layout.steps[stepIndex].rows.length ? rowIndex - 1 : rowIndex;
                if (layout.steps[stepIndex].rows[targetRowIndex].row.length > 0) {
                    this.manageActiveInputPosition(stepIndex, targetRowIndex, 0);
                }
            }
            this.updateActiveInputPosition(stepIndex);
            return removedRow;
        };
        this.moveRowUp = function(stepIndex, rowIndex) {
            if (layout.steps[stepIndex].rows[rowIndex - 1] !== undefined) {
                var rowAbove = layout.steps[stepIndex].rows[rowIndex - 1];
                var currentRow = layout.steps[stepIndex].rows[rowIndex];
                layout.steps[stepIndex].rows[rowIndex - 1] = currentRow;
                layout.steps[stepIndex].rows[rowIndex] = rowAbove;
                this.manageActiveInputPosition(stepIndex, rowIndex - 1, 0);
            }
        };
        this.moveRowDown = function(stepIndex, rowIndex) {
            if (layout.steps[stepIndex].rows[rowIndex + 1] !== undefined) {
                var rowBelow = layout.steps[stepIndex].rows[rowIndex + 1];
                var currentRow = layout.steps[stepIndex].rows[rowIndex];
                layout.steps[stepIndex].rows[rowIndex + 1] = currentRow;
                layout.steps[stepIndex].rows[rowIndex] = rowBelow;
                this.manageActiveInputPosition(stepIndex, rowIndex + 1, 0);
            }
        };
        this.cleanAndResizeRow = function(stepIndex, rowIndex) {
            var row = [];
            for (var i in layout.steps[stepIndex].rows[rowIndex].row) {
                if (layout.steps[stepIndex].rows[rowIndex].row[i].layoutUUID !== null) {
                    row.push(angular.copy(layout.steps[stepIndex].rows[rowIndex].row[i]));
                }
            }
            layout.steps[stepIndex].rows[rowIndex].row = row;
            if (layout.steps[stepIndex].rows[rowIndex].row.length === 0) {
                this.removeRow(stepIndex, rowIndex);
            } else {
                resizeColumns(stepIndex, rowIndex, layout.steps[stepIndex].rows[rowIndex].row.length, true);
            }
        };
        this.shrinkCol = function(currentStep, rowIndex, colIndex) {
            this.reduceColValue(currentStep, rowIndex, colIndex, "col");
        };
        this.expandCol = function(currentStep, rowIndex, colIndex) {
            this.addColValue(currentStep, rowIndex, colIndex, "col");
        };
        this.addCol = function(currentStep, rowIndex) {
            var totalWidth = this.getTotalWidth(currentStep, rowIndex);
            if (totalWidth === MAX_WIDTH) {
                return false;
            }
            var newWidth = MAX_WIDTH - totalWidth;
            var cl = updateClass(colClass, newWidth);
            layout.steps[currentStep].rows[rowIndex].row.push({
                col: cl,
                layoutUUID: null,
                offset: offsetClass,
                moveActive: false,
                activeClass: "inActiveColumn"
            });
            return true;
        };
        this.removeCol = function(stepIndex, rowIndex, colIndex) {
            return layout.steps[stepIndex].rows[rowIndex].row.splice(colIndex, 1);
        };
        this.addColOffset = function(stepIndex, rowIndex, colIndex) {
            this.addColValue(stepIndex, rowIndex, colIndex, "offset");
        };
        this.removeColOffset = function(stepIndex, rowIndex, colIndex) {
            this.reduceColValue(stepIndex, rowIndex, colIndex, "offset");
        };
        this.getTotalWidth = function(currentStep, rowIndex) {
            var totalWidth = 0;
            for (var colIndex in layout.steps[currentStep].rows[rowIndex].row) {
                totalWidth += getColWidth(layout.steps[currentStep].rows[rowIndex].row[colIndex].col);
                totalWidth += getColWidth(layout.steps[currentStep].rows[rowIndex].row[colIndex].offset);
            }
            return totalWidth;
        };
        this.reduceColValue = function(stepIndex, rowIndex, colIndex, target) {
            var rowClass = layout.steps[stepIndex].rows[rowIndex].row[colIndex][target];
            var colWidth = getColWidth(rowClass);
            if (target === "offset") {
                if (colWidth > 0) {
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex][target] = updateClass(rowClass, --colWidth);
                }
            } else {
                if (colWidth > 1) {
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex][target] = updateClass(rowClass, --colWidth);
                }
            }
        };
        this.addColValue = function(stepIndex, rowIndex, colIndex, target) {
            var rowClass = layout.steps[stepIndex].rows[rowIndex].row[colIndex][target];
            var colWidth = getColWidth(rowClass);
            var totalWidth = this.getTotalWidth(stepIndex, rowIndex);
            if (totalWidth + 1 <= MAX_WIDTH) {
                layout.steps[stepIndex].rows[rowIndex].row[colIndex][target] = updateClass(rowClass, ++colWidth);
            }
        };
        function getColWidth(item) {
            if (item === null) {
                return 0;
            }
            var parts = item.split("-");
            if (parts.length === 4) {
                return parseInt(parts[3]);
            } else if (parts.length === 3) {
                return parseInt(parts[2]);
            }
        }
        function updateClass(oldClass, size) {
            var parts = oldClass.split("-");
            if (parts.length === 4) {
                parts.splice(3, 1);
            } else if (parts.length === 3) {
                parts.splice(2, 1);
            }
            parts.push(size);
            return parts.join("-");
        }
        function resizeColumns(stepIndex, rowIndex, numOfCols, useAllColSpaces) {
            var requiredSpace = Math.floor(MAX_WIDTH / numOfCols);
            requiredSpace = requiredSpace == 0 ? MIN_COL_THRESHOLD : requiredSpace;
            for (var i in layout.steps[stepIndex].rows[rowIndex].row) {
                var offsetAvailable = getColWidth(layout.steps[stepIndex].rows[rowIndex].row[i].offset);
                var colWidth = getColWidth(layout.steps[stepIndex].rows[rowIndex].row[i].col);
                if (useAllColSpaces && numOfCols < MAX_WIDTH && numOfCols * MIN_COL_THRESHOLD < 12 && MAX_WIDTH % numOfCols != 0) {
                    requiredSpace = parseInt(i) + 1 <= Math.ceil(MAX_WIDTH % numOfCols) ? Math.ceil(MAX_WIDTH / numOfCols) : Math.floor(MAX_WIDTH / numOfCols);
                }
                if (colWidth > requiredSpace) {
                    if (offsetAvailable > 0) {
                        layout.steps[stepIndex].rows[rowIndex].row[i].offset = updateClass(layout.steps[stepIndex].rows[rowIndex].row[i].offset, 0);
                    }
                    layout.steps[stepIndex].rows[rowIndex].row[i].col = updateClass(layout.steps[stepIndex].rows[rowIndex].row[i].col, requiredSpace);
                } else if (colWidth + offsetAvailable > requiredSpace) {
                    layout.steps[stepIndex].rows[rowIndex].row[i].offset = updateClass(layout.steps[stepIndex].rows[rowIndex].row[i].offset, colWidth - requiredSpace);
                } else {
                    layout.steps[stepIndex].rows[rowIndex].row[i].col = updateClass(layout.steps[stepIndex].rows[rowIndex].row[i].col, requiredSpace - offsetAvailable);
                }
            }
        }
        this.addInput = function(stepIndex, rowIndex, colIndex, fieldName) {
            layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = fieldName;
        };
        this.removeInput = function(stepIndex, rowIndex, colIndex) {
            var col = angular.copy(layout.steps[stepIndex].rows[rowIndex].row[colIndex]);
            layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = null;
            return col;
        };
        this.moveInputX = function(stepIndex, direction, movement) {
            var rowIndex = layout.steps[stepIndex].inputPositionManagement.rowIndex;
            var colIndex = layout.steps[stepIndex].inputPositionManagement.colIndex;
            var canMove = false;
            var newIndex;
            switch (movement) {
              case "shift":
                switch (direction) {
                  case "left":
                    if (layout.steps[stepIndex].rows[rowIndex].row.length > 1 && colIndex - 1 >= 0) {
                        canMove = true;
                        newIndex = colIndex - 1;
                    }
                    break;

                  case "right":
                    if (layout.steps[stepIndex].rows[rowIndex].row.length > 1 && colIndex + 1 < layout.steps[stepIndex].rows[rowIndex].row.length) {
                        canMove = true;
                        newIndex = colIndex + 1;
                    }
                    break;
                }
                if (canMove) {
                    var target = angular.copy(layout.steps[stepIndex].rows[rowIndex].row[newIndex].layoutUUID);
                    layout.steps[stepIndex].rows[rowIndex].row[newIndex].layoutUUID = angular.copy(layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID);
                    layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = target;
                    layout.steps[stepIndex].inputPositionManagement.colIndex = newIndex;
                    this.manageInputMovementHistory(stepIndex, layout.steps[stepIndex].inputPositionManagement.rowIndex, layout.steps[stepIndex].inputPositionManagement.colIndex, false, false);
                }
                break;

              case "alt":
                break;
            }
        };
        this.moveInputY = function(stepIndex, direction, movement) {
            var rowIndex = layout.steps[stepIndex].inputPositionManagement.rowIndex;
            var colIndex = layout.steps[stepIndex].inputPositionManagement.colIndex;
            if (layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID === null) {
                return false;
            }
            var targetRowIndex = direction == "up" ? rowIndex - 1 : rowIndex + 1;
            var targetColIndex;
            var topOrBottomRow = !!(rowIndex === 0 && direction == "up" || rowIndex === layout.steps[stepIndex].rows.length - 1 && direction == "down");
            switch (movement) {
              case "shift":
                if (topOrBottomRow) {
                    return false;
                } else if (layout.steps[stepIndex].rows[targetRowIndex].row.length === 0) {
                    if (_.isFunction(displayToast) && controllerContext !== null) {
                        var data = {
                            toastId: "noAvailableColumn",
                            type: "warning",
                            title: "angular.ffLayoutService.toast.unAbleToMoveInput",
                            message: "angular.ffLayoutService.toast.noAvailableColumn"
                        };
                        displayToast.call(controllerContext, data);
                    }
                    return false;
                }
                var layoutUUID = angular.copy(layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID);
                layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = null;
                if (layout.steps[stepIndex].rows[rowIndex].row.length === layout.steps[stepIndex].rows[targetRowIndex].row.length) {
                    targetColIndex = colIndex;
                } else if (colIndex === 0) {
                    targetColIndex = 0;
                } else if (layout.steps[stepIndex].rows[targetRowIndex].row.length > 0 && layout.steps[stepIndex].rows[targetRowIndex].row.length < 3) {
                    targetColIndex = direction === "up" || layout.steps[stepIndex].rows[rowIndex].row.length - 1 === colIndex ? layout.steps[stepIndex].rows[targetRowIndex].row.length - 1 : 0;
                } else if (colIndex === layout.steps[stepIndex].rows[rowIndex].row.length - 1) {
                    targetColIndex = layout.steps[stepIndex].rows[targetRowIndex].row.length - 1;
                } else {
                    var ratio = (colIndex + 1) / layout.steps[stepIndex].rows[rowIndex].row.length;
                    targetColIndex = Math.round(ratio * (layout.steps[stepIndex].rows[targetRowIndex].row.length - 2));
                    if (targetColIndex === 0 && layout.steps[stepIndex].rows[targetRowIndex].row.length > 2) {
                        targetColIndex++;
                    } else if (targetColIndex === layout.steps[stepIndex].rows[targetRowIndex].row.length - 1 && layout.steps[stepIndex].rows[targetRowIndex].row.length > 2) {
                        targetColIndex--;
                    }
                }
                layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID = angular.copy(layout.steps[stepIndex].rows[targetRowIndex].row[targetColIndex].layoutUUID);
                layout.steps[stepIndex].rows[targetRowIndex].row[targetColIndex].layoutUUID = layoutUUID;
                this.manageActiveInputPosition(stepIndex, targetRowIndex, targetColIndex);
                this.manageInputMovementHistory(stepIndex, layout.steps[stepIndex].inputPositionManagement.rowIndex, layout.steps[stepIndex].inputPositionManagement.colIndex, false, false);
                break;

              case "alt":
                break;
            }
        };
        this.navigate = function(stepIndex, direction) {
            switch (direction) {
              case "left":
              case "right":
                var targetColIndex = direction == "left" ? layout.steps[stepIndex].inputPositionManagement.colIndex - 1 : layout.steps[stepIndex].inputPositionManagement.colIndex + 1;
                if (targetColIndex >= 0 && targetColIndex < layout.steps[stepIndex].rows[layout.steps[stepIndex].inputPositionManagement.rowIndex].row.length) {
                    this.manageActiveInputPosition(stepIndex, layout.steps[stepIndex].inputPositionManagement.rowIndex, targetColIndex);
                }
                break;

              case "up":
              case "down":
                var targetRowIndex = direction == "up" ? layout.steps[stepIndex].inputPositionManagement.rowIndex - 1 : layout.steps[stepIndex].inputPositionManagement.rowIndex + 1;
                if (targetRowIndex >= 0 && targetRowIndex < layout.steps[stepIndex].rows.length && layout.steps[stepIndex].rows[targetRowIndex].row.length > 0) {
                    var rowIndex = layout.steps[stepIndex].inputPositionManagement.rowIndex;
                    var colIndex = layout.steps[stepIndex].inputPositionManagement.colIndex;
                    var targetColIndex;
                    if (layout.steps[stepIndex].rows[rowIndex].row.length === layout.steps[stepIndex].rows[targetRowIndex].row.length) {
                        targetColIndex = colIndex;
                    } else if (colIndex === 0) {
                        targetColIndex = 0;
                    } else if (layout.steps[stepIndex].rows[targetRowIndex].row.length > 0 && layout.steps[stepIndex].rows[targetRowIndex].row.length < 3) {
                        targetColIndex = direction === "up" || layout.steps[stepIndex].rows[rowIndex].row.length - 1 === colIndex ? layout.steps[stepIndex].rows[targetRowIndex].row.length - 1 : 0;
                    } else if (colIndex === layout.steps[stepIndex].rows[rowIndex].row.length - 1) {
                        targetColIndex = layout.steps[stepIndex].rows[targetRowIndex].row.length - 1;
                    } else {
                        var ratio = (colIndex + 1) / layout.steps[stepIndex].rows[rowIndex].row.length;
                        targetColIndex = Math.round(ratio * (layout.steps[stepIndex].rows[targetRowIndex].row.length - 2));
                        if (targetColIndex === 0 && layout.steps[stepIndex].rows[targetRowIndex].row.length > 2) {
                            targetColIndex++;
                        } else if (targetColIndex === layout.steps[stepIndex].rows[targetRowIndex].row.length - 1 && layout.steps[stepIndex].rows[targetRowIndex].row.length > 2) {
                            targetColIndex--;
                        }
                    }
                    this.manageActiveInputPosition(stepIndex, targetRowIndex, targetColIndex);
                }
                break;
            }
        };
        this.manageActiveInputPosition = function(stepIndex, rowIndex, colIndex) {
            for (var i in layout.steps[stepIndex].rows) {
                for (var j in layout.steps[stepIndex].rows[i].row) {
                    layout.steps[stepIndex].rows[i].row[j].moveActive = false;
                    layout.steps[stepIndex].rows[i].row[j].activeClass = "inActiveColumn";
                }
            }
            rowIndex = parseInt(rowIndex);
            colIndex = parseInt(colIndex);
            layout.steps[stepIndex].inputPositionManagement.rowIndex = rowIndex;
            layout.steps[stepIndex].inputPositionManagement.colIndex = colIndex;
            layout.steps[stepIndex].rows[rowIndex].row[colIndex].moveActive = true;
            layout.steps[stepIndex].rows[rowIndex].row[colIndex].activeClass = "activeColumn";
            layout.steps[stepIndex].inputPositionManagement.activeInputExists = false;
            layout.steps[stepIndex].inputPositionManagement.activeInputExists = true;
            if (layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID !== layout.steps[stepIndex].inputPositionManagement.activeInputFieldName) {
                layout.steps[stepIndex].inputPositionManagement.activeInputFieldName = layout.steps[stepIndex].rows[rowIndex].row[colIndex].layoutUUID;
                layout.steps[stepIndex].inputMovementHistory = [];
                this.manageInputMovementHistory(stepIndex, layout.steps[stepIndex].inputPositionManagement.rowIndex, layout.steps[stepIndex].inputPositionManagement.colIndex, false, false);
            }
        };
        this.getActiveInputPosition = function(stepIndex) {
            return layout.steps[stepIndex].inputPositionManagement;
        };
        this.verifyActiveInputExists = function(stepIndex) {
            if (!layout.steps[stepIndex].inputPositionManagement.activeInputExists) {
                if (layout.steps[stepIndex].rows.length > 0) {
                    this.manageActiveInputPosition(stepIndex, 0, 0);
                    return true;
                }
                return false;
            }
            return true;
        };
        this.isActiveColumn = function(stepIndex) {
            return layout.steps[stepIndex].inputPositionManagement.activeInputExists;
        };
        this.selectNextAvailableColumn = function(stepIndex) {
            var rowIndex = layout.steps[stepIndex].inputPositionManagement.rowIndex;
            var colIndex = layout.steps[stepIndex].inputPositionManagement.colIndex;
            if (rowIndex < layout.steps[stepIndex].rows.length) {
                for (var i = rowIndex < layout.steps[stepIndex].rows.length ? rowIndex : rowIndex - 1; i >= 0; i--) {
                    for (var j = layout.steps[stepIndex].rows[i].row.length - 1; j >= 0; j--) {
                        if (rowIndex === i && colIndex === j) {
                            this.manageActiveInputPosition(stepIndex, i, j, true);
                            return;
                        } else if (rowIndex === i && colIndex > j) {
                            this.manageActiveInputPosition(stepIndex, i, j, true);
                            return;
                        } else if (i < rowIndex) {
                            this.manageActiveInputPosition(stepIndex, i, 0, true);
                            return;
                        }
                    }
                }
            } else {
                layout.steps[stepIndex].inputPositionManagement.activeInputExists = false;
            }
        };
        this.manageInputMovementHistory = function(stepIndex, rowIndex, colIndex, createdColumn, updatePreviousMovement) {
            if (updatePreviousMovement) {
                layout.steps[stepIndex].inputMovementHistory[0].rowIndex = rowIndex;
                layout.steps[stepIndex].inputMovementHistory[0].colIndex = colIndex;
                layout.steps[stepIndex].inputMovementHistory[0].createdColumn = createdColumn;
                return;
            }
            var historyItem = angular.copy(historyMovementTemplate);
            historyItem.rowIndex = rowIndex;
            historyItem.colIndex = colIndex;
            historyItem.createdColumn = createdColumn;
            layout.steps[stepIndex].inputMovementHistory.push(historyItem);
            if (layout.steps[stepIndex].inputMovementHistory.length === 2) {
                if (layout.steps[stepIndex].inputMovementHistory[0].createdColumn && layout.steps[stepIndex].rows[layout.steps[stepIndex].inputMovementHistory[0].rowIndex].row[layout.steps[stepIndex].inputMovementHistory[0].colIndex].layoutUUID === null) {
                    var columnToRemove = layout.steps[stepIndex].inputMovementHistory.splice(0, 1)[0];
                    this.removeCol(stepIndex, columnToRemove.rowIndex, columnToRemove.colIndex);
                } else {
                    layout.steps[stepIndex].inputMovementHistory.shift();
                }
            }
        };
        this.updateActiveInputPosition = function(stepIndex) {
            for (var i in layout.steps[stepIndex].rows) {
                for (var j in layout.steps[stepIndex].rows[i].row) {
                    if (layout.steps[stepIndex].rows[i].row[j].moveActive) {
                        layout.steps[stepIndex].inputPositionManagement.rowIndex = parseInt(i);
                        layout.steps[stepIndex].inputPositionManagement.colIndex = parseInt(j);
                        this.manageInputMovementHistory(stepIndex, i, j, layout.steps[stepIndex].inputMovementHistory[0].createdColumn, true);
                        return;
                    }
                }
            }
            layout.steps[stepIndex].inputPositionManagement.rowIndex = null;
            layout.steps[stepIndex].inputPositionManagement.colIndex = null;
        };
        this.handleInputMove = function(currentStep, targetStep, layoutUUID) {
            this.handleInputRemoval(currentStep, layoutUUID);
            this.addRow(targetStep);
            this.addInput(targetStep, layout.steps[targetStep].rows.length - 1, 0, layoutUUID);
        };
        this.handleInputRemoval = function(currentStep, layoutUUID) {
            for (var rowIndex in layout.steps[currentStep].rows) {
                for (var colIndex in layout.steps[currentStep].rows[rowIndex].row) {
                    if (layout.steps[currentStep].rows[rowIndex].row[colIndex].layoutUUID === layoutUUID) {
                        if (layout.steps[currentStep].rows[rowIndex].row.length > 1) {
                            layout.steps[currentStep].rows[rowIndex].row[colIndex].layoutUUID = null;
                        } else {
                            this.removeRow(currentStep, rowIndex);
                        }
                    }
                }
            }
        };
        this.handleInputAdd = function(currentStep, layoutUUID) {
            this.addRow(currentStep);
            layout.steps[currentStep].rows[layout.steps[currentStep].rows.length - 1].row[0].layoutUUID = layoutUUID;
        };
    };
    angular.module("formFactory").service("ffLayoutService", [ "$log", layoutService ]);
})();

(function() {
    "use strict";
    var inputValidationDirective = function($log, contextualData, ffValidationService, $timeout) {
        var directive = {
            restrict: "A",
            require: [ "ngModel" ],
            link: linkFunction
        };
        return directive;
        function linkFunction(scope, el, attr, ctrls) {
            var fbc = scope.$parent.$parent.$parent.fbc;
            var model = ctrls[0];
            var nameExists = false;
            var inputDiv = $(el).parent();
            model.$viewChangeListeners.push(function() {
                nameExists = false;
                var s = fbc.form.steps[fbc.currentStep].inputs;
                for (var input1 in s) {
                    for (var input2 in s) {
                        if (input1 !== input2 && s[input1].name === s[input2].name) {
                            nameExists = true;
                            fbc.containsDuplicateInput = true;
                        }
                    }
                }
                if (!nameExists) {
                    fbc.containsDuplicateInput = false;
                    inputDiv.removeClass("has-error");
                    inputDiv.find(".help-block").addClass("hide");
                } else {
                    inputDiv.addClass("has-error");
                    inputDiv.find(".help-block").removeClass("hide");
                }
            });
        }
    };
    angular.module("formFactory").directive("ffNameUniquenessCheck", [ "$log", "contextualData", "ffValidationWorker", "$timeout", inputValidationDirective ]);
})();

onmessage = function(e) {
    "use strict";
    var layoutInvalid = false;
    var messages = [];
    if (e.data.layout !== null && e.data.layout.active && e.data.layout.steps.length > 0) {
        var runningInputCount = 0;
        for (var i in e.data.layout.steps[e.data.currentStep].rows) {
            for (var j in e.data.layout.steps[e.data.currentStep].rows[i].row) {
                if (e.data.layout.steps[e.data.currentStep].rows[i].row[j].layoutUUID !== undefined && e.data.layout.steps[e.data.currentStep].rows[i].row[j].layoutUUID !== null && e.data.layout.steps[e.data.currentStep].rows[i].row[j].layoutUUID.trim() !== "") {
                    runningInputCount++;
                }
            }
        }
        if (runningInputCount !== e.data.steps[e.data.currentStep].inputs.length) {
            messages.unassignedElement = {};
            messages.unassignedElement.validationMessage = "angular.ffFormBuilderDirective.message.unassignedElement";
            messages.unassignedElement.errorInfo = "";
            messages.unassignedElement.toastId = "ue";
            messages.unassignedElement.class = "warning";
        }
        for (var i = e.data.layout.steps.length - 1; i >= 0; i--) {
            var containsAnInput = false;
            for (var j in e.data.layout.steps[i].rows) {
                for (var k in e.data.layout.steps[i].rows[j].row) {
                    if (e.data.layout.steps[i].rows[j].row[k].layoutUUID !== undefined && e.data.layout.steps[i].rows[j].row[k].layoutUUID !== null && e.data.layout.steps[i].rows[j].row[k].layoutUUID.trim() !== "") {
                        containsAnInput = true;
                        break;
                    }
                }
                if (containsAnInput) {
                    break;
                }
            }
            if (containsAnInput) {
                containsAnInput = false;
            } else {
                messages.layoutStepInvalid = {};
                messages.layoutStepInvalid.validationMessage = "angular.ffFormBuilderDirective.message.layoutStepInvalid";
                messages.layoutStepInvalid.errorInfo = e.data.steps[i].label !== "" ? "'" + e.data.steps[i].label + "'" : "'name is empty'";
                messages.layoutStepInvalid.stepIndex = i;
                messages.layoutStepInvalid.toastId = "lsi";
                messages.layoutStepInvalid.class = "error";
                layoutInvalid = true;
                break;
            }
        }
    }
    postMessage({
        flag: "stepContainsUnassignedElements",
        flagValue: layoutInvalid,
        callbacks: [ {
            callback: "unassignedElementsNotification",
            args: messages
        } ]
    });
    close();
};

onmessage = function(e) {
    var hasInvalidLogics = false;
    if (e.data.input.logics !== undefined) {
        for (var i in e.data.input.logics) {
            switch (e.data.type) {
              case "any":
                if (e.data.input.logics[i].requiredValue === undefined || e.data.input.logics[i].requiredValue === "" || e.data.input.logics[i].requiredValue === null) {
                    hasInvalidLogics = true;
                }
                break;

              case "number":
                if (e.data.input.logics[i].requiredValue === undefined || e.data.input.logics[i].requiredValue === "" || e.data.input.logics[i].requiredValue === null || isNaN(e.data.input.logics[i].requiredValue)) {
                    hasInvalidLogics = true;
                }
                break;
            }
        }
    }
    postMessage({
        flag: "containsInvalidLogics",
        flagValue: hasInvalidLogics,
        callbacks: []
    });
    close();
};

(function() {
    "use strict";
    var logicsSyncronizerDirective = function($log) {
        var directive = {
            restrict: "A",
            require: [ "ngModel" ],
            link: linkFunction
        };
        return directive;
        function linkFunction(scope, el, attr, ctrls) {
            var fbc = scope.$parent.$parent.$parent.fbc;
            var model = ctrls[0];
            var s = fbc.form.steps[fbc.currentStep].inputs;
            scope.$watch(function() {
                return model.$modelValue;
            }, _.debounce(function(newValue, oldValue) {
                for (var i in s) {
                    for (var logic in s[i].logics) {
                        if (s[i].logics[logic].fieldName === oldValue) {
                            s[i].logics[logic].fieldName = newValue;
                        }
                    }
                }
            }, 0));
        }
    };
    angular.module("formFactory").directive("ffLogicsSyncronizer", [ "$log", logicsSyncronizerDirective ]);
})();

(function() {
    "use strict";
    var editActionDisplay = function($log, $compile, $timeout) {
        var directive = {
            restrict: "E",
            require: [ "^ffController" ],
            scope: {
                form: "=",
                action: "=",
                inTranslateMode: "=",
                containsInvalidAction: "="
            },
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {
            scope.formController = ctrls[0].getFormController();
            if (scope.action.wizard) {
                el.append($compile(scope.action.wizard)(scope));
            }
            scope.fields = {};
            scope.$on("validateFields", function() {
                validateFields();
                $timeout(function() {
                    scope.$emit("validateActions", null);
                });
            });
            function validateFields() {
                var isValid = true;
                for (var i in scope.fields) {
                    if (!scope.fields[i]) {
                        isValid = false;
                        break;
                    }
                }
                scope.containsInvalidAction = !isValid;
            }
            scope.isFieldValid = function(fieldName) {
                return scope.fields[fieldName];
            };
        }
    };
    angular.module("formFactory").directive("ffEditActionDisplay", [ "$log", "$compile", "$timeout", editActionDisplay ]);
    var actionValidator = function($log) {
        var directive = {
            restrict: "A",
            require: [ "^ngModel" ],
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {
            var model = ctrls[0];
            var fieldName = attr.fieldName;
            var validationType = attr.validationType;
            var emailRegexp = /^[A-Z0-9._%+-]{1,64}@(?:[A-Z0-9-]{1,63}\.){1,125}[A-Z]{2,63}$/i;
            if (!("ngModelOptions" in attr)) {
                model.$options = {
                    updateOn: "blur",
                    updateOnDefault: true,
                    debounce: {
                        blur: 0,
                        "default": 500
                    }
                };
            }
            model.$validators[fieldName] = function(newValue) {
                var isValid = true;
                switch (validationType) {
                  case "number":
                    if (newValue === undefined || newValue === "" || newValue === null || isNaN(newValue)) {
                        isValid = false;
                    }
                    break;

                  case "positiveNumber":
                    if (newValue === undefined || newValue === "" || newValue === null || isNaN(newValue) || newValue < 0) {
                        isValid = false;
                    }
                    break;

                  case "email":
                    if (!emailRegexp.test(newValue)) {
                        isValid = false;
                    }
                    break;

                  case "any":
                  default:
                    if (newValue === undefined || newValue === "" || newValue === null) {
                        isValid = false;
                    }
                    break;
                }
                scope.fields[fieldName] = isValid;
                scope.$emit("validateFields", null);
                return isValid;
            };
        }
    };
    angular.module("formFactory").directive("ffActionValidator", [ "$log", "$compile", actionValidator ]);
})();

(function() {
    "use strict";
    var editActionTab = function($log, contextualData) {
        var directive = {
            restrict: "E",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editaction/editActionTab.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrl) {
            scope.$on("validateActions", function() {
                scope.fbc.stepValidityCheck();
            });
        }
    };
    angular.module("formFactory").directive("ffEditActionTab", [ "$log", "contextualData", editActionTab ]);
})();

(function() {
    "use strict";
    var nodePicker = function(contextualData) {
        var directive = {
            restrict: "E",
            scope: {
                selectedPath: "=",
                selectedId: "=",
                selectedName: "=",
                nodeTypes: "@",
                selectableNodeTypes: "@",
                rootPath: "@",
                label: "@"
            },
            controller: NodePickerController,
            controllerAs: "npc",
            bindToController: true,
            link: function(scope, element, attrs) {
                if (!attrs.selectedId) {
                    scope.selectedIdSpecified = false;
                } else {
                    scope.selectedIdSpecified = true;
                }
            },
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editaction/pickerPopup.html"
        };
        return directive;
    };
    var NodePickerController = function($scope, $modal, contextualData) {
        var npc = this;
        npc.openPicker = openPicker;
        npc.selectedPath = npc.selectedPath === "" ? contextualData.sitePath : npc.selectedPath;
        npc.selectedName = npc.selectedName === "" ? "" : npc.selectedName;
        function openPicker() {
            var modalInstance = $modal.open({
                backdrop: false,
                templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editaction/nodePicker.html",
                controller: function($scope, $uibModalInstance, ds) {
                    $scope.root = {};
                    function selectInTree() {
                        if (npc.selectedPath) {
                            $scope.root.children.forEach(function(child) {
                                if (npc.selectedPath != child.path && npc.selectedPath.indexOf(child.path) == 0) {
                                    $scope.toggle(child, selectItemInTree);
                                }
                            });
                        }
                    }
                    function selectItemInTree(item) {
                        if (npc.selectedPath && item && item.hasChildren && item.children.length > 0) {
                            item.displayed = true;
                            item.children.forEach(function(child) {
                                if (npc.selectedPath != child.path && npc.selectedPath.indexOf(child.path) == 0) {
                                    $scope.toggle(child, selectItemInTree);
                                }
                            });
                        }
                    }
                    $.ajax({
                        type: "GET",
                        dataType: "json",
                        url: (npc.rootPath ? contextualData.urlBase + npc.rootPath : contextualData.urlSiteBase) + ".treeRootItem.json?nodeTypes=" + npc.nodeTypes + (ds.selectableNodeTypes ? "&selectableNodeTypes=" + ds.selectableNodeTypes : "")
                    }).done(function(data) {
                        $scope.$apply(function() {
                            if (data && data.length > 0) {
                                $scope.root = data[0];
                                $scope.root.displayed = true;
                                $scope.$watch(function() {
                                    return npc.selectedPath;
                                }, selectInTree);
                            }
                        });
                    });
                    $scope.getIcon = function(isRoot, item) {
                        if (isRoot) {
                            return "fa fa-globe";
                        }
                        if (item) {
                            if ($scope.isSelectable(item)) {
                                return "fa fa-file";
                            } else {
                                return "fa fa-folder";
                            }
                        }
                        return "fa fa-file";
                    };
                    $scope.getArrow = function(item) {
                        if (item.hasChildren) {
                            if (item.displayed) {
                                return "fa fa-chevron-down";
                            } else {
                                return "fa fa-chevron-right";
                            }
                        }
                        return "";
                    };
                    $scope.getItemClass = function(item) {
                        if ($scope.isSelected(item)) {
                            return "selected cursorPointer";
                        }
                        if ($scope.isSelectable(item)) {
                            return "selectable cursorPointer";
                        }
                    };
                    $scope.isSelectable = function(item) {
                        return "selectable" == item.classes;
                    };
                    $scope.isSelected = function(item) {
                        return item.path == npc.selectedPath;
                    };
                    $scope.select = function(item) {
                        if ("selectable" == item.classes) {
                            npc.selectedName = item.text;
                            npc.selectedPath = item.path;
                            $uibModalInstance.close(item);
                        }
                    };
                    $scope.closeModal = function() {
                        $uibModalInstance.dismiss("cancel");
                    };
                    $scope.toggle = function(item, cb) {
                        if (item.hasChildren) {
                            if (item.children && item.children.length > 0) {
                                item.displayed = !item.displayed;
                                if (cb) {
                                    cb(item);
                                }
                            } else {
                                $.ajax({
                                    type: "GET",
                                    dataType: "json",
                                    url: contextualData.urlBase + item.path + ".treeRootItem.json?nodeTypes=" + npc.nodeTypes + (ds.selectableNodeTypes ? "&selectableNodeTypes=" + ds.selectableNodeTypes : "")
                                }).done(function(data) {
                                    var children = data && data.length > 0 ? data[0].children : [];
                                    $scope.$apply(function() {
                                        item.children = children;
                                        item.displayed = true;
                                        if (cb) {
                                            cb(item);
                                        }
                                    });
                                });
                            }
                        }
                    };
                },
                size: "sm",
                resolve: {
                    ds: function() {
                        return $scope;
                    }
                }
            });
            modalInstance.result.then(function(item) {
                $scope.selectedPath = item.path;
                if ($scope.selectedIdSpecified) {
                    $scope.selectedId = item.id;
                }
            });
        }
    };
    NodePickerController.$inject = [ "$scope", "$uibModal", "contextualData" ];
    angular.module("formFactory").directive("ffNodePicker", [ "contextualData", nodePicker ]);
})();

(function() {
    "use strict";
    var callbackEditor = function($log, contextualData) {
        var directive = {
            restrict: "E",
            scope: {
                clbks: "="
            },
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editformmetadata/callbacktab/callback.html",
            controller: CallbackEditorController,
            controllerAs: "cbe",
            bindToController: true,
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {}
    };
    angular.module("formFactory").directive("ffCallbackEditor", [ "$log", "contextualData", callbackEditor ]);
    var CallbackEditorController = function($scope, $log, ffDataFactory, contextualData, $i18n) {
        var cbe = this;
        cbe.callbacks = [];
        cbe.callbackName = null;
        cbe.data = [];
        cbe.callbackOn = false;
        cbe.message = $i18n.message;
        cbe.toggleON = toggleOn;
        cbe.addSelected = addSelected;
        cbe.removeCallback = removeCallback;
        activate();
        function activate() {
            ffDataFactory.getData(contextualData.context + "/modules/formfactory/builder/definitionslist/callbacks/" + contextualData.siteIdentifier + "/" + contextualData.language).then(function(data) {
                var tmp = cbe.clbks !== null ? cbe.clbks.callbacks : [];
                for (var i in data) {
                    if (!_.contains(tmp, i)) {
                        cbe.callbacks.push(i);
                    }
                    cbe.data.push(i);
                }
                if (tmp.length > 0) {
                    cbe.callbackOn = true;
                }
                cbe.activated = true;
                if (cbe.callbacks.length === 0 && tmp.length === 0) {
                    cbe.callbackOn = false;
                }
            });
        }
        function toggleOn() {
            if (!cbe.callbackOn) {
                cbe.clbks = null;
            } else {
                cbe.callbacks = angular.copy(cbe.data);
                cbe.clbks = {
                    callbacks: [],
                    displayTemplates: true
                };
            }
        }
        function addSelected() {
            if (cbe.callbackName !== null) {
                cbe.clbks.callbacks.push(cbe.callbackName);
                cbe.callbacks = allExcept(cbe.callbacks, cbe.callbackName);
            }
        }
        function removeCallback(callback) {
            cbe.clbks.callbacks = allExcept(cbe.clbks.callbacks, callback);
            cbe.callbacks.push(callback);
        }
        function allExcept(array, exception) {
            var a = [];
            for (var i in array) {
                if (array[i] !== exception && array[i] !== null) {
                    a.push(array[i]);
                }
            }
            return a;
        }
    };
    CallbackEditorController.$inject = [ "$scope", "$log", "ffDataFactory", "contextualData", "i18nService" ];
})();

(function() {
    "use strict";
    var metaDataEditor = function($log, contextualData, ffDataFactory) {
        var directive = {
            restrict: "E",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editformmetadata/metaDataEditor.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {
            scope.hasThemes = false;
            scope.activeTab = "edit-meta-data";
            scope.updateActiveTab = updateActiveTab;
            scope.getImgSrc = getImgSrc;
            ffDataFactory.getData(contextualData.context + "/modules/formfactory/builder/themes/" + contextualData.siteIdentifier).then(function(data) {
                if (data.length > 0) {
                    scope.hasThemes = true;
                }
            });
            scope.icons = {
                callback: {
                    active: null,
                    inactive: null
                },
                "edit-meta-data": {
                    active: null,
                    inactive: null
                },
                "progress-bar": {
                    active: null,
                    inactive: null
                },
                theme: {
                    active: null,
                    inactive: null
                }
            };
            for (var i in scope.icons) {
                scope.icons[i].active = contextualData.context + "/modules/form-factory-core/img/metaDataIcons/" + i + "_active.png";
                scope.icons[i].inactive = contextualData.context + "/modules/form-factory-core/img/metaDataIcons/" + i + "_inactive.png";
            }
            function updateActiveTab(tab) {
                scope.activeTab = tab;
            }
            function getImgSrc(tab) {
                return tab === scope.activeTab ? scope.icons[tab].active : scope.icons[tab].inactive;
            }
        }
    };
    angular.module("formFactory").directive("ffMetaDataEditor", [ "$log", "contextualData", "ffDataFactory", metaDataEditor ]);
})();

(function() {
    "use strict";
    var editLanguages = function($log, contextualData) {
        var directive = {
            restrict: "E",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editformmetadata/languagestab/editLanguages.html",
            controller: EditLanguagesController,
            controllerAs: "elc",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {}
    };
    angular.module("formFactory").directive("ffEditLanguages", [ "$log", "contextualData", editLanguages ]);
    var EditLanguagesController = function($scope, $log) {
        var elc = this;
        elc.selectedLanguagesToAdd = null;
        elc.existingLanguages = $scope.fbc.form.existingLanguages;
        elc.missingLanguages = $scope.fbc.form.missingLanguages;
        elc.addLanguages = addLanguages;
        elc.isLanguageSelected = false;
        elc.updateAddButton = updateAddButton;
        elc.removeLanguage = removeLanguage;
        elc.isMissingLanguages = false;
        elc.newlyAddedLanguages = {};
        init();
        function init() {
            elc.isMissingLanguages = !_.isEmpty(elc.missingLanguages);
            _.each(elc.missingLanguages, function(language, code) {
                elc.newlyAddedLanguages[code] = false;
            });
        }
        function addLanguages() {
            _.each(elc.selectedLanguagesToAdd, function(code) {
                elc.existingLanguages[code] = elc.missingLanguages[code];
                elc.newlyAddedLanguages[code] = true;
                delete elc.missingLanguages[code];
            });
            elc.selectedLanguagesToAdd = [];
            elc.isMissingLanguages = !_.isEmpty(elc.missingLanguages);
            updateAddButton();
        }
        function updateAddButton() {
            elc.isLanguageSelected = !_.isEmpty(elc.selectedLanguagesToAdd);
        }
        function removeLanguage(code) {
            elc.missingLanguages[code] = elc.existingLanguages[code];
            elc.newlyAddedLanguages[code] = false;
            delete elc.existingLanguages[code];
            elc.isMissingLanguages = true;
        }
    };
    EditLanguagesController.$inject = [ "$scope", "$log" ];
})();

(function() {
    "use strict";
    var metaDataEditor = function($log, contextualData) {
        var directive = {
            restrict: "E",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editformmetadata/metadatatab/metaDataTab.html",
            controller: MetaDataEditorController,
            controllerAs: "mdec",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {}
    };
    angular.module("formFactory").directive("ffMetaDataTab", [ "$log", "contextualData", metaDataEditor ]);
    var MetaDataEditorController = function($scope, $log, contextualData, $sce, i18n) {
        var mdec = this;
        mdec.formInvalidMessage = "";
        mdec.hasCaptcha = contextualData.hasCaptcha;
        mdec.formRenameWarning = $sce.trustAsHtml(i18n.message("fcnt_metaData.formRenamingWarningMessage"));
    };
    MetaDataEditorController.$inject = [ "$scope", "$log", "contextualData", "$sce", "i18nService" ];
})();

(function() {
    "use strict";
    var progressBarEditor = function($log, $compile, contextualData) {
        var directive = {
            restrict: "E",
            controller: ProgressBarEditorController,
            controllerAs: "pbec",
            bindToController: true,
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editformmetadata/progressbartab/progressBarEditor.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {}
    };
    var ProgressBarEditorController = function($scope, $log, $compile, ffDataFactory, contextualData) {
        var pbec = this;
        pbec.toggle = false;
        pbec.progressBarsCache = null;
        pbec.retrieveProgressBars = retrieveProgressBars;
        pbec.syncData = syncData;
        activate();
        function activate() {
            retrieveProgressBars();
            if ($scope.fbc.form.progressBar !== null) {
                pbec.toggle = true;
            }
        }
        function retrieveProgressBars() {
            if (pbec.progressBarsCache === null) {
                ffDataFactory.customRequest({
                    url: contextualData.context + "/modules/formfactory/builder/definitionslist/progressBars/" + contextualData.siteIdentifier + "/" + "en",
                    method: "GET"
                }).then(function(response) {
                    pbec.progressBarsCache = response;
                });
            }
        }
        function syncData() {
            if (pbec.toggle) {
                $scope.fbc.form.progressBar = pbec.progressBarsCache[Object.keys(pbec.progressBarsCache)[0]];
            } else {
                $scope.fbc.form.progressBar = null;
            }
        }
    };
    ProgressBarEditorController.$inject = [ "$scope", "$log", "$compile", "ffDataFactory", "contextualData" ];
    angular.module("formFactory").directive("ffProgressBarEditor", [ "$log", "$compile", "contextualData", progressBarEditor ]);
})();

angular.module("formFactory").directive("ffProgressBarViewChooser", [ "$log", "$compile", function($log, $compile) {
    var directive = {
        restrict: "E",
        replace: true,
        scope: {
            form: "=",
            currentStep: "="
        },
        link: linkFunc
    };
    return directive;
    function linkFunc(scope, el, attr) {
        if (scope.form.progressBar != null) el.append($compile(scope.form.progressBar.template)(scope));
        scope.$watch(function() {
            if (scope.form.progressBar != null) return scope.form.progressBar.nodeType;
            return null;
        }, function() {
            if (scope.form.progressBar != null) el.html($compile(scope.form.progressBar.template)(scope));
        });
    }
} ]);

(function() {
    "use strict";
    var themeDirective = function($log, contextualData, ffDataFactory) {
        var directive = {
            restrict: "E",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editformmetadata/themetab/themeTab.html",
            controller: themeController,
            controllerAs: "tc",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {}
    };
    angular.module("formFactory").directive("ffTheme", [ "$log", "contextualData", themeDirective ]);
    var themeController = function($scope, $log, ffDataFactory, contextualData, i18nService) {
        var tc = this;
        tc.themeStatusChange = themeStatusChange;
        init();
        function init() {
            ffDataFactory.getData(contextualData.context + "/modules/formfactory/builder/themes/" + contextualData.siteIdentifier).then(function(data) {
                tc.themeEnabled = !!(!_.isUndefined($scope.fbc.form.theme) && $scope.fbc.form.theme !== null);
                tc.themes = [];
                angular.forEach(data, function(theme) {
                    tc.themes.push({
                        id: theme,
                        name: i18nService.message("label.themes." + theme.toLowerCase() + ".display.name")
                    });
                });
            });
        }
        function themeStatusChange() {
            if (!tc.themeEnabled) {
                delete $scope.fbc.form.theme;
            }
        }
    };
    themeController.$inject = [ "$scope", "$log", "ffDataFactory", "contextualData", "i18nService" ];
})();

(function() {
    "use strict";
    var topSelectionsSelection = function(contextualData) {
        var directive = {
            restrict: "E",
            scope: {
                topSelections: "=",
                countries: "="
            },
            controller: CountrySelectionController,
            controllerAs: "csc",
            bindToController: true,
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/countrytop/countryTopSelection.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr) {}
    };
    var CountrySelectionController = function($scope) {
        var csc = this;
        csc.addToTop = addToTop;
        csc.removeFromTop = removeFromTop;
        csc.swapCountry = swapCountry;
        csc.currentSelection = null;
        csc.selectedObjects = [];
        activate();
        function activate() {
            for (var i in csc.topSelections) {
                csc.selectedObjects.push(angular.copy(csc.countries[i]));
            }
        }
        function addToTop() {
            if (notInTop(csc.currentSelection.country.key)) {
                csc.topSelections.push(csc.currentSelection.country.key);
                csc.selectedObjects.push(angular.copy(csc.currentSelection));
            }
            csc.currentSelection = null;
        }
        function removeFromTop(index) {
            var newSelectedObjects = [];
            var newTopSelections = [];
            for (var i in csc.selectedObjects) {
                if (i != index) {
                    newSelectedObjects.push(csc.selectedObjects[i]);
                    newTopSelections.push(csc.selectedObjects[i].country.key);
                }
            }
            csc.topSelections = newTopSelections;
            csc.selectedObjects = newSelectedObjects;
        }
        function notInTop(key) {
            for (var i in csc.topSelections) {
                if (key === csc.topSelections[i]) {
                    return false;
                }
            }
            return true;
        }
        function swapCountry($index) {
            csc.selectedObjects.splice($index, 1);
            csc.topSelections = [];
            for (var i in csc.selectedObjects) {
                csc.topSelections.push(csc.selectedObjects[i].country.key);
            }
        }
    };
    CountrySelectionController.$inject = [ "$scope" ];
    angular.module("formFactory").directive("ffCountryTopSelection", [ "contextualData", topSelectionsSelection ]);
})();

(function() {
    "use strict";
    var designInput = function($compile, ffDataFactory, $log, contextualData, $timeout) {
        var directive = {
            restrict: "E",
            require: [ "^ffController" ],
            scope: {
                input: "=",
                duplicateKeyDetected: "=",
                inTranslateMode: "=",
                containsInvalidInput: "=",
                containsInvalidKeyValue: "="
            },
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {
            scope.readOnly = !ctrls[0].isLiveMode();
            scope.$on("containsInvalidKeyValue", function(event, result) {
                scope.containsInvalidKeyValue = result;
            });
            if (scope.input.wizard !== undefined) {
                var compiled = $compile(scope.input.wizard)(scope);
                el.append(compiled);
            }
            scope.fieldsStatus = {};
            for (var i in scope.input.definitionOptions) {
                scope.fieldsStatus[scope.input.definitionOptions[i]] = true;
            }
            scope.$on("requiredValueChanged", function(event, data) {
                scope.fieldsStatus[data.fieldId] = data.isValid;
                scope.containsInvalidInput = areFieldsInvalid();
            });
            function areFieldsInvalid() {
                for (var i in scope.fieldsStatus) {
                    if (!scope.fieldsStatus[i]) {
                        return true;
                    }
                }
                return false;
            }
            scope.isFieldValid = function(fieldId) {
                return scope.fieldsStatus[fieldId];
            };
            scope.$on("duplicateKeyCheck", function(event, isInvalid) {
                scope.duplicateKeyDetected = isInvalid;
            });
        }
    };
    angular.module("formFactory").directive("ffDesignInput", [ "$compile", "ffDataFactory", "$log", "contextualData", "$timeout", designInput ]);
})();

(function() {
    "use strict";
    var editInputTabs = function($log, contextualData) {
        var directive = {
            restrict: "E",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/editInputTabs.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrl) {}
    };
    angular.module("formFactory").directive("ffEditInputTabs", [ "$log", "contextualData", editInputTabs ]);
})();

(function() {
    "use strict";
    var inputBucket = function($log, contextualData) {
        var directive = {
            restrict: "E",
            scope: {
                fieldName: "=",
                setDefault: "=",
                displayTitle: "=",
                availableInputs: "=",
                bucketMode: "=",
                multiStepMode: "=",
                emitOnChange: "@?",
                broadcast: "&?"
            },
            controller: InputBucketController,
            controllerAs: "ibc",
            bindToController: true,
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/inputBucket.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {}
    };
    angular.module("formFactory").directive("ffInputBucket", [ "$log", "contextualData", inputBucket ]);
    var InputBucketController = function($scope, $log, i18n) {
        var ibc = this;
        ibc.updateSelectedChoice = updateSelectedChoice;
        ibc.sortOptions = sortOptions;
        ibc.filterInputs = filterInputs;
        init();
        function init() {
            var dummyOption = {
                exists: false,
                index: 0
            };
            ibc.fieldNameNotSet = true;
            for (var i in ibc.availableInputs) {
                if ("dummy" in ibc.availableInputs[i]) {
                    dummyOption.exists = true;
                    dummyOption.index = i;
                    continue;
                }
                if ((_.isUndefined(ibc.fieldName) || ibc.fieldName === null) && ibc.setDefault && !("inUse" in ibc.availableInputs[i])) {
                    ibc.selectedInput = ibc.availableInputs[i];
                    ibc.fieldNameNotSet = false;
                    break;
                } else {
                    if (ibc.fieldName === ibc.availableInputs[i].fieldName) {
                        ibc.selectedInput = ibc.availableInputs[i];
                        ibc.fieldNameNotSet = false;
                    }
                }
            }
            if (ibc.fieldNameNotSet && !dummyOption.exists) {
                ibc.availableInputs.push({
                    label: i18n.message("angular.ffInputBucketDirective.selectOption"),
                    index: ibc.availableInputs.length,
                    dummy: true
                });
                ibc.selectedInput = ibc.availableInputs[ibc.availableInputs.length - 1];
                ibc.fieldNameNotSet = false;
            } else if (ibc.fieldNameNotSet) {
                ibc.selectedInput = ibc.availableInputs[dummyOption.index];
                ibc.fieldNameNotSet = false;
            }
            if (!_.isUndefined(ibc.selectedInput)) {
                ibc.updateSelectedChoice();
            }
        }
        function updateSelectedChoice(previousValue) {
            if (ibc.selectedInput !== null && !_.isUndefined(ibc.selectedInput)) {
                if ("dummy" in ibc.selectedInput) {
                    ibc.availableInputs[ibc.selectedInput.index].inUse = ibc.selectedInput.index;
                    return;
                }
                if (!_.isUndefined(previousValue) && previousValue.index === ibc.selectedInput.index) {
                    return;
                }
                $scope.$parent.selectedInput = ibc.selectedInput;
                if (!_.isUndefined(ibc.broadcast) && _.isFunction(ibc.broadcast)) {
                    ibc.broadcast();
                }
                if (ibc.bucketMode) {
                    if (_.isObject(previousValue) && !("dummy" in previousValue)) {
                        delete ibc.availableInputs[previousValue.index].inUse;
                    }
                    ibc.availableInputs[ibc.selectedInput.index].inUse = ibc.selectedInput.index;
                }
                if (!_.isUndefined(ibc.emitOnChange)) {
                    $scope.$emit(ibc.emitOnChange, ibc.selectedInput);
                }
            }
        }
        function filterInputs(input) {
            return !!(!("inUse" in input) || ibc.selectedInput !== null && !_.isUndefined(ibc.selectedInput) && input.inUse === ibc.selectedInput.index);
        }
        function sortOptions() {
            return function(option) {
                var prefix = ibc.multiStepMode ? "b" + option.stepIndex : "b";
                return "dummy" in option ? "a" : prefix + option.label;
            };
        }
    };
    InputBucketController.$inject = [ "$scope", "$log", "i18nService" ];
})();

(function() {
    "use strict";
    var KeyValueController = function($scope, $log, $parse, $timeout, i18n, _) {
        var kvc = this;
        function init() {
            kvc.kv = kvc.input[kvc.property];
            if (kvc.multipleDefaultValueSelection === undefined) {
                kvc.useMultipleSelect = false;
            } else {
                kvc.useMultipleSelect = $parse(kvc.multipleDefaultValueSelection)($scope);
            }
            if (kvc.displayName === undefined) {
                kvc.displayName = "ff.label.keyValue";
            }
            if (kvc.displayDefaultValueSelection === undefined) {
                kvc.showSelectors = true;
            } else {
                kvc.showSelectors = $parse(kvc.displayDefaultValueSelection)($scope);
            }
            kvc.remove = remove;
            kvc.addKeyValue = addKeyValue;
            kvc.isDuplicateKey = isDuplicateKey;
            kvc.checkForDuplicateKeys = checkForDuplicateKeys;
            kvc.duplicateKeyDetected = false;
            kvc.resetDefault = resetDefault;
            kvc.markPairIfInvalid = markPairIfInvalid;
            kvc.areFieldsValid = areFieldsValid;
            kvc.clearValues = clearValues;
            kvc.i18nMessageGetter = i18nMessageGetter;
            kvc.moveUp = moveUp;
            kvc.moveDown = moveDown;
            checkForDuplicateKeys();
        }
        function remove(key) {
            removeByKey(key);
            $scope.$emit("containsInvalidKeyValue", !kvc.areFieldsValid());
        }
        function resetDefault() {
            kvc.input.value = null;
        }
        function removeByKey(key) {
            var arr = [];
            var selectedValues = [];
            for (var i in kvc.kv) {
                if (kvc.kv[i].key !== key) {
                    arr.push(kvc.kv[i]);
                }
            }
            var value = kvc.input.value;
            if (kvc.useMultipleSelect) {
                selectedValues = _.filter(value, function(value) {
                    return value !== key;
                });
            } else if (key !== value) {
                selectedValues.push(value);
            }
            kvc.input.value = selectedValues;
            kvc.kv = arr;
            kvc.input[kvc.property] = kvc.kv;
            checkForDuplicateKeys();
        }
        function addKeyValue() {
            var length = 0;
            var keys = [];
            _.each(kvc.kv, function(item, key) {
                keys.push(item.key);
            });
            while (true) {
                var keyTaken = _.find(keys, function(key) {
                    return "option" + length == key;
                });
                if (keyTaken === undefined) {
                    var obj = {
                        key: "option" + length,
                        value: "Option " + length,
                        selected: false
                    };
                    kvc.kv.push(obj);
                    break;
                }
                length++;
            }
            kvc.input[kvc.property] = kvc.kv;
            $scope.$emit("containsInvalidKeyValue", !kvc.areFieldsValid());
        }
        function checkForDuplicateKeys() {
            var keys = [];
            _.each(kvc.kv, function(item, index) {
                keys.push(item.key);
            });
            $scope.$parent.duplicateKeyDetected = kvc.duplicateKeyDetected = keys.length !== _.uniq(keys).length;
            $scope.$emit("duplicateKeyCheck", kvc.duplicateKeyDetected);
        }
        function clearValues() {
            if (_.isArray(kvc.input.value)) {
                kvc.input.value = [];
            } else {
                kvc.input.value = null;
            }
        }
        function isDuplicateKey(key) {
            var keys = [];
            _.each(kvc.kv, function(item, index) {
                if (item.key === key) {
                    keys.push(item.key);
                }
            });
            return keys.length > 1;
        }
        function markPairIfInvalid(index) {
            var i = kvc.kv[index];
            if (i.key === "" || i.key === null) {
                i["invalidKey"] = true;
            } else {
                delete i.invalidKey;
            }
            if (i.value === "" || i.value === null) {
                i["invalidValue"] = true;
            } else {
                delete i.invalidValue;
            }
            $scope.$emit("containsInvalidKeyValue", !kvc.areFieldsValid());
        }
        function areFieldsValid() {
            if (kvc.kv.length < 1) {
                return false;
            }
            for (var i in kvc.kv) {
                if (kvc.kv[i].invalidKey || kvc.kv[i].invalidValue) {
                    return false;
                }
            }
            return true;
        }
        init();
        function i18nMessageGetter(key) {
            return i18n.message(key);
        }
        function moveUp(key) {
            var originalIndex = _.findIndex(kvc.kv, {
                key: key
            });
            var previousObject = kvc.kv[originalIndex - 1];
            kvc.kv[originalIndex - 1] = kvc.kv[originalIndex];
            kvc.kv[originalIndex] = previousObject;
        }
        function moveDown(key) {
            var originalIndex = _.findIndex(kvc.kv, {
                key: key
            });
            var previousObject = kvc.kv[originalIndex + 1];
            kvc.kv[originalIndex + 1] = kvc.kv[originalIndex];
            kvc.kv[originalIndex] = previousObject;
        }
    };
    KeyValueController.$inject = [ "$scope", "$log", "$parse", "$timeout", "i18nService", "_" ];
    var keyValueMaker = function($log, contextualData, i18n) {
        var directive = {
            restrict: "E",
            controller: KeyValueController,
            scope: {
                input: "=",
                readOnly: "=",
                property: "@",
                displayName: "@",
                multipleDefaultValueSelection: "@",
                displayDefaultValueSelection: "@",
                inTranslateMode: "="
            },
            controllerAs: "kvc",
            bindToController: true,
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/keyvalue/keyValue.html"
        };
        return directive;
    };
    angular.module("formFactory").directive("ffKeyValueMaker", [ "$log", "contextualData", "i18nService", keyValueMaker ]);
})();

(function() {
    "use strict";
    var editLogics = function($log, contextualData) {
        var directive = {
            restrict: "E",
            scope: {
                input: "=",
                form: "=",
                currentStep: "=",
                validateAllSteps: "&"
            },
            controller: DesignLogicsController,
            controllerAs: "dlc",
            bindToController: true,
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/logics/logics.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr) {}
    };
    var DesignLogicsController = function($scope, contextualData, ffDataFactory, i18n, $timeout, _) {
        var dlc = this;
        dlc.validationStatuses = {};
        dlc.enableLogics = false;
        dlc.addRemoveLogicsArray = addRemoveLogicsArray;
        dlc.logicsCache = null;
        dlc.addLogicRule = addLogicRule;
        dlc.i18nMessageGetter = i18n.message;
        dlc.prepareLogicsForBuilder = prepareLogicsForBuilder;
        dlc.prepareAvailableInputs = prepareAvailableInputs;
        dlc.checkAvailableLogics = checkAvailableLogics;
        dlc.resetAvailableInputs = resetAvailableInputs;
        dlc.availableLogics = false;
        dlc.validateSteps = validateSteps;
        dlc.displayFieldName = displayFieldName;
        activate();
        $scope.$on("updateAvailableLogics", function() {
            dlc.checkAvailableLogics();
        });
        function activate() {
            if ($scope.$parent.fbc.logicsCache === null) {
                ffDataFactory.customRequest({
                    url: contextualData.context + "/modules/formfactory/builder/definitionslist/logics/" + contextualData.siteIdentifier + "/" + contextualData.locale,
                    method: "GET"
                }).then(function(data) {
                    dlc.logicsCache = $scope.$parent.fbc.logicsCache = data;
                    dlc.prepareLogicsForBuilder();
                    $scope.$broadcast("logicsCacheAvailable", null);
                });
            } else {
                dlc.logicsCache = $scope.$parent.fbc.logicsCache;
            }
            if (dlc.input.logics !== undefined) {
                dlc.enableLogics = true;
            }
            dlc.prepareAvailableInputs();
        }
        function validateSteps() {
            $timeout(function() {
                dlc.validateAllSteps();
            }, 550);
        }
        function prepareAvailableInputs() {
            dlc.availableInputs = [];
            _.each(dlc.form.steps, function(step, sIndex) {
                if (sIndex <= dlc.currentStep) {
                    _.each(step.inputs, function(input, iIndex) {
                        if (input.name === dlc.input.name || _.isUndefined(input.supportedLogicTypes)) {
                            return;
                        }
                        dlc.availableInputs.push({
                            fieldName: input.name,
                            label: input.label,
                            supportedLogicTypes: input.supportedLogicTypes,
                            stepName: step.label,
                            stepIndex: sIndex,
                            inputIndex: iIndex
                        });
                        dlc.availableInputs[dlc.availableInputs.length - 1].index = dlc.availableInputs.length - 1;
                    });
                }
            });
            dlc.checkAvailableLogics();
        }
        function addRemoveLogicsArray() {
            dlc.checkAvailableLogics();
            if (!dlc.enableLogics) {
                if (dlc.input.logics !== undefined) {
                    dlc.resetAvailableInputs();
                    delete dlc.input.logics;
                    $scope.$broadcast("requiredValueChanged", {
                        isValid: true,
                        "case": "any"
                    });
                }
            } else {
                dlc.input.logics = [];
                addLogicRule();
            }
            dlc.validateSteps();
        }
        function addLogicRule() {
            if (dlc.availableLogics) {
                var dummy = {};
                dummy.name = "dummyLogic";
                dummy.fieldName = null;
                dummy.requiredValue = null;
                dlc.input.logics.push(dummy);
            }
        }
        function prepareLogicsForBuilder() {
            for (var cacheLogic in dlc.logicsCache) {
                dlc.logicsCache[cacheLogic].name = cacheLogic;
                dlc.logicsCache[cacheLogic].label = i18n.message("ff.label.logic." + cacheLogic, dlc.logicsCache[cacheLogic].label);
            }
            for (var inputLogic in dlc.input.logics) {
                delete dlc.input.logics[inputLogic].definitionOptionsTranslatable;
                delete dlc.input.logics[inputLogic].definitionOptions;
                for (var cacheLogic in dlc.logicsCache) {
                    if (dlc.input.logics[inputLogic].nodeType === dlc.logicsCache[cacheLogic].nodeType) {
                        dlc.input.logics[inputLogic] = angular.merge({}, dlc.logicsCache[cacheLogic], dlc.input.logics[inputLogic]);
                    }
                }
            }
        }
        function checkAvailableLogics() {
            var usedInputs = 0;
            for (var i in dlc.availableInputs) {
                if ("inUse" in dlc.availableInputs[i]) {
                    usedInputs++;
                }
            }
            var availableInputs = dlc.availableInputs.length - usedInputs;
            dlc.availableLogics = !_.isUndefined(dlc.availableInputs) && availableInputs > 0;
        }
        function resetAvailableInputs() {
            for (var i in dlc.availableInputs) {
                delete dlc.availableInputs[i].inUse;
            }
        }
        function displayFieldName(logic) {
            if (dlc.logicsCache !== null) {
                var s = i18n.message("ff.label.logic.nlg.display") + " <strong><em>" + dlc.input.label + "</em></strong>";
                if (logic.name.split("_")[1] > 0) {
                    s = i18n.message("ff.label.logic.nlg.and");
                }
                var logic2 = dlc.input.logics[logic.name.split("_")[1]];
                if (!_.isUndefined(logic2)) {
                    var feedBack = i18n.message("ff.label.logic.displayFeedback." + logic.name.split("_")[0]);
                    var properties = feedBack.match(/\{(.*?)\}/g);
                    for (var i in properties) {
                        var property = properties[i].replace(/\{|\}/g, "");
                        var value = logic2[property] === null || _.isUndefined(logic2[property]) ? "" : logic2[property] instanceof Date ? moment(logic2[property]).format("YYYY-MM-DD") : moment(logic2[property], moment.ISO_8601, true).isValid() ? moment(logic2[property], moment.ISO_8601, true).format("YYYY-MM-DD") : logic2[property];
                        feedBack = feedBack.replace(properties[i], "<mark>" + value + "</mark>");
                    }
                    var input = _.where(dlc.availableInputs, {
                        fieldName: logic.fieldName
                    });
                    feedBack = feedBack.replace(i18n.message("ff.label.logic.nlg.field.placeholder"), "<strong><em>" + input[0].label + "</em></strong>");
                    return input.length > 0 ? s + " " + feedBack : i18n.message("angular.ffEditLogicsDirective.message.invalidLogicRule");
                }
            }
        }
    };
    DesignLogicsController.$inject = [ "$scope", "contextualData", "ffDataFactory", "i18nService", "$timeout", "_", "$sanitize" ];
    angular.module("formFactory").directive("ffDesignLogics", [ "$log", "contextualData", "_", "$sanitize", editLogics ]);
})();

(function() {
    "use strict";
    var valueSelector = function($log, contextualData) {
        var directive = {
            restrict: "E",
            controller: ValueSelectorController,
            controllerAs: "vsc",
            bindToController: true,
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/logics/logicsCountrySelector.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr) {
            scope.vsc.countryObjects = angular.fromJson(attr.countryObjects.replace(/'/g, '"'));
            scope.vsc.activate();
        }
    };
    var ValueSelectorController = function($scope, ffLogicsService, i18n) {
        var vsc = this;
        vsc.selectedValues = [];
        vsc.selectedValue = null;
        vsc.availableValues = [];
        vsc.updateSelected = updateSelected;
        vsc.removeValue = removeValue;
        vsc.activate = activate;
        vsc.getLabel = i18n.message;
        function activate() {
            var step = $scope.$parent.selectedInput.stepIndex;
            if (!_.isUndefined(step)) {
                vsc.availableValues = vsc.countryObjects;
                var rv = ffLogicsService.getProperty($scope.ddc.input.logics, $scope.ddc.logicIndex, "requiredValue");
                var req;
                if (rv.replace) {
                    req = angular.fromJson(rv.replace(/'/g, '"'));
                } else {
                    req = rv;
                }
                for (var j in req) {
                    for (var k in vsc.availableValues) {
                        if (req[j] === vsc.availableValues[k].name) {
                            vsc.selectedValues.push(vsc.availableValues[k]);
                        }
                    }
                }
            }
            if (vsc.selectedValues.length > 0) {
                vsc.selectedValue = vsc.selectedValues[0];
            } else {
                vsc.selectedValue = vsc.availableValues[0];
            }
            vsc.activated = true;
            vsc.updateSelected();
        }
        function updateSelected() {
            if (vsc.activated) {
                if (!_.contains(vsc.selectedValues, vsc.selectedValue)) {
                    vsc.selectedValues.push(vsc.selectedValue);
                }
                updateRequiredValues();
                $scope.$emit("requiredValueChanged", {
                    isValid: vsc.selectedValues.length > 0,
                    "case": "multiple"
                });
            }
        }
        function removeValue(index) {
            if (vsc.selectedValues[index] === vsc.selectedValue) {
                if (vsc.selectedValues.length - 1 > 0) {
                    vsc.selectedValue = vsc.selectedValues.length - 1 !== index ? vsc.selectedValue = vsc.selectedValues[vsc.selectedValues.length - 1] : vsc.selectedValue = vsc.selectedValues[vsc.selectedValues.length - 2];
                } else {
                    vsc.selectedValue = "";
                }
            }
            vsc.selectedValues.splice(index, 1);
            updateRequiredValues();
            $scope.$emit("requiredValueChanged", {
                isValid: vsc.selectedValues.length > 0,
                "case": "multiple"
            });
            if (vsc.selectedValues.length < 1) {
                vsc.selectedValue = null;
            }
        }
        function updateRequiredValues() {
            var requiredValues = [];
            for (var i in vsc.selectedValues) {
                requiredValues.push(vsc.selectedValues[i].name);
            }
            ffLogicsService.setProperty($scope.ddc.input.logics, $scope.ddc.logicIndex, "requiredValue", requiredValues);
        }
    };
    ValueSelectorController.$inject = [ "$scope", "ffLogicsService", "i18nService" ];
    angular.module("formFactory").directive("ffLogicsCountrySelector", [ "$log", "contextualData", valueSelector ]);
})();

(function() {
    "use strict";
    var logicsDropDown = function($log, contextualData, ffLogicsService) {
        var directive = {
            restrict: "E",
            scope: {
                input: "=",
                form: "=",
                logicIndex: "@",
                selectedLogicType: "@",
                logicModule: "@",
                logicWizard: "=?"
            },
            controller: DropDownController,
            controllerAs: "ddc",
            bindToController: true,
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/logics/logicsDropDown.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr) {}
    };
    var DropDownController = function($scope, contextualData, ffLogicsService, i18n) {
        $scope.$on("targetChanged", function() {
            ddc.availableLogics = [];
            ffLogicsService.setProperty(ddc.input.logics, ddc.logicIndex, "fieldName", $scope.$parent.selectedInput.fieldName);
            ddc.getAvailableLogics();
            ddc.selectedLogicType = ddc.availableLogics[0].logicId;
            ddc.logicModule = ddc.availableLogics[0].logicModule;
            ddc.logicWizard = ddc.availableLogics[0].logicWizard;
            updateAvailableLogics(undefined);
            $scope.$parent.dlc.validateSteps();
        });
        $scope.$on("logicsCacheAvailable", function() {
            ddc.getAvailableLogics();
        });
        var ddc = this;
        $scope.$watch(function() {
            return ddc.selectedLogicType;
        }, function(newValue, oldValue) {
            ddc.oldSelectedLogicType = ffLogicsService.normalizeSelectedLogicsType(oldValue);
            ddc.selectedLogicType = ffLogicsService.normalizeSelectedLogicsType(ddc.selectedLogicType);
        });
        ddc.availableLogics = [];
        ddc.getAvailableLogics = getAvailableLogics;
        ddc.updateAvailableLogics = updateAvailableLogics;
        ddc.showCloseButtonIfNoView = showCloseButtonIfNoView;
        ddc.i18nMessageGetter = i18n.message;
        activate();
        function activate() {
            ddc.getAvailableLogics();
            if (ddc.availableLogics.length > 0) {
                if (ddc.selectedLogicType === "dummyLogic") {
                    ddc.selectedLogicType = ddc.availableLogics[0].logicId;
                    ddc.logicModule = ddc.availableLogics[0].logicModule;
                    ddc.logicWizard = ddc.availableLogics[0].logicWizard;
                    updateAvailableLogics(undefined);
                }
            }
            if (!_.isUndefined($scope.$parent.dlc.logicsCache) && $scope.$parent.dlc.logicsCache !== null) {
                if (ddc.logicModule === "") {
                    ddc.logicModule = ddc.input.logics[ddc.logicIndex].logicModule = $scope.$parent.dlc.logicsCache[ddc.input.logics[ddc.logicIndex].name.split("_")[0]].logicModule;
                }
            } else {
                var deregisterLogicsCacheWatch = $scope.$watch(function() {
                    return !_.isUndefined($scope.$parent.dlc.logicsCache) && $scope.$parent.dlc.logicsCache !== null;
                }, function(newValue) {
                    if (newValue) {
                        deregisterLogicsCacheWatch();
                        if (ddc.logicModule === "") {
                            ddc.logicModule = ddc.input.logics[ddc.logicIndex].logicModule = $scope.$parent.dlc.logicsCache[ddc.input.logics[ddc.logicIndex].name.split("_")[0]].logicModule;
                        }
                    }
                });
            }
        }
        function updateAvailableLogics(oldValue) {
            if (ddc.input.logics[oldValue] !== undefined) {
                delete ddc.input.logics[oldValue];
            }
            ddc.selectedLogicType = ddc.selectedLogicType === null ? ddc.oldSelectedLogicType : ddc.selectedLogicType;
            ffLogicsService.addFromCache(ddc.input.logics, $scope.$parent.dlc.logicsCache, ddc.logicIndex, ddc.selectedLogicType);
            ffLogicsService.setProperty(ddc.input.logics, ddc.logicIndex, "fieldName", $scope.$parent.selectedInput.fieldName);
            ddc.logicModule = ddc.input.logics[ddc.logicIndex].logicModule;
            ddc.logicWizard = !_.isUndefined(ddc.input.logics[ddc.logicIndex].wizard) ? ddc.input.logics[ddc.logicIndex].wizard : undefined;
        }
        function showCloseButtonIfNoView() {
            if (!$scope.$parent.dlc.logicsCache[ddc.selectedLogicType].noview !== undefined) {
                $scope.$emit("requiredValueChanged", {
                    isValid: true,
                    "case": "any"
                });
            }
        }
        function getAvailableLogics() {
            if (!_.isUndefined($scope.$parent.selectedInput)) {
                for (var i in $scope.$parent.selectedInput.supportedLogicTypes) {
                    for (var j in $scope.$parent.dlc.logicsCache) {
                        for (var k in $scope.$parent.dlc.logicsCache[j].types) {
                            if ($scope.$parent.selectedInput.supportedLogicTypes[i] === $scope.$parent.dlc.logicsCache[j].types[k]) {
                                ddc.availableLogics.push({
                                    logicId: j,
                                    logicName: ddc.i18nMessageGetter("ff.label.logic." + $scope.$parent.dlc.logicsCache[j].name),
                                    logicModule: $scope.$parent.dlc.logicsCache[j].logicModule,
                                    logicNodeType: $scope.$parent.dlc.logicsCache[j].nodeType,
                                    logicWizard: !_.isUndefined($scope.$parent.dlc.logicsCache[j].wizard) ? $scope.$parent.dlc.logicsCache[j].wizard : undefined
                                });
                            }
                        }
                    }
                }
            }
        }
    };
    DropDownController.$inject = [ "$scope", "contextualData", "ffLogicsService", "i18nService" ];
    angular.module("formFactory").directive("ffLogicsDropDown", [ "$log", "contextualData", "ffLogicsService", logicsDropDown ]);
})();

(function() {
    "use strict";
    var logicsService = function($log) {
        this.getProperty = function(logics, index, property) {
            return logics[index][property];
        };
        this.setProperty = function(logics, index, property, value) {
            logics[index][property] = value;
        };
        this.removeLogic = function(logics, index) {
            logics.splice(index, 1);
        };
        this.addFromCache = function(logics, cache, logicIndex, logicType) {
            logics[logicIndex] = angular.copy(cache[logicType]);
            logics[logicIndex].name = logicType + "_" + logicIndex;
        };
        this.normalizeSelectedLogicsType = function(type) {
            return type.split("_")[0];
        };
    };
    angular.module("formFactory").service("ffLogicsService", [ "$log", logicsService ]);
})();

(function() {
    "use strict";
    var valueSelector = function($log, contextualData) {
        var directive = {
            restrict: "E",
            controller: ValueSelectorController,
            controllerAs: "vsc",
            bindToController: true,
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/logics/logicsValueSelector.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr) {
            console.log("Linking");
        }
    };
    var ValueSelectorController = function($scope, ffLogicsService, i18n) {
        var vsc = this;
        vsc.selectedValues = [];
        vsc.selectedValue = null;
        vsc.availableValues = [];
        vsc.recognizedFields = [ "radios", "checkboxes", "options" ];
        vsc.updateSelected = updateSelected;
        vsc.removeValue = removeValue;
        vsc.getLabel = i18n.message;
        activate();
        function activate() {
            var input = $scope.$parent.selectedInput.inputIndex;
            var step = $scope.$parent.selectedInput.stepIndex;
            if (!_.isUndefined(step)) {
                for (var i in vsc.recognizedFields) {
                    if (vsc.recognizedFields[i] in $scope.ddc.form.steps[step].inputs[input]) {
                        vsc.availableValues = angular.copy($scope.ddc.form.steps[step].inputs[input][vsc.recognizedFields[i]]);
                        var req = ffLogicsService.getProperty($scope.ddc.input.logics, $scope.ddc.logicIndex, "requiredValue");
                        for (var j in req) {
                            for (var k in vsc.availableValues) {
                                if (req[j] === vsc.availableValues[k].key) {
                                    vsc.selectedValues.push(vsc.availableValues[k]);
                                }
                            }
                        }
                        break;
                    }
                }
            }
            if (vsc.selectedValues.length > 0) {
                vsc.selectedValue = vsc.selectedValues[0];
            } else {
                vsc.selectedValue = vsc.availableValues[0];
            }
            vsc.updateSelected();
        }
        function updateSelected() {
            if (!_.contains(vsc.selectedValues, vsc.selectedValue)) {
                vsc.selectedValues.push(vsc.selectedValue);
            }
            updateRequiredValues();
            $scope.$emit("requiredValueChanged", {
                isValid: vsc.selectedValues.length > 0,
                "case": "multiple"
            });
        }
        function removeValue(index) {
            if (vsc.selectedValues[index] === vsc.selectedValue) {
                if (vsc.selectedValues.length - 1 > 0) {
                    vsc.selectedValue = vsc.selectedValues.length - 1 !== index ? vsc.selectedValue = vsc.selectedValues[vsc.selectedValues.length - 1] : vsc.selectedValue = vsc.selectedValues[vsc.selectedValues.length - 2];
                } else {
                    vsc.selectedValue = "";
                }
            }
            vsc.selectedValues.splice(index, 1);
            updateRequiredValues();
            $scope.$emit("requiredValueChanged", {
                isValid: vsc.selectedValues.length > 0,
                "case": "multiple"
            });
            if (vsc.selectedValues.length < 1) {
                vsc.selectedValue = null;
            }
        }
        function updateRequiredValues() {
            var requiredValues = [];
            for (var i in vsc.selectedValues) {
                requiredValues.push(vsc.selectedValues[i].key);
            }
            ffLogicsService.setProperty($scope.ddc.input.logics, $scope.ddc.logicIndex, "requiredValue", requiredValues);
        }
    };
    ValueSelectorController.$inject = [ "$scope", "ffLogicsService", "i18nService" ];
    angular.module("formFactory").directive("ffLogicsValueSelector", [ "$log", "contextualData", valueSelector ]);
})();

(function() {
    "use strict";
    var wd = function(ffDataFactory, $compile, contextualData) {
        var directive = {
            restrict: "E",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr) {
            scope.$on("targetChanged", function() {
                el.html("");
            });
            scope.$watch(scope.ddc.selectedLogicType, function() {
                if (scope.ddc.selectedLogicType !== "dummyLogic" && !_.isUndefined(scope.ddc.logicModule) && !_.isEmpty(scope.ddc.logicModule)) {
                    if (_.isUndefined(scope.ddc.logicWizard) || scope.ddc.logicWizard === null) {
                        ffDataFactory.customRequest({
                            url: contextualData.context + "/cms/render/default/en/" + scope.ddc.logicModule + "/templates/contents/form-factory-logics/" + scope.ddc.selectedLogicType.split("_")[0] + ".designView.html.ajax",
                            method: "GET"
                        }).then(function(response) {
                            el.html(response);
                            $compile(el.contents())(scope);
                        });
                    } else {
                        var compiled = $compile(scope.ddc.logicWizard)(scope);
                        el.html(compiled);
                    }
                }
            });
        }
    };
    angular.module("formFactory").directive("ffLogicsWizardDisplay", [ "ffDataFactory", "$compile", "contextualData", wd ]);
})();

(function() {
    "use strict";
    var logicsWrap = function($log, contextualData, ffLogicsService, ffValidationService) {
        var directive = {
            restrict: "E",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr) {
            scope.invalidRequiredValue = false;
            scope.broadcastEvent = function() {
                scope.$broadcast("targetChanged", null);
            };
            scope.removeLogic = function(logics, index) {
                for (var i in scope.dlc.availableInputs) {
                    if (!_.isUndefined(scope.selectedInput) && scope.dlc.availableInputs[i].fieldName === scope.selectedInput.fieldName) {
                        delete scope.dlc.availableInputs[i].inUse;
                        scope.$emit("updateAvailableLogics", null);
                        break;
                    }
                }
                ffLogicsService.removeLogic(logics, index);
                delete scope.dlc.validationStatuses[scope.logic.fieldName];
                checkValidationStatuses();
            };
            scope.$on("requiredValueChanged", function(event, data) {
                scope.invalidRequiredValue = !data.isValid;
                scope.dlc.validationStatuses[scope.logic.fieldName] = data.isValid;
                updateValidationSatusesFields();
                checkValidationStatuses();
            });
            function updateValidationSatusesFields() {
                for (var i in scope.dlc.validationStatuses) {
                    var validField = false;
                    for (var j in scope.dlc.availableInputs) {
                        if (i === scope.dlc.availableInputs[j].fieldName) {
                            validField = true;
                        }
                    }
                    if (!validField || !scope.dlc.enableLogics) {
                        delete scope.dlc.validationStatuses[i];
                    }
                }
            }
            function checkValidationStatuses() {
                var hasInvalid = false;
                for (var i in scope.dlc.validationStatuses) {
                    if (scope.dlc.validationStatuses[i] === false) {
                        hasInvalid = true;
                    }
                }
                scope.$parent.$parent.fbc.containsInvalidLogics = hasInvalid;
            }
        }
    };
    angular.module("formFactory").directive("ffLogicsWrap", [ "$log", "contextualData", "ffLogicsService", "ffValidationWorker", logicsWrap ]);
})();

(function() {
    "use strict";
    var designValidation = function($compile, ffDataFactory, $log, contextualData) {
        var directive = {
            restrict: "E",
            scope: {
                input: "=",
                validationName: "@",
                validation: "=",
                inTranslateMode: "=",
                form: "=",
                currentStep: "=",
                broadcastedSyncFunc: "="
            },
            controller: ValidationController,
            controllerAs: "vc",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {
            scope.element = el;
            ctrls.afterSyncInit();
        }
    };
    var ValidationController = function($scope, $log, $compile, ffDataFactory, contextualData) {
        var vc = this;
        vc.areFieldsValid = areFieldsValid;
        vc.isFieldValid = isFieldValid;
        vc.afterSyncInit = afterSyncInit;
        vc.validatedFields = {};
        init();
        if ($scope.broadcastedSyncFunc) {
            afterSyncInit();
        } else {
            $scope.$on("validationsMergeCompleted", function() {
                $scope.validation = $scope.input.validations[$scope.validationName];
                afterSyncInit();
            });
        }
        function init() {
            setUpValidatedFields();
        }
        function afterSyncInit() {
            if ($scope.validation.validationModule !== undefined && $scope.element !== undefined) {
                if ($scope.validation.wizard === undefined) {
                    var url = contextualData.context + "/cms/render/default/en/" + $scope.validation.validationModule + "/templates/contents/form-factory-validations/" + $scope.validationName + ".designView.html.ajax";
                    ffDataFactory.getData(url).then(function success(data) {
                        var compiled = $compile(data)($scope);
                        $scope.element.html(compiled);
                    }, function error(data) {});
                } else {
                    var compiled = $compile($scope.validation.wizard)($scope);
                    $scope.element.html(compiled);
                }
            }
        }
        $scope.$on("validationOn", function(event, data) {
            $scope.$emit("checkValidationsValidity", {
                isValid: vc.areFieldsValid(),
                caseName: $scope.validationName
            });
        });
        $scope.$on("requiredValueChanged", function(event, data) {
            vc.validatedFields[data.fieldId] = data.isValid;
            if ($scope.input.validations[$scope.validationName].active) {
                $scope.$emit("checkValidationsValidity", {
                    isValid: vc.areFieldsValid(),
                    caseName: data.caseName
                });
            }
        });
        function setUpValidatedFields() {
            for (var i in $scope.input.validations[$scope.validationName].definitionOptions) {
                vc.validatedFields[$scope.input.validations[$scope.validationName].definitionOptions[i]] = true;
            }
        }
        function areFieldsValid() {
            for (var i in vc.validatedFields) {
                if (!vc.isFieldValid(i)) {
                    return false;
                }
            }
            return true;
        }
        function isFieldValid(fieldName) {
            return vc.validatedFields[fieldName];
        }
    };
    ValidationController.$inject = [ "$scope", "$log", "$compile", "ffDataFactory", "contextualData" ];
    angular.module("formFactory").directive("ffDesignValidation", [ "$compile", "ffDataFactory", "$log", "contextualData", designValidation ]);
})();

(function() {
    "use strict";
    var designValidations = function($compile, ffDataFactory, $log, contextualData) {
        var directive = {
            restrict: "E",
            scope: {
                input: "=",
                inTranslateMode: "=",
                form: "=",
                currentStep: "=",
                containsInvalidValidation: "="
            },
            controller: DesignValidationsController,
            controllerAs: "dvc",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/editinput/validations/designValidations.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ffController) {
            var accordion = el.find("#ffValidationsAccordion");
            accordion.on("show.bs.collapse", function(event) {
                var validationName = event.target.id;
                updatePanelsParam(validationName, "inProgress", true);
            }).on("shown.bs.collapse", function(event) {
                var validationName = event.target.id;
                updatePanelsParam(validationName, "inProgress", false);
                updatePanelsParam(validationName, "open", true);
            }).on("hide.bs.collapse", function(event) {
                var validationName = event.target.id;
                updatePanelsParam(validationName, "inProgress", true);
            }).on("hidden.bs.collapse", function(event) {
                var validationName = event.target.id;
                updatePanelsParam(validationName, "inProgress", false);
                updatePanelsParam(validationName, "open", false);
            });
            function updatePanelsParam(validationName, param, value) {
                scope.dvc.panels[validationName][param] = value;
            }
        }
    };
    var DesignValidationsController = function($scope, $log, contextualData, ffDataFactory, i18n, $timeout) {
        var dvc = this;
        dvc.validationsCache = null;
        dvc.validationStatuses = {};
        dvc.hasInvalidValidation = hasInvalidValidation;
        dvc.setInvalidFlag = setInvalidFlag;
        dvc.retrieveValidations = retrieveValidations;
        dvc.closeOrOpenPanel = closeOrOpenPanel;
        dvc.panels = {};
        dvc.i18nMessageGetter = i18n.message;
        dvc.broadcastedSyncFunc = false;
        activate();
        function activate() {
            retrieveValidations();
        }
        function retrieveValidations() {
            if (dvc.validationsCache === null) {
                ffDataFactory.customRequest({
                    url: contextualData.context + "/modules/formfactory/builder/definitionslist/validations/" + contextualData.siteIdentifier + "/en",
                    method: "GET"
                }).then(function(response) {
                    dvc.validationsCache = response;
                    initializeValidations();
                    console.log("input validation");
                    console.log($scope.input.validations);
                    buildPanelObject();
                    $scope.$broadcast("validationsMergeCompleted", null);
                    dvc.broadcastedSyncFunc = true;
                });
            }
        }
        function initializeValidations() {
            var validValidations = [];
            _.each($scope.input.validations, function(validation, validationName) {
                if (validation.active === undefined || validation.active === true) {
                    validValidations.push(validationName);
                    $scope.input.validations[validationName] = angular.merge({}, dvc.validationsCache[validationName], $scope.input.validations[validationName]);
                    _.each($scope.input.validations[validationName], function(field, fieldKey) {
                        if (!(fieldKey in dvc.validationsCache[validationName])) {
                            delete $scope.input.validations[validationName][fieldKey];
                        }
                    });
                    $scope.input.validations[validationName].active = true;
                }
            });
            var validationNames = [];
            var hasValidation = false;
            for (var i in $scope.input.supportedValidationTypes) {
                _.each(dvc.validationsCache, function(item, validationName) {
                    hasValidation = _.find(item.types, function(value) {
                        return value === $scope.input.supportedValidationTypes[i];
                    });
                    if (hasValidation) {
                        validationNames.push(validationName);
                    }
                });
            }
            validationNames = _.unique(validationNames);
            if (!("validations" in $scope.input)) {
                $scope.input.validations = {};
            } else {
                validValidations = _.difference(validValidations, validationNames);
                for (var i in validValidations) {
                    delete $scope.input.validations[validValidations[i]];
                }
            }
            for (var i in validationNames) {
                if (!(validationNames[i] in $scope.input.validations)) {
                    $scope.input.validations[validationNames[i]] = angular.copy(dvc.validationsCache[validationNames[i]]);
                    $scope.input.validations[validationNames[i]].active = false;
                }
            }
            for (var i in $scope.input.validations) {
                dvc.validationStatuses[i] = false;
            }
        }
        $scope.$on("checkValidationsValidity", function(event, data) {
            dvc.validationStatuses[data.caseName] = data.isValid;
            dvc.setInvalidFlag(hasInvalidValidation());
        });
        function setInvalidFlag(value) {
            $timeout(function() {
                $scope.$apply(function() {
                    $scope.containsInvalidValidation = value;
                });
            });
        }
        function hasInvalidValidation() {
            for (var i in dvc.validationStatuses) {
                if ($scope.input.validations[i].active && !dvc.validationStatuses[i]) {
                    return true;
                }
            }
            return false;
        }
        $scope.$on("toggleEvent", function(event, validationName) {
            if (!dvc.panels["panel_" + validationName].inProgress) {
                var newState = !$scope.input.validations[validationName].active;
                $scope.input.validations[validationName].active = newState;
                if (dvc.panels["panel_" + validationName].open && newState === false) {
                    dvc.closeOrOpenPanel(validationName);
                }
                if (!dvc.panels["panel_" + validationName].open && newState === true) {
                    dvc.closeOrOpenPanel(validationName);
                }
                $scope.$broadcast("switchToggle", {
                    validationName: validationName,
                    active: newState
                });
            }
        });
        function buildPanelObject() {
            for (var name in $scope.input.validations) {
                var v = $scope.input.validations[name];
                var ref = "panel_" + name;
                dvc.panels[ref] = {};
                dvc.panels[ref]["validationName"] = name;
                dvc.panels[ref]["inProgress"] = false;
                dvc.panels[ref]["active"] = v.active;
                dvc.panels[ref]["open"] = false;
            }
        }
        function closeOrOpenPanel(validationName) {
            angular.element("#link_" + validationName).trigger("click");
        }
    };
    DesignValidationsController.$inject = [ "$scope", "$log", "contextualData", "ffDataFactory", "i18nService", "$timeout" ];
    angular.module("formFactory").directive("ffDesignValidations", [ "$compile", "ffDataFactory", "$log", "contextualData", designValidations ]);
    angular.module("formFactory").directive("ffValidationSwitch", function() {
        return {
            restrict: "E",
            replace: true,
            template: function(element, attrs) {
                var html = "";
                html += "<span";
                html += ' class="switch' + (attrs.color ? " " + attrs.color : "") + '"';
                html += ' ng-class="{ checked:' + attrs.initState + ", disabled:" + attrs.disabled + ' }"';
                html += ">";
                html += "<small></small>";
                return html;
            },
            link: function(scope, el, attr, ctrls) {
                scope.$on("switchToggle", function(event, data) {
                    if (data.validationName === scope.validationName) {
                        data.active ? el.addClass("checked") : el.removeClass("checked");
                    }
                    scope.$parent.$broadcast("validationOn", {
                        validationName: scope.validationName
                    });
                });
                el.bind("click", function() {
                    scope.$emit("toggleEvent", attr.validationName);
                });
            }
        };
    });
})();

(function() {
    "use strict";
    var ffRenderInput = function($log, contextualData) {
        var directive = {
            restrict: "E",
            require: [ "^ffController" ],
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/sidePanel.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ffController) {}
    };
    angular.module("formFactory").directive("ffSidePanel", [ "$log", "contextualData", ffRenderInput ]);
})();

(function() {
    "use strict";
    var pickActionTabs = function($log, contextualData, $http, _) {
        var directive = {
            require: "^ffController",
            restrict: "E",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/pickaction/pickActionTabs.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, fbc) {
            if (_.isUndefined(fbc.actionsIconsCache)) {
                fbc.actionsIconsCache = {};
                _.forEach(fbc.actionsCache, function(action) {
                    var url = contextualData.context + "/modules/" + action.packageId + "/img/actionIcons/" + action.actionname + ".png";
                    fbc.actionsIconsCache[action.actionname] = "";
                    $http.get(url).then(function() {
                        fbc.actionsIconsCache[action.actionname] = url;
                    }, function() {
                        fbc.actionsIconsCache[action.actionname] = contextualData.context + "/modules/form-factory-core/img/actionIcons/default.png";
                    });
                });
            }
        }
    };
    angular.module("formFactory").directive("ffPickActionTabs", [ "$log", "contextualData", "$http", "_", pickActionTabs ]);
})();

(function() {
    "use strict";
    var showInputTabs = function($compile, $log, contextualData, $http, _) {
        var directive = {
            require: "^ffController",
            restrict: "E",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/builder/sidepanel/pickinput/pickInputTabs.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, fbc) {
            if (_.isUndefined(fbc.inputsIconsCache)) {
                fbc.inputsIconsCache = {};
                _.forEach(fbc.inputsCache, function(input) {
                    var url = contextualData.context + "/modules/" + input.packageId + "/img/inputIcons/" + input.name + ".png";
                    fbc.inputsIconsCache[input.name] = "";
                    $http.get(url).then(function() {
                        fbc.inputsIconsCache[input.name] = url;
                    }, function() {
                        fbc.inputsIconsCache[input.name] = contextualData.context + "/modules/form-factory-core/img/inputIcons/default.png";
                    });
                });
            }
        }
    };
    angular.module("formFactory").directive("ffPickInputTabs", [ "$compile", "$log", "contextualData", "$http", "_", showInputTabs ]);
})();

onmessage = function(e) {
    var hasInvalidSteps = false;
    var messages = {};
    if (e.data.form.steps.length < 1) {
        hasInvalidSteps = true;
        messages["noStep"] = {};
        messages["noStep"].errorInfo = "";
        messages["noStep"].validationMessage = "angular.ffFormBuilderDirective.message.noStep";
        messages["noStep"].toastId = "ns";
    }
    for (var i in e.data.form.steps) {
        if (e.data.form.steps[i].inputs.length < 1) {
            hasInvalidSteps = true;
            messages["emptyStep"] = {};
            messages["emptyStep"].errorInfo = e.data.form.steps[i].label !== "" ? "'" + e.data.form.steps[i].label + "'" : "'name is empty'";
            messages["emptyStep"].stepIndex = i;
            messages["emptyStep"].validationMessage = "angular.ffFormBuilderDirective.message.emptyStep";
            messages["emptyStep"].toastId = "es";
        }
        if (e.data.form.steps[i].label === "") {
            hasInvalidSteps = true;
            messages["emptyStepName"] = {};
            messages["emptyStepName"].errorInfo = i;
            messages["emptyStepName"].validationMessage = "angular.ffFormBuilderDirective.message.invalidStepName";
            messages["emptyStepName"].toastId = "esn";
        }
    }
    if (e.data.form.actions.length < 1) {
        hasInvalidSteps = true;
        messages["noAction"] = {};
        messages["noAction"].errorInfo = "action";
        messages["noAction"].validationMessage = "angular.ffFormBuilderDirective.message.missingAction";
        messages["noAction"].toastId = "na";
    }
    var invalidAction = false;
    var emailRegexp = /^[A-Z0-9._%+-]{1,64}@(?:[A-Z0-9-]{1,63}\.){1,125}[A-Z]{2,63}$/i;
    for (var i in e.data.form.actions) {
        if ("requiredFields" in e.data.form.actions[i] && e.data.form.actions[i].requiredFields.length > 0) {
            for (var j in e.data.form.actions[i].requiredFields) {
                var value = e.data.form.actions[i][e.data.form.actions[i].requiredFields[j].key];
                var isValid = true;
                switch (e.data.form.actions[i].requiredFields[j].value) {
                  case "number":
                    if (value === undefined || value === "" || value === null || isNaN(value)) {
                        isValid = false;
                    }
                    break;

                  case "positiveNumber":
                    if (value === undefined || value === "" || value === null || isNaN(value) || value < 0) {
                        isValid = false;
                    }
                    break;

                  case "email":
                    if (!emailRegexp.test(value)) {
                        isValid = false;
                    }
                    break;

                  case "any":
                  default:
                    if (value === undefined || value === "" || value === null) {
                        isValid = false;
                    }
                    break;
                }
                if (!isValid) {
                    invalidAction = true;
                    break;
                }
            }
            if (invalidAction) {
                hasInvalidSteps = true;
                messages["invalidActionFields"] = {};
                messages["invalidActionFields"].errorInfo = e.data.form.actions[i].label;
                messages["invalidActionFields"].validationMessage = "angular.ffFormBuilderDirective.message.invalidActionFields";
                messages["invalidActionFields"].toastId = "iaf";
                messages["invalidActionFields"].actionIndex = i;
                invalidAction = false;
            }
        }
    }
    hasInvalidSteps = hasInvalidSteps ? true : validateLogics(e.data.form, messages);
    postMessage({
        flag: "containsInvalidStep",
        flagValue: hasInvalidSteps,
        callbacks: [ {
            callback: "notifyUserOfInvalidStep",
            args: messages
        } ]
    });
    close();
};

var validateLogics = function(form, messages) {
    var hasInvalidSteps = false;
    var numberOfLogicsOnFirstStep = 0;
    for (var i in form.steps[0].inputs) {
        if (form.steps[0].inputs[i].logics !== undefined) {
            numberOfLogicsOnFirstStep++;
        }
    }
    if (numberOfLogicsOnFirstStep === form.steps[0].inputs.length) {
        hasInvalidSteps = true;
        messages["logicsFirstStepError"] = {};
        messages["logicsFirstStepError"].errorInfo = form.steps[0].label;
        messages["logicsFirstStepError"].validationMessage = "angular.ffFormBuilderDirective.message.firstStepLogicsError";
        messages["logicsFirstStepError"].toastId = "logicsFirstStepError";
        return hasInvalidSteps;
    }
    var inputMap = {};
    for (var i in form.steps) {
        for (var j in form.steps[i].inputs) {
            inputMap[form.steps[i].inputs[j].name] = {
                stepNumber: i,
                stepName: form.steps[i].label
            };
        }
    }
    for (var i in form.steps) {
        for (var j in form.steps[i].inputs) {
            if (form.steps[i].inputs[j].logics !== undefined) {
                for (var k in form.steps[i].inputs[j].logics) {
                    if (!(form.steps[i].inputs[j].logics[k].fieldName in inputMap)) {
                        hasInvalidSteps = true;
                        messages["logicsSourceMissing"] = {};
                        messages["logicsSourceMissing"].errorInfo = form.steps[i].inputs[j].name + "|" + form.steps[i].label + "|" + form.steps[i].inputs[j].logics[k].fieldName;
                        messages["logicsSourceMissing"].validationMessage = "angular.ffFormBuilderDirective.message.logicSourceMissing";
                        messages["logicsSourceMissing"].toastId = "logicsSourceMissing";
                        return hasInvalidSteps;
                    } else if (parseInt(inputMap[form.steps[i].inputs[j].logics[k].fieldName].stepNumber) > i) {
                        hasInvalidSteps = true;
                        messages["logicsUnreachableSource"] = {};
                        messages["logicsUnreachableSource"].errorInfo = form.steps[i].inputs[j].name + "|" + form.steps[i].label + "|" + form.steps[i].inputs[j].logics[k].fieldName + "|" + inputMap[form.steps[i].inputs[j].logics[k].fieldName].stepName;
                        messages["logicsUnreachableSource"].validationMessage = "angular.ffFormBuilderDirective.message.logicSourceNotReachable";
                        messages["logicsUnreachableSource"].toastId = "logicsUnreachableSource";
                        return hasInvalidSteps;
                    }
                }
            }
        }
    }
    hasInvalidSteps = hasInvalidSteps ? true : logicsCycleTest(form, inputMap, messages);
    hasInvalidSteps = hasInvalidSteps ? true : emptyLogicsTest(form, messages);
    return hasInvalidSteps;
};

var logicsCycleTest = function(form, inputMap, messages) {
    var hasInvalidSteps = false;
    var sourceTargetMap = [];
    for (var i in form.steps) {
        var step = {
            targetSourcePairs: [],
            stepName: form.steps[i].label
        };
        for (var j in form.steps[i].inputs) {
            if (form.steps[i].inputs[j].logics !== undefined) {
                for (var k in form.steps[i].inputs[j].logics) {
                    if (parseInt(inputMap[form.steps[i].inputs[j].logics[k].fieldName].stepNumber) == i) {
                        step.targetSourcePairs.push({
                            target: form.steps[i].inputs[j].name,
                            source: form.steps[i].inputs[j].logics[k].fieldName
                        });
                    }
                }
            }
        }
        sourceTargetMap.push(step);
    }
    for (var step in sourceTargetMap) {
        for (var l1 in sourceTargetMap[step].targetSourcePairs) {
            for (var l2 in sourceTargetMap[step].targetSourcePairs) {
                if (l1 != l2) {
                    if (sourceTargetMap[step].targetSourcePairs[l2].target === sourceTargetMap[step].targetSourcePairs[l1].source && sourceTargetMap[step].targetSourcePairs[l2].source === sourceTargetMap[step].targetSourcePairs[l1].target) {
                        hasInvalidSteps = true;
                        messages["logicsCycleDetected"] = {};
                        messages["logicsCycleDetected"].errorInfo = sourceTargetMap[step].stepName + "|" + sourceTargetMap[step].targetSourcePairs[l1].target + "|" + sourceTargetMap[step].targetSourcePairs[l1].source;
                        messages["logicsCycleDetected"].validationMessage = "angular.ffFormBuilderDirective.message.cycleDetected";
                        messages["logicsCycleDetected"].toastId = "logicsCycleDetected";
                        return hasInvalidSteps;
                    }
                }
            }
        }
    }
    return hasInvalidSteps;
};

var emptyLogicsTest = function(form, messages) {
    var hasInvalidSteps = false;
    for (var i in form.steps) {
        for (var j in form.steps[i].inputs) {
            if (form.steps[i].inputs[j].logics !== undefined && form.steps[i].inputs[j].logics.length < 1) {
                hasInvalidSteps = true;
                messages["emptyLogics"] = {};
                messages["emptyLogics"].errorInfo = form.steps[i].label + "|" + form.steps[i].inputs[j].name;
                messages["emptyLogics"].validationMessage = "angular.ffFormBuilderDirective.message.logicsEmpty";
                messages["emptyLogics"].toastId = "emptyLogics";
                return hasInvalidSteps;
            }
        }
    }
    return hasInvalidSteps;
};

(function() {
    "use strict";
    var formNameValidator = function($log, ffCommonUseFactory, contextualData, ffDataFactory, $q, i18n) {
        var directive = {
            restrict: "A",
            require: [ "ngModel" ],
            scope: {
                invalidFlag: "=?",
                errorMessage: "=",
                formIdentifier: "="
            },
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {
            var model = ctrls[0];
            var regexp = new RegExp(/^[\'\"~+=!*&%#@,:;_\.\^\$\?<\>\|\/\\\[\]\(\)\}\{\-0-9]|[\'\"~+=!*&%#@,:;_\.\^\$\?<\>\|\/\\\[\]\(\)\}\{\-]$|(?=[`])/);
            model.$asyncValidators.formName = function(modelValue, viewValue) {
                var def = $q.defer();
                scope.invalidFlag = true;
                if (regexp.test(viewValue) || model.$isEmpty(viewValue)) {
                    scope.errorMessage = setMessage(model.$isEmpty(viewValue) ? "empty" : "invalid");
                    def.reject();
                } else {
                    var data = {
                        formName: viewValue,
                        siteIdentifier: contextualData.siteIdentifier
                    };
                    if (!model.$isEmpty(scope.formIdentifier)) {
                        data.formIdentifier = scope.formIdentifier;
                    }
                    ffDataFactory.customRequest({
                        url: contextualData.context + "/modules/formfactory/builder/checkformnameavailability/" + contextualData.locale,
                        method: "POST",
                        data: data
                    }).then(function(response) {
                        if (response.available) {
                            scope.invalidFlag = false;
                            if (model.$isEmpty(scope.formIdentifier)) {
                                if (scope.$parent.fbc !== undefined) {
                                    scope.$parent.fbc.form.expectedFormName = response.expectedFormName;
                                } else if (scope.$parent.fc !== undefined) {
                                    scope.$parent.fc.expectedFormName = response.expectedFormName;
                                }
                            }
                            def.resolve();
                        } else {
                            scope.errorMessage = setMessage("exists");
                            scope.invalidFlag = true;
                            def.reject();
                        }
                    }, function(response) {
                        scope.errorMessage = setMessage("invalid");
                        scope.invalidFlag = true;
                        def.reject();
                    });
                }
                return def.promise;
            };
        }
        function setMessage(flag) {
            if (flag === "empty") {
                return i18n.message("angular.ffMetaDataTabDirective.label.emptyFormName");
            } else if (flag === "invalid") {
                return i18n.message("angular.ffMetaDataTabDirective.label.invalidCharacters");
            } else if (flag === "exists") {
                return i18n.message("fcnt_createEntry.error.formNameAlreadyExists");
            }
        }
    };
    angular.module("formFactory").directive("ffFormNameValidator", [ "$log", "ffCommonUseFactory", "contextualData", "ffDataFactory", "$q", "i18nService", formNameValidator ]);
})();

(function() {
    var DownloadZipFactory = function($log, $resource, contextualData) {
        return $resource(null, null, {
            download: {
                url: contextualData.context + "/modules/formfactory/builder/exportforms/" + contextualData.locale,
                method: "POST",
                headers: {
                    accept: "application/zip"
                },
                responseType: "arraybuffer",
                cache: false,
                transformResponse: function(data, headers) {
                    var zip = null;
                    if (data) {
                        zip = new Blob([ data ], {
                            type: "application/zip"
                        });
                    }
                    var fileName = getFileNameFromHeader(headers("content-disposition"));
                    var result = {
                        blob: zip,
                        fileName: fileName
                    };
                    return {
                        response: result
                    };
                }
            }
        });
        function getFileNameFromHeader(header) {
            if (!header) {
                return null;
            }
            var result = header.split(";")[1].trim().split("=")[1];
            return result.replace(/"/g, "");
        }
    };
    DownloadZipFactory.$inject = [ "$log", "$resource", "contextualData" ];
    angular.module("formFactory.downloadZipFactory", []).factory("ffDownloadZipFactory", DownloadZipFactory);
})();

angular.module("formFactory").config(function(contextualData, $stateProvider, $urlRouterProvider) {
    $urlRouterProvider.otherwise(function($injector, $location) {
        var $state = $injector.get("$state");
        if ($location.$$state == null) {
            $state.go("library", {}, {
                location: false
            });
        }
    });
    $stateProvider.state("library", {
        url: "/library",
        templateUrl: contextualData.urlBaseSiteSettingsTemplates + "library.html.ajax"
    }).state("builder", {
        url: "/builder",
        template: "<ff-controller>",
        params: {
            formIdentifier: null,
            form: null,
            options: {}
        }
    }).state("translator", {
        url: "/translator",
        template: "<ff-form-translator>",
        params: {
            formIdentifier: null
        }
    });
}, [ "contextualData", "$stateProvider", "$urlRouterProvider" ]);

(function() {
    "use strict";
    var SpinnerFactory = function($log) {
        var spinners = {};
        return {
            register: function(data) {
                spinners[data.id] = data;
            },
            show: function(id) {
                spinners[id].show();
            },
            hide: function(id) {
                spinners[id].hide();
            }
        };
    };
    angular.module("formFactory").factory("ffSpinnerService", [ "$log", SpinnerFactory ]);
    var SpinnerController = function($scope, spinnerService) {
        var sc = this;
        sc.show = false;
        sc.showSpinner = function() {
            sc.show = true;
        };
        sc.hideSpinner = function() {
            sc.show = false;
        };
        var data = {
            id: sc.id,
            show: sc.showSpinner,
            hide: sc.hideSpinner
        };
        spinnerService.register(data);
    };
    SpinnerController.$inject = [ "$scope", "ffSpinnerService" ];
    var spinnerDirective = function($log, spinnerService) {
        var directive = {
            restrict: "E",
            scope: {
                id: "@",
                size: "@?",
                backsplash: "=?",
                orientation: "@?"
            },
            controller: SpinnerController,
            controllerAs: "sc",
            bindToController: true,
            template: '<div class="ffSpinnerBacksplash" ng-show="sc.show && sc.backsplash"></div>' + '<div class="ffSpinner{{sc.orientation}}" ng-show="sc.show">' + '<i class="fa fa-spinner fa-spin {{sc.size}}"></i>' + "</div>",
            link: linkFunction
        };
        return directive;
        function linkFunction(scope, el, attr, ctrls) {}
    };
    angular.module("formFactory").directive("ffSpinner", [ "$log", "ffSpinnerService", spinnerDirective ]);
})();

(function() {
    var UpdaterFactory = function($log) {
        return {
            getFormListUpdated: getFormListUpdated,
            setFormListUpdated: setFormListUpdated
        };
        var isFormListedUpdated = false;
        function getFormListUpdated() {
            return isFormListedUpdated;
        }
        function setFormListUpdated(value) {
            isFormListedUpdated = value;
        }
    };
    UpdaterFactory.$inject = [ "$log" ];
    angular.module("formFactory.updaterFactory", []).factory("ffUpdaterFactory", UpdaterFactory);
})();

(function() {
    var DuplicateFormController = function($scope, $log, $http, $state, contextualData, ffCommonUseFactory) {
        var df = this;
        df.isFormNameAvailable = false;
        df.formName = "";
        df.duplicateForm = duplicateForm;
        df.checkFormAvailability = checkFormAvailability;
        df.formIdentifier = $scope.formIdentifier;
        function duplicateForm() {
            if (df.formName != "" && df.isFormNameAvailable) {
                $http.post(contextualData.context + "/modules/formfactory/builder/duplicateform/" + df.formIdentifier + "/" + contextualData.locale, {
                    formName: df.formName,
                    siteIdentifier: contextualData.siteIdentifier
                }).then(function(response) {
                    if ("success" in response.data) {
                        df.formName = "";
                        df.isFormNameAvailable = false;
                    }
                });
            }
        }
        function checkFormAvailability() {
            ffCommonUseFactory.checkIfNameExists.call(df, df.formName, "isFormNameAvailable", df.formIdentifier);
        }
    };
    DuplicateFormController.$inject = [ "$scope", "$log", "$http", "$state", "contextualData", "ffCommonUseFactory" ];
    var duplicateFormDirective = function($log, contextualData) {
        var directive = {
            restrict: "E",
            scope: {
                formIdentifier: "="
            },
            controller: DuplicateFormController,
            controllerAs: "df",
            link: postLinkFunc,
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/library/duplicate/duplicateForm.html"
        };
        return directive;
        function postLinkFunc(scope, el, attr, ffLibraryCtrl) {}
    };
    angular.module("formFactory").directive("ffDuplicateForm", [ "$log", "contextualData", duplicateFormDirective ]);
})();

(function() {
    var ffExportDirective = function($log) {
        var directive = {
            restrict: "A",
            controller: ExportController,
            controllerAs: "ec",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {}
    };
    angular.module("formFactory").directive("ffExport", [ "$log", ffExportDirective ]);
    var ExportController = function($scope, $log, ffDownloadZipFactory) {
        var ec = this;
        ec.exportForms = exportForms;
        ec.exportListChanged = exportListChanged;
        ec.exportAvailable = false;
        ec._isSafari = function() {
            return navigator.userAgent.indexOf("Safari") !== -1 && navigator.userAgent.indexOf("Chrome") === -1 && navigator.userAgent.indexOf("Opera") === -1;
        };
        function exportListChanged() {
            ec.exportAvailable = !_.isEmpty($scope.flc.exportChoices);
        }
        function exportForms() {
            if (!_.isEmpty($scope.flc.exportChoices)) {
                var data = {
                    formIdentifiers: $scope.flc.exportChoices
                };
                return ffDownloadZipFactory.download(data).$promise.then(function(data) {
                    saveAs(data.response.blob, data.response.fileName);
                    $scope.flc.exportChoices = [];
                });
            }
        }
    };
    ExportController.$inject = [ "$scope", "$log", "ffDownloadZipFactory" ];
})();

(function() {
    var formCreation = function($log, contextualData) {
        var directive = {
            restrict: "E",
            controller: formCreationController,
            controllerAs: "fc",
            link: linkFunc,
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/library/formcreation/formCreation.html"
        };
        return directive;
        function linkFunc(scope, el, attr, ffLibraryCtrl) {}
    };
    var formCreationController = function($scope, $log, $state, ffDataFactory, contextualData, i18n) {
        var fc = this;
        fc.createForm = getFormModel;
        fc.invalidFlag = false;
        fc.formInvalidMessage = "";
        fc.i18nMessageGetter = i18n.message;
        function getFormModel() {
            ffDataFactory.getData(contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/library/formcreation/formModel.json").then(function(response) {
                response.buildingLang = contextualData.locale;
                response.formName = fc.formName;
                response.displayableName = fc.formName;
                response.expectedFormName = fc.expectedFormName;
                $state.go("builder", {
                    form: response,
                    options: {
                        doNotAddStep: true
                    }
                });
            });
        }
    };
    formCreationController.$inject = [ "$scope", "$log", "$state", "ffDataFactory", "contextualData", "i18nService" ];
    angular.module("formFactory").directive("ffFormCreation", [ "$log", "contextualData", formCreation ]);
})();

(function() {
    var MenuController = function($scope, contextualData, $log) {
        var mc = this;
        mc.switchValue = switchValue;
        mc.switchValueDropDown = switchValueDropDown;
        mc.switchIfMarkedForRemoval = switchIfMarkedForRemoval;
        function switchValue(item) {
            if (item.markedForRemoval) {
                return "markedForRemoval";
            }
            if (item.hasPublicationWorkflow) {
                return "hasWorkflow";
            }
            if (item.buildLanguage === contextualData.language) {
                return "modify";
            }
            return "translate";
        }
        function switchIfMarkedForRemoval(item) {
            if (!item.published) {
                return "notpublished";
            }
            return "workflow";
        }
        function switchValueDropDown(item) {
            if (item.markedForRemoval) {
                return "markedForRemoval";
            }
            if (item.hasAllDefaultPermission) {
                return "hasAllDefault";
            }
        }
    };
    MenuController.$inject = [ "$scope", "contextualData", "$log" ];
    var actionMenu = function($log, contextualData) {
        var directive = {
            restrict: "E",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/library/formlist/actionMenu.html",
            link: linkFunction,
            controller: MenuController,
            controllerAs: "mc",
            bindToController: true
        };
        return directive;
        function linkFunction(scope, el, attr) {}
    };
    angular.module("formFactory").directive("ffActionMenu", [ "$log", "contextualData", actionMenu ]);
})();

(function() {
    var FormListController = function($scope, ffDataFactory, contextualData, $log, $state, $uibModal, i18nService, ffUpdaterFactory, DTOptionsBuilder, DTColumnDefBuilder, spinner, $window) {
        var flc = this;
        flc.getImageType = getImageType;
        flc.imageType = "";
        flc.formToCopyId = null;
        flc.rbPublish = "";
        flc.exportChoices = [];
        flc.dtOptions = DTOptionsBuilder.newOptions();
        var locale = contextualData.locale in contextualData.supportedLocales ? contextualData.locale : "en";
        flc.dtOptions.withOption("language", {
            url: contextualData.context + "/modules/form-factory-core/javascript/dtlanguages/datatable.language_" + locale + ".json"
        });
        flc.dtOptions.withBootstrap();
        flc.dtColumnDefs = [ DTColumnDefBuilder.newColumnDef(0).withOption("width", "5%"), DTColumnDefBuilder.newColumnDef(1).withOption("width", "5%"), DTColumnDefBuilder.newColumnDef(2).withOption("width", "15%"), DTColumnDefBuilder.newColumnDef(3).withOption("width", "40%"), DTColumnDefBuilder.newColumnDef(4).withOption("width", "15%").renderWith(function render(data, type, row, meta) {
            if (type === "display") {
                return moment(flc.formlist[meta.row].modified, [ moment.ISO_8601 ], true).calendar();
            } else {
                return moment(flc.formlist[meta.row].modified, [ moment.ISO_8601 ], true).format("x");
            }
        }), DTColumnDefBuilder.newColumnDef(5).withOption("width", "20%") ];
        flc.i18nMessageGetter = i18nService.message;
        flc.updateFormList = updateFormList;
        activate();
        $scope.$watch(function() {
            return ffUpdaterFactory.getFormListUpdated();
        }, function(newValue) {
            if (newValue) {
                updateFormList();
                ffUpdaterFactory.setFormListUpdated(false);
            }
        });
        function activate() {
            spinner.show("formListSpinner");
            return getData().then(function() {
                flc.activated = true;
                spinner.hide("formListSpinner");
            });
        }
        function getImageType(item) {
            if (item.hasPublicationWorkflow) {
                return "publicationwf";
            }
            if (!item.published) {
                return "notpublished";
            }
            if (item.needPublication) {
                return "needpublication";
            }
            return "default";
        }
        function getData() {
            return ffDataFactory.getData(contextualData.context + "/modules/formfactory/builder/formslist/" + contextualData.siteIdentifier + "/" + contextualData.language).then(function(data) {
                flc.formlist = data.formlist;
                flc.context = contextualData.context;
                flc.publishForm = publishForm;
                flc.deleteForm = deleteForm;
                flc.undeleteForm = undeleteForm;
                flc.modifyForm = modifyForm;
                flc.editFormMetaData = editFormMetaData;
                flc.translateForm = translateForm;
                flc.startWorkflow = startWorkflow;
                flc.useAsTemplate = useAsTemplate;
                flc.setRbPublish = setRbPublish;
                flc.createCustomLabelOne = createCustomLabelOne;
                flc.createCustomLabelTwo = createCustomLabelTwo;
                flc.getTitleFromRB = getTitleFromRB;
            });
        }
        function updateFormList() {
            spinner.show("formListSpinner");
            ffDataFactory.getData(contextualData.context + "/modules/formfactory/builder/formslist/" + contextualData.siteIdentifier + "/" + contextualData.language).then(function(data) {
                flc.formlist = data.formlist;
                spinner.hide("formListSpinner");
            });
        }
        function createCustomLabelOne(item, abbr) {
            if (item.markedForRemoval) {
                flc.setRbPublish("ff.label.delete");
            } else {
                flc.setRbPublish("ff.label.startWorkflow");
            }
            var string = flc.rbPublish + " - " + item.availableWorkflows[0];
            if (abbr) {
                return abbreviate(string, 15, 40, "...");
            }
            return string;
        }
        function createCustomLabelTwo(item, abbr) {
            if (item.markedForRemoval) {
                flc.setRbPublish("ff.label.deletePermanently");
            } else {
                flc.setRbPublish("ff.label.publish");
            }
            var label = i18nService.message("ff.label.bypassWorkflow") + " - " + flc.rbPublish;
            if (abbr) {
                return abbreviate(label, 15, 40, "...");
            }
            return label;
        }
        function getTitleFromRB(key) {
            return i18nService.message(key);
        }
        function setRbPublish(key) {
            flc.rbPublish = i18nService.message(key);
        }
        function publishForm(currentFormIdentifier) {
            var data = {
                url: contextualData.context + "/modules/formfactory/builder/publishform/" + currentFormIdentifier + "/" + contextualData.language,
                method: "PUT"
            };
            spinner.show("formListSpinner");
            ffDataFactory.customRequest(data).then(function successCallback() {
                spinner.hide("formListSpinner");
                getData();
            }, function errorCallback() {
                spinner.hide("formListSpinner");
                $log.debug("Could not publish form");
            });
        }
        function undeleteForm(formIdentifier) {
            spinner.show("formListSpinner");
            ffDataFactory.customRequest({
                url: contextualData.context + "/modules/formfactory/builder/undelete/" + formIdentifier + "/" + contextualData.language,
                method: "PUT"
            }).then(function(result) {
                spinner.hide("formListSpinner");
                if (result.error) {
                    $log.error(result.error);
                } else {
                    getData();
                }
            });
        }
        function deleteForm(item) {
            var request;
            if (item.markedForRemoval) {
                request = {
                    url: contextualData.context + "/modules/formfactory/builder/delete/" + item.jcrId + "/" + contextualData.language,
                    method: "DELETE"
                };
            } else {
                request = {
                    url: contextualData.context + "/modules/formfactory/builder/markfordeletion/" + item.jcrId + "/" + contextualData.language,
                    method: "PUT"
                };
            }
            spinner.show("formListSpinner");
            ffDataFactory.customRequest(request).then(function(result) {
                spinner.hide("formListSpinner");
                if (result.error) {
                    $log.error(result.error);
                } else {
                    getData();
                }
            });
        }
        function modifyForm(currentFormIdentifier) {
            $state.go("builder", {
                formIdentifier: currentFormIdentifier
            });
        }
        function editFormMetaData(currentFormIdentifier) {
            $state.go("builder", {
                formIdentifier: currentFormIdentifier,
                options: {
                    openEditMetaDataPanel: true
                }
            });
        }
        function translateForm(currentFormIdentifier) {
            $state.go("builder", {
                formIdentifier: currentFormIdentifier,
                options: {
                    translate: true
                }
            });
        }
        function startWorkflow(formId) {
            var data = {
                url: contextualData.context + "/modules/formfactory/builder/workflowonform/" + formId + "/" + contextualData.language,
                method: "PUT"
            };
            spinner.show("formListSpinner");
            ffDataFactory.customRequest(data).then(function successCallback(data) {
                spinner.hide("formListSpinner");
                getData();
            }, function errorCallback(data) {
                spinner.hide("formListSpinner");
                $log.error(data.error);
            });
        }
        function useAsTemplate(formId, template) {
            flc.formToCopyId = formId;
            $uibModal.open({
                templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/library/formlist/" + template,
                controller: ModalController,
                controllerAs: "modalctrl",
                bindToController: true,
                scope: $scope
            });
        }
        function abbreviate(str, lower, upper, ending) {
            if (str.trim() === "") {
                return null;
            }
            if (lower > str.length) {
                lower = str.length;
            }
            if (upper == -1 || upper > str.length) {
                upper = str.length;
            }
            if (upper < lower) {
                upper = lower;
            }
            var result = "";
            var index = str.indexOf(" ", lower);
            if (index === -1) {
                result += str.substring(0, upper);
                if (upper != str.length) {
                    result += ending;
                }
            } else if (index > upper) {
                result += str.substring(0, upper);
                result += ending;
            } else {
                result += str.substring(0, index);
                result += ending;
            }
            return result;
        }
        flc.createTestForm = createTestForm;
        function createTestForm(obj) {
            ffDataFactory.customRequest({
                url: contextualData.context + "/modules/formfactory/builder/form/" + contextualData.language + "/targetsite/" + contextualData.siteIdentifier,
                method: "POST",
                data: obj
            }).then(function(response) {
                $window.location.reload();
            });
        }
    };
    FormListController.$inject = [ "$scope", "ffDataFactory", "contextualData", "$log", "$state", "$uibModal", "i18nService", "ffUpdaterFactory", "DTOptionsBuilder", "DTColumnDefBuilder", "ffSpinnerService", "$window" ];
    var formListDirective = function($log, contextualData) {
        var directive = {
            restrict: "E",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/library/formlist/formList.html",
            controller: FormListController,
            controllerAs: "flc",
            bindToController: true,
            link: linkFunction
        };
        return directive;
        function linkFunction(scope, el, attr) {}
    };
    var ModalController = function($scope, $state, ffDataFactory, ffCommonUseFactory, contextualData, $uibModalInstance, $log) {
        var modalctrl = this;
        modalctrl.newName = null;
        modalctrl.startTemplate = startTemplate;
        modalctrl.duplicateAsTemplate = duplicateAsTemplate;
        modalctrl.checkFormAvailability = checkFormAvailability;
        modalctrl.closeModal = closeModal;
        modalctrl.formInvalidMessage = "";
        function startTemplate() {
            var data = {
                url: contextualData.context + "/modules/formfactory/builder/copyform/" + $scope.flc.formToCopyId + "/" + contextualData.language + "/" + modalctrl.newName,
                method: "post"
            };
            ffDataFactory.customRequest(data).then(function successCallback(data) {
                modalctrl.newName = null;
                $state.go("builder", {
                    form: data,
                    options: {
                        doNotAddStep: true
                    }
                });
            }, function errorCallback(data) {
                $log.error(data.error);
            });
        }
        function duplicateAsTemplate() {
            var data = {
                url: contextualData.context + "/modules/formfactory/builder/duplicateform/" + $scope.flc.formToCopyId + "/" + contextualData.language,
                method: "post",
                data: {
                    formName: modalctrl.newName,
                    siteIdentifier: contextualData.siteIdentifier
                }
            };
            ffDataFactory.customRequest(data).then(function successCallback(data) {
                modalctrl.newName = null;
                modalctrl.isFormNameAvailable = false;
                $state.go("builder", {
                    form: data,
                    options: {
                        doNotAddStep: true
                    }
                });
            }, function errorCallback(data) {
                $log.error(data.error);
            });
        }
        function closeModal() {
            $uibModalInstance.dismiss("cancel");
        }
        function checkFormAvailability() {
            ffCommonUseFactory.checkIfNameExists.call(modalctrl, modalctrl.newName, "isFormNameAvailable");
        }
    };
    ModalController.$inject = [ "$scope", "$state", "ffDataFactory", "ffCommonUseFactory", "contextualData", "$uibModalInstance", "$log" ];
    angular.module("formFactory").directive("ffFormList", [ "$log", "contextualData", formListDirective ]);
})();

(function() {
    var importFormDisplayDirective = function($log, contextualData) {
        var directive = {
            restrict: "E",
            controller: ImportFormController,
            controllerAs: "ifc",
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/formbuilder/library/import/importFormDisplay.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrls) {}
    };
    angular.module("formFactory").directive("ffImportFormDisplay", [ "$log", "contextualData", importFormDisplayDirective ]);
    var importFormDirective = function($log) {
        var directive = {
            restrict: "A",
            controller: ImportFormController,
            controllerAs: "ifc",
            bindToController: true,
            require: [ "^ngModel" ],
            link: postLinkFunction
        };
        return directive;
        function postLinkFunction(scope, el, attr, ctrls) {
            var ngModelCtrl = ctrls[0];
            scope.ifc.el = el;
            scope.ifc.model = ngModelCtrl;
            var $scope = scope;
            var onChange = function(event, data) {
                if (!_.isUndefined(data) && "reset" in data && data["reset"]) {
                    el.val(null);
                } else {
                    var isValid = event.target.files.length > 0;
                    if (isValid) {
                        var type = event.target.files[0].name.substring(event.target.files[0].name.lastIndexOf(".") + 1).toLowerCase();
                        if (type != "zip") {
                            isValid = false;
                        }
                    }
                    if (isValid) {
                        ngModelCtrl.$setViewValue(event.target.files, "change");
                    } else {
                        el.val(null);
                    }
                    $scope.$apply(function() {
                        $scope.ifc.fileAvailable = isValid;
                    });
                }
            };
            el.bind("change", onChange);
        }
    };
    angular.module("formFactory").directive("ffImportForm", [ "$log", importFormDirective ]);
    var ImportFormController = function($scope, $log, contextualData, ffDataFactory, ffUpdaterFactory, i18n, toaster, spinner) {
        var ifc = this;
        ifc.fileUpload = fileUpload;
        ifc.files = "";
        ifc.fileAvailable = false;
        ifc.el = null;
        ifc.model = null;
        ifc.i18nMessageGetter = i18n.message;
        function fileUpload() {
            spinner.show("importSpinner");
            if (ifc.files.length > 0) {
                _.each(ifc.files, function(file) {
                    var request = {
                        url: contextualData.context + "/modules/formfactory/builder/importforms/" + contextualData.siteIdentifier + "/" + contextualData.locale,
                        method: "POST",
                        headers: {
                            "Content-Type": "application/octet-stream"
                        },
                        data: file
                    };
                    ffDataFactory.customRequest(request).then(function(success) {
                        ffUpdaterFactory.setFormListUpdated(true);
                        $scope.ifc.files = "";
                        ifc.model.$setViewValue(null);
                        ifc.el.val(null);
                        ifc.fileAvailable = false;
                        ifc.el.trigger("change", {
                            reset: true
                        });
                        spinner.hide("importSpinner");
                        toaster.pop({
                            type: "success",
                            title: i18n.message("angular.ffImportFormDisplayDirective.label.success"),
                            toastId: "importSuccess"
                        });
                    }, function(error) {
                        spinner.hide("importSpinner");
                        toaster.pop({
                            type: "error",
                            title: i18n.message("angular.ffImportFormDisplayDirective.label.fail"),
                            body: i18n.format("angular.ffImportFormDisplayDirective.message.fail", error.statusText)
                        });
                    });
                });
            }
        }
    };
    ImportFormController.$inject = [ "$scope", "$log", "contextualData", "ffDataFactory", "ffUpdaterFactory", "i18nService", "toaster", "ffSpinnerService" ];
})();

(function() {
    var CommonUseFactory = function($http, contextualData, $log) {
        return {
            checkIfNameExists: checkFormAvailability,
            logicResolver: logicResolver,
            valueResolver: valueResolver,
            placeholderResolver: placeholderResolver,
            inputsizeResolver: inputsizeResolver,
            nameResolver: nameResolver,
            labelResolver: labelResolver,
            parseDate: parseDate,
            createMoment: createMoment
        };
        function checkFormAvailability(newName, flag, formIdentifier) {
            var self = this;
            if (!_.isUndefined(newName) && newName != "") {
                var data = {
                    formName: newName,
                    siteIdentifier: contextualData.siteIdentifier
                };
                if (!_.isUndefined(formIdentifier)) {
                    data.formIdentifier = formIdentifier;
                }
                $http({
                    url: contextualData.context + "/modules/formfactory/builder/checkformnameavailability/" + contextualData.locale,
                    method: "POST",
                    data: data
                }).then(function(response) {
                    self[flag] = response.data.available;
                });
            } else {
                self[flag] = false;
            }
        }
        function valueResolver(args) {
            console.log("Resolving: ");
        }
        function placeholderResolver(input) {
            if ("placeholder" in input) {
                return input.placeholder;
            }
            return null;
        }
        function logicResolver(input, form) {
            if (input !== undefined) {
                if (!("ffVisible" in form[input.name])) {
                    return true;
                }
                return form[input.name].ffVisible;
            }
            return true;
        }
        function inputsizeResolver(input) {
            if ("inputsize" in input) {
                return input.inputsize;
            }
            return null;
        }
        function nameResolver(input) {
            if ("name" in input) {
                return input.name;
            }
            return null;
        }
        function labelResolver(input) {
            if ("label" in input) {
                return input.label;
            }
            return null;
        }
        function parseDate(value, format) {
            if (_.isUndefined(value) || value === null || value instanceof Date && isNaN(value.getTime())) {
                return false;
            }
            format = format != null ? format : "YYYY-MM-DD";
            if (value instanceof Date) {
                value = moment(value.toISOString()).format(format);
            } else if (moment.isMoment(value)) {
                return true;
            }
            if (typeof value === "string") {
                var components = value.split("-");
                if (components.length === 3) {
                    components = components[2].split(":");
                    if (components.length === 3) {
                        components = components[2].split(".");
                        if (components.length === 2) {
                            return true;
                        }
                    }
                }
            }
            return validateFormat(value, [ "-", "/" ], format).isValid;
        }
        function createMoment(value, formatSeparators, format) {
            if (_.isUndefined(value) || value === null) {
                return null;
            }
            if (value instanceof Date) {
                return moment(value.toISOString());
            } else if (moment(value, moment.ISO_8601, true).isValid()) {
                return moment(value, moment.ISO_8601, true).toISOString();
            }
            format = format != null ? format : "YYYY-MM-DD";
            var formatSeparators = _.isUndefined(formatSeparators) || formatSeparators === null ? [ "-", "/" ] : _.isString(formatSeparators) ? [].push(formatSeparators) : formatSeparators;
            var validatedDate = validateFormat(value, formatSeparators, format);
            return validatedDate.isValid ? validatedDate.date.toISOString() : null;
        }
        function validateFormat(value, formatSeparators, format) {
            var validatedDate = {
                isValid: false,
                date: null
            };
            for (var i in formatSeparators) {
                var sections = value.toString().split(formatSeparators[i]);
                var formatSections = format.split(formatSeparators[i]);
                if (sections.length == formatSections.length) {
                    validatedDate.isValid = true;
                    var formatSectionIndexes = {
                        year: null,
                        month: null,
                        date: null
                    };
                    for (var j in sections) {
                        if (sections[j] === undefined || sections[j] === "" || sections[j] === null || isNaN(sections[j]) || parseInt(sections[j]) < 0 || sections[j].toString().length !== formatSections[j].length) {
                            validatedDate.isValid = false;
                            break;
                        }
                        if (formatSections[j].toLowerCase().indexOf("y") !== -1) {
                            formatSectionIndexes.year = j;
                        } else if (formatSections[j].toLowerCase().indexOf("m") !== -1) {
                            formatSectionIndexes.month = j;
                        } else if (formatSections[j].toLowerCase().indexOf("d") !== -1) {
                            formatSectionIndexes.date = j;
                        }
                        sections[j] = parseInt(sections[j], 10);
                    }
                    if (!validatedDate.isValid) {
                        break;
                    }
                    validatedDate.date = moment();
                    if (!_.isNull(formatSectionIndexes.year)) {
                        validatedDate.date.year(sections[formatSectionIndexes.year]);
                    }
                    if (!_.isNull(formatSectionIndexes.month)) {
                        validatedDate.date.month(sections[formatSectionIndexes.month] - 1);
                    }
                    if (!_.isNull(formatSectionIndexes.date)) {
                        validatedDate.date.date(sections[formatSectionIndexes.date]);
                    }
                    var formatString = "";
                    for (var sec in formatSections) {
                        formatString += formatSections[sec].substring(0, 1);
                    }
                    validatedDate.isValid = validatedDate.date.format(formatString) == sections.join("-");
                }
            }
            return validatedDate;
        }
    };
    CommonUseFactory.$inject = [ "$http", "contextualData", "$log" ];
    angular.module("formFactory.commonUseFactory", []).factory("ffCommonUseFactory", CommonUseFactory);
})();

(function() {
    var dataFactory = function($http, $log) {
        return {
            getData: getData,
            customRequest: customRequest
        };
        function getData(url) {
            return $http.get(url).then(getDataComplete).catch(getDataFailed);
        }
        function customRequest(obj) {
            return $http(obj).then(getDataComplete);
        }
        function getDataComplete(response) {
            return response.data;
        }
        function getDataFailed(error) {
            $log.error("XHR Failed to execute your request." + error.data);
            return error.data;
        }
    };
    dataFactory.$inject = [ "$http", "$log" ];
    angular.module("formFactory.dataFactory", []).factory("ffDataFactory", dataFactory);
})();

(function() {
    var parseDate = function($log, ffCommonUseFactory, $timeout) {
        var directive = {
            restrict: "A",
            require: [ "^ngModel" ],
            link: linkFunction
        };
        return directive;
        function linkFunction(scope, el, attr, ctrls) {
            var model = ctrls[0];
            var hasParserExecuted = false;
            var parserInProgress = false;
            var viewValue;
            var AVAILABLE_FORMAT_SEPARATORS = [ "-", "/" ];
            var FORMAT_TEMPLATE = attr.format != null ? attr.format : "YYYY-MM-DD";
            var MAX_CHARACTERS = getMaxCharacters(FORMAT_TEMPLATE);
            var FORMAT_SEPARATOR_PROVIDED = !_.isUndefined(attr.ffParseDate) && attr.ffParseDate !== null && attr.ffParseDate.trim().length > 0;
            var REGEXP_FORMAT_SEPARATOR = FORMAT_SEPARATOR_PROVIDED ? attr.ffParseDate : "-|/";
            var FORMAT_REGEXP_PATTERN = "(^[0-9]+)(?=[" + REGEXP_FORMAT_SEPARATOR + "]+)[" + REGEXP_FORMAT_SEPARATOR + "](?=[0-9]+)[0-9]+(?=[" + REGEXP_FORMAT_SEPARATOR + "]+)[" + REGEXP_FORMAT_SEPARATOR + "](?=[0-9]+)[0-9]+(?=[0-9]*)" + "|(^[0-9]+)(?=[" + REGEXP_FORMAT_SEPARATOR + "]+)[" + REGEXP_FORMAT_SEPARATOR + "](?=[0-9]+)[0-9]+(?=[" + REGEXP_FORMAT_SEPARATOR + "]+)[" + REGEXP_FORMAT_SEPARATOR + "]" + "|(^[0-9]+)(?=[" + REGEXP_FORMAT_SEPARATOR + "]+)[" + REGEXP_FORMAT_SEPARATOR + "](?=[0-9]+)[0-9]+" + "|(^[0-9]+)(?=[" + REGEXP_FORMAT_SEPARATOR + "]+)[" + REGEXP_FORMAT_SEPARATOR + "]" + "|(^[0-9]+)";
            var FORMAT_REGEXP = RegExp(FORMAT_REGEXP_PATTERN, "g");
            var REPLACE_REGEXP = RegExp(REGEXP_FORMAT_SEPARATOR, "g");
            var initializeViewValue = scope.$watch(function() {
                return model.$viewValue;
            }, function(value) {
                if (hasParserExecuted) {
                    initializeViewValue();
                    return;
                }
                viewValue = value;
                initializeViewValue();
            });
            function getFormattedRepresentation(value, formatSeparator) {
                if (value instanceof Date) {
                    return moment(value.toISOString(), moment.ISO_8601, true).format(FORMAT_TEMPLATE).replace(/-/g, formatSeparator);
                } else if (typeof value === "string" && moment(value, moment.ISO_8601, true).isValid()) {
                    return moment(value, moment.ISO_8601, true).format(FORMAT_TEMPLATE).replace(/-/g, formatSeparator);
                } else {
                    return value;
                }
            }
            function getFormatSeparator(value) {
                if (FORMAT_SEPARATOR_PROVIDED) {
                    return REGEXP_FORMAT_SEPARATOR;
                } else {
                    var formatSeparator = "-";
                    if (!_.isUndefined(value) && value !== null && !(value instanceof Date)) {
                        var separatorIndex = -1;
                        for (var i in AVAILABLE_FORMAT_SEPARATORS) {
                            var currentSeparatorIndex = value.indexOf(AVAILABLE_FORMAT_SEPARATORS[i]);
                            if (currentSeparatorIndex !== -1 && (separatorIndex === -1 || currentSeparatorIndex < separatorIndex)) {
                                separatorIndex = currentSeparatorIndex;
                                formatSeparator = AVAILABLE_FORMAT_SEPARATORS[i];
                            }
                        }
                    }
                    return formatSeparator;
                }
            }
            function setViewValueFromDateOrMoment(value, separator) {
                var m = value instanceof Date ? moment(viewValue.toISOString(), moment.ISO_8601, true) : moment(viewValue, moment.ISO_8601, true);
                value = m.format(FORMAT_TEMPLATE);
                if (separator !== "-") {
                    value.replace(/-/g, separator);
                }
                model.$setViewValue(value);
                model.$render();
                return m.toISOString();
            }
            function getMaxCharacters(format) {
                var maxCharacters;
                for (var i in AVAILABLE_FORMAT_SEPARATORS) {
                    if (format.indexOf(AVAILABLE_FORMAT_SEPARATORS[i]) !== -1) {
                        var sections = format.split(AVAILABLE_FORMAT_SEPARATORS[i]);
                        maxCharacters = sections.length - 1;
                        for (var j in sections) {
                            maxCharacters += sections[j].length;
                        }
                        break;
                    }
                }
                return maxCharacters;
            }
            model.$parsers.push(function(value) {
                hasParserExecuted = true;
                if (parserInProgress) {
                    return value;
                }
                parserInProgress = true;
                if (_.isUndefined(value) || value === null) {
                    parserInProgress = false;
                    viewValue = value;
                    return value;
                }
                if (value instanceof Date) {
                    model.$setViewValue(getFormattedRepresentation(value, getFormatSeparator(viewValue)));
                    viewValue = value;
                    model.$render();
                    parserInProgress = false;
                    return moment(value.toISOString(), moment.ISO_8601, true).toISOString();
                }
                var matchedValue = value.match(FORMAT_REGEXP);
                if (matchedValue === null) {
                    value = viewValue;
                    model.$setViewValue(getFormattedRepresentation(value, getFormatSeparator(value)));
                    model.$render();
                    parserInProgress = false;
                    return value;
                }
                var formatSeparator = getFormatSeparator(value);
                value = viewValue !== null && matchedValue[0].length < viewValue.length && matchedValue[0].length != value.length ? viewValue : matchedValue[0];
                value = value.replace(REPLACE_REGEXP, formatSeparator);
                if (value.toString().length > MAX_CHARACTERS) {
                    if (ffCommonUseFactory.parseDate(value, FORMAT_TEMPLATE)) {
                        var momentFormat = formatSeparator !== "-" ? angular.copy(FORMAT_TEMPLATE).replace(/-/g, formatSeparator) : FORMAT_TEMPLATE;
                        var m = moment(ffCommonUseFactory.createMoment(value, FORMAT_SEPARATOR_PROVIDED ? REGEXP_FORMAT_SEPARATOR : [ "-", "/" ], FORMAT_TEMPLATE), moment.ISO_8601, true);
                        value = m.toISOString();
                        viewValue = value;
                        model.$setViewValue(m.format(momentFormat));
                        model.$render();
                    } else {
                        if (viewValue instanceof Date || moment(viewValue, moment.ISO_8601, true).isValid()) {
                            value = setViewValueFromDateOrMoment(viewValue, formatSeparator);
                        } else {
                            value = viewValue;
                            model.$setViewValue(value);
                            model.$render();
                            value = moment(value, angular.copy(FORMAT_TEMPLATE).replace(/-/g, formatSeparator), true).toISOString();
                        }
                    }
                } else {
                    viewValue = value;
                    model.$setViewValue(value);
                    model.$render();
                    if (ffCommonUseFactory.parseDate(value, FORMAT_TEMPLATE)) {
                        value = moment(value, angular.copy(FORMAT_TEMPLATE).replace(/-/g, formatSeparator)).toISOString();
                    }
                }
                $timeout(function() {
                    model.$setValidity("date", true);
                });
                parserInProgress = false;
                return value;
            });
        }
    };
    angular.module("formFactory").directive("ffParseDate", [ "$log", "ffCommonUseFactory", "$timeout", parseDate ]);
})();

(function() {
    "use strict";
    var datePicker = function($log, contextualData) {
        var directive = {
            restrict: "E",
            scope: {
                format: "@?",
                minValue: "=?",
                maxValue: "=?",
                datePickerSize: "=",
                minDatePlaceholder: "=",
                maxDatePlaceholder: "=",
                datePickerOptions: "=?",
                datePickerMode: "@?",
                minLabel: "@?",
                maxLabel: "@?",
                readOnly: "@?",
                isDisabled: "@?",
                enforceMinValue: "@?",
                enforceMaxValue: "@?",
                errorControl: "=?",
                parserSeparator: "@?"
            },
            controller: DatePickerController,
            controllerAs: "dpc",
            bindToController: true,
            templateUrl: contextualData.context + "/modules/form-factory-core/javascript/angular/components/datePicker.html",
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrl) {}
    };
    angular.module("formFactory").directive("ffDatePicker", [ "$log", "contextualData", datePicker ]);
    var DatePickerController = function($scope, $log, i18n, uibDateParser, $timeout, ffCommonUseFactory) {
        var dpc = this;
        var DEFAULT_FORMAT = "YYYY-MM-DD";
        dpc.isOpenMin = false;
        dpc.isOpenMax = false;
        dpc.previousValue = {
            min: "",
            max: ""
        };
        dpc.selectedMinDate;
        dpc.selectedMaxDate;
        dpc.openDatePicker = openDatePicker;
        dpc.executeOnChange = executeOnChange;
        dpc.i18nMessageGetter = i18n.message;
        dpc.format = dpc.format == null || dpc.format.trim().length == 0 ? DEFAULT_FORMAT : dpc.format;
        dpc.uibDateParserFormat = convertFormatToUibDateFormat(dpc.format);
        activate();
        function activate() {
            dpc.isAvailableDatepicker = {
                min: _.isUndefined(dpc.minValue) ? false : true,
                max: _.isUndefined(dpc.maxValue) ? false : true
            };
            if (_.isObject(dpc.errorControl)) {
                if (!_.isUndefined(dpc.errorControl.min) && _.isObject(dpc.errorControl.min)) {
                    dpc.errorControl.min.hasError = !_.isUndefined(dpc.errorControl.min.hasError) && _.isBoolean(dpc.errorControl.min.hasError) ? dpc.errorControl.min.hasError : false;
                } else {
                    dpc.errorControl.min = {
                        hasError: false,
                        errorMessage: null
                    };
                }
                if (!_.isUndefined(dpc.errorControl.max) && _.isObject(dpc.errorControl.max)) {
                    dpc.errorControl.max.hasError = !_.isUndefined(dpc.errorControl.max.hasError) && _.isBoolean(dpc.errorControl.max.hasError) ? dpc.errorControl.max.hasError : false;
                } else {
                    dpc.errorControl.max = {
                        hasError: false,
                        errorMessage: null
                    };
                }
            } else {
                dpc.errorControl = {
                    min: {
                        hasError: false,
                        errorMessage: null
                    },
                    max: {
                        hasError: false,
                        errorMessage: null
                    }
                };
            }
            dpc.minLabelAvailable = !_.isUndefined(dpc.minLabel);
            dpc.maxLabelAvailable = !_.isUndefined(dpc.maxLabel);
            dpc.readOnly = _.isUndefined(dpc.readOnly) ? false : dpc.readOnly === true || dpc.readOnly == "true";
            dpc.isDisabled = _.isUndefined(dpc.isDisabled) ? false : dpc.isDisabled === true || dpc.isDisabled == "true";
            dpc.enforceMinValue = _.isUndefined(dpc.enforceMinValue) ? false : dpc.enforceMinValue === true || dpc.enforceMinValue == "true";
            dpc.enforceMaxValue = _.isUndefined(dpc.enforceMaxValue) ? false : dpc.enforceMaxValue === true || dpc.enforceMaxValue == "true";
            setupDatepickerOptions();
            if (!_.isUndefined(dpc.minValue)) {
                if (dpc.minValue instanceof Date) {
                    dpc.selectedMinDate = dpc.minValue;
                } else if (moment(dpc.minValue, moment.ISO_8601, true).isValid()) {
                    dpc.selectedMinDate = new Date(moment(dpc.minValue, moment.ISO_8601, true).toISOString());
                } else {
                    var verifyDate = new Date(dpc.minValue);
                    if (dpc.minValue !== null && verifyDate instanceof Date && !isNaN(verifyDate.getTime())) {
                        dpc.selectedMinDate = verifyDate;
                    } else {
                        dpc.selectedMinDate = null;
                    }
                }
                dpc.initMin = !_.isUndefined(dpc.datePickerOptions.maxDate) && moment(dpc.datePickerOptions.maxDate, moment.ISO_8601, true).isBefore(new Date().toISOString()) ? moment(dpc.datePickerOptions.maxDate, moment.ISO_8601, true).toDate() : new Date();
            }
            if (!_.isUndefined(dpc.maxValue)) {
                if (dpc.maxValue instanceof Date) {
                    dpc.selectedMaxDate = new Date(dpc.maxValue.toISOString());
                } else if (moment(dpc.maxValue, moment.ISO_8601, true).isValid()) {
                    dpc.selectedMaxDate = new Date(moment(dpc.maxValue, moment.ISO_8601, true).toISOString());
                } else {
                    var verifyDate = new Date(dpc.maxValue);
                    if (dpc.maxValue !== null && verifyDate instanceof Date && !isNaN(verifyDate.getTime())) {
                        dpc.selectedMaxDate = verifyDate;
                    } else {
                        dpc.selectedMaxDate = null;
                    }
                }
                dpc.initMax = !_.isUndefined(dpc.datePickerOptions.maxDate) && moment(dpc.datePickerOptions.maxDate, moment.ISO_8601, true).isBefore(new Date().toISOString()) ? moment(dpc.datePickerOptions.maxDate, moment.ISO_8601, true).toDate() : new Date();
            }
            dpc.previousValue.min = angular.copy(dpc.selectedMinDate);
            dpc.previousValue.max = angular.copy(dpc.selectedMaxDate);
        }
        function openDatePicker(popup) {
            dpc.isOpenMin = popup === "min";
            dpc.isOpenMax = popup === "max";
            if (dpc.isOpenMin) {
                $timeout(function() {
                    $timeout(function() {
                        angular.element("div.datePickerMin").find("ul.uib-datepicker-popup button.uib-datepicker-current").focus();
                        angular.element("div.datePickerMin").find("ul.uib-datepicker-popup button.uib-datepicker-current").blur();
                        angular.element("div.datePickerMin").find("table").focus();
                    });
                });
            } else if (dpc.isOpenMax) {
                $timeout(function() {
                    $timeout(function() {
                        angular.element("div.datePickerMax").find("ul.uib-datepicker-popup button.uib-datepicker-current").focus();
                        angular.element("div.datePickerMax").find("ul.uib-datepicker-popup button.uib-datepicker-current").blur();
                        angular.element("div.datePickerMax").find("table").focus();
                    });
                });
            }
        }
        function setupDatepickerOptions() {
            if (_.isUndefined(dpc.datePickerOptions)) {
                dpc.datePickerOptions = {};
                return;
            } else {
                _.each(dpc.datePickerOptions, function(option, optionName) {
                    if (_.isUndefined(option) || _.isEmpty(option)) {
                        delete dpc.datePickerOptions[optionName];
                    }
                });
            }
        }
        function executeOnChange(input) {
            if (dpc.enforceMinValue && input === "min" && (_.isUndefined(dpc.selectedMinDate) || !moment(dpc.selectedMinDate, moment.ISO_8601, true).isValid())) {
                dpc.selectedMinDate = moment("1970", "YYYY").toDate();
            }
            if (dpc.enforceMaxValue && input === "max" && (_.isUndefined(dpc.selectedMaxDate) || !moment(dpc.selectedMaxDate, moment.ISO_8601, true).isValid())) {
                dpc.selectedMaxDate = moment().toDate();
            }
            if (input === "min" && ffCommonUseFactory.parseDate(dpc.selectedMinDate, dpc.format) && !_.isUndefined(dpc.selectedMaxDate) && ffCommonUseFactory.parseDate(dpc.selectedMaxDate, dpc.format)) {
                if (moment(dpc.selectedMinDate).isAfter(moment(dpc.selectedMaxDate).toISOString())) {
                    dpc.selectedMinDate = uibDateParser.parse(new Date(dpc.previousValue.min));
                }
            }
            if (input === "max" && ffCommonUseFactory.parseDate(dpc.selectedMaxDate, dpc.format) && !_.isUndefined(dpc.selectedMinDate) && ffCommonUseFactory.parseDate(dpc.selectedMinDate, dpc.format)) {
                if (moment(dpc.selectedMaxDate).isBefore(moment(dpc.selectedMinDate).toISOString())) {
                    dpc.selectedMaxDate = uibDateParser.parse(new Date(dpc.previousValue.max));
                }
            }
            if (input === "min" && ffCommonUseFactory.parseDate(dpc.selectedMinDate, dpc.format)) {
                dpc.previousValue.min = angular.copy(dpc.selectedMinDate);
            }
            if (input === "max" && ffCommonUseFactory.parseDate(dpc.selectedMaxDate, dpc.format)) {
                dpc.previousValue.max = angular.copy(dpc.selectedMaxDate);
            }
            if (input === "min" && !_.isUndefined(dpc.selectedMinDate)) {
                $timeout(function() {
                    $scope.$apply(function() {
                        dpc.minValue = dpc.selectedMinDate;
                    });
                });
            }
            if (input === "max" && !_.isUndefined(dpc.selectedMaxDate)) {
                $timeout(function() {
                    $scope.$apply(function() {
                        dpc.maxValue = dpc.selectedMaxDate;
                    });
                });
            }
        }
        function convertFormatToUibDateFormat(format) {
            if (format == null || format.trim().length == 0) {
                format = DEFAULT_FORMAT;
            }
            var separator = dpc.parserSeparator != null && dpc.parserSeparator.trim().length > 0 ? [ dpc.parserSeparator ] : [ "-", "/" ];
            var uibFormat = "";
            var separatorDetected = false;
            for (var i in separator) {
                if (format.indexOf(separator[i]) !== -1) {
                    var sections = format.split(separator[i]);
                    for (var j in sections) {
                        if (sections[j].toLowerCase().indexOf("y") !== -1) {
                            uibFormat += sections[j].toLowerCase() + (j < sections.length - 1 ? separator[i] : "");
                        } else if (sections[j].toLowerCase().indexOf("m") !== -1) {
                            uibFormat += sections[j].toUpperCase() + (j < sections.length - 1 ? separator[i] : "");
                        } else if (sections[j].toLowerCase().indexOf("d") !== -1) {
                            uibFormat += sections[j].toLowerCase() + (j < sections.length - 1 ? separator[i] : "");
                        }
                    }
                    separatorDetected = true;
                    break;
                }
            }
            if (!separatorDetected) {
                if (format.toLowerCase().indexOf("y") !== -1) {
                    uibFormat += format.toLowerCase();
                } else if (format.toLowerCase().indexOf("m") !== -1) {
                    uibFormat += format.toUpperCase();
                } else if (format.toLowerCase().indexOf("d") !== -1) {
                    uibFormat += format.toLowerCase();
                }
            }
            return uibFormat;
        }
    };
    DatePickerController.$inject = [ "$scope", "$log", "i18nService", "uibDateParser", "$timeout", "ffCommonUseFactory" ];
    var dateValidator = function($log, ffCommonUseFactory) {
        var directive = {
            restrict: "A",
            require: [ "^ngModel" ],
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrl) {
            var model = ctrl[0];
            var fieldId = attr.fieldId;
            var caseName = attr.caseName;
            model.$validators[attr.ffDateValidator] = function() {
                var isValid = ffCommonUseFactory.parseDate(model.$viewValue);
                scope.$emit("requiredValueChanged", {
                    isValid: isValid,
                    fieldId: fieldId,
                    caseName: caseName,
                    validator: attr.ffDateValidator
                });
                return isValid;
            };
        }
    };
    angular.module("formFactory").directive("ffDateValidator", [ "$log", "ffCommonUseFactory", dateValidator ]);
})();

(function() {
    var editInPlace = function() {
        var directive = {
            restrict: "E",
            scope: {
                value: "="
            },
            template: '<span ng-click="edit()" ng-bind="value"></span><input class="form-control" ng-model="value" />',
            link: linkFunction
        };
        return directive;
        function linkFunction(scope, el, attrs) {
            var inputElement = el.find("input");
            el.addClass("edit-in-place");
            el.addClass("inputHidden");
            scope.edit = function() {
                el.addClass("spanHidden");
                el.removeClass("inputHidden");
                inputElement[0].focus();
            };
            inputElement.on("blur", function(e) {
                e.stopPropagation();
                el.removeClass("spanHidden");
                el.addClass("inputHidden");
            });
        }
    };
    angular.module("formFactory").directive("ffEditInPlace", [ editInPlace ]);
})();

(function() {
    "use strict";
    var logicsFieldValidation = function($log, contextualData, $timeout) {
        var directive = {
            restrict: "EA",
            require: [ "^ngModel" ],
            link: linkFunc
        };
        return directive;
        function linkFunc(scope, el, attr, ctrl) {
            var type = attr["ffFieldValueValidation"];
            var fieldId = attr["fieldId"];
            var caseName = attr["caseName"];
            el.bind("keyup", function(e) {
                scope.$apply(function() {
                    validate(e.currentTarget.value);
                });
            });
            el.bind("change", function(e) {
                scope.$apply(function() {
                    validate(e.currentTarget.value);
                });
            });
            $timeout(function() {
                validate(ctrl[0].$viewValue);
            }, 500);
            function validate(value) {
                switch (type) {
                  case "any":
                    if (value === undefined || value === "" || value === null) {
                        scope.$emit("requiredValueChanged", {
                            isValid: false,
                            "case": type,
                            fieldId: fieldId,
                            caseName: caseName
                        });
                    } else {
                        scope.$emit("requiredValueChanged", {
                            isValid: true,
                            "case": type,
                            fieldId: fieldId,
                            caseName: caseName
                        });
                    }
                    break;

                  case "number":
                    if (value === undefined || value === "" || value === null || isNaN(value)) {
                        scope.$emit("requiredValueChanged", {
                            isValid: false,
                            "case": type,
                            fieldId: fieldId,
                            caseName: caseName
                        });
                    } else {
                        scope.$emit("requiredValueChanged", {
                            isValid: true,
                            "case": type,
                            fieldId: fieldId,
                            caseName: caseName
                        });
                    }
                    break;

                  case "positiveNumber":
                    if (value === undefined || value === "" || value === null || isNaN(value) || value < 0) {
                        scope.$emit("requiredValueChanged", {
                            isValid: false,
                            "case": type,
                            fieldId: fieldId,
                            caseName: caseName
                        });
                    } else {
                        scope.$emit("requiredValueChanged", {
                            isValid: true,
                            "case": type,
                            fieldId: fieldId,
                            caseName: caseName
                        });
                    }
                    break;

                  case "multiple":
                    scope.$emit("requiredValueChanged", {
                        isValid: scope.vsc.selectedValues.length > 0,
                        "case": type,
                        fieldId: fieldId,
                        caseName: caseName
                    });
                    break;
                }
            }
        }
    };
    angular.module("formFactory").directive("ffFieldValueValidation", [ "$log", "contextualData", "$timeout", logicsFieldValidation ]);
})();

(function() {
    "use strict";
    var ResolveTemplatesService = function($log) {
        this.resolveTemplatePath = function(path, viewType) {
            viewType = viewType !== undefined ? "." + viewType : "";
            return path.replace(".html.ajax", viewType + ".html.ajax");
        };
    };
    ResolveTemplatesService.$inject = [ "$log" ];
    angular.module("formFactory.templateResolver", []).service("ffTemplateResolver", ResolveTemplatesService);
})();

(function() {
    "use strict";
    var sanitize = function($sce) {
        return function(htmlCode) {
            return $sce.trustAsHtml(htmlCode);
        };
    };
    var removeSpaces = function() {
        return function(string) {
            if (!angular.isString(string)) {
                return string;
            }
            return string.replace(/[\s]/g, "");
        };
    };
    var lowercase = function() {
        return function(string) {
            if (!angular.isString(string)) {
                return string;
            }
            return string.toLowerCase();
        };
    };
    var normalize = function() {
        return function(value) {
            var newValue = "";
            for (var i = 0; i < value.length; i++) {
                if (value.charAt(i) === "-") {
                    if (i++ < value.length) {
                        newValue += value.charAt(i).toUpperCase();
                    }
                    continue;
                }
                newValue += value.charAt(i);
            }
            return newValue;
        };
    };
    var removeDashes = function() {
        return function(string) {
            if (!angular.isString(string)) {
                return string;
            }
            return string.replace(/[\-]/g, "");
        };
    };
    var callUnderscoreString = function() {
        return function(str, fn, params) {
            str = str || "";
            params = params || [];
            params.unshift(str);
            return fn ? s[fn].apply(this, params) : str;
        };
    };
    var momentCalendar = function() {
        return function(string) {
            if (!angular.isString(string)) {
                return string;
            }
            return moment(string, "LLL").calendar();
        };
    };
    var resourceBundle = function(i18n) {
        return function(string, resourcePartial) {
            return i18n.message(resourcePartial + "." + string);
        };
    };
    var removeChar = function() {
        return function(string, charIndex) {
            return string.substr(charIndex);
        };
    };
    var sanitizeFormName = function() {
        return function(formName) {
            if (!angular.isString(formName)) {
                return formName;
            }
            return formName.replace(/[`\s\'\"~+=!*&%#@,:;\.\^\$\?<\>\|\/\\\[\]\(\)\}\{\-]/g, "");
        };
    };
    var roundValue = function() {
        return function(value) {
            var regexp = new RegExp(/^-{0,1}\d*\.?\d*$/);
            if (!regexp.test(value)) {
                return value;
            }
            return Math.round(value);
        };
    };
    var dasherize = function() {
        return function(str) {
            return str != null ? str.toLowerCase().replace(/\s/g, "-") : "";
        };
    };
    angular.module("formFactory").filter("sanitize", [ "$sce", sanitize ]).filter("removeSpaces", [ removeSpaces ]).filter("lowercase", [ lowercase ]).filter("normalize", [ normalize ]).filter("removeDashes", [ removeDashes ]).filter("s", [ callUnderscoreString ]).filter("momentCalendar", [ momentCalendar ]).filter("i18n", [ "i18nService", resourceBundle ]).filter("removeIndex", [ removeChar ]).filter("sanitizeFormName", [ sanitizeFormName ]).filter("roundValue", [ roundValue ]).filter("dasherize", [ dasherize ]);
})();

(function() {
    "use strict";
    var i18nMessageKeyDirectiveFunction = function(i18nService) {
        return {
            restrict: "A",
            link: function($scope, $element, $attrs) {
                var i18n;
                if (!$attrs.messageParams) {
                    i18n = i18nService.message($attrs.messageKey);
                } else {
                    i18n = i18nService.format($attrs.messageKey, $attrs.messageParams);
                }
                if ($attrs.messageAttr) {
                    $element.attr($attrs.messageAttr, i18n);
                } else {
                    $element.text(i18n);
                }
            }
        };
    };
    var i18nTranslateFilterFunction = function(i18nService) {
        return function(input) {
            return i18nService.message(input);
        };
    };
    angular.module("i18n", []).service("i18nService", function() {
        this.message = function(key, fallback) {
            if (ffi18n && ffi18n[key]) {
                return ffi18n[key];
            } else if (angular.isDefined(fallback)) {
                return fallback;
            } else {
                return "???" + key + "???";
            }
        };
        this.format = function(key, params) {
            var replacer = function(params) {
                return function(s, index) {
                    return params[index] ? params[index] === "__void__" ? "" : params[index] : "";
                };
            };
            if (params) {
                if (ffi18n && ffi18n[key]) {
                    return ffi18n[key].replace(/\{(\w+)\}/g, replacer(params.split("|")));
                } else {
                    return "???" + key + "???";
                }
            } else {
                return this.message(key);
            }
        };
    }).directive("messageKey", [ "i18nService", i18nMessageKeyDirectiveFunction ]).filter("translate", [ "i18nService", i18nTranslateFilterFunction ]);
})();

(function() {
    "use strict";
    var UnderscoreFactory = function() {
        return window._;
    };
    angular.module("formFactory").factory("_", UnderscoreFactory);
})();